=== modified file 'client/Makefile.am'
--- client/Makefile.am	2008-07-08 21:36:40 +0000
+++ client/Makefile.am	2008-07-15 20:24:05 +0000
@@ -15,57 +15,49 @@
 
 # This file is public domain and comes with NO WARRANTY of any kind
 
-AM_CPPFLAGS =			-I$(top_builddir)/include \
-				-I$(top_srcdir)/include \
-				-I$(top_srcdir)/regex \
-				-I$(top_srcdir)/server \
-				-I$(top_srcdir)/strings
+AM_CPPFLAGS =		-I$(top_builddir)/include \
+					-I$(top_srcdir)/include 
 
 LDADD=				$(top_builddir)/libdrizzle/libdrizzle.la -lz
 
 
-noinst_HEADERS =		sql_string.h completion_hash.h my_readline.h \
-				client_priv.h
-
-CLEANFILES =			$(BUILT_SOURCES)
-
-bin_PROGRAMS =			mysql \
-				mysqladmin \
-				mysqlbinlog \
-				mysqlcheck \
-				mysqldump \
-				mysqlimport \
-				mysqltest \
+noinst_HEADERS =	completion_hash.h my_readline.h client_priv.h
+
+CLEANFILES =		$(BUILT_SOURCES)
+
+bin_PROGRAMS =	drizzle \
+				drizzleadmin \
+				drizzlebinlog \
+				drizzlecheck \
+				drizzledump \
+				drizzleimport \
+				drizzletest \
 				mysqlslap 
 
-mysql_SOURCES =			mysql.cc readline.cc sql_string.cc \
-				completion_hash.cc
-mysql_LDADD =			-lreadline @TERMCAP_LIB@ \
+drizzle_SOURCES =		drizzle.c readline.c completion_hash.c
+drizzle_LDADD =			-lreadline @TERMCAP_LIB@ $(GLIB_LIBS) \
 				$(LDADD) $(CXXLDFLAGS)
-mysqladmin_SOURCES =		mysqladmin.cc
-
-mysqlbinlog_SOURCES =		mysqlbinlog.cc \
-				$(top_srcdir)/mysys/mf_tempdir.c \
-				$(top_srcdir)/mysys/my_new.cc \
-				$(top_srcdir)/mysys/my_bit.c \
-				$(top_srcdir)/mysys/my_bitmap.c \
-				$(top_srcdir)/mysys/base64.c 
-mysqlbinlog_LDADD =		$(LDADD) $(CXXLDFLAGS) 
-
-mysqldump_SOURCES=              mysqldump.c \
-	                        $(top_srcdir)/mysys/mf_getdate.c
-
-mysqlimport_SOURCES=		mysqlimport.c
+drizzle_CPPFLAGS = 		$(AM_CPPFLAGS) $(GLIB_CFLAGS)
+drizzleadmin_SOURCES =		drizzleadmin.cc
+
+drizzlebinlog_SOURCES =     drizzlebinlog.cc \
+                $(top_srcdir)/mysys/mf_tempdir.c \
+                $(top_srcdir)/mysys/my_new.cc \
+                $(top_srcdir)/mysys/my_bit.c \
+                $(top_srcdir)/mysys/my_bitmap.c \
+                $(top_srcdir)/mysys/base64.c
+drizzlebinlog_CPPFLAGS = $(AM_CPPFLAGS) -I$(top_srcdir)/server
+
+drizzledump_SOURCES=            drizzledump.c 
+
+drizzleimport_SOURCES=		drizzleimport.c
 
 mysqlslap_SOURCES=		mysqlslap.c
 mysqlslap_CFLAGS=		-DTHREAD -UUNDEF_THREADS_HACK
 
-mysqltest_SOURCES=		mysqltest.cc \
-				$(top_srcdir)/mysys/my_getsystime.c \
-				$(top_srcdir)/mysys/my_copy.c \
-                                $(top_srcdir)/mysys/my_mkdir.c
-mysqltest_LDADD =		${LDADD} @PCRE_LIBS@
-mysqltest_CFLAGS = 		${AM_CPPFLAGS} @PCRE_CFLAGS@
+drizzletest_SOURCES=		drizzletest.cc 
+drizzletest_LDADD =		${LDADD} @PCRE_LIBS@
+drizzletest_CFLAGS = 		${AM_CPPFLAGS} @PCRE_CFLAGS@
 
 # Fix for mit-threads
 DEFS =			-DUNDEF_THREADS_HACK \

=== renamed file 'client/completion_hash.cc' => 'client/completion_hash.c'
=== modified file 'client/completion_hash.h'
--- client/completion_hash.h	2008-06-25 05:29:13 +0000
+++ client/completion_hash.h	2008-07-13 14:36:50 +0000
@@ -57,4 +57,6 @@
 extern int completion_hash_exists(HashTable *ht, char *arKey, uint nKeyLength);
 extern void completion_hash_free(HashTable *ht);
 
+uint hashpjw(const char *arKey, uint nKeyLength);
+
 #endif /* _HASH_ */

=== renamed file 'client/mysql.cc' => 'client/drizzle.c'
--- client/mysql.cc	2008-07-15 20:14:05 +0000
+++ client/drizzle.c	2008-07-15 21:40:58 +0000
@@ -1,17 +1,22 @@
-/* Copyright (C) 2000-2008 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 /* mysql command tool
  * Commands compatible with mSQL by David J. Hughes
@@ -44,6 +49,8 @@
 #include <locale.h>
 #endif
 
+#include <glib.h>
+
 const char *VER= "14.14";
 
 /* Don't try to make a nice table if the data is too big */
@@ -57,9 +64,7 @@
 
 void* sql_alloc(unsigned size);	     // Don't use mysqld alloc for these
 void sql_element_free(void *ptr);
-#include "sql_string.h"
 
-extern "C" {
 #if defined(HAVE_CURSES_H) && defined(HAVE_TERM_H)
 #include <curses.h>
 #include <term.h>
@@ -89,10 +94,7 @@
 #undef bcmp				// Fix problem with new readline
 
 #include <readline/readline.h>
-#define HAVE_READLINE
 
-  //int vidattr(long unsigned int attrs);	// Was missing in sun curses
-}
 
 #if !defined(HAVE_VIDATTR)
 #undef vidattr
@@ -128,16 +130,16 @@
 
 static MYSQL mysql;			/* The connection */
 static bool ignore_errors=0,wait_flag=0,quick=0,
-               connected=0,opt_raw_data=0,unbuffered=0,output_tables=0,
-	       opt_rehash=1,skip_updates=0,safe_updates=0,one_database=0,
-	       opt_compress=0, using_opt_local_infile=0,
-	       vertical=0, line_numbers=1, column_names=1,opt_html=0,
-               opt_xml=0,opt_nopager=1, opt_outfile=0, named_cmds= 0,
-	       tty_password= 0, opt_nobeep=0, opt_reconnect=1,
-	       default_charset_used= 0, opt_secure_auth= 0,
-               default_pager_set= 0, opt_sigint_ignore= 0,
-               auto_vertical_output= 0,
-               show_warnings= 0, executing_query= 0, interrupted_query= 0;
+  connected=0,opt_raw_data=0,unbuffered=0,output_tables=0,
+  opt_rehash=1,skip_updates=0,safe_updates=0,one_database=0,
+  opt_compress=0, using_opt_local_infile=0,
+  vertical=0, line_numbers=1, column_names=1,opt_html=0,
+  opt_xml=0,opt_nopager=1, opt_outfile=0, named_cmds= 0,
+  tty_password= 0, opt_nobeep=0, opt_reconnect=1,
+  default_charset_used= 0, opt_secure_auth= 0,
+  default_pager_set= 0, opt_sigint_ignore= 0,
+  auto_vertical_output= 0,
+  show_warnings= 0, executing_query= 0, interrupted_query= 0;
 static bool debug_info_flag, debug_check_flag;
 static bool column_types_flag;
 static bool preserve_comments= 0;
@@ -147,13 +149,14 @@
 static char * opt_mysql_unix_port=0;
 static int connect_flag=CLIENT_INTERACTIVE;
 static char *current_host,*current_db,*current_user=0,*opt_password=0,
-            *current_prompt=0, *delimiter_str= 0,
-            *default_charset= (char*) MYSQL_DEFAULT_CHARSET_NAME;
+  *delimiter_str= 0,*current_prompt=0,
+  *default_charset= (char*) MYSQL_DEFAULT_CHARSET_NAME;
 static char *histfile;
 static char *histfile_tmp;
-static String glob_buffer,old_buffer;
-static String processed_prompt;
-static char *full_username=0,*part_username=0,*default_prompt=0;
+static GString *glob_buffer;
+static GString *processed_prompt= NULL;
+static GString *default_prompt= NULL;
+static char *full_username=0,*part_username=0;
 static int wait_time = 5;
 static STATUS status;
 static uint32_t select_limit;
@@ -169,7 +172,7 @@
 };
 static const char *day_names[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
 static const char *month_names[]={"Jan","Feb","Mar","Apr","May","Jun","Jul",
-			    "Aug","Sep","Oct","Nov","Dec"};
+                                  "Aug","Sep","Oct","Nov","Dec"};
 static char default_pager[FN_REFLEN];
 static char pager[FN_REFLEN], outfile[FN_REFLEN];
 static FILE *PAGER, *OUTFILE;
@@ -183,6 +186,9 @@
 static CHARSET_INFO *charset_info= &my_charset_latin1;
 
 const char *default_dbug_option="d:t:o,/tmp/mysql.trace";
+int mysql_real_query_for_lazy(const char *buf, int length);
+int mysql_store_result_for_lazy(MYSQL_RES **result);
+
 
 void tee_fprintf(FILE *file, const char *fmt, ...);
 void tee_fputs(const char *s, FILE *file);
@@ -191,55 +197,51 @@
 static void tee_print_sized_data(const char *, unsigned int, unsigned int, bool);
 /* The names of functions that actually do the manipulation. */
 static int get_options(int argc,char **argv);
-extern "C" bool get_one_option(int optid, const struct my_option *opt,
-                                  char *argument);
-static int com_quit(String *str,char*),
-	   com_go(String *str,char*), com_ego(String *str,char*),
-	   com_print(String *str,char*),
-	   com_help(String *str,char*), com_clear(String *str,char*),
-	   com_connect(String *str,char*), com_status(String *str,char*),
-	   com_use(String *str,char*), com_source(String *str, char*),
-	   com_rehash(String *str, char*), com_tee(String *str, char*),
-           com_notee(String *str, char*), com_charset(String *str,char*),
-           com_prompt(String *str, char*), com_delimiter(String *str, char*),
-     com_warnings(String *str, char*), com_nowarnings(String *str, char*);
-
-#ifdef USE_POPEN
-static int com_nopager(String *str, char*), com_pager(String *str, char*),
-           com_edit(String *str,char*), com_shell(String *str, char *);
-#endif
+bool get_one_option(int optid, const struct my_option *opt,
+                    char *argument);
+static int com_quit(GString *str,char*),
+  com_go(GString *str,char*), com_ego(GString *str,char*),
+  com_print(GString *str,char*),
+  com_help(GString *str,char*), com_clear(GString *str,char*),
+  com_connect(GString *str,char*), com_status(GString *str,char*),
+  com_use(GString *str,char*), com_source(GString *str, char*),
+  com_rehash(GString *str, char*), com_tee(GString *str, char*),
+  com_notee(GString *str, char*), com_charset(GString *str,char*),
+  com_prompt(GString *str, char*), com_delimiter(GString *str, char*),
+  com_warnings(GString *str, char*), com_nowarnings(GString *str, char*),
+  com_nopager(GString *str, char*), com_pager(GString *str, char*);
 
 static int read_and_execute(bool interactive);
 static int sql_connect(char *host,char *database,char *user,char *password,
-		       uint silent);
+                       uint silent);
 static const char *server_version_string(MYSQL *mysql);
-static int put_info(const char *str,INFO_TYPE info,uint error=0,
-		    const char *sql_state=0);
+static int put_info(const char *str,INFO_TYPE info,uint error,
+                    const char *sql_state);
 static int put_error(MYSQL *mysql);
 static void safe_put_field(const char *pos,ulong length);
 static void xmlencode_print(const char *src, uint length);
-static void init_pager();
-static void end_pager();
+static void init_pager(void);
+static void end_pager(void);
 static void init_tee(const char *);
-static void end_tee();
-static const char* construct_prompt();
+static void end_tee(void);
+static const char* construct_prompt(void);
 static char *get_arg(char *line, bool get_next_arg);
-static void init_username();
+static void init_username(void);
 static void add_int_to_prompt(int toadd);
 static int get_result_width(MYSQL_RES *res);
 static int get_field_disp_length(MYSQL_FIELD * field);
 
 /* A structure which contains information on the commands this program
    can understand. */
-
 typedef struct {
   const char *name;		/* User printable name of the function. */
   char cmd_char;		/* msql command character */
-  int (*func)(String *str,char *); /* Function to call to do the job. */
+  int (*func)(GString *str,char *); /* Function to call to do the job. */
   bool takes_params;		/* Max parameters for command */
   const char *doc;		/* Documentation for this function.  */
 } COMMANDS;
 
+
 static COMMANDS commands[] = {
   { "?",      '?', com_help,   1, "Synonym for `help'." },
   { "clear",  'c', com_clear,  0, "Clear command."},
@@ -247,22 +249,15 @@
     "Reconnect to the server. Optional arguments are db and host." },
   { "delimiter", 'd', com_delimiter,    1,
     "Set statement delimiter. NOTE: Takes the rest of the line as new delimiter." },
-#ifdef USE_POPEN
-  { "edit",   'e', com_edit,   0, "Edit command with $EDITOR."},
-#endif
   { "ego",    'G', com_ego,    0,
     "Send command to mysql server, display result vertically."},
   { "exit",   'q', com_quit,   0, "Exit mysql. Same as quit."},
   { "go",     'g', com_go,     0, "Send command to mysql server." },
   { "help",   'h', com_help,   1, "Display this help." },
-#ifdef USE_POPEN
   { "nopager",'n', com_nopager,0, "Disable pager, print to stdout." },
-#endif
   { "notee",  't', com_notee,  0, "Don't write into outfile." },
-#ifdef USE_POPEN
-  { "pager",  'P', com_pager,  1, 
+  { "pager",  'P', com_pager,  1,
     "Set PAGER [to_pager]. Print the query results via PAGER." },
-#endif
   { "print",  'p', com_print,  0, "Print current command." },
   { "prompt", 'R', com_prompt, 1, "Change your mysql prompt."},
   { "quit",   'q', com_quit,   0, "Quit mysql." },
@@ -270,10 +265,7 @@
   { "source", '.', com_source, 1,
     "Execute an SQL script file. Takes a file name as an argument."},
   { "status", 's', com_status, 0, "Get status information from the server."},
-#ifdef USE_POPEN
-  { "system", '!', com_shell,  1, "Execute a system shell command."},
-#endif
-  { "tee",    'T', com_tee,    1, 
+  { "tee",    'T', com_tee,    1,
     "Set outfile [to_outfile]. Append everything into given outfile." },
   { "use",    'u', com_use,    1,
     "Use another database. Takes database name as argument." },
@@ -383,7 +375,7 @@
   { "DAY_MICROSECOND", 0, 0, 0, ""},
   { "DAY_MINUTE", 0, 0, 0, ""},
   { "DAY_SECOND", 0, 0, 0, ""},
-  { "DEALLOCATE", 0, 0, 0, ""},     
+  { "DEALLOCATE", 0, 0, 0, ""},
   { "DEC", 0, 0, 0, ""},
   { "DECIMAL", 0, 0, 0, ""},
   { "DECLARE", 0, 0, 0, ""},
@@ -1000,15 +992,15 @@
 static const char *embedded_server_groups[]=
 { "server", "mysql_SERVER", 0 };
 
-extern "C" int history_length;
+int history_length;
 static int not_in_history(const char *line);
-static void initialize_readline (char *name);
-static void fix_history(String *final_command);
+static void initialize_readline (const char *name);
+static void fix_history(GString *final_command);
 
 static COMMANDS *find_command(char *name,char cmd_name);
-static bool add_line(String &buffer,char *line,char *in_string,
+static bool add_line(GString *buffer,char *line,char *in_string,
                      bool *ml_comment);
-static void remove_cntrl(String &buffer);
+static void remove_cntrl(GString *buffer);
 static void print_table_data(MYSQL_RES *result);
 static void print_table_data_html(MYSQL_RES *result);
 static void print_table_data_xml(MYSQL_RES *result);
@@ -1019,8 +1011,8 @@
 static void end_timer(ulong start_time,char *buff);
 static void mysql_end_timer(ulong start_time,char *buff);
 static void nice_time(double sec,char *buff,bool part_second);
-extern "C" sig_handler mysql_end(int sig);
-extern "C" sig_handler handle_sigint(int sig);
+extern sig_handler mysql_end(int sig);
+extern sig_handler handle_sigint(int sig);
 #if defined(HAVE_TERMIOS_H) && defined(GWINSZ_IN_SYS_IOCTL)
 static sig_handler window_resize(int sig);
 #endif
@@ -1030,12 +1022,12 @@
   char buff[80];
 
   MY_INIT(argv[0]);
-
   delimiter_str= delimiter;
-  default_prompt = my_strdup(getenv("MYSQL_PS1") ? 
-			     getenv("MYSQL_PS1") : 
-			     "drizzle> ",MYF(MY_WME));
-  current_prompt = my_strdup(default_prompt,MYF(MY_WME));
+  default_prompt = g_string_new(g_strdup(getenv("DRIZZLE_PS1") ?
+                                         getenv("DRIZZLE_PS1") :
+                                         "drizzle>> "));
+  current_prompt = g_strdup(default_prompt->str);
+  processed_prompt = g_string_sized_new(16);
   prompt_counter=0;
 
   outfile[0]=0;			// no (default) outfile
@@ -1058,10 +1050,10 @@
   status.exit_status=1;
 
   {
-    /* 
-     The file descriptor-layer may be out-of-sync with the file-number layer,
-     so we make sure that "stdout" is really open.  If its file is closed then
-     explicitly close the FD layer. 
+    /*
+      The file descriptor-layer may be out-of-sync with the file-number layer,
+      so we make sure that "stdout" is really open.  If its file is closed then
+      explicitly close the FD layer.
     */
     int stdout_fileno_copy;
     stdout_fileno_copy= dup(fileno(stdout)); /* Okay if fileno fails. */
@@ -1086,7 +1078,7 @@
     my_end(0);
     exit(1);
   }
-  if (mysql_server_init(embedded_server_arg_count, embedded_server_args, 
+  if (mysql_server_init(embedded_server_arg_count, embedded_server_args,
                         (char**) embedded_server_groups))
   {
     put_error(NULL);
@@ -1094,12 +1086,11 @@
     my_end(0);
     exit(1);
   }
-  glob_buffer.realloc(512);
   completion_hash_init(&ht, 128);
   init_alloc_root(&hash_mem_root, 16384, 0);
   bzero((char*) &mysql, sizeof(mysql));
   if (sql_connect(current_host,current_db,current_user,opt_password,
-		  opt_silent))
+                  opt_silent))
   {
     quick= 1;					// Avoid history
     status.exit_status= 1;
@@ -1122,26 +1113,27 @@
 #endif
 
   put_info("Welcome to the Drizzle client..  Commands end with ; or \\g.",
-	   INFO_INFO);
-  sprintf((char*) glob_buffer.ptr(),
-	  "Your Drizzle connection id is %u\nServer version: %s\n",
-	  mysql_thread_id(&mysql), server_version_string(&mysql));
-  put_info((char*) glob_buffer.ptr(),INFO_INFO);
+           INFO_INFO,0,0);
+  glob_buffer = g_string_sized_new(512);
+  g_string_printf(glob_buffer,
+                  "Your Drizzle connection id is %u\nServer version: %s\n",
+                  mysql_thread_id(&mysql), server_version_string(&mysql));
+  put_info(glob_buffer->str,INFO_INFO,0,0);
+  g_string_truncate(glob_buffer,0);
 
-#ifdef HAVE_READLINE
-  initialize_readline((char*) my_progname);
+  initialize_readline(my_progname);
   if (!status.batch && !quick && !opt_html && !opt_xml)
   {
     /* read-history from file, default ~/.mysql_history*/
     if (getenv("MYSQL_HISTFILE"))
-      histfile=my_strdup(getenv("MYSQL_HISTFILE"),MYF(MY_WME));
+      histfile=g_strdup(getenv("MYSQL_HISTFILE"));
     else if (getenv("HOME"))
     {
       histfile=(char*) my_malloc((uint) strlen(getenv("HOME"))
-				 + (uint) strlen("/.mysql_history")+2,
-				 MYF(MY_WME));
+                                 + (uint) strlen("/.mysql_history")+2,
+                                 MYF(MY_WME));
       if (histfile)
-	sprintf(histfile,"%s/.mysql_history",getenv("HOME"));
+        sprintf(histfile,"%s/.mysql_history",getenv("HOME"));
       char link_name[FN_REFLEN];
       if (my_readlink(link_name, histfile, 0) == 0 &&
           strncmp(link_name, "/dev/null", 10) == 0)
@@ -1154,25 +1146,21 @@
     if (histfile)
     {
       if (verbose)
-	tee_fprintf(stdout, "Reading history-file %s\n",histfile);
+        tee_fprintf(stdout, "Reading history-file %s\n",histfile);
       read_history(histfile);
       if (!(histfile_tmp= (char*) my_malloc((uint) strlen(histfile) + 5,
-					    MYF(MY_WME))))
+                                            MYF(MY_WME))))
       {
-	fprintf(stderr, "Couldn't allocate memory for temp histfile!\n");
-	exit(1);
+        fprintf(stderr, "Couldn't allocate memory for temp histfile!\n");
+        exit(1);
       }
       sprintf(histfile_tmp, "%s.TMP", histfile);
     }
   }
-#endif
   sprintf(buff, "%s",
-#ifndef NOT_YET
-	  "Type 'help;' or '\\h' for help. Type '\\c' to clear the buffer.\n");
-#else
-	  "Type 'help [[%]function name[%]]' to get help on usage of function.\n");
-#endif
-  put_info(buff,INFO_INFO);
+          "Type 'help;' or '\\h' for help. Type '\\c' to clear the buffer.\n");
+
+  put_info(buff,INFO_INFO,0,0);
   status.exit_status= read_and_execute(!status.batch);
   if (opt_outfile)
     end_tee();
@@ -1185,7 +1173,6 @@
 sig_handler mysql_end(int sig)
 {
   mysql_close(&mysql);
-#ifdef HAVE_READLINE
   if (!status.batch && !quick && !opt_html && !opt_xml && histfile)
   {
     /* write-history */
@@ -1198,12 +1185,14 @@
   completion_hash_free(&ht);
   free_root(&hash_mem_root,MYF(0));
 
-#endif
   if (sig >= 0)
-    put_info(sig ? "Aborted" : "Bye", INFO_RESULT);
-  glob_buffer.free();
-  old_buffer.free();
-  processed_prompt.free();
+    put_info(sig ? "Aborted" : "Bye", INFO_RESULT,0,0);
+  assert(glob_buffer != NULL);
+  g_string_free(glob_buffer,true);
+  assert(processed_prompt != NULL);
+  g_string_free(processed_prompt,true);
+  assert(default_prompt != NULL);
+  g_string_free(default_prompt,true);
   my_free(opt_password,MYF(MY_ALLOW_ZERO_PTR));
   my_free(opt_mysql_unix_port,MYF(MY_ALLOW_ZERO_PTR));
   my_free(histfile,MYF(MY_ALLOW_ZERO_PTR));
@@ -1228,20 +1217,23 @@
   This function handles sigint calls
   If query is in process, kill query
   no query in process, terminate like previous behavior
- */
+*/
 sig_handler handle_sigint(int sig)
 {
   char kill_buffer[40];
   MYSQL *kill_mysql= NULL;
 
   /* terminate if no query being executed, or we already tried interrupting */
-  if (!executing_query || interrupted_query)
+  if (!executing_query || interrupted_query) {
     goto err;
+  }
 
   kill_mysql= mysql_init(kill_mysql);
   if (!mysql_real_connect(kill_mysql,current_host, current_user, opt_password,
                           "", opt_mysql_port, opt_mysql_unix_port,0))
+  {
     goto err;
+  }
 
   /* kill_buffer is always big enough because max length of %lu is 15 */
   sprintf(kill_buffer, "KILL /*!50000 QUERY */ %u", mysql_thread_id(&mysql));
@@ -1281,9 +1273,9 @@
   {"no-auto-rehash", 'A',
    "No automatic rehashing. One has to use 'rehash' to get table and field completion. This gives a quicker start of mysql and disables rehashing on reconnect. WARNING: options deprecated; use --disable-auto-rehash instead.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-   {"auto-vertical-output", OPT_AUTO_VERTICAL_OUTPUT,
-    "Automatically switch to vertical output mode if the result is wider than the terminal width.",
-    (char**) &auto_vertical_output, (char**) &auto_vertical_output, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+  {"auto-vertical-output", OPT_AUTO_VERTICAL_OUTPUT,
+   "Automatically switch to vertical output mode if the result is wider than the terminal width.",
+   (char**) &auto_vertical_output, (char**) &auto_vertical_output, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"batch", 'B',
    "Don't use history file. Disable interactive behavior. (Enables --silent)", 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"character-sets-dir", OPT_CHARSETS_DIR,
@@ -1332,7 +1324,7 @@
    (char**) &opt_local_infile,
    (char**) &opt_local_infile, 0, GET_BOOL, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"no-beep", 'b', "Turn off beep on error.", (char**) &opt_nobeep,
-   (char**) &opt_nobeep, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0}, 
+   (char**) &opt_nobeep, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"host", 'h', "Connect to host.", (char**) &current_host,
    (char**) &current_host, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"html", 'H', "Produce HTML output.", (char**) &opt_html, (char**) &opt_html,
@@ -1341,7 +1333,7 @@
    GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"line-numbers", OPT_LINE_NUMBERS, "Write line numbers for errors.",
    (char**) &line_numbers, (char**) &line_numbers, 0, GET_BOOL,
-   NO_ARG, 1, 0, 0, 0, 0, 0},  
+   NO_ARG, 1, 0, 0, 0, 0, 0},
   {"skip-line-numbers", 'L', "Don't write line number for errors. WARNING: -L is deprecated, use long version of this option instead.", 0, 0, 0, GET_NO_ARG,
    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"unbuffered", 'n', "Flush buffer after each query.", (char**) &unbuffered,
@@ -1361,14 +1353,12 @@
   {"one-database", 'o',
    "Only update the default database. This is useful for skipping updates to other database in the update log.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-#ifdef USE_POPEN
   {"pager", OPT_PAGER,
    "Pager to use to display results. If you don't supply an option the default pager is taken from your ENV variable PAGER. Valid pagers are less, more, cat [> filename], etc. See interactive help (\\h) also. This option does not work in batch mode. Disable with --disable-pager. This option is disabled by default.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"no-pager", OPT_NOPAGER,
    "Disable pager and print to stdout. See interactive help (\\h) also. WARNING: option deprecated; use --disable-pager instead.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-#endif
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's asked from the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
@@ -1391,7 +1381,7 @@
   {"raw", 'r', "Write fields without conversion. Used with --batch.",
    (char**) &opt_raw_data, (char**) &opt_raw_data, 0, GET_BOOL, NO_ARG, 0, 0, 0,
    0, 0, 0},
-  {"reconnect", OPT_RECONNECT, "Reconnect if the connection is lost. Disable with --disable-reconnect. This option is enabled by default.", 
+  {"reconnect", OPT_RECONNECT, "Reconnect if the connection is lost. Disable with --disable-reconnect. This option is enabled by default.",
    (char**) &opt_reconnect, (char**) &opt_reconnect, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
   {"silent", 's', "Be more silent. Print results with a tab as separator, each row on new line.", 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0,
    0, 0},
@@ -1446,39 +1436,30 @@
    (char**) &max_join_size, 0, GET_ULONG, REQUIRED_ARG, 1000000L, 1, ULONG_MAX,
    0, 1, 0},
   {"secure-auth", OPT_SECURE_AUTH, "Refuse client connecting to server if it"
-    " uses old (pre-4.1.1) protocol", (char**) &opt_secure_auth,
-    (char**) &opt_secure_auth, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+   " uses old (pre-4.1.1) protocol", (char**) &opt_secure_auth,
+   (char**) &opt_secure_auth, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"server-arg", OPT_SERVER_ARG, "Send embedded server this as a parameter.",
    0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"show-warnings", OPT_SHOW_WARNINGS, "Show warnings after every statement.",
-    (char**) &show_warnings, (char**) &show_warnings, 0, GET_BOOL, NO_ARG, 
-    0, 0, 0, 0, 0, 0},
+   (char**) &show_warnings, (char**) &show_warnings, 0, GET_BOOL, NO_ARG,
+   0, 0, 0, 0, 0, 0},
   { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
 };
 
 
 static void usage(int version)
 {
-#if defined(USE_LIBEDIT_INTERFACE)
-  const char* readline= "";
-#else
   const char* readline= "readline";
-#endif
 
-#ifdef HAVE_READLINE
   printf("%s  Ver %s Distrib %s, for %s (%s) using %s %s\n",
-	 my_progname, VER, MYSQL_SERVER_VERSION, SYSTEM_TYPE, MACHINE_TYPE,
+         my_progname, VER, MYSQL_SERVER_VERSION, SYSTEM_TYPE, MACHINE_TYPE,
          readline, rl_library_version);
-#else
-  printf("%s  Ver %s Distrib %s, for %s (%s)\n", my_progname, VER,
-	MYSQL_SERVER_VERSION, SYSTEM_TYPE, MACHINE_TYPE);
-#endif
 
   if (version)
     return;
   printf("\
-Copyright (C) 2000-2008 MySQL AB\n\
-This software comes with ABSOLUTELY NO WARRANTY. This is free software,\n\
+Copyright (C) 2000-2008 MySQL AB\n                                      \
+This software comes with ABSOLUTELY NO WARRANTY. This is free software,\n \
 and you are welcome to modify and redistribute it under the GPL license\n");
   printf("Usage: %s [OPTIONS] [database]\n", my_progname);
   my_print_help(my_long_options);
@@ -1489,7 +1470,7 @@
 
 bool
 get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
-	       char *argument)
+               char *argument)
 {
   switch(optid) {
   case OPT_CHARSETS_DIR:
@@ -1500,22 +1481,23 @@
     default_charset_used= 1;
     break;
   case OPT_DELIMITER:
-    if (argument == disabled_my_option) 
+    if (argument == disabled_my_option)
     {
       strmov(delimiter, DEFAULT_DELIMITER);
     }
-    else 
+    else
     {
       /* Check that delimiter does not contain a backslash */
-      if (!strstr(argument, "\\")) 
+      if (!strstr(argument, "\\"))
       {
         strmake(delimiter, argument, sizeof(delimiter) - 1);
       }
-      else 
+      else
       {
-        put_info("DELIMITER cannot contain a backslash character", INFO_ERROR);
+        put_info("DELIMITER cannot contain a backslash character",
+                 INFO_ERROR,0,0);
         return 0;
-      } 
+      }
     }
     delimiter_length= (uint)strlen(delimiter);
     delimiter_str= delimiter;
@@ -1527,7 +1509,7 @@
     if (argument == disabled_my_option)
     {
       if (opt_outfile)
-	end_tee();
+        end_tee();
     }
     else
       init_tee(argument);
@@ -1545,14 +1527,14 @@
       opt_nopager= 0;
       if (argument && strlen(argument))
       {
-	default_pager_set= 1;
-	strmake(pager, argument, sizeof(pager) - 1);
-	strmov(default_pager, pager);
+        default_pager_set= 1;
+        strmake(pager, argument, sizeof(pager) - 1);
+        strmov(default_pager, pager);
       }
       else if (default_pager_set)
-	strmov(pager, default_pager);
+        strmov(pager, default_pager);
       else
-	opt_nopager= 1;
+        opt_nopager= 1;
     }
     break;
   case OPT_NOPAGER:
@@ -1577,10 +1559,10 @@
     }
     if (embedded_server_arg_count == MAX_SERVER_ARGS-1 ||
         !(embedded_server_args[embedded_server_arg_count++]=
-          my_strdup(argument, MYF(MY_FAE))))
+          g_strdup(argument)))
     {
-        put_info("Can't use server argument", INFO_ERROR);
-        return 0;
+      put_info("Can't use server argument", INFO_ERROR);
+      return 0;
     }
 #else /*EMBEDDED_LIBRARY */
     printf("WARNING: --server-arg option not supported in this configuration.\n");
@@ -1613,10 +1595,10 @@
     {
       char *start= argument;
       my_free(opt_password, MYF(MY_ALLOW_ZERO_PTR));
-      opt_password= my_strdup(argument, MYF(MY_FAE));
+      opt_password= g_strdup(argument);
       while (*argument) *argument++= 'x';		// Destroy argument
       if (*start)
-	start[1]=0 ;
+        start[1]=0 ;
       tty_password= 0;
     }
     else
@@ -1660,7 +1642,7 @@
 
   tmp= (char *) getenv("MYSQL_HOST");
   if (tmp)
-    current_host= my_strdup(tmp, MYF(MY_WME));
+    current_host= strdup(tmp);
 
   pagpoint= getenv("PAGER");
   if (!((char*) (pagpoint)))
@@ -1691,10 +1673,10 @@
     opt_reconnect= 0;
     connect_flag= 0; /* Not in interactive mode */
   }
-  
+
   if (strcmp(default_charset, charset_info->csname) &&
-      !(charset_info= get_charset_by_csname(default_charset, 
-					    MY_CS_PRIMARY, MYF(MY_WME))))
+      !(charset_info= get_charset_by_csname(default_charset,
+                                            MY_CS_PRIMARY, MYF(MY_WME))))
     exit(1);
   if (argc > 1)
   {
@@ -1705,7 +1687,7 @@
   {
     skip_updates= 0;
     my_free(current_db, MYF(MY_ALLOW_ZERO_PTR));
-    current_db= my_strdup(*argv, MYF(MY_WME));
+    current_db= g_strdup(*argv);
   }
   if (tty_password)
     opt_password= get_tty_password(NullS);
@@ -1718,13 +1700,13 @@
 
 static int read_and_execute(bool interactive)
 {
-  char	*line;
-  char	in_string=0;
+  char *line;
+  char in_string=0;
   ulong line_number=0;
-  bool ml_comment= 0;  
+  bool ml_comment= 0;
   COMMANDS *com;
   status.exit_status=1;
-  
+
   for (;;)
   {
     if (!interactive)
@@ -1737,38 +1719,38 @@
         you save the file using "Unicode UTF-8" format.
       */
       if (!line_number &&
-           (uchar) line[0] == 0xEF &&
-           (uchar) line[1] == 0xBB &&
-           (uchar) line[2] == 0xBF)
+          (uchar) line[0] == 0xEF &&
+          (uchar) line[1] == 0xBB &&
+          (uchar) line[2] == 0xBF)
         line+= 3;
       line_number++;
-      if (!glob_buffer.length())
-	status.query_start_line=line_number;
+      if (glob_buffer->len!=0)
+        status.query_start_line=line_number;
     }
     else
     {
       char *prompt= (char*) (ml_comment ? "   /*> " :
-                             glob_buffer.is_empty() ?  construct_prompt() :
-			     !in_string ? "    -> " :
-			     in_string == '\'' ?
-			     "    '> " : (in_string == '`' ?
-			     "    `> " :
-			     "    \"> "));
-      if (opt_outfile && glob_buffer.is_empty())
-	fflush(OUTFILE);
+                             (glob_buffer->len == 0) ?  construct_prompt() :
+                             !in_string ? "    -> " :
+                             in_string == '\'' ?
+                             "    '> " : (in_string == '`' ?
+                                          "    `> " :
+                                          "    \"> "));
+      if (opt_outfile && (glob_buffer->len==0))
+        fflush(OUTFILE);
 
       if (opt_outfile)
-	fputs(prompt, OUTFILE);
+        fputs(prompt, OUTFILE);
       line= readline(prompt);
-
       /*
         When Ctrl+d or Ctrl+z is pressed, the line may be NULL on some OS
         which may cause coredump.
       */
       if (opt_outfile && line)
-	fprintf(OUTFILE, "%s\n", line);
+        fprintf(OUTFILE, "%s\n", line);
     }
-    if (!line)					// End of file
+    // End of file
+    if (!line)
     {
       status.exit_status=0;
       break;
@@ -1778,17 +1760,16 @@
       Check if line is a mysql command line
       (We want to allow help, print and clear anywhere at line start
     */
-    if ((named_cmds || glob_buffer.is_empty())
-	&& !ml_comment && !in_string && (com=find_command(line,0)))
+    if ((named_cmds || (glob_buffer->len==0))
+        && !ml_comment && !in_string && (com=find_command(line,0)))
     {
-      if ((*com->func)(&glob_buffer,line) > 0)
-	break;
-      if (glob_buffer.is_empty())		// If buffer was emptied
-	in_string=0;
-#ifdef HAVE_READLINE
+      if ((*com->func)(glob_buffer,line) > 0)
+        break;
+      // If buffer was emptied
+      if (glob_buffer->len==0)
+        in_string=0;
       if (interactive && status.add_to_history && not_in_history(line))
-	add_history(line);
-#endif
+        add_history(line);
       continue;
     }
     if (add_line(glob_buffer,line,&in_string,&ml_comment))
@@ -1799,11 +1780,11 @@
   if (!interactive && !status.exit_status)
   {
     remove_cntrl(glob_buffer);
-    if (!glob_buffer.is_empty())
+    if (glob_buffer->len != 0)
     {
       status.exit_status=1;
-      if (com_go(&glob_buffer,line) <= 0)
-	status.exit_status=0;
+      if (com_go(glob_buffer,line) <= 0)
+        status.exit_status=0;
     }
   }
 
@@ -1841,9 +1822,9 @@
     {
       len=(uint) (end - name);
       while (my_isspace(charset_info,*end))
-	end++;
+        end++;
       if (!*end)
-	end=0;					// no arguments to function
+        end=0;					// no arguments to function
     }
     else
       len=(uint) strlen(name);
@@ -1852,7 +1833,7 @@
   for (uint i= 0; commands[i].name; i++)
   {
     if (commands[i].func &&
-	((name && !my_strnncoll(charset_info,(uchar*)name,len, (uchar*)commands[i].name,len) && !commands[i].name[len] && (!end || (end && commands[i].takes_params))) || (!name && commands[i].cmd_char == cmd_char)))
+        ((name && !my_strnncoll(charset_info,(uchar*)name,len, (uchar*)commands[i].name,len) && !commands[i].name[len] && (!end || (end && commands[i].takes_params))) || (!name && commands[i].cmd_char == cmd_char)))
     {
       return(&commands[i]);
     }
@@ -1861,8 +1842,8 @@
 }
 
 
-static bool add_line(String &buffer,char *line,char *in_string,
-                     bool *ml_comment)
+static bool add_line(GString *buffer,char *line,char *in_string,
+                        bool *ml_comment)
 {
   uchar inchar;
   char buff[80], *pos, *out;
@@ -1871,12 +1852,10 @@
   bool ss_comment= 0;
 
 
-  if (!line[0] && buffer.is_empty())
+  if (!line[0] && (buffer->len==0))
     return(0);
-#ifdef HAVE_READLINE
   if (status.add_to_history && line[0] && not_in_history(line))
     add_history(line);
-#endif
   char *end_of_line=line+(uint) strlen(line);
 
   for (pos=out=line ; (inchar= (uchar) *pos) ; pos++)
@@ -1885,10 +1864,10 @@
     {
       // Skip spaces at the beggining of a statement
       if (my_isspace(charset_info,inchar) && (out == line) &&
-          buffer.is_empty())
+          (buffer->len==0))
         continue;
     }
-        
+
 #ifdef USE_MB
     // Accept multi-byte characters as-is
     int length;
@@ -1906,29 +1885,29 @@
       continue;
     }
 #endif
-    if (!*ml_comment && inchar == '\\' &&
+        if (!*ml_comment && inchar == '\\' &&
         !(mysql.server_status & SERVER_STATUS_NO_BACKSLASH_ESCAPES))
     {
       // Found possbile one character command like \c
 
       if (!(inchar = (uchar) *++pos))
-	break;				// readline adds one '\'
+        break;				// readline adds one '\'
       if (*in_string || inchar == 'N')	// \N is short for NULL
       {					// Don't allow commands in string
-	*out++='\\';
-	*out++= (char) inchar;
-	continue;
+        *out++='\\';
+        *out++= (char) inchar;
+        continue;
       }
       if ((com=find_command(NullS,(char) inchar)))
       {
         // Flush previously accepted characters
         if (out != line)
         {
-          buffer.append(line, (uint) (out-line));
+          g_string_append_len(buffer, line, (gssize) (out-line));
           out= line;
         }
-        
-        if ((*com->func)(&buffer,pos-1) > 0)
+
+        if ((*com->func)(buffer,pos-1) > 0)
           return(1);                       // Quit
         if (com->takes_params)
         {
@@ -1951,19 +1930,19 @@
               ;	// Remove parameters
             if (!*pos)
               pos--;
-            else 
+            else
               pos+= delimiter_length - 1; // Point at last delim char
           }
         }
       }
       else
       {
-	sprintf(buff,"Unknown command '\\%c'.",inchar);
-	if (put_info(buff,INFO_ERROR) > 0)
-	  return(1);
-	*out++='\\';
-	*out++=(char) inchar;
-	continue;
+        sprintf(buff,"Unknown command '\\%c'.",inchar);
+        if (put_info(buff,INFO_ERROR,0,0) > 0)
+          return(1);
+        *out++='\\';
+        *out++=(char) inchar;
+        continue;
       }
     }
     else if (!*ml_comment && !*in_string &&
@@ -1974,27 +1953,28 @@
       // Flush previously accepted characters
       if (out != line)
       {
-        buffer.append(line, (uint32) (out - line));
+        g_string_append_len(buffer, line, (gssize) (out - line));
         out= line;
       }
 
       // Flush possible comments in the buffer
-      if (!buffer.is_empty())
+      if (buffer->len != 0)
       {
-        if (com_go(&buffer, 0) > 0) // < 0 is not fatal
+        if (com_go(buffer, 0) > 0) // < 0 is not fatal
           return(1);
-        buffer.length(0);
+        assert(buffer!=NULL);
+        g_string_truncate(buffer,0);
       }
 
       /*
         Delimiter wants the get rest of the given line as argument to
         allow one to change ';' to ';;' and back
       */
-      buffer.append(pos);
-      if (com_delimiter(&buffer, pos) > 0)
+      g_string_append(buffer,pos);
+      if (com_delimiter(buffer, pos) > 0)
         return(1);
 
-      buffer.length(0);
+      g_string_truncate(buffer,0);
       break;
     }
     else if (!*ml_comment && !*in_string && is_prefix(pos, delimiter))
@@ -2010,7 +1990,7 @@
       // Flush previously accepted characters
       if (out != line)
       {
-        buffer.append(line, (uint32) (out-line));
+        g_string_append_len(buffer, line, (gssize) (out-line));
         out= line;
       }
 
@@ -2020,43 +2000,47 @@
                                  my_isspace(charset_info, pos[2]))))
       {
         // Add trailing single line comments to this statement
-        buffer.append(pos);
+        g_string_append(buffer, pos);
         pos+= strlen(pos);
       }
 
       pos--;
 
-      if ((com= find_command(buffer.c_ptr(), 0)))
+      if ((com= find_command(buffer->str, 0)))
       {
-          
-        if ((*com->func)(&buffer, buffer.c_ptr()) > 0)
-          return(1);                       // Quit 
+
+        if ((*com->func)(buffer, buffer->str) > 0)
+          return(1);                       // Quit
       }
       else
       {
-        if (com_go(&buffer, 0) > 0)             // < 0 is not fatal
+        if (com_go(buffer, 0) > 0)             // < 0 is not fatal
           return(1);
       }
-      buffer.length(0);
+      g_string_truncate(buffer,0);
     }
-    else if (!*ml_comment && (!*in_string && (inchar == '#' ||
-			      (inchar == '-' && pos[1] == '-' && my_isspace(charset_info,pos[2])))))
+    else if (!*ml_comment
+             && (!*in_string
+                 && (inchar == '#'
+                     || (inchar == '-'
+                         && pos[1] == '-'
+                         && my_isspace(charset_info,pos[2])))))
     {
       // Flush previously accepted characters
       if (out != line)
       {
-        buffer.append(line, (uint32) (out - line));
+        g_string_append_len(buffer, line, (gssize) (out - line));
         out= line;
       }
 
       // comment to end of line
       if (preserve_comments)
-        buffer.append(pos);
+        g_string_append(buffer,pos);
 
       break;
     }
     else if (!*in_string && inchar == '/' && *(pos+1) == '*' &&
-	     *(pos+2) != '!')
+             *(pos+2) != '!')
     {
       if (preserve_comments)
       {
@@ -2068,7 +2052,7 @@
       *ml_comment= 1;
       if (out != line)
       {
-        buffer.append(line,(uint) (out-line));
+        g_string_append_len(buffer, line, (gssize) (out-line));
         out=line;
       }
     }
@@ -2084,25 +2068,26 @@
       *ml_comment= 0;
       if (out != line)
       {
-        buffer.append(line, (uint32) (out - line));
+        g_string_append_len(buffer, line, (gssize) (out - line));
         out= line;
       }
       // Consumed a 2 chars or more, and will add 1 at most,
       // so using the 'line' buffer to edit data in place is ok.
       need_space= 1;
-    }      
+    }
     else
-    {						// Add found char to buffer
+    {
+      // Add found char to buffer
       if (!*in_string && inchar == '/' && *(pos + 1) == '*' &&
           *(pos + 2) == '!')
         ss_comment= 1;
       else if (!*in_string && ss_comment && inchar == '*' && *(pos + 1) == '/')
         ss_comment= 0;
       if (inchar == *in_string)
-	*in_string= 0;
+        *in_string= 0;
       else if (!*ml_comment && !*in_string &&
-	       (inchar == '\'' || inchar == '"' || inchar == '`'))
-	*in_string= (char) inchar;
+               (inchar == '\'' || inchar == '"' || inchar == '`'))
+        *in_string= (char) inchar;
       if (!*ml_comment || preserve_comments)
       {
         if (need_space && !my_isspace(charset_info, (char)inchar))
@@ -2112,26 +2097,24 @@
       }
     }
   }
-  if (out != line || !buffer.is_empty())
+  if (out != line || (buffer->len > 0))
   {
     *out++='\n';
     uint length=(uint) (out-line);
-    if (buffer.length() + length >= buffer.alloced_length())
-      buffer.realloc(buffer.length()+length+IO_SIZE);
-    if ((!*ml_comment || preserve_comments) && buffer.append(line, length))
+    if ((!*ml_comment || preserve_comments)
+        && (g_string_append_len(buffer, line, length) == NULL))
       return(1);
   }
   return(0);
 }
 
 /*****************************************************************
-	    Interface to Readline Completion
+            Interface to Readline Completion
 ******************************************************************/
 
-#ifdef HAVE_READLINE
 
 static char *new_command_generator(const char *text, int);
-extern "C" char **new_mysql_completion (const char *text, int start, int end);
+extern char **new_mysql_completion (const char *text, int start, int end);
 
 /*
   Tell the GNU Readline library how to complete.  We want to try to complete
@@ -2140,75 +2123,79 @@
 */
 
 #if defined(USE_NEW_READLINE_INTERFACE) || defined(USE_LIBEDIT_INTERFACE)
-extern "C" char *no_completion(const char*,int)
+extern char *no_completion(const char*,int);
 #else
-extern "C" char *no_completion()
+char *no_completion(void);
+char *no_completion(void)
+{
+  /* No filename completion */
+  return 0;
+}
 #endif
-{
-  return 0;					/* No filename completion */
-}
 
-/*	glues pieces of history back together if in pieces   */
-static void fix_history(String *final_command) 
+/* glues pieces of history back together if in pieces   */
+static void fix_history(GString *final_command)
 {
   int total_lines = 1;
-  char *ptr = final_command->c_ptr();
-  String fixed_buffer; 	/* Converted buffer */
+  const char *ptr = final_command->str;
+  /* Converted buffer */
+  GString * fixed_buffer;
+  fixed_buffer = g_string_sized_new(16);
   char str_char = '\0';  /* Character if we are in a string or not */
-  
+
   /* find out how many lines we have and remove newlines */
-  while (*ptr != '\0') 
+  while (*ptr != '\0')
   {
     switch (*ptr) {
       /* string character */
     case '"':
     case '\'':
     case '`':
-      if (str_char == '\0')	/* open string */
-	str_char = *ptr;
+      // open string
+      if (str_char == '\0')
+        str_char = *ptr;
       else if (str_char == *ptr)   /* close string */
-	str_char = '\0';
-      fixed_buffer.append(ptr,1);
+        str_char = '\0';
+      g_string_append_len(fixed_buffer, ptr, 1);
       break;
     case '\n':
-      /* 
-	 not in string, change to space
-	 if in string, leave it alone 
+      /*
+        not in string, change to space
+        if in string, leave it alone
       */
-      fixed_buffer.append(str_char == '\0' ? " " : "\n");
+      g_string_append(fixed_buffer,(str_char == '\0') ? " " : "\n");
       total_lines++;
       break;
     case '\\':
-      fixed_buffer.append('\\');
+      g_string_append_c(fixed_buffer, '\\');
       /* need to see if the backslash is escaping anything */
-      if (str_char) 
+      if (str_char)
       {
-	ptr++;
-	/* special characters that need escaping */
-	if (*ptr == '\'' || *ptr == '"' || *ptr == '\\')
-	  fixed_buffer.append(ptr,1);
-	else
-	  ptr--;
+        ptr++;
+        /* special characters that need escaping */
+        if (*ptr == '\'' || *ptr == '"' || *ptr == '\\')
+          g_string_append_len(fixed_buffer, ptr, 1);
+        else
+          ptr--;
       }
       break;
-      
     default:
-      fixed_buffer.append(ptr,1);
+      g_string_append_len(fixed_buffer, ptr, 1);
     }
     ptr++;
   }
-  if (total_lines > 1)			
-    add_history(fixed_buffer.ptr());
+  if (total_lines > 1)
+    add_history(fixed_buffer->str);
 }
 
-/*	
+/*
   returns 0 if line matches the previous history entry
   returns 1 if the line doesn't match the previous history entry
 */
-static int not_in_history(const char *line) 
+static int not_in_history(const char *line)
 {
   HIST_ENTRY *oldhist = history_get(history_length);
-  
+
   if (oldhist == 0)
     return 1;
   if (strcmp(oldhist->line,line) == 0)
@@ -2216,7 +2203,7 @@
   return 1;
 }
 
-static void initialize_readline (char *name)
+static void initialize_readline (const char *name)
 {
   /* Allow conditional parsing of the ~/.inputrc file. */
   rl_readline_name= name;
@@ -2262,13 +2249,13 @@
 
       b = find_all_matches(&ht,text,(uint) strlen(text),&len);
       if (!b)
-	return NullS;
+        return NullS;
       e = b->pData;
     }
 
     if (e)
     {
-      ptr= strdup(e->str);
+      ptr= g_strdup(e->str);
       e = e->pNext;
       return ptr;
     }
@@ -2281,38 +2268,38 @@
       /* find the first used bucket */
       for (i=0 ; i < ht.nTableSize ; i++)
       {
-	if (ht.arBuckets[i])
-	{
-	  b = ht.arBuckets[i];
-	  e = b->pData;
-	  break;
-	}
+        if (ht.arBuckets[i])
+        {
+          b = ht.arBuckets[i];
+          e = b->pData;
+          break;
+        }
       }
     }
     ptr= NullS;
     while (e && !ptr)
     {					/* find valid entry in bucket */
       if ((uint) strlen(e->str) == b->nKeyLength)
-	ptr = strdup(e->str);
+        ptr = g_strdup(e->str);
       /* find the next used entry */
       e = e->pNext;
       if (!e)
       { /* find the next used bucket */
-	b = b->pNext;
-	if (!b)
-	{
-	  for (i++ ; i<ht.nTableSize; i++)
-	  {
-	    if (ht.arBuckets[i])
-	    {
-	      b = ht.arBuckets[i];
-	      e = b->pData;
-	      break;
-	    }
-	  }
-	}
-	else
-	  e = b->pData;
+        b = b->pNext;
+        if (!b)
+        {
+          for (i++ ; i<ht.nTableSize; i++)
+          {
+            if (ht.arBuckets[i])
+            {
+              b = ht.arBuckets[i];
+              e = b->pData;
+              break;
+            }
+          }
+        }
+        else
+          e = b->pData;
       }
     }
     if (ptr)
@@ -2359,14 +2346,14 @@
   if (mysql_query(&mysql,"show databases") == 0)
   {
     if (!(databases = mysql_store_result(&mysql)))
-      put_info(mysql_error(&mysql),INFO_INFO);
+      put_info(mysql_error(&mysql),INFO_INFO,0,0);
     else
     {
       while ((database_row=mysql_fetch_row(databases)))
       {
-	char *str=strdup_root(&hash_mem_root, (char*) database_row[0]);
-	if (str)
-	  add_word(&ht,(char*) str);
+        char *str=strdup_root(&hash_mem_root, (char*) database_row[0]);
+        if (str)
+          add_word(&ht,(char*) str);
       }
       mysql_free_result(databases);
     }
@@ -2375,21 +2362,21 @@
   if (mysql_query(&mysql,"show tables")==0)
   {
     if (!(tables = mysql_store_result(&mysql)))
-      put_info(mysql_error(&mysql),INFO_INFO);
+      put_info(mysql_error(&mysql),INFO_INFO,0,0);
     else
     {
       if (mysql_num_rows(tables) > 0 && !opt_silent && write_info)
       {
-	tee_fprintf(stdout, "\
-Reading table information for completion of table and column names\n\
+        tee_fprintf(stdout, "\
+Reading table information for completion of table and column names\n    \
 You can turn off this feature to get a quicker startup with -A\n\n");
       }
       while ((table_row=mysql_fetch_row(tables)))
       {
-	char *str=strdup_root(&hash_mem_root, (char*) table_row[0]);
-	if (str &&
-	    !completion_hash_exists(&ht,(char*) str, (uint) strlen(str)))
-	  add_word(&ht,str);
+        char *str=strdup_root(&hash_mem_root, (char*) table_row[0]);
+        if (str &&
+            !completion_hash_exists(&ht,(char*) str, (uint) strlen(str)))
+          add_word(&ht,str);
       }
     }
   }
@@ -2401,7 +2388,7 @@
   }
   mysql_data_seek(tables,0);
   if (!(field_names= (char ***) alloc_root(&hash_mem_root,sizeof(char **) *
-					   (uint) (mysql_num_rows(tables)+1))))
+                                           (uint) (mysql_num_rows(tables)+1))))
   {
     mysql_free_result(tables);
     return;
@@ -2413,8 +2400,8 @@
     {
       num_fields=mysql_num_fields(fields);
       if (!(field_names[i] = (char **) alloc_root(&hash_mem_root,
-						  sizeof(char *) *
-						  (num_fields*2+1))))
+                                                  sizeof(char *) *
+                                                  (num_fields*2+1))))
       {
         mysql_free_result(fields);
         break;
@@ -2423,15 +2410,15 @@
       j=0;
       while ((sql_field=mysql_fetch_field(fields)))
       {
-	sprintf(buf,"%.64s.%.64s",table_row[0],sql_field->name);
-	field_names[i][j] = strdup_root(&hash_mem_root,buf);
-	add_word(&ht,field_names[i][j]);
-	field_names[i][num_fields+j] = strdup_root(&hash_mem_root,
-						   sql_field->name);
-	if (!completion_hash_exists(&ht,field_names[i][num_fields+j],
-				    (uint) strlen(field_names[i][num_fields+j])))
-	  add_word(&ht,field_names[i][num_fields+j]);
-	j++;
+        sprintf(buf,"%.64s.%.64s",table_row[0],sql_field->name);
+        field_names[i][j] = strdup_root(&hash_mem_root,buf);
+        add_word(&ht,field_names[i][j]);
+        field_names[i][num_fields+j] = strdup_root(&hash_mem_root,
+                                                   sql_field->name);
+        if (!completion_hash_exists(&ht,field_names[i][num_fields+j],
+                                    (uint) strlen(field_names[i][num_fields+j])))
+          add_word(&ht,field_names[i][num_fields+j]);
+        j++;
       }
       mysql_free_result(fields);
     }
@@ -2445,32 +2432,31 @@
   return;
 }
 
-	/* for gnu readline */
+/* for gnu readline */
 
 #ifndef HAVE_INDEX
 extern "C" {
-extern char *index(const char *,int c),*rindex(const char *,int);
-
-char *index(const char *s,int c)
-{
-  for (;;)
-  {
-     if (*s == (char) c) return (char*) s;
-     if (!*s++) return NullS;
-  }
-}
-
-char *rindex(const char *s,int c)
-{
-  register char *t;
-
-  t = NullS;
-  do if (*s == (char) c) t = (char*) s; while (*s++);
-  return (char*) t;
-}
+  extern char *index(const char *,int c),*rindex(const char *,int);
+
+  char *index(const char *s,int c)
+  {
+    for (;;)
+    {
+      if (*s == (char) c) return (char*) s;
+      if (!*s++) return NullS;
+    }
+  }
+
+  char *rindex(const char *s,int c)
+  {
+    register char *t;
+
+    t = NullS;
+    do if (*s == (char) c) t = (char*) s; while (*s++);
+    return (char*) t;
+  }
 }
 #endif
-#endif /* HAVE_READLINE */
 
 
 static int reconnect(void)
@@ -2478,18 +2464,18 @@
   /* purecov: begin tested */
   if (opt_reconnect)
   {
-    put_info("No connection. Trying to reconnect...",INFO_INFO);
-    (void) com_connect((String *) 0, 0);
+    put_info("No connection. Trying to reconnect...",INFO_INFO,0,0);
+    (void) com_connect((GString *) 0, 0);
     if (opt_rehash)
       com_rehash(NULL, NULL);
   }
   if (!connected)
-    return put_info("Can't connect to the server\n",INFO_ERROR);
+    return put_info("Can't connect to the server\n",INFO_ERROR,0,0);
   /* purecov: end */
   return 0;
 }
 
-static void get_current_db()
+static void get_current_db(void)
 {
   MYSQL_RES *res;
 
@@ -2501,7 +2487,7 @@
   {
     MYSQL_ROW row= mysql_fetch_row(res);
     if (row[0])
-      current_db= my_strdup(row[0], MYF(MY_WME));
+      current_db= g_strdup(row[0]);
     mysql_free_result(res);
   }
 }
@@ -2541,40 +2527,35 @@
   char ccat= (*cur)[num_cat][0];
   if (*last_char != ccat)
   {
-    put_info(ccat == 'Y' ? "categories:" : "topics:", INFO_INFO);
+    put_info(ccat == 'Y' ? "categories:" : "topics:", INFO_INFO,0,0);
     *last_char= ccat;
   }
   tee_fprintf(PAGER, "   %s\n", (*cur)[num_name]);
 }
 
 
-static int com_server_help(String *buffer __attribute__((unused)),
-			   char *line __attribute__((unused)), char *help_arg)
+static int com_server_help(GString *buffer,
+                           char *line __attribute__((unused)),
+                           char *help_arg)
 {
   MYSQL_ROW cur;
-  const char *server_cmd= buffer->ptr();
+  const char *server_cmd= buffer->str;
   char cmd_buf[100];
   MYSQL_RES *result;
   int error;
-  
+
   if (help_arg[0] != '\'')
   {
-	char *end_arg= strend(help_arg);
-	if(--end_arg)
-	{
-		while (my_isspace(charset_info,*end_arg))
-          end_arg--;
-		*++end_arg= '\0';
-	}
-	(void) strxnmov(cmd_buf, sizeof(cmd_buf), "help '", help_arg, "'", NullS);
+    char *end_arg= strend(help_arg);
+    if(--end_arg)
+    {
+      while (my_isspace(charset_info,*end_arg))
+        end_arg--;
+      *++end_arg= '\0';
+    }
+    (void) strxnmov(cmd_buf, sizeof(cmd_buf), "help '", help_arg, "'", NullS);
     server_cmd= cmd_buf;
   }
-  
-  if (!status.batch)
-  {
-    old_buffer= *buffer;
-    old_buffer.copy();
-  }
 
   if (!connected && reconnect())
     return 1;
@@ -2592,15 +2573,15 @@
     {
       if (!(cur= mysql_fetch_row(result)))
       {
-	error= -1;
-	goto err;
+        error= -1;
+        goto err;
       }
 
       init_pager();
       tee_fprintf(PAGER,   "Name: \'%s\'\n", cur[0]);
       tee_fprintf(PAGER,   "Description:\n%s", cur[1]);
       if (cur[2] && *((char*)cur[2]))
-	tee_fprintf(PAGER, "Examples:\n%s", cur[2]);
+        tee_fprintf(PAGER, "Examples:\n%s", cur[2]);
       tee_fprintf(PAGER,   "\n");
       end_pager();
     }
@@ -2613,29 +2594,29 @@
 
       if (num_fields == 2)
       {
-	put_info("Many help items for your request exist.", INFO_INFO);
-	put_info("To make a more specific request, please type 'help <item>',\nwhere <item> is one of the following", INFO_INFO);
-	num_name= 0;
-	num_cat= 1;
+        put_info("Many help items for your request exist.", INFO_INFO,0,0);
+        put_info("To make a more specific request, please type 'help <item>',\nwhere <item> is one of the following", INFO_INFO,0,0);
+        num_name= 0;
+        num_cat= 1;
       }
       else if ((cur= mysql_fetch_row(result)))
       {
-	tee_fprintf(PAGER, "You asked for help about help category: \"%s\"\n", cur[0]);
-	put_info("For more information, type 'help <item>', where <item> is one of the following", INFO_INFO);
-	num_name= 1;
-	num_cat= 2;
-	print_help_item(&cur,1,2,&last_char);
+        tee_fprintf(PAGER, "You asked for help about help category: \"%s\"\n", cur[0]);
+        put_info("For more information, type 'help <item>', where <item> is one of the following", INFO_INFO,0,0);
+        num_name= 1;
+        num_cat= 2;
+        print_help_item(&cur,1,2,&last_char);
       }
 
       while ((cur= mysql_fetch_row(result)))
-	print_help_item(&cur,num_name,num_cat,&last_char);
+        print_help_item(&cur,num_name,num_cat,&last_char);
       tee_fprintf(PAGER, "\n");
       end_pager();
     }
     else
     {
-      put_info("\nNothing found", INFO_INFO);
-      put_info("Please try to run 'help contents' for a list of all accessible topics\n", INFO_INFO);
+      put_info("\nNothing found", INFO_INFO,0,0);
+      put_info("Please try to run 'help contents' for a list of all accessible topics\n", INFO_INFO,0,0);
     }
   }
 
@@ -2645,8 +2626,8 @@
 }
 
 static int
-com_help(String *buffer __attribute__((unused)),
-	 char *line __attribute__((unused)))
+com_help(GString *buffer __attribute__((unused)),
+         char *line __attribute__((unused)))
 {
   register int i, j;
   char * help_arg= strchr(line,' '), buff[32], *end;
@@ -2654,13 +2635,13 @@
   {
     while (my_isspace(charset_info,*help_arg))
       help_arg++;
-	if (*help_arg)	  
-	  return com_server_help(buffer,line,help_arg);
+    if (*help_arg)
+      return com_server_help(buffer,line,help_arg);
   }
 
-  put_info("List of all Drizzle commands:", INFO_INFO);
+  put_info("List of all Drizzle commands:", INFO_INFO,0,0);
   if (!named_cmds)
-    put_info("Note that all text commands must be first on line and end with ';'",INFO_INFO);
+    put_info("Note that all text commands must be first on line and end with ';'",INFO_INFO,0,0);
   for (i = 0; commands[i].name; i++)
   {
     end= strmov(buff, commands[i].name);
@@ -2668,29 +2649,25 @@
       end= strmov(end, " ");
     if (commands[i].func)
       tee_fprintf(stdout, "%s(\\%c) %s\n", buff,
-		  commands[i].cmd_char, commands[i].doc);
+                  commands[i].cmd_char, commands[i].doc);
   }
   if (connected && mysql_get_server_version(&mysql) >= 40100)
-    put_info("\nFor server side help, type 'help contents'\n", INFO_INFO);
+    put_info("\nFor server side help, type 'help contents'\n", INFO_INFO,0,0);
   return 0;
 }
 
 
-	/* ARGSUSED */
 static int
-com_clear(String *buffer,char *line __attribute__((unused)))
+com_clear(GString *buffer,char *line __attribute__((unused)))
 {
-#ifdef HAVE_READLINE
   if (status.add_to_history)
     fix_history(buffer);
-#endif
-  buffer->length(0);
+  g_string_truncate(buffer, 0);
   return 0;
 }
 
-	/* ARGSUSED */
 static int
-com_charset(String *buffer __attribute__((unused)), char *line)
+com_charset(GString *buffer __attribute__((unused)), char *line)
 {
   char buff[256], *param;
   CHARSET_INFO * new_cs;
@@ -2698,8 +2675,8 @@
   param= get_arg(buff, 0);
   if (!param || !*param)
   {
-    return put_info("Usage: \\C char_setname | charset charset_name", 
-		    INFO_ERROR, 0);
+    return put_info("Usage: \\C char_setname | charset charset_name",
+                    INFO_ERROR, 0, 0);
   }
   new_cs= get_charset_by_csname(param, MY_CS_PRIMARY, MYF(MY_WME));
   if (new_cs)
@@ -2708,78 +2685,72 @@
     mysql_set_character_set(&mysql, charset_info->csname);
     default_charset= (char *)charset_info->csname;
     default_charset_used= 1;
-    put_info("Charset changed", INFO_INFO);
+    put_info("Charset changed", INFO_INFO,0,0);
   }
-  else put_info("Charset is not found", INFO_INFO);
+  else put_info("Charset is not found", INFO_INFO,0,0);
   return 0;
 }
 
 /*
   Execute command
   Returns: 0  if ok
-          -1 if not fatal error
-	  1  if fatal error
+  -1 if not fatal error
+  1  if fatal error
 */
-
-
 static int
-com_go(String *buffer,char *line __attribute__((unused)))
+com_go(GString *buffer,
+       char *line __attribute__((unused)))
 {
-  char		buff[200]; /* about 110 chars used so far */
-  char		time_buff[52+3+1]; /* time max + space&parens + NUL */
-  MYSQL_RES	*result;
-  ulong		timer, warnings= 0;
-  uint		error= 0;
+  char          buff[200]; /* about 110 chars used so far */
+  char          time_buff[52+3+1]; /* time max + space&parens + NUL */
+  MYSQL_RES     *result;
+  ulong         timer, warnings= 0;
+  uint          error= 0;
   int           err= 0;
 
   interrupted_query= 0;
-  if (!status.batch)
-  {
-    old_buffer= *buffer;			// Save for edit command
-    old_buffer.copy();
-  }
 
   /* Remove garbage for nicer messages */
-  remove_cntrl(*buffer);
+  remove_cntrl(buffer);
 
-  if (buffer->is_empty())
+  if (buffer->len == 0)
   {
-    if (status.batch)				// Ignore empty quries
+    // Ignore empty quries
+    if (status.batch)
       return 0;
-    return put_info("No query specified\n",INFO_ERROR);
+    return put_info("No query specified\n",INFO_ERROR,0,0);
 
   }
   if (!connected && reconnect())
   {
-    buffer->length(0);				// Remove query on error
+    // Remove query on error
+    g_string_truncate(buffer, 0);
     return opt_reconnect ? -1 : 1;          // Fatal error
   }
   if (verbose)
-    (void) com_print(buffer,0);
+    (void) com_print(buffer, 0);
 
   if (skip_updates &&
-      (buffer->length() < 4 || my_strnncoll(charset_info,
-					    (const uchar*)buffer->ptr(),4,
-					    (const uchar*)"SET ",4)))
+      ((buffer->len < 4)
+      || g_string_equal(g_string_new_len(buffer->str,4),
+                        g_string_new("SET "))))
   {
-    (void) put_info("Ignoring query to other database",INFO_INFO);
+    (void) put_info("Ignoring query to other database",INFO_INFO,0,0);
     return 0;
   }
 
   timer=start_timer();
   executing_query= 1;
-  error= mysql_real_query_for_lazy(buffer->ptr(),buffer->length());
+  error= mysql_real_query_for_lazy(buffer->str,buffer->len);
 
-#ifdef HAVE_READLINE
-  if (status.add_to_history) 
-  {  
-    buffer->append(vertical ? "\\G" : delimiter);
+  if (status.add_to_history)
+  {
+    g_string_append(buffer, vertical ? "\\G" : delimiter);
     /* Append final command onto history */
     fix_history(buffer);
   }
-#endif
 
-  buffer->length(0);
+  g_string_truncate(buffer, 0);
 
   if (error)
     goto end;
@@ -2813,9 +2784,9 @@
     {
       if (!mysql_num_rows(result) && ! quick && !column_types_flag)
       {
-	strmov(buff, "Empty set");
+        strmov(buff, "Empty set");
         if (opt_xml)
-        { 
+        {
           /*
             We must print XML header and footer
             to produce a well-formed XML even if
@@ -2828,21 +2799,21 @@
       }
       else
       {
-	init_pager();
-	if (opt_html)
-	  print_table_data_html(result);
-	else if (opt_xml)
-	  print_table_data_xml(result);
-  else if (vertical || (auto_vertical_output && (terminal_width < get_result_width(result))))
-	  print_table_data_vertically(result);
-	else if (opt_silent && verbose <= 2 && !output_tables)
-	  print_tab_data(result);
-	else
-	  print_table_data(result);
-	sprintf(buff,"%ld %s in set",
-		(long) mysql_num_rows(result),
-		(long) mysql_num_rows(result) == 1 ? "row" : "rows");
-	end_pager();
+        init_pager();
+        if (opt_html)
+          print_table_data_html(result);
+        else if (opt_xml)
+          print_table_data_xml(result);
+        else if (vertical || (auto_vertical_output && (terminal_width < get_result_width(result))))
+          print_table_data_vertically(result);
+        else if (opt_silent && verbose <= 2 && !output_tables)
+          print_tab_data(result);
+        else
+          print_table_data(result);
+        sprintf(buff,"%ld %s in set",
+                (long) mysql_num_rows(result),
+                (long) mysql_num_rows(result) == 1 ? "row" : "rows");
+        end_pager();
         if (mysql_errno(&mysql))
           error= put_error(&mysql);
       }
@@ -2851,8 +2822,8 @@
       strmov(buff,"Query OK");
     else
       sprintf(buff,"Query OK, %ld %s affected",
-	      (long) mysql_affected_rows(&mysql),
-	      (long) mysql_affected_rows(&mysql) == 1 ? "row" : "rows");
+              (long) mysql_affected_rows(&mysql),
+              (long) mysql_affected_rows(&mysql) == 1 ? "row" : "rows");
 
     pos=strend(buff);
     if ((warnings= mysql_warning_count(&mysql)))
@@ -2862,13 +2833,13 @@
       pos=int10_to_str(warnings, pos, 10);
       pos=strmov(pos, " warning");
       if (warnings != 1)
-	*pos++= 's';
+        *pos++= 's';
     }
     strmov(pos, time_buff);
-    put_info(buff,INFO_RESULT);
+    put_info(buff,INFO_RESULT,0,0);
     if (mysql_info(&mysql))
-      put_info(mysql_info(&mysql),INFO_RESULT);
-    put_info("",INFO_RESULT);			// Empty row
+      put_info(mysql_info(&mysql),INFO_RESULT,0,0);
+    put_info("",INFO_RESULT,0,0);			// Empty row
 
     if (result && !mysql_eof(result))	/* Something wrong when using quick */
       error= put_error(&mysql);
@@ -2881,11 +2852,11 @@
 
 end:
 
- /* Show warnings if any or error occured */
+  /* Show warnings if any or error occured */
   if (show_warnings == 1 && (warnings >= 1 || error))
     print_warnings();
 
-  if (!error && !status.batch && 
+  if (!error && !status.batch &&
       (mysql.server_status & SERVER_STATUS_DB_DROPPED))
     get_current_db();
 
@@ -2896,7 +2867,6 @@
 
 static void init_pager()
 {
-#ifdef USE_POPEN
   if (!opt_nopager)
   {
     if (!(PAGER= popen(pager, "w")))
@@ -2906,16 +2876,13 @@
     }
   }
   else
-#endif
     PAGER= stdout;
 }
 
 static void end_pager()
 {
-#ifdef USE_POPEN
   if (!opt_nopager)
     pclose(PAGER);
-#endif
 }
 
 
@@ -2947,7 +2914,7 @@
 
 
 static int
-com_ego(String *buffer,char *line)
+com_ego(GString *buffer,char *line)
 {
   int result;
   bool oldvertical=vertical;
@@ -2986,8 +2953,8 @@
   static char buf[1024];
   char *s=buf;
   *s=0;
-#define ff2s_check_flag(X) \
-                if (f & X ## _FLAG) { s=strmov(s, # X " "); f &= ~ X ## _FLAG; }
+#define ff2s_check_flag(X)                                              \
+  if (f & X ## _FLAG) { s=strmov(s, # X " "); f &= ~ X ## _FLAG; }
   ff2s_check_flag(NOT_NULL);
   ff2s_check_flag(PRI_KEY);
   ff2s_check_flag(UNIQUE_KEY);
@@ -3022,16 +2989,16 @@
   while ((field = mysql_fetch_field(result)))
   {
     tee_fprintf(PAGER, "Field %3u:  `%s`\n"
-                       "Catalog:    `%s`\n"
-                       "Database:   `%s`\n"
-                       "Table:      `%s`\n"
-                       "Org_table:  `%s`\n"
-                       "Type:       %s\n"
-                       "Collation:  %s (%u)\n"
-                       "Length:     %lu\n"
-                       "Max_length: %lu\n"
-                       "Decimals:   %u\n"
-                       "Flags:      %s\n\n",
+                "Catalog:    `%s`\n"
+                "Database:   `%s`\n"
+                "Table:      `%s`\n"
+                "Org_table:  `%s`\n"
+                "Type:       %s\n"
+                "Collation:  %s (%u)\n"
+                "Length:     %lu\n"
+                "Max_length: %lu\n"
+                "Decimals:   %u\n"
+                "Flags:      %s\n\n",
                 ++i,
                 field->name, field->catalog, field->db, field->table,
                 field->org_table, fieldtype2str(field->type),
@@ -3046,12 +3013,13 @@
 static void
 print_table_data(MYSQL_RES *result)
 {
-  String separator(256);
-  MYSQL_ROW	cur;
-  MYSQL_FIELD	*field;
-  bool		*num_flag;
+  GString       *separator = g_string_sized_new(256);
+  MYSQL_ROW     cur;
+  MYSQL_FIELD   *field;
+  bool          *num_flag;
 
-  num_flag=(bool*) my_alloca(sizeof(bool)*mysql_num_fields(result));
+  num_flag=(bool*) my_malloc(sizeof(bool)*mysql_num_fields(result),
+                             MYF(MY_WME));
   if (column_types_flag)
   {
     print_field_types(result);
@@ -3059,7 +3027,7 @@
       return;
     mysql_field_seek(result,0);
   }
-  separator.copy("+",1,charset_info);
+  separator = g_string_append_c(separator, '+');
   while ((field = mysql_fetch_field(result)))
   {
     uint length= column_names ? field->name_length : 0;
@@ -3068,13 +3036,19 @@
     else
       length=max(length,field->max_length);
     if (length < 4 && !IS_NOT_NULL(field->flags))
-      length=4;					// Room for "NULL"
+      // Room for "NULL"
+      length=4;
     field->max_length=length;
-    separator.fill(separator.length()+length+2,'-');
-    separator.append('+');
+    uint x;
+    for (x=0; x< (length+2); x++)
+      g_string_append_c(separator, '-');
+    g_string_append_c(separator, '+');
   }
-  separator.append('\0');                       // End marker for \0
-  tee_puts((char*) separator.ptr(), PAGER);
+  // End marker for \0
+  // TODO: Huh? Do we need this with GString?
+  g_string_append_c(separator, '\0');
+
+  tee_puts((char*) separator->str, PAGER);
   if (column_names)
   {
     mysql_field_seek(result,0);
@@ -3087,12 +3061,12 @@
                                                   field->name + name_length);
       uint display_length= field->max_length + name_length - numcells;
       tee_fprintf(PAGER, " %-*s |",(int) min(display_length,
-                                            MAX_COLUMN_LENGTH),
+                                             MAX_COLUMN_LENGTH),
                   field->name);
       num_flag[off]= IS_NUM(field->type);
     }
     (void) tee_fputs("\n", PAGER);
-    tee_puts((char*) separator.ptr(), PAGER);
+    tee_puts((char*) separator->str, PAGER);
   }
 
   while ((cur= mysql_fetch_row(result)))
@@ -3114,8 +3088,8 @@
       {
         buffer= "NULL";
         data_length= 4;
-      } 
-      else 
+      }
+      else
       {
         buffer= cur[off];
         data_length= (uint) lengths[off];
@@ -3124,13 +3098,13 @@
       field= mysql_fetch_field(result);
       field_max_length= field->max_length;
 
-      /* 
-       How many text cells on the screen will this string span?  If it contains
-       multibyte characters, then the number of characters we occupy on screen
-       will be fewer than the number of bytes we occupy in memory.
+      /*
+        How many text cells on the screen will this string span?  If it contains
+        multibyte characters, then the number of characters we occupy on screen
+        will be fewer than the number of bytes we occupy in memory.
 
-       We need to find how much screen real-estate we will occupy to know how 
-       many extra padding-characters we should send with the printing function.
+        We need to find how much screen real-estate we will occupy to know how
+        many extra padding-characters we should send with the printing function.
       */
       visible_length= charset_info->cset->numcells(charset_info, buffer, buffer + data_length);
       extra_padding= data_length - visible_length;
@@ -3141,32 +3115,33 @@
       {
         if (num_flag[off] != 0) /* if it is numeric, we right-justify it */
           tee_print_sized_data(buffer, data_length, field_max_length+extra_padding, TRUE);
-        else 
-          tee_print_sized_data(buffer, data_length, field_max_length+extra_padding, FALSE);
+        else
+          tee_print_sized_data(buffer, data_length,
+                               field_max_length+extra_padding, FALSE);
       }
       tee_fputs(" | ", PAGER);
     }
     (void) tee_fputs("\n", PAGER);
   }
-  tee_puts((char*) separator.ptr(), PAGER);
-  my_afree((uchar*) num_flag);
+  tee_puts(separator->str, PAGER);
+  my_free(num_flag, MYF(MY_ALLOW_ZERO_PTR));
 }
 
 /**
-  Return the length of a field after it would be rendered into text.
-
-  This doesn't know or care about multibyte characters.  Assume we're
-  using such a charset.  We can't know that all of the upcoming rows 
-  for this column will have bytes that each render into some fraction
-  of a character.  It's at least possible that a row has bytes that 
-  all render into one character each, and so the maximum length is 
-  still the number of bytes.  (Assumption 1:  This can't be better 
-  because we can never know the number of characters that the DB is 
-  going to send -- only the number of bytes.  2: Chars <= Bytes.)
-
-  @param  field  Pointer to a field to be inspected
-
-  @returns  number of character positions to be used, at most
+   Return the length of a field after it would be rendered into text.
+
+   This doesn't know or care about multibyte characters.  Assume we're
+   using such a charset.  We can't know that all of the upcoming rows
+   for this column will have bytes that each render into some fraction
+   of a character.  It's at least possible that a row has bytes that
+   all render into one character each, and so the maximum length is
+   still the number of bytes.  (Assumption 1:  This can't be better
+   because we can never know the number of characters that the DB is
+   going to send -- only the number of bytes.  2: Chars <= Bytes.)
+
+   @param  field  Pointer to a field to be inspected
+
+   @returns  number of character positions to be used, at most
 */
 static int get_field_disp_length(MYSQL_FIELD *field)
 {
@@ -3184,26 +3159,26 @@
 }
 
 /**
-  For a new result, return the max number of characters that any
-  upcoming row may return.
-
-  @param  result  Pointer to the result to judge
-
-  @returns  The max number of characters in any row of this result
+   For a new result, return the max number of characters that any
+   upcoming row may return.
+
+   @param  result  Pointer to the result to judge
+
+   @returns  The max number of characters in any row of this result
 */
 static int get_result_width(MYSQL_RES *result)
 {
   unsigned int len= 0;
   MYSQL_FIELD *field;
   MYSQL_FIELD_OFFSET offset;
-  
+
   offset= mysql_field_tell(result);
   assert(offset == 0);
 
   while ((field= mysql_fetch_field(result)) != NULL)
     len+= get_field_disp_length(field) + 3; /* plus bar, space, & final space */
 
-  (void) mysql_field_seek(result, offset);	
+  (void) mysql_field_seek(result, offset);
 
   return len + 1; /* plus final bar. */
 }
@@ -3211,15 +3186,15 @@
 static void
 tee_print_sized_data(const char *data, unsigned int data_length, unsigned int total_bytes_to_send, bool right_justified)
 {
-  /* 
+  /*
     For '\0's print ASCII spaces instead, as '\0' is eaten by (at
     least my) console driver, and that messes up the pretty table
-    grid.  (The \0 is also the reason we can't use fprintf() .) 
+    grid.  (The \0 is also the reason we can't use fprintf() .)
   */
   unsigned int i;
   const char *p;
 
-  if (right_justified) 
+  if (right_justified)
     for (i= data_length; i < total_bytes_to_send; i++)
       tee_putc((int)' ', PAGER);
 
@@ -3231,7 +3206,7 @@
       tee_putc((int)*p, PAGER);
   }
 
-  if (! right_justified) 
+  if (! right_justified)
     for (i= data_length; i < total_bytes_to_send; i++)
       tee_putc((int)' ', PAGER);
 }
@@ -3250,9 +3225,9 @@
   {
     while((field = mysql_fetch_field(result)))
     {
-      tee_fprintf(PAGER, "<TH>%s</TH>", (field->name ? 
-					 (field->name[0] ? field->name : 
-					  " &nbsp; ") : "NULL"));
+      tee_fprintf(PAGER, "<TH>%s</TH>", (field->name ?
+                                         (field->name[0] ? field->name :
+                                          " &nbsp; ") : "NULL"));
     }
     (void) tee_fputs("</TR>", PAGER);
   }
@@ -3260,7 +3235,7 @@
   {
     if (interrupted_query)
       break;
-    uint32_t *lengths= mysql_fetch_lengths(result);
+    uint32_t *lengths=mysql_fetch_lengths(result);
     (void) tee_fputs("<TR>", PAGER);
     for (uint32_t i= 0; i < mysql_num_fields(result); i++)
     {
@@ -3283,7 +3258,7 @@
   mysql_field_seek(result,0);
 
   tee_fputs("<?xml version=\"1.0\"?>\n\n<resultset statement=\"", PAGER);
-  xmlencode_print(glob_buffer.ptr(), (int)strlen(glob_buffer.ptr()));
+  xmlencode_print(glob_buffer->str, glob_buffer->len);
   tee_fputs("\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">",
             PAGER);
 
@@ -3292,7 +3267,7 @@
   {
     if (interrupted_query)
       break;
-    uint32_t *lengths= mysql_fetch_lengths(result);
+    uint32_t *lengths=mysql_fetch_lengths(result);
     (void) tee_fputs("\n  <row>\n", PAGER);
     for (uint i=0; i < mysql_num_fields(result); i++)
     {
@@ -3334,8 +3309,8 @@
     if (interrupted_query)
       break;
     mysql_field_seek(result,0);
-    tee_fprintf(PAGER, 
-		"*************************** %d. row ***************************\n", row_count);
+    tee_fprintf(PAGER,
+                "*************************** %d. row ***************************\n", row_count);
     for (uint off=0; off < mysql_num_fields(result); off++)
     {
       field= mysql_fetch_field(result);
@@ -3407,13 +3382,13 @@
     tee_fputs("NULL", PAGER);
   else
   {
-    for (const char *p = src; *p && length; *p++, length--)
+    for (const char *p = src; *p && length; length--)
     {
       const char *t;
-      if ((t = array_value(xmlmeta, *p)))
-	tee_fputs(t, PAGER);
+      if ((t = array_value(xmlmeta, *p++)))
+        tee_fputs(t, PAGER);
       else
-	tee_putc(*p, PAGER);
+        tee_putc(*p, PAGER);
     }
   }
 }
@@ -3429,29 +3404,29 @@
     if (opt_raw_data)
       tee_fputs(pos, PAGER);
     else for (const char *end=pos+length ; pos != end ; pos++)
-    {
+         {
 #ifdef USE_MB
-      int l;
-      if (use_mb(charset_info) &&
-          (l = my_ismbchar(charset_info, pos, end)))
-      {
-	  while (l--)
-	    tee_putc(*pos++, PAGER);
-	  pos--;
-	  continue;
-      }
+           int l;
+           if (use_mb(charset_info) &&
+               (l = my_ismbchar(charset_info, pos, end)))
+           {
+             while (l--)
+               tee_putc(*pos++, PAGER);
+             pos--;
+             continue;
+           }
 #endif
-      if (!*pos)
-	tee_fputs("\\0", PAGER); // This makes everything hard
-      else if (*pos == '\t')
-	tee_fputs("\\t", PAGER); // This would destroy tab format
-      else if (*pos == '\n')
-	tee_fputs("\\n", PAGER); // This too
-      else if (*pos == '\\')
-	tee_fputs("\\\\", PAGER);
-	else
-	tee_putc(*pos, PAGER);
-    }
+           if (!*pos)
+             tee_fputs("\\0", PAGER); // This makes everything hard
+           else if (*pos == '\t')
+             tee_fputs("\\t", PAGER); // This would destroy tab format
+           else if (*pos == '\n')
+             tee_fputs("\\n", PAGER); // This too
+           else if (*pos == '\\')
+             tee_fputs("\\\\", PAGER);
+           else
+             tee_putc(*pos, PAGER);
+         }
   }
 }
 
@@ -3469,7 +3444,7 @@
     while ((field = mysql_fetch_field(result)))
     {
       if (first++)
-	(void) tee_fputs("\t", PAGER);
+        (void) tee_fputs("\t", PAGER);
       (void) tee_fputs(field->name, PAGER);
     }
     (void) tee_fputs("\n", PAGER);
@@ -3488,7 +3463,7 @@
 }
 
 static int
-com_tee(String *buffer __attribute__((__unused__)), char *line )
+com_tee(GString *buffer __attribute__((__unused__)), char *line )
 {
   char file_name[FN_REFLEN], *end, *param;
 
@@ -3517,8 +3492,8 @@
     param++;
   end= strmake(file_name, param, sizeof(file_name) - 1);
   /* remove end space from command line */
-  while (end > file_name && (my_isspace(charset_info,end[-1]) || 
-			     my_iscntrl(charset_info,end[-1])))
+  while (end > file_name && (my_isspace(charset_info,end[-1]) ||
+                             my_iscntrl(charset_info,end[-1])))
     end--;
   end[0]= 0;
   if (end == file_name)
@@ -3532,8 +3507,8 @@
 
 
 static int
-com_notee(String *buffer __attribute__((unused)),
-	  char *line __attribute__((unused)))
+com_notee(GString *buffer __attribute__((unused)),
+          char *line __attribute__((unused)))
 {
   if (opt_outfile)
     end_tee();
@@ -3545,9 +3520,9 @@
   Sorry, this command is not available in Windows.
 */
 
-#ifdef USE_POPEN
 static int
-com_pager(String *buffer, char *line __attribute__((unused)))
+com_pager(GString *buffer __attribute__((__unused__)),
+          char *line __attribute__((unused)))
 {
   char pager_name[FN_REFLEN], *end, *param;
 
@@ -3576,7 +3551,7 @@
   else
   {
     end= strmake(pager_name, param, sizeof(pager_name)-1);
-    while (end > pager_name && (my_isspace(charset_info,end[-1]) || 
+    while (end > pager_name && (my_isspace(charset_info,end[-1]) ||
                                 my_iscntrl(charset_info,end[-1])))
       end--;
     end[0]=0;
@@ -3590,8 +3565,8 @@
 
 
 static int
-com_nopager(String *buffer __attribute__((unused)),
-	    char *line __attribute__((unused)))
+com_nopager(GString *buffer __attribute__((unused)),
+            char *line __attribute__((unused)))
 {
   strmov(pager, "stdout");
   opt_nopager=1;
@@ -3599,60 +3574,12 @@
   tee_fprintf(stdout, "PAGER set to stdout\n");
   return 0;
 }
-#endif
-
-
-/*
-  Sorry, you can't send the result to an editor in Win32
-*/
-
-#ifdef USE_POPEN
-static int
-com_edit(String *buffer,char *line __attribute__((unused)))
-{
-  char	filename[FN_REFLEN],buff[160];
-  int	fd,tmp;
-  const char *editor;
-
-  if ((fd=create_temp_file(filename,NullS,"sql", O_CREAT | O_WRONLY,
-			   MYF(MY_WME))) < 0)
-    goto err;
-  if (buffer->is_empty() && !old_buffer.is_empty())
-    (void) my_write(fd,(uchar*) old_buffer.ptr(),old_buffer.length(),
-		    MYF(MY_WME));
-  else
-    (void) my_write(fd,(uchar*) buffer->ptr(),buffer->length(),MYF(MY_WME));
-  (void) my_close(fd,MYF(0));
-
-  if (!(editor = (char *)getenv("EDITOR")) &&
-      !(editor = (char *)getenv("VISUAL")))
-    editor = "vi";
-  strxmov(buff,editor," ",filename,NullS);
-  (void) system(buff);
-
-  struct stat stat_arg;
-  if (stat(filename,&stat_arg))
-    goto err;
-  if ((fd = my_open(filename,O_RDONLY, MYF(MY_WME))) < 0)
-    goto err;
-  (void) buffer->alloc((uint) stat_arg.st_size);
-  if ((tmp=read(fd,(char*) buffer->ptr(),buffer->alloced_length())) >= 0L)
-    buffer->length((uint) tmp);
-  else
-    buffer->length(0);
-  (void) my_close(fd,MYF(0));
-  (void) my_delete(filename,MYF(MY_WME));
-err:
-  return 0;
-}
-#endif
-
 
 /* If arg is given, exit without errors. This happens on command 'quit' */
 
 static int
-com_quit(String *buffer __attribute__((unused)),
-	 char *line __attribute__((unused)))
+com_quit(GString *buffer __attribute__((unused)),
+         char *line __attribute__((unused)))
 {
   /* let the screen auto close on a normal shutdown */
   status.exit_status=0;
@@ -3660,58 +3587,31 @@
 }
 
 static int
-com_rehash(String *buffer __attribute__((unused)),
-	 char *line __attribute__((unused)))
+com_rehash(GString *buffer __attribute__((unused)),
+           char *line __attribute__((unused)))
 {
-#ifdef HAVE_READLINE
   build_completion_hash(1, 0);
-#endif
-  return 0;
-}
-
-
-#ifdef USE_POPEN
-static int
-com_shell(String *buffer, char *line __attribute__((unused)))
-{
-  char *shell_cmd;
-
-  /* Skip space from line begin */
-  while (my_isspace(charset_info, *line))
-    line++;
-  if (!(shell_cmd = strchr(line, ' ')))
-  {
-    put_info("Usage: \\! shell-command", INFO_ERROR);
-    return -1;
-  }
-  /*
-    The output of the shell command does not
-    get directed to the pager or the outfile
-  */
-  if (system(shell_cmd) == -1)
-  {
-    put_info(strerror(errno), INFO_ERROR, errno);
-    return -1;
-  }
-  return 0;
-}
-#endif
-
-
-static int
-com_print(String *buffer,char *line __attribute__((unused)))
+  return 0;
+}
+
+
+
+static int
+com_print(GString *buffer,char *line __attribute__((unused)))
 {
   tee_puts("--------------", stdout);
-  (void) tee_fputs(buffer->c_ptr(), stdout);
-  if (!buffer->length() || (*buffer)[buffer->length()-1] != '\n')
+  (void) tee_fputs(buffer->str, stdout);
+  if ( (buffer->len == 0)
+       || (buffer->str)[(buffer->len)-1] != '\n')
     tee_putc('\n', stdout);
   tee_puts("--------------\n", stdout);
-  return 0;					/* If empty buffer */
+  /* If empty buffer */
+  return 0;
 }
 
-	/* ARGSUSED */
+/* ARGSUSED */
 static int
-com_connect(String *buffer, char *line)
+com_connect(GString *buffer, char *line)
 {
   char *tmp, buff[256];
   bool save_rehash= opt_rehash;
@@ -3732,12 +3632,12 @@
     if (tmp && *tmp)
     {
       my_free(current_db, MYF(MY_ALLOW_ZERO_PTR));
-      current_db= my_strdup(tmp, MYF(MY_WME));
+      current_db= g_strdup(tmp);
       tmp= get_arg(buff, 1);
       if (tmp)
       {
-	my_free(current_host,MYF(MY_ALLOW_ZERO_PTR));
-	current_host=my_strdup(tmp,MYF(MY_WME));
+        my_free(current_host,MYF(MY_ALLOW_ZERO_PTR));
+        current_host=g_strdup(tmp);
       }
     }
     else
@@ -3745,7 +3645,9 @@
       /* Quick re-connect */
       opt_rehash= 0;                            /* purecov: tested */
     }
-    buffer->length(0);				// command used
+    // command used
+    assert(buffer!=NULL);
+    g_string_truncate(buffer, 0);
   }
   else
     opt_rehash= 0;
@@ -3755,16 +3657,16 @@
   if (connected)
   {
     sprintf(buff,"Connection id:    %u",mysql_thread_id(&mysql));
-    put_info(buff,INFO_INFO);
+    put_info(buff,INFO_INFO,0,0);
     sprintf(buff,"Current database: %.128s\n",
-	    current_db ? current_db : "*** NONE ***");
-    put_info(buff,INFO_INFO);
+            current_db ? current_db : "*** NONE ***");
+    put_info(buff,INFO_INFO,0,0);
   }
   return error;
 }
 
 
-static int com_source(String *buffer __attribute__((__unused__)), char *line)
+static int com_source(GString *buffer __attribute__((__unused__)), char *line)
 {
   char source_name[FN_REFLEN], *end, *param;
   LINE_BUFFER *line_buff;
@@ -3776,12 +3678,12 @@
   while (my_isspace(charset_info,*line))
     line++;
   if (!(param = strchr(line, ' ')))		// Skip command name
-    return put_info("Usage: \\. <filename> | source <filename>", 
-		    INFO_ERROR, 0);
+    return put_info("Usage: \\. <filename> | source <filename>",
+                    INFO_ERROR, 0,0);
   while (my_isspace(charset_info,*param))
     param++;
   end=strmake(source_name,param,sizeof(source_name)-1);
-  while (end > source_name && (my_isspace(charset_info,end[-1]) || 
+  while (end > source_name && (my_isspace(charset_info,end[-1]) ||
                                my_iscntrl(charset_info,end[-1])))
     end--;
   end[0]=0;
@@ -3791,34 +3693,38 @@
   {
     char buff[FN_REFLEN+60];
     sprintf(buff,"Failed to open file '%s', error: %d", source_name,errno);
-    return put_info(buff, INFO_ERROR, 0);
+    return put_info(buff, INFO_ERROR, 0 ,0);
   }
 
   if (!(line_buff=batch_readline_init(opt_max_allowed_packet+512,sql_file)))
   {
     my_fclose(sql_file,MYF(0));
-    return put_info("Can't initialize batch_readline", INFO_ERROR, 0);
+    return put_info("Can't initialize batch_readline", INFO_ERROR, 0 ,0);
   }
 
   /* Save old status */
   old_status=status;
   bfill((char*) &status,sizeof(status),(char) 0);
 
-  status.batch=old_status.batch;		// Run in batch mode
+  // Run in batch mode
+  status.batch=old_status.batch;
   status.line_buff=line_buff;
   status.file_name=source_name;
-  glob_buffer.length(0);			// Empty command buffer
+  // Empty command buffer
+  assert(glob_buffer!=NULL);
+  g_string_truncate(glob_buffer, 0);
   error= read_and_execute(false);
-  status=old_status;				// Continue as before
+  // Continue as before
+  status=old_status;
   my_fclose(sql_file,MYF(0));
   batch_readline_end(line_buff);
   return error;
 }
 
 
-	/* ARGSUSED */
+/* ARGSUSED */
 static int
-com_delimiter(String *buffer __attribute__((unused)), char *line)
+com_delimiter(GString *buffer __attribute__((unused)), char *line)
 {
   char buff[256], *tmp;
 
@@ -3828,14 +3734,15 @@
   if (!tmp || !*tmp)
   {
     put_info("DELIMITER must be followed by a 'delimiter' character or string",
-	     INFO_ERROR);
+             INFO_ERROR, 0, 0);
     return 0;
   }
   else
   {
-    if (strstr(tmp, "\\")) 
+    if (strstr(tmp, "\\"))
     {
-      put_info("DELIMITER cannot contain a backslash character", INFO_ERROR);
+      put_info("DELIMITER cannot contain a backslash character",
+               INFO_ERROR, 0, 0);
       return 0;
     }
   }
@@ -3845,9 +3752,9 @@
   return 0;
 }
 
-	/* ARGSUSED */
+/* ARGSUSED */
 static int
-com_use(String *buffer __attribute__((unused)), char *line)
+com_use(GString *buffer __attribute__((unused)), char *line)
 {
   char *tmp, buff[FN_REFLEN + 1];
   int select_db;
@@ -3857,7 +3764,7 @@
   tmp= get_arg(buff, 0);
   if (!tmp || !*tmp)
   {
-    put_info("USE must be followed by a database name", INFO_ERROR);
+    put_info("USE must be followed by a database name", INFO_ERROR, 0, 0);
     return 0;
   }
   /*
@@ -3909,32 +3816,30 @@
         return put_error(&mysql);
     }
     my_free(current_db,MYF(MY_ALLOW_ZERO_PTR));
-    current_db=my_strdup(tmp,MYF(MY_WME));
-#ifdef HAVE_READLINE
+    current_db=g_strdup(tmp);
     if (select_db > 1)
       build_completion_hash(opt_rehash, 1);
-#endif
   }
 
-  put_info("Database changed",INFO_INFO);
+  put_info("Database changed",INFO_INFO, 0, 0);
   return 0;
 }
 
 static int
-com_warnings(String *buffer __attribute__((unused)),
-   char *line __attribute__((unused)))
+com_warnings(GString *buffer __attribute__((unused)),
+             char *line __attribute__((unused)))
 {
   show_warnings = 1;
-  put_info("Show warnings enabled.",INFO_INFO);
+  put_info("Show warnings enabled.",INFO_INFO, 0, 0);
   return 0;
 }
 
 static int
-com_nowarnings(String *buffer __attribute__((unused)),
-   char *line __attribute__((unused)))
+com_nowarnings(GString *buffer __attribute__((unused)),
+               char *line __attribute__((unused)))
 {
   show_warnings = 0;
-  put_info("Show warnings disabled.",INFO_INFO);
+  put_info("Show warnings disabled.",INFO_INFO, 0, 0);
   return 0;
 }
 
@@ -4002,7 +3907,7 @@
 
 static int
 sql_real_connect(char *host,char *database,char *user,char *password,
-		 uint silent)
+                 uint silent)
 {
   if (connected)
   {
@@ -4014,7 +3919,7 @@
   {
     uint timeout=opt_connect_timeout;
     mysql_options(&mysql,MYSQL_OPT_CONNECT_TIMEOUT,
-		  (char*) &timeout);
+                  (char*) &timeout);
   }
   if (opt_compress)
     mysql_options(&mysql,MYSQL_OPT_COMPRESS,NullS);
@@ -4028,20 +3933,20 @@
   {
     char init_command[100];
     sprintf(init_command,
-	    "SET SQL_SAFE_UPDATES=1,SQL_SELECT_LIMIT=%"PRIu32
+	          "SET SQL_SAFE_UPDATES=1,SQL_SELECT_LIMIT=%"PRIu32
             ",SQL_MAX_JOIN_SIZE=%"PRIu32,
-	    select_limit, max_join_size);
+	          select_limit, max_join_size);
     mysql_options(&mysql, MYSQL_INIT_COMMAND, init_command);
   }
   if (default_charset_used)
     mysql_options(&mysql, MYSQL_SET_CHARSET_NAME, default_charset);
   if (!mysql_real_connect(&mysql, host, user, password,
-			  database, opt_mysql_port, opt_mysql_unix_port,
-			  connect_flag | CLIENT_MULTI_STATEMENTS))
+                          database, opt_mysql_port, opt_mysql_unix_port,
+                          connect_flag | CLIENT_MULTI_STATEMENTS))
   {
     if (!silent ||
-	(mysql_errno(&mysql) != CR_CONN_HOST_ERROR &&
-	 mysql_errno(&mysql) != CR_CONNECTION_ERROR))
+        (mysql_errno(&mysql) != CR_CONN_HOST_ERROR &&
+         mysql_errno(&mysql) != CR_CONNECTION_ERROR))
     {
       (void) put_error(&mysql);
       (void) fflush(stdout);
@@ -4050,14 +3955,8 @@
     return -1;					// Retryable
   }
   connected=1;
-#ifndef EMBEDDED_LIBRARY
   mysql.reconnect= debug_info_flag; // We want to know if this happens
-#else
-  mysql.reconnect= 1;
-#endif
-#ifdef HAVE_READLINE
   build_completion_hash(opt_rehash, 1);
-#endif
   return 0;
 }
 
@@ -4074,8 +3973,8 @@
     {
       if (count)
       {
-	tee_fputs("\n", stderr);
-	(void) fflush(stderr);
+        tee_fputs("\n", stderr);
+        (void) fflush(stderr);
       }
       return error;
     }
@@ -4098,8 +3997,8 @@
 
 
 static int
-com_status(String *buffer __attribute__((unused)),
-	   char *line __attribute__((unused)))
+com_status(GString *buffer __attribute__((unused)),
+           char *line __attribute__((unused)))
 {
   const char *status_str;
   char buff[40];
@@ -4111,12 +4010,12 @@
   if (connected)
   {
     tee_fprintf(stdout, "\nConnection id:\t\t%lu\n",mysql_thread_id(&mysql));
-    /* 
-      Don't remove "limit 1", 
+    /*
+      Don't remove "limit 1",
       it is protection againts SQL_SELECT_LIMIT=0
     */
     if (!mysql_query(&mysql,"select DATABASE(), USER() limit 1") &&
-	(result=mysql_use_result(&mysql)))
+        (result=mysql_use_result(&mysql)))
     {
       MYSQL_ROW cur=mysql_fetch_row(result);
       if (cur)
@@ -4125,8 +4024,8 @@
         tee_fprintf(stdout, "Current user:\t\t%s\n", cur[1]);
       }
       mysql_free_result(result);
-    } 
-      tee_puts("SSL:\t\t\tNot in use", stdout);
+    }
+    tee_puts("SSL:\t\t\tNot in use", stdout);
   }
   else
   {
@@ -4141,10 +4040,8 @@
     tee_fprintf(stdout, "\nAll updates ignored to this database\n");
     vidattr(A_NORMAL);
   }
-#ifdef USE_POPEN
   tee_fprintf(stdout, "Current pager:\t\t%s\n", pager);
   tee_fprintf(stdout, "Using outfile:\t\t'%s'\n", opt_outfile ? outfile : "");
-#endif
   tee_fprintf(stdout, "Using delimiter:\t%s\n", delimiter);
   tee_fprintf(stdout, "Server version:\t\t%s\n", server_version_string(&mysql));
   tee_fprintf(stdout, "Protocol version:\t%d\n", mysql_get_proto_info(&mysql));
@@ -4205,10 +4102,10 @@
     vidattr(A_NORMAL);
     tee_fprintf(stdout, "\
 UPDATEs and DELETEs that don't use a key in the WHERE clause are not allowed.\n\
-(One can force an UPDATE/DELETE by adding LIMIT # at the end of the command.)\n\
-SELECT has an automatic 'LIMIT %lu' if LIMIT is not used.\n\
+(One can force an UPDATE/DELETE by adding LIMIT # at the end of the command.)\n \
+SELECT has an automatic 'LIMIT %lu' if LIMIT is not used.\n             \
 Max number of examined row combination in a join is set to: %lu\n\n",
-select_limit, max_join_size);
+                select_limit, max_join_size);
   }
   tee_puts("--------------\n", stdout);
   return 0;
@@ -4261,21 +4158,21 @@
       fprintf(file,"ERROR");
       if (error)
       {
-	if (sqlstate)
-	  (void) fprintf(file," %d (%s)",error, sqlstate);
+        if (sqlstate)
+          (void) fprintf(file," %d (%s)",error, sqlstate);
         else
-	  (void) fprintf(file," %d",error);
+          (void) fprintf(file," %d",error);
       }
       if (status.query_start_line && line_numbers)
       {
-	(void) fprintf(file," at line %"PRIu32,status.query_start_line);
-	if (status.file_name)
-	  (void) fprintf(file," in file: '%s'", status.file_name);
+        (void) fprintf(file," at line %"PRIu32,status.query_start_line);
+        if (status.file_name)
+          (void) fprintf(file," in file: '%s'", status.file_name);
       }
       (void) fprintf(file,": %s\n",str);
       (void) fflush(file);
       if (!ignore_errors)
-	return 1;
+        return 1;
     }
     else if (info_type == INFO_RESULT && verbose > 1)
       tee_puts(str, file);
@@ -4295,11 +4192,12 @@
     if (info_type == INFO_ERROR)
     {
       if (!opt_nobeep)
-        putchar('\a');		      	/* This should make a bell */
+        /* This should make a bell */
+        putchar('\a');
       vidattr(A_STANDOUT);
       if (error)
       {
-	if (sqlstate)
+        if (sqlstate)
           (void) tee_fprintf(file, "ERROR %d (%s): ", error, sqlstate);
         else
           (void) tee_fprintf(file, "ERROR %d: ", error);
@@ -4322,17 +4220,19 @@
 put_error(MYSQL *con)
 {
   return put_info(mysql_error(con), INFO_ERROR, mysql_errno(con),
-		  mysql_sqlstate(con));
-}  
-
-
-static void remove_cntrl(String &buffer)
+                  mysql_sqlstate(con));
+}
+
+
+static void remove_cntrl(GString *buffer)
 {
-  char *start,*end;
-  end=(start=(char*) buffer.ptr())+buffer.length();
+  char *start=  buffer->str;
+  char *end= start + (buffer->len);
   while (start < end && !my_isgraph(charset_info,end[-1]))
     end--;
-  buffer.length((uint) (end-start));
+  uint chars_to_truncate = end-start;
+  if (buffer->len > chars_to_truncate)
+    g_string_truncate(buffer, chars_to_truncate);
 }
 
 
@@ -4392,10 +4292,10 @@
 }
 
 
-/** 
-  Write as many as 52+1 bytes to buff, in the form of a legible duration of time.
+/**
+   Write as many as 52+1 bytes to buff, in the form of a legible duration of time.
 
-  len("4294967296 days, 23 hours, 59 minutes, 60.00 seconds")  ->  52
+   len("4294967296 days, 23 hours, 59 minutes, 60.00 seconds")  ->  52
 */
 static void nice_time(double sec,char *buff,bool part_second)
 {
@@ -4431,7 +4331,7 @@
 static void end_timer(ulong start_time,char *buff)
 {
   nice_time((double) (start_timer() - start_time) /
-	    CLOCKS_PER_SEC,buff,1);
+            CLOCKS_PER_SEC,buff,1);
 }
 
 
@@ -4443,168 +4343,174 @@
   strmov(strend(buff),")");
 }
 
-static const char* construct_prompt()
+static const char * construct_prompt()
 {
-  processed_prompt.free();			// Erase the old prompt
-  time_t  lclock = time(NULL);			// Get the date struct
+  // Erase the old prompt
+  assert(processed_prompt!=NULL);
+  g_string_truncate(processed_prompt, 0);
+
+  // Get the date struct
+  time_t  lclock = time(NULL);
   struct tm *t = localtime(&lclock);
 
   /* parse thru the settings for the prompt */
-  for (char *c = current_prompt; *c ; *c++)
+  for (char *c= current_prompt; *c; (void)*c++)
   {
     if (*c != PROMPT_CHAR)
-	processed_prompt.append(*c);
+    {
+      g_string_append_c(processed_prompt, c[0]);
+    }
     else
     {
+      int getHour;
+      int getYear;
+      char* dateTime= NULL;
       switch (*++c) {
       case '\0':
-	c--;			// stop it from going beyond if ends with %
-	break;
+        // stop it from going beyond if ends with %
+        c--;
+        break;
       case 'c':
-	add_int_to_prompt(++prompt_counter);
-	break;
+        add_int_to_prompt(++prompt_counter);
+        break;
       case 'v':
-	if (connected)
-	  processed_prompt.append(mysql_get_server_info(&mysql));
-	else
-	  processed_prompt.append("not_connected");
-	break;
+        if (connected)
+          g_string_append(processed_prompt, mysql_get_server_info(&mysql));
+        else
+          g_string_append(processed_prompt, "not_connected");
+        break;
       case 'd':
-	processed_prompt.append(current_db ? current_db : "(none)");
-	break;
+        g_string_append(processed_prompt, current_db ? current_db : "(none)");
+        break;
       case 'h':
       {
-	const char *prompt;
-	prompt= connected ? mysql_get_host_info(&mysql) : "not_connected";
-	if (strstr(prompt, "Localhost"))
-	  processed_prompt.append("localhost");
-	else
-	{
-	  const char *end=strcend(prompt,' ');
-	  processed_prompt.append(prompt, (uint) (end-prompt));
-	}
-	break;
+        const char *prompt;
+        prompt= connected ? mysql_get_host_info(&mysql) : "not_connected";
+        if (strstr(prompt, "Localhost"))
+          g_string_append(processed_prompt, "localhost");
+        else
+        {
+          const char *end=strcend(prompt,' ');
+          g_string_append_len(processed_prompt, prompt, (gssize) (end-prompt));
+        }
+        break;
       }
       case 'p':
       {
-#ifndef EMBEDDED_LIBRARY
-	if (!connected)
-	{
-	  processed_prompt.append("not_connected");
-	  break;
-	}
+        if (!connected)
+        {
+          g_string_append(processed_prompt, "not_connected");
+          break;
+        }
 
-	const char *host_info = mysql_get_host_info(&mysql);
-	if (strstr(host_info, "memory")) 
-	{
-		processed_prompt.append( mysql.host );
-	}
-	else if (strstr(host_info,"TCP/IP") ||
-	    !mysql.unix_socket)
-	  add_int_to_prompt(mysql.port);
-	else
-	{
-	  char *pos=strrchr(mysql.unix_socket,'/');
- 	  processed_prompt.append(pos ? pos+1 : mysql.unix_socket);
-	}
-#endif
+        const char *host_info = mysql_get_host_info(&mysql);
+        if (strstr(host_info, "memory"))
+        {
+          g_string_append(processed_prompt, mysql.host );
+        }
+        else if (strstr(host_info,"TCP/IP") ||
+                 !mysql.unix_socket)
+          add_int_to_prompt(mysql.port);
+        else
+        {
+          char *pos=strrchr(mysql.unix_socket,'/');
+          g_string_append(processed_prompt, pos ? pos+1 : mysql.unix_socket);
+        }
       }
-	break;
+      break;
       case 'U':
-	if (!full_username)
-	  init_username();
-        processed_prompt.append(full_username ? full_username :
-                                (current_user ?  current_user : "(unknown)"));
-	break;
+        if (!full_username)
+          init_username();
+        g_string_append(processed_prompt, full_username ? full_username :
+                        (current_user ?  current_user : "(unknown)"));
+        break;
       case 'u':
-	if (!full_username)
-	  init_username();
-        processed_prompt.append(part_username ? part_username :
-                                (current_user ?  current_user : "(unknown)"));
-	break;
+        if (!full_username)
+          init_username();
+        g_string_append(processed_prompt, part_username ? part_username :
+                        (current_user ?  current_user : "(unknown)"));
+        break;
       case PROMPT_CHAR:
-	processed_prompt.append(PROMPT_CHAR);
-	break;
+        g_string_append_c(processed_prompt, PROMPT_CHAR);
+        break;
       case 'n':
-	processed_prompt.append('\n');
-	break;
+        g_string_append_c(processed_prompt, '\n');
+        break;
       case ' ':
       case '_':
-	processed_prompt.append(' ');
-	break;
+        g_string_append_c(processed_prompt, ' ');
+        break;
       case 'R':
-	if (t->tm_hour < 10)
-	  processed_prompt.append('0');
-	add_int_to_prompt(t->tm_hour);
-	break;
+        if (t->tm_hour < 10)
+          g_string_append_c(processed_prompt, '0');
+        add_int_to_prompt(t->tm_hour);
+        break;
       case 'r':
-	int getHour;
-	getHour = t->tm_hour % 12;
-	if (getHour == 0)
-	  getHour=12;
-	if (getHour < 10)
-	  processed_prompt.append('0');
-	add_int_to_prompt(getHour);
-	break;
+        getHour = t->tm_hour % 12;
+        if (getHour == 0)
+          getHour=12;
+        if (getHour < 10)
+          g_string_append_c(processed_prompt, '0');
+        add_int_to_prompt(getHour);
+        break;
       case 'm':
-	if (t->tm_min < 10)
-	  processed_prompt.append('0');
-	add_int_to_prompt(t->tm_min);
-	break;
+        if (t->tm_min < 10)
+          g_string_append_c(processed_prompt, '0');
+        add_int_to_prompt(t->tm_min);
+        break;
       case 'y':
-	int getYear;
-	getYear = t->tm_year % 100;
-	if (getYear < 10)
-	  processed_prompt.append('0');
-	add_int_to_prompt(getYear);
-	break;
+        getYear = t->tm_year % 100;
+        if (getYear < 10)
+          g_string_append_c(processed_prompt, '0');
+        add_int_to_prompt(getYear);
+        break;
       case 'Y':
-	add_int_to_prompt(t->tm_year+1900);
-	break;
+        add_int_to_prompt(t->tm_year+1900);
+        break;
       case 'D':
-	char* dateTime;
-	dateTime = ctime(&lclock);
-	processed_prompt.append(strtok(dateTime,"\n"));
-	break;
+        dateTime = ctime(&lclock);
+        g_string_append(processed_prompt, strtok(dateTime,"\n"));
+        break;
       case 's':
-	if (t->tm_sec < 10)
-	  processed_prompt.append('0');
-	add_int_to_prompt(t->tm_sec);
-	break;
+        if (t->tm_sec < 10)
+          g_string_append_c(processed_prompt, '0');
+        add_int_to_prompt(t->tm_sec);
+        break;
       case 'w':
-	processed_prompt.append(day_names[t->tm_wday]);
-	break;
+        g_string_append(processed_prompt, (day_names[t->tm_wday]));
+        break;
       case 'P':
-	processed_prompt.append(t->tm_hour < 12 ? "am" : "pm");
-	break;
+        g_string_append(processed_prompt, t->tm_hour < 12 ? "am" : "pm");
+        break;
       case 'o':
-	add_int_to_prompt(t->tm_mon+1);
-	break;
+        add_int_to_prompt(t->tm_mon+1);
+        break;
       case 'O':
-	processed_prompt.append(month_names[t->tm_mon]);
-	break;
+        g_string_append(processed_prompt, month_names[t->tm_mon]);
+        break;
       case '\'':
-	processed_prompt.append("'");
-	break;
+        g_string_append(processed_prompt, "'");
+        break;
       case '"':
-	processed_prompt.append('"');
-	break;
+        g_string_append_c(processed_prompt, '"');
+        break;
       case 'S':
-	processed_prompt.append(';');
-	break;
+        g_string_append_c(processed_prompt, ';');
+        break;
       case 't':
-	processed_prompt.append('\t');
-	break;
+        g_string_append_c(processed_prompt, '\t');
+        break;
       case 'l':
-	processed_prompt.append(delimiter_str);
-	break;
+        g_string_append(processed_prompt, delimiter_str);
+        break;
       default:
-	processed_prompt.append(c);
+        g_string_append(processed_prompt, c);
       }
     }
   }
-  processed_prompt.append('\0');
-  return processed_prompt.ptr();
+  // TODO: Is this needed with GString?
+  g_string_append_c(processed_prompt, '\0');
+  return processed_prompt->str;
 }
 
 
@@ -4612,7 +4518,7 @@
 {
   char buffer[16];
   int10_to_str(toadd,buffer,10);
-  processed_prompt.append(buffer);
+  g_string_append(processed_prompt, buffer);
 }
 
 static void init_username()
@@ -4625,35 +4531,22 @@
       (result=mysql_use_result(&mysql)))
   {
     MYSQL_ROW cur=mysql_fetch_row(result);
-    full_username=my_strdup(cur[0],MYF(MY_WME));
-    part_username=my_strdup(strtok(cur[0],"@"),MYF(MY_WME));
+    full_username=g_strdup(cur[0]);
+    part_username=g_strdup(strtok(cur[0],"@"));
     (void) mysql_fetch_row(result);		// Read eof
   }
 }
 
-static int com_prompt(String *buffer __attribute__((__unused__)), char *line)
+static int com_prompt(GString *buffer __attribute__((__unused__)), char *line)
 {
   char *ptr=strchr(line, ' ');
   prompt_counter = 0;
   my_free(current_prompt,MYF(MY_ALLOW_ZERO_PTR));
-  current_prompt=my_strdup(ptr ? ptr+1 : default_prompt,MYF(MY_WME));
+  current_prompt=g_strdup(ptr ? ptr+1 : default_prompt->str);
   if (!ptr)
-    tee_fprintf(stdout, "Returning to default PROMPT of %s\n", default_prompt);
+    tee_fprintf(stdout, "Returning to default PROMPT of %s\n",
+                default_prompt->str);
   else
     tee_fprintf(stdout, "PROMPT set to '%s'\n", current_prompt);
   return 0;
 }
-
-#ifndef EMBEDDED_LIBRARY
-/* Keep sql_string library happy */
-
-void *sql_alloc(size_t Size)
-{
-  return my_malloc(Size,MYF(MY_WME));
-}
-
-void sql_element_free(void *ptr)
-{
-  my_free(ptr,MYF(0));
-}
-#endif /* EMBEDDED_LIBRARY */

=== renamed file 'client/mysqladmin.cc' => 'client/drizzleadmin.cc'
=== renamed file 'client/mysqlbinlog.cc' => 'client/drizzlebinlog.cc'
--- client/mysqlbinlog.cc	2008-07-15 15:58:19 +0000
+++ client/drizzlebinlog.cc	2008-07-16 19:46:20 +0000
@@ -30,14 +30,28 @@
 
 #define MYSQL_CLIENT
 #undef MYSQL_SERVER
+#include <my_time.h>
 #include <my_global.h>
-#include "client_priv.h"
-#include <my_time.h>
+#include <my_sys.h>
+#include <m_string.h>
+#include <drizzle.h>
+#include <errmsg.h>
+#include <my_getopt.h>
 /* That one is necessary for defines of OPTION_NO_FOREIGN_KEY_CHECKS etc */
 #include "mysql_priv.h" 
 #include "log_event.h"
 #include "sql_common.h"
 
+
+enum options_drizzlebinlog
+{
+  OPT_CHARSETS_DIR=256, OPT_BASE64_OUTPUT_MODE,
+  OPT_DEBUG_CHECK, OPT_DEBUG_INFO, OPT_MYSQL_PROTOCOL,
+  OPT_SERVER_ID, OPT_SET_CHARSET, OPT_START_DATETIME,
+  OPT_START_POSITION, OPT_STOP_DATETIME, OPT_STOP_POSITION,
+  OPT_OPEN_FILES_LIMIT
+};
+
 #define BIN_LOG_HEADER_SIZE	4
 #define PROBE_HEADER_LEN	(EVENT_LEN_OFFSET+4)
 
@@ -430,7 +444,7 @@
   ptr= fname + target_dir_name_len;
   memcpy(ptr,bname,blen);
   ptr+= blen;
-  ptr+= my_sprintf(ptr, (ptr, "-%x", file_id));
+  ptr+= sprintf(ptr, "-%x", file_id);
 
   if ((file= create_unique_file(fname,ptr)) < 0)
   {

=== renamed file 'client/mysqlcheck.c' => 'client/drizzlecheck.c'
--- client/mysqlcheck.c	2008-07-15 00:14:18 +0000
+++ client/drizzlecheck.c	2008-07-16 19:46:20 +0000
@@ -637,8 +637,7 @@
   if (opt_all_in_1)
   {
     /* No backticks here as we added them before */
-    query_length= my_sprintf(query,
-			     (query, "%s TABLE %s %s", op, tables, options));
+    query_length= sprintf(query, "%s TABLE %s %s", op, tables, options);
   }
   else
   {

=== renamed file 'client/mysqldump.c' => 'client/drizzledump.c'
=== renamed file 'client/mysqlimport.c' => 'client/drizzleimport.c'
=== renamed file 'client/mysqltest.cc' => 'client/drizzletest.cc'
=== renamed file 'client/readline.cc' => 'client/readline.c'
=== removed file 'client/sql_string.cc'
--- client/sql_string.cc	2008-07-15 06:45:16 +0000
+++ client/sql_string.cc	1970-01-01 00:00:00 +0000
@@ -1,829 +0,0 @@
-/* Copyright (C) 2000 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* This file is originally from the mysql distribution. Coded by monty */
-
-#ifdef USE_PRAGMA_IMPLEMENTATION
-#pragma implementation				// gcc: Class implementation
-#endif
-
-#include <my_global.h>
-#include <my_sys.h>
-#include <m_string.h>
-#include <m_ctype.h>
-#ifdef HAVE_FCONVERT
-#include <floatingpoint.h>
-#endif
-
-/*
-  The following extern declarations are ok as these are interface functions
-  required by the string function
-*/
-
-extern void sql_alloc(size_t size);
-extern void sql_element_free(void *ptr);
-
-#include "sql_string.h"
-
-/*****************************************************************************
-** String functions
-*****************************************************************************/
-
-bool String::real_alloc(uint32 arg_length)
-{
-  arg_length=ALIGN_SIZE(arg_length+1);
-  str_length=0;
-  if (Alloced_length < arg_length)
-  {
-    free();
-    if (!(Ptr=(char*) my_malloc(arg_length,MYF(MY_WME))))
-      return true;
-    Alloced_length=arg_length;
-    alloced=1;
-  }
-  Ptr[0]=0;
-  return false;
-}
-
-
-/*
-** Check that string is big enough. Set string[alloc_length] to 0
-** (for C functions)
-*/
-
-bool String::realloc(uint32 alloc_length)
-{
-  uint32 len=ALIGN_SIZE(alloc_length+1);
-  if (Alloced_length < len)
-  {
-    char *new_ptr;
-    if (alloced)
-    {
-      if ((new_ptr= (char*) my_realloc(Ptr,len,MYF(MY_WME))))
-      {
-	Ptr=new_ptr;
-	Alloced_length=len;
-      }
-      else
-	return true;				// Signal error
-    }
-    else if ((new_ptr= (char*) my_malloc(len,MYF(MY_WME))))
-    {
-      if (str_length)				// Avoid bugs in memcpy on AIX
-	memcpy(new_ptr,Ptr,str_length);
-      new_ptr[str_length]=0;
-      Ptr=new_ptr;
-      Alloced_length=len;
-      alloced=1;
-    }
-    else
-      return true;			// Signal error
-  }
-  Ptr[alloc_length]=0;			// This make other funcs shorter
-  return false;
-}
-
-bool String::set(int64_t num, CHARSET_INFO *cs)
-{
-  uint l=20*cs->mbmaxlen+1;
-
-  if (alloc(l))
-    return true;
-  str_length=(uint32) (cs->cset->int64_t10_to_str)(cs,Ptr,l,-10,num);
-  str_charset=cs;
-  return false;
-}
-
-bool String::set(uint64_t num, CHARSET_INFO *cs)
-{
-  uint l=20*cs->mbmaxlen+1;
-
-  if (alloc(l))
-    return true;
-  str_length=(uint32) (cs->cset->int64_t10_to_str)(cs,Ptr,l,10,num);
-  str_charset=cs;
-  return false;
-}
-
-bool String::set(double num,uint decimals, CHARSET_INFO *cs)
-{
-  char buff[331];
-  uint dummy_errors;
-
-  str_charset=cs;
-  if (decimals >= NOT_FIXED_DEC)
-  {
-    uint32 len= my_sprintf(buff,(buff, "%.14g",num));// Enough for a DATETIME
-    return copy(buff, len, &my_charset_latin1, cs, &dummy_errors);
-  }
-#ifdef HAVE_SNPRINTF
-  buff[sizeof(buff)-1]=0;			// Safety
-  snprintf(buff,sizeof(buff)-1, "%.*f",(int) decimals,num);
-#else
-  sprintf(buff,"%.*f",(int) decimals,num);
-#endif
-  return copy(buff,(uint32) strlen(buff), &my_charset_latin1, cs,
-              &dummy_errors);
-}
-
-
-bool String::copy()
-{
-  if (!alloced)
-  {
-    Alloced_length=0;				// Force realloc
-    return realloc(str_length);
-  }
-  return false;
-}
-
-bool String::copy(const String &str)
-{
-  if (alloc(str.str_length))
-    return true;
-  str_length=str.str_length;
-  bmove(Ptr,str.Ptr,str_length);		// May be overlapping
-  Ptr[str_length]=0;
-  str_charset=str.str_charset;
-  return false;
-}
-
-bool String::copy(const char *str,uint32 arg_length, CHARSET_INFO *cs)
-{
-  if (alloc(arg_length))
-    return true;
-  if ((str_length=arg_length))
-    memcpy(Ptr,str,arg_length);
-  Ptr[arg_length]=0;
-  str_charset=cs;
-  return false;
-}
-
-
-/*
-  Checks that the source string can be just copied to the destination string
-  without conversion.
-
-  SYNPOSIS
-
-  needs_conversion()
-  arg_length		Length of string to copy.
-  from_cs		Character set to copy from
-  to_cs			Character set to copy to
-  uint32 *offset	Returns number of unaligned characters.
-
-  RETURN
-   0  No conversion needed
-   1  Either character set conversion or adding leading  zeros
-      (e.g. for UCS-2) must be done
-
-  NOTE
-  to_cs may be NULL for "no conversion" if the system variable
-  character_set_results is NULL.
-*/
-
-bool String::needs_conversion(uint32 arg_length,
-			      CHARSET_INFO *from_cs,
-			      CHARSET_INFO *to_cs,
-			      uint32 *offset)
-{
-  *offset= 0;
-  if (!to_cs ||
-      (to_cs == &my_charset_bin) || 
-      (to_cs == from_cs) ||
-      my_charset_same(from_cs, to_cs) ||
-      ((from_cs == &my_charset_bin) &&
-       (!(*offset=(arg_length % to_cs->mbminlen)))))
-    return false;
-  return true;
-}
-
-
-/*
-  Copy a multi-byte character sets with adding leading zeros.
-
-  SYNOPSIS
-
-  copy_aligned()
-  str			String to copy
-  arg_length		Length of string. This should NOT be dividable with
-			cs->mbminlen.
-  offset		arg_length % cs->mb_minlength
-  cs			Character set for 'str'
-
-  NOTES
-    For real multi-byte, ascii incompatible charactser sets,
-    like UCS-2, add leading zeros if we have an incomplete character.
-    Thus, 
-      SELECT _ucs2 0xAA 
-    will automatically be converted into
-      SELECT _ucs2 0x00AA
-
-  RETURN
-    0  ok
-    1  error
-*/
-
-bool String::copy_aligned(const char *str,uint32 arg_length, uint32 offset,
-			  CHARSET_INFO *cs)
-{
-  /* How many bytes are in incomplete character */
-  offset= cs->mbmaxlen - offset; /* How many zeros we should prepend */
-  assert(offset && offset != cs->mbmaxlen);
-
-  uint32 aligned_length= arg_length + offset;
-  if (alloc(aligned_length))
-    return true;
-  
-  /*
-    Note, this is only safe for little-endian UCS-2.
-    If we add big-endian UCS-2 sometimes, this code
-    will be more complicated. But it's OK for now.
-  */
-  bzero((char*) Ptr, offset);
-  memcpy(Ptr + offset, str, arg_length);
-  Ptr[aligned_length]=0;
-  /* str_length is always >= 0 as arg_length is != 0 */
-  str_length= aligned_length;
-  str_charset= cs;
-  return false;
-}
-
-
-bool String::set_or_copy_aligned(const char *str,uint32 arg_length,
-				 CHARSET_INFO *cs)
-{
-  /* How many bytes are in incomplete character */
-  uint32 offset= (arg_length % cs->mbminlen); 
-  
-  if (!offset) /* All characters are complete, just copy */
-  {
-    set(str, arg_length, cs);
-    return false;
-  }
-  return copy_aligned(str, arg_length, offset, cs);
-}
-
-	/* Copy with charset convertion */
-
-bool String::copy(const char *str, uint32 arg_length,
-		  CHARSET_INFO *from_cs, CHARSET_INFO *to_cs, uint *errors)
-{
-  uint32 offset;
-  if (!needs_conversion(arg_length, from_cs, to_cs, &offset))
-  {
-    *errors= 0;
-    return copy(str, arg_length, to_cs);
-  }
-  if ((from_cs == &my_charset_bin) && offset)
-  {
-    *errors= 0;
-    return copy_aligned(str, arg_length, offset, to_cs);
-  }
-  uint32 new_length= to_cs->mbmaxlen*arg_length;
-  if (alloc(new_length))
-    return true;
-  str_length=copy_and_convert((char*) Ptr, new_length, to_cs,
-                              str, arg_length, from_cs, errors);
-  str_charset=to_cs;
-  return false;
-}
-
-
-/*
-  Set a string to the value of a latin1-string, keeping the original charset
-  
-  SYNOPSIS
-    copy_or_set()
-    str			String of a simple charset (latin1)
-    arg_length		Length of string
-
-  IMPLEMENTATION
-    If string object is of a simple character set, set it to point to the
-    given string.
-    If not, make a copy and convert it to the new character set.
-
-  RETURN
-    0	ok
-    1	Could not allocate result buffer
-
-*/
-
-bool String::set_ascii(const char *str, uint32 arg_length)
-{
-  if (str_charset->mbminlen == 1)
-  {
-    set(str, arg_length, str_charset);
-    return 0;
-  }
-  uint dummy_errors;
-  return copy(str, arg_length, &my_charset_latin1, str_charset, &dummy_errors);
-}
-
-
-/* This is used by mysql.cc */
-
-bool String::fill(uint32 max_length,char fill_char)
-{
-  if (str_length > max_length)
-    Ptr[str_length=max_length]=0;
-  else
-  {
-    if (realloc(max_length))
-      return true;
-    bfill(Ptr+str_length,max_length-str_length,fill_char);
-    str_length=max_length;
-  }
-  return false;
-}
-
-void String::strip_sp()
-{
-   while (str_length && my_isspace(str_charset,Ptr[str_length-1]))
-    str_length--;
-}
-
-bool String::append(const String &s)
-{
-  if (s.length())
-  {
-    if (realloc(str_length+s.length()))
-      return true;
-    memcpy(Ptr+str_length,s.ptr(),s.length());
-    str_length+=s.length();
-  }
-  return false;
-}
-
-
-/*
-  Append an ASCII string to the a string of the current character set
-*/
-
-bool String::append(const char *s,uint32 arg_length)
-{
-  if (!arg_length)
-    return false;
-
-  /*
-    For an ASCII incompatible string, e.g. UCS-2, we need to convert
-  */
-  if (str_charset->mbminlen > 1)
-  {
-    uint32 add_length=arg_length * str_charset->mbmaxlen;
-    uint dummy_errors;
-    if (realloc(str_length+ add_length))
-      return true;
-    str_length+= copy_and_convert(Ptr+str_length, add_length, str_charset,
-				  s, arg_length, &my_charset_latin1,
-                                  &dummy_errors);
-    return false;
-  }
-
-  /*
-    For an ASCII compatinble string we can just append.
-  */
-  if (realloc(str_length+arg_length))
-    return true;
-  memcpy(Ptr+str_length,s,arg_length);
-  str_length+=arg_length;
-  return false;
-}
-
-
-/*
-  Append a 0-terminated ASCII string
-*/
-
-bool String::append(const char *s)
-{
-  return append(s, strlen(s));
-}
-
-
-/*
-  Append a string in the given charset to the string
-  with character set recoding
-*/
-
-bool String::append(const char *s,uint32 arg_length, CHARSET_INFO *cs)
-{
-  uint32 dummy_offset;
-  
-  if (needs_conversion(arg_length, cs, str_charset, &dummy_offset))
-  {
-    uint32 add_length= arg_length / cs->mbminlen * str_charset->mbmaxlen;
-    uint dummy_errors;
-    if (realloc(str_length + add_length)) 
-      return true;
-    str_length+= copy_and_convert(Ptr+str_length, add_length, str_charset,
-				  s, arg_length, cs, &dummy_errors);
-  }
-  else
-  {
-    if (realloc(str_length + arg_length)) 
-      return true;
-    memcpy(Ptr + str_length, s, arg_length);
-    str_length+= arg_length;
-  }
-  return false;
-}
-
-
-bool String::append(IO_CACHE* file, uint32 arg_length)
-{
-  if (realloc(str_length+arg_length))
-    return true;
-  if (my_b_read(file, (uchar*) Ptr + str_length, arg_length))
-  {
-    shrink(str_length);
-    return true;
-  }
-  str_length+=arg_length;
-  return false;
-}
-
-bool String::append_with_prefill(const char *s,uint32 arg_length,
-		 uint32 full_length, char fill_char)
-{
-  int t_length= arg_length > full_length ? arg_length : full_length;
-
-  if (realloc(str_length + t_length))
-    return true;
-  t_length= full_length - arg_length;
-  if (t_length > 0)
-  {
-    bfill(Ptr+str_length, t_length, fill_char);
-    str_length=str_length + t_length;
-  }
-  append(s, arg_length);
-  return false;
-}
-
-uint32 String::numchars()
-{
-  return str_charset->cset->numchars(str_charset, Ptr, Ptr+str_length);
-}
-
-int String::charpos(int i,uint32 offset)
-{
-  if (i <= 0)
-    return i;
-  return str_charset->cset->charpos(str_charset,Ptr+offset,Ptr+str_length,i);
-}
-
-int String::strstr(const String &s,uint32 offset)
-{
-  if (s.length()+offset <= str_length)
-  {
-    if (!s.length())
-      return ((int) offset);	// Empty string is always found
-
-    register const char *str = Ptr+offset;
-    register const char *search=s.ptr();
-    const char *end=Ptr+str_length-s.length()+1;
-    const char *search_end=s.ptr()+s.length();
-skip:
-    while (str != end)
-    {
-      if (*str++ == *search)
-      {
-	register char *i,*j;
-	i=(char*) str; j=(char*) search+1;
-	while (j != search_end)
-	  if (*i++ != *j++) goto skip;
-	return (int) (str-Ptr) -1;
-      }
-    }
-  }
-  return -1;
-}
-
-/*
-** Search string from end. Offset is offset to the end of string
-*/
-
-int String::strrstr(const String &s,uint32 offset)
-{
-  if (s.length() <= offset && offset <= str_length)
-  {
-    if (!s.length())
-      return offset;				// Empty string is always found
-    register const char *str = Ptr+offset-1;
-    register const char *search=s.ptr()+s.length()-1;
-
-    const char *end=Ptr+s.length()-2;
-    const char *search_end=s.ptr()-1;
-skip:
-    while (str != end)
-    {
-      if (*str-- == *search)
-      {
-	register char *i,*j;
-	i=(char*) str; j=(char*) search-1;
-	while (j != search_end)
-	  if (*i-- != *j--) goto skip;
-	return (int) (i-Ptr) +1;
-      }
-    }
-  }
-  return -1;
-}
-
-/*
-  Replace substring with string
-  If wrong parameter or not enough memory, do nothing
-*/
-
-bool String::replace(uint32 offset,uint32 arg_length,const String &to)
-{
-  return replace(offset,arg_length,to.ptr(),to.length());
-}
-
-bool String::replace(uint32 offset,uint32 arg_length,
-                     const char *to, uint32 to_length)
-{
-  long diff = (long) to_length-(long) arg_length;
-  if (offset+arg_length <= str_length)
-  {
-    if (diff < 0)
-    {
-      if (to_length)
-	memcpy(Ptr+offset,to,to_length);
-      bmove(Ptr+offset+to_length,Ptr+offset+arg_length,
-	    str_length-offset-arg_length);
-    }
-    else
-    {
-      if (diff)
-      {
-	if (realloc(str_length+(uint32) diff))
-	  return true;
-	bmove_upp((uchar*) Ptr+str_length+diff, (uchar*) Ptr+str_length,
-		  str_length-offset-arg_length);
-      }
-      if (to_length)
-	memcpy(Ptr+offset,to,to_length);
-    }
-    str_length+=(uint32) diff;
-  }
-  return false;
-}
-
-
-// added by Holyfoot for "geometry" needs
-int String::reserve(uint32 space_needed, uint32 grow_by)
-{
-  if (Alloced_length < str_length + space_needed)
-  {
-    if (realloc(Alloced_length + max(space_needed, grow_by) - 1))
-      return true;
-  }
-  return false;
-}
-
-void String::qs_append(const char *str, uint32 len)
-{
-  memcpy(Ptr + str_length, str, len + 1);
-  str_length += len;
-}
-
-void String::qs_append(double d)
-{
-  char *buff = Ptr + str_length;
-  str_length+= my_gcvt(d, MY_GCVT_ARG_DOUBLE, FLOATING_POINT_BUFFER - 1, buff, NULL);
-}
-
-void String::qs_append(double *d)
-{
-  double ld;
-  float8get(ld, (char*) d);
-  qs_append(ld);
-}
-
-void String::qs_append(int i)
-{
-  char *buff= Ptr + str_length;
-  char *end= int10_to_str(i, buff, -10);
-  str_length+= (int) (end-buff);
-}
-
-void String::qs_append(uint i)
-{
-  char *buff= Ptr + str_length;
-  char *end= int10_to_str(i, buff, 10);
-  str_length+= (int) (end-buff);
-}
-
-/*
-  Compare strings according to collation, without end space.
-
-  SYNOPSIS
-    sortcmp()
-    s		First string
-    t		Second string
-    cs		Collation
-
-  NOTE:
-    Normally this is case sensitive comparison
-
-  RETURN
-  < 0	s < t
-  0	s == t
-  > 0	s > t
-*/
-
-
-int sortcmp(const String *s,const String *t, CHARSET_INFO *cs)
-{
- return cs->coll->strnncollsp(cs,
-                              (unsigned char *) s->ptr(),s->length(),
-                              (unsigned char *) t->ptr(),t->length(), 0);
-}
-
-
-/*
-  Compare strings byte by byte. End spaces are also compared.
-
-  SYNOPSIS
-    stringcmp()
-    s		First string
-    t		Second string
-
-  NOTE:
-    Strings are compared as a stream of unsigned chars
-
-  RETURN
-  < 0	s < t
-  0	s == t
-  > 0	s > t
-*/
-
-
-int stringcmp(const String *s,const String *t)
-{
-  uint32 s_len=s->length(),t_len=t->length(),len=min(s_len,t_len);
-  int cmp= memcmp(s->ptr(), t->ptr(), len);
-  return (cmp) ? cmp : (int) (s_len - t_len);
-}
-
-
-String *copy_if_not_alloced(String *to,String *from,uint32 from_length)
-{
-  if (from->Alloced_length >= from_length)
-    return from;
-  if (from->alloced || !to || from == to)
-  {
-    (void) from->realloc(from_length);
-    return from;
-  }
-  if (to->realloc(from_length))
-    return from;				// Actually an error
-  if ((to->str_length=min(from->str_length,from_length)))
-    memcpy(to->Ptr,from->Ptr,to->str_length);
-  to->str_charset=from->str_charset;
-  return to;
-}
-
-
-/****************************************************************************
-  Help functions
-****************************************************************************/
-
-/*
-  copy a string from one character set to another
-  
-  SYNOPSIS
-    copy_and_convert()
-    to			Store result here
-    to_cs		Character set of result string
-    from		Copy from here
-    from_length		Length of from string
-    from_cs		From character set
-
-  NOTES
-    'to' must be big enough as form_length * to_cs->mbmaxlen
-
-  RETURN
-    length of bytes copied to 'to'
-*/
-
-
-uint32
-copy_and_convert(char *to, uint32 to_length, CHARSET_INFO *to_cs, 
-                 const char *from, uint32 from_length, CHARSET_INFO *from_cs,
-                 uint *errors)
-{
-  int         cnvres;
-  my_wc_t     wc;
-  const uchar *from_end= (const uchar*) from+from_length;
-  char *to_start= to;
-  uchar *to_end= (uchar*) to+to_length;
-  my_charset_conv_mb_wc mb_wc= from_cs->cset->mb_wc;
-  my_charset_conv_wc_mb wc_mb= to_cs->cset->wc_mb;
-  uint error_count= 0;
-
-  while (1)
-  {
-    if ((cnvres= (*mb_wc)(from_cs, &wc, (uchar*) from,
-				      from_end)) > 0)
-      from+= cnvres;
-    else if (cnvres == MY_CS_ILSEQ)
-    {
-      error_count++;
-      from++;
-      wc= '?';
-    }
-    else if (cnvres > MY_CS_TOOSMALL)
-    {
-      /*
-        A correct multibyte sequence detected
-        But it doesn't have Unicode mapping.
-      */
-      error_count++;
-      from+= (-cnvres);
-      wc= '?';
-    }
-    else
-      break;  // Not enough characters
-
-outp:
-    if ((cnvres= (*wc_mb)(to_cs, wc, (uchar*) to, to_end)) > 0)
-      to+= cnvres;
-    else if (cnvres == MY_CS_ILUNI && wc != '?')
-    {
-      error_count++;
-      wc= '?';
-      goto outp;
-    }
-    else
-      break;
-  }
-  *errors= error_count;
-  return (uint32) (to - to_start);
-}
-
-
-void String::print(String *str)
-{
-  char *st= (char*)Ptr, *end= st+str_length;
-  for (; st < end; st++)
-  {
-    uchar c= *st;
-    switch (c)
-    {
-    case '\\':
-      str->append(STRING_WITH_LEN("\\\\"));
-      break;
-    case '\0':
-      str->append(STRING_WITH_LEN("\\0"));
-      break;
-    case '\'':
-      str->append(STRING_WITH_LEN("\\'"));
-      break;
-    case '\n':
-      str->append(STRING_WITH_LEN("\\n"));
-      break;
-    case '\r':
-      str->append(STRING_WITH_LEN("\\r"));
-      break;
-    case 26: //Ctrl-Z
-      str->append(STRING_WITH_LEN("\\z"));
-      break;
-    default:
-      str->append(c);
-    }
-  }
-}
-
-
-/*
-  Exchange state of this object and argument.
-
-  SYNOPSIS
-    String::swap()
-
-  RETURN
-    Target string will contain state of this object and vice versa.
-*/
-
-void String::swap(String &s)
-{
-  swap_variables(char *, Ptr, s.Ptr);
-  swap_variables(uint32, str_length, s.str_length);
-  swap_variables(uint32, Alloced_length, s.Alloced_length);
-  swap_variables(bool, alloced, s.alloced);
-  swap_variables(CHARSET_INFO*, str_charset, s.str_charset);
-}

=== removed file 'client/sql_string.h'
--- client/sql_string.h	2008-07-15 06:45:16 +0000
+++ client/sql_string.h	1970-01-01 00:00:00 +0000
@@ -1,357 +0,0 @@
-/* Copyright (C) 2000 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* This file is originally from the mysql distribution. Coded by monty */
-
-#ifdef USE_PRAGMA_INTERFACE
-#pragma interface			/* gcc class implementation */
-#endif
-
-#ifndef NOT_FIXED_DEC
-#define NOT_FIXED_DEC			31
-#endif
-
-class String;
-int sortcmp(const String *a,const String *b, CHARSET_INFO *cs);
-String *copy_if_not_alloced(String *a,String *b,uint32 arg_length);
-uint32 copy_and_convert(char *to, uint32 to_length, CHARSET_INFO *to_cs,
-			const char *from, uint32 from_length,
-			CHARSET_INFO *from_cs, uint *errors);
-
-class String
-{
-  char *Ptr;
-  uint32 str_length,Alloced_length;
-  bool alloced;
-  CHARSET_INFO *str_charset;
-public:
-  String()
-  { 
-    Ptr=0; str_length=Alloced_length=0; alloced=0; 
-    str_charset= &my_charset_bin; 
-  }
-  String(uint32 length_arg)
-  { 
-    alloced=0; Alloced_length=0; (void) real_alloc(length_arg); 
-    str_charset= &my_charset_bin;
-  }
-  String(const char *str, CHARSET_INFO *cs)
-  { 
-    Ptr=(char*) str; str_length=(uint) strlen(str); Alloced_length=0; alloced=0;
-    str_charset=cs;
-  }
-  String(const char *str,uint32 len, CHARSET_INFO *cs)
-  { 
-    Ptr=(char*) str; str_length=len; Alloced_length=0; alloced=0;
-    str_charset=cs;
-  }
-  String(char *str,uint32 len, CHARSET_INFO *cs)
-  { 
-    Ptr=(char*) str; Alloced_length=str_length=len; alloced=0;
-    str_charset=cs;
-  }
-  String(const String &str)
-  { 
-    Ptr=str.Ptr ; str_length=str.str_length ;
-    Alloced_length=str.Alloced_length; alloced=0; 
-    str_charset=str.str_charset;
-  }
-  static void *operator new(size_t size, MEM_ROOT *mem_root)
-  { return (void*) alloc_root(mem_root, (uint) size); }
-  static void operator delete(void *ptr_arg __attribute__((__unused__)),
-                              size_t size __attribute__((__unused__)))
-  { /* never called */ }
-  static void operator delete(void *ptr_arg __attribute__((__unused__)),
-                              MEM_ROOT *mem_root __attribute__((__unused__)))
-  { /* never called */ }
-  ~String() { free(); }
-
-  inline void set_charset(CHARSET_INFO *charset_arg)
-  { str_charset= charset_arg; }
-  inline CHARSET_INFO *charset() const { return str_charset; }
-  inline uint32 length() const { return str_length;}
-  inline uint32 alloced_length() const { return Alloced_length;}
-  inline char& operator [] (uint32 i) const { return Ptr[i]; }
-  inline void length(uint32 len) { str_length=len ; }
-  inline bool is_empty() { return (str_length == 0); }
-  inline void mark_as_const() { Alloced_length= 0;}
-  inline const char *ptr() const { return Ptr; }
-  inline char *c_ptr()
-  {
-    if (!Ptr || Ptr[str_length])		/* Should be safe */
-      (void) realloc(str_length);
-    return Ptr;
-  }
-  inline char *c_ptr_quick()
-  {
-    if (Ptr && str_length < Alloced_length)
-      Ptr[str_length]=0;
-    return Ptr;
-  }
-  inline char *c_ptr_safe()
-  {
-    if (Ptr && str_length < Alloced_length)
-      Ptr[str_length]=0;
-    else
-      (void) realloc(str_length);
-    return Ptr;
-  }
-
-  void set(String &str,uint32 offset,uint32 arg_length)
-  {
-    assert(&str != this);
-    free();
-    Ptr=(char*) str.ptr()+offset; str_length=arg_length; alloced=0;
-    if (str.Alloced_length)
-      Alloced_length=str.Alloced_length-offset;
-    else
-      Alloced_length=0;
-    str_charset=str.str_charset;
-  }
-  inline void set(char *str,uint32 arg_length, CHARSET_INFO *cs)
-  {
-    free();
-    Ptr=(char*) str; str_length=Alloced_length=arg_length ; alloced=0;
-    str_charset=cs;
-  }
-  inline void set(const char *str,uint32 arg_length, CHARSET_INFO *cs)
-  {
-    free();
-    Ptr=(char*) str; str_length=arg_length; Alloced_length=0 ; alloced=0;
-    str_charset=cs;
-  }
-  bool set_ascii(const char *str, uint32 arg_length);
-  inline void set_quick(char *str,uint32 arg_length, CHARSET_INFO *cs)
-  {
-    if (!alloced)
-    {
-      Ptr=(char*) str; str_length=Alloced_length=arg_length;
-    }
-    str_charset=cs;
-  }
-  bool set(int64_t num, CHARSET_INFO *cs);
-  bool set(uint64_t num, CHARSET_INFO *cs);
-  bool set(double num,uint decimals, CHARSET_INFO *cs);
-
-  /*
-    PMG 2004.11.12
-    This is a method that works the same as perl's "chop". It simply
-    drops the last character of a string. This is useful in the case
-    of the federated storage handler where I'm building a unknown
-    number, list of values and fields to be used in a sql insert
-    statement to be run on the remote server, and have a comma after each.
-    When the list is complete, I "chop" off the trailing comma
-
-    ex. 
-      String stringobj; 
-      stringobj.append("VALUES ('foo', 'fi', 'fo',");
-      stringobj.chop();
-      stringobj.append(")");
-
-    In this case, the value of string was:
-
-    VALUES ('foo', 'fi', 'fo',
-    VALUES ('foo', 'fi', 'fo'
-    VALUES ('foo', 'fi', 'fo')
-      
-  */
-  inline void chop()
-  {
-    Ptr[str_length--]= '\0'; 
-  }
-
-  inline void free()
-  {
-    if (alloced)
-    {
-      alloced=0;
-      Alloced_length=0;
-      my_free(Ptr,MYF(0));
-      Ptr=0;
-      str_length=0;				/* Safety */
-    }
-  }
-  inline bool alloc(uint32 arg_length)
-  {
-    if (arg_length < Alloced_length)
-      return 0;
-    return real_alloc(arg_length);
-  }
-  bool real_alloc(uint32 arg_length);			// Empties old string
-  bool realloc(uint32 arg_length);
-  inline void shrink(uint32 arg_length)		// Shrink buffer
-  {
-    if (arg_length < Alloced_length)
-    {
-      char *new_ptr;
-      if (!(new_ptr=(char*) my_realloc(Ptr,arg_length,MYF(0))))
-      {
-	Alloced_length = 0;
-	real_alloc(arg_length);
-      }
-      else
-      {
-	Ptr=new_ptr;
-	Alloced_length=arg_length;
-      }
-    }
-  }
-  bool is_alloced() { return alloced; }
-  inline String& operator = (const String &s)
-  {
-    if (&s != this)
-    {
-      /*
-        It is forbidden to do assignments like 
-        some_string = substring_of_that_string
-       */
-      assert(!s.uses_buffer_owned_by(this));
-      free();
-      Ptr=s.Ptr ; str_length=s.str_length ; Alloced_length=s.Alloced_length;
-      alloced=0;
-    }
-    return *this;
-  }
-
-  bool copy();					// Alloc string if not alloced
-  bool copy(const String &s);			// Allocate new string
-  bool copy(const char *s,uint32 arg_length, CHARSET_INFO *cs);	// Allocate new string
-  static bool needs_conversion(uint32 arg_length,
-  			       CHARSET_INFO *cs_from, CHARSET_INFO *cs_to,
-			       uint32 *offset);
-  bool copy_aligned(const char *s, uint32 arg_length, uint32 offset,
-		    CHARSET_INFO *cs);
-  bool set_or_copy_aligned(const char *s, uint32 arg_length, CHARSET_INFO *cs);
-  bool copy(const char*s,uint32 arg_length, CHARSET_INFO *csfrom,
-	    CHARSET_INFO *csto, uint *errors);
-  bool append(const String &s);
-  bool append(const char *s);
-  bool append(const char *s,uint32 arg_length);
-  bool append(const char *s,uint32 arg_length, CHARSET_INFO *cs);
-  bool append(IO_CACHE* file, uint32 arg_length);
-  bool append_with_prefill(const char *s, uint32 arg_length, 
-			   uint32 full_length, char fill_char);
-  int strstr(const String &search,uint32 offset=0); // Returns offset to substring or -1
-  int strrstr(const String &search,uint32 offset=0); // Returns offset to substring or -1
-  bool replace(uint32 offset,uint32 arg_length,const char *to,uint32 length);
-  bool replace(uint32 offset,uint32 arg_length,const String &to);
-  inline bool append(char chr)
-  {
-    if (str_length < Alloced_length)
-    {
-      Ptr[str_length++]=chr;
-    }
-    else
-    {
-      if (realloc(str_length+1))
-	return 1;
-      Ptr[str_length++]=chr;
-    }
-    return 0;
-  }
-  bool fill(uint32 max_length,char fill);
-  void strip_sp();
-  friend int sortcmp(const String *a,const String *b, CHARSET_INFO *cs);
-  friend int stringcmp(const String *a,const String *b);
-  friend String *copy_if_not_alloced(String *a,String *b,uint32 arg_length);
-  uint32 numchars();
-  int charpos(int i,uint32 offset=0);
-
-  int reserve(uint32 space_needed)
-  {
-    return realloc(str_length + space_needed);
-  }
-  int reserve(uint32 space_needed, uint32 grow_by);
-
-  /*
-    The following append operations do NOT check alloced memory
-    q_*** methods writes values of parameters itself
-    qs_*** methods writes string representation of value
-  */
-  void q_append(const char c)
-  {
-    Ptr[str_length++] = c;
-  }
-  void q_append(const uint32 n)
-  {
-    int4store(Ptr + str_length, n);
-    str_length += 4;
-  }
-  void q_append(double d)
-  {
-    float8store(Ptr + str_length, d);
-    str_length += 8;
-  }
-  void q_append(double *d)
-  {
-    float8store(Ptr + str_length, *d);
-    str_length += 8;
-  }
-  void q_append(const char *data, uint32 data_len)
-  {
-    memcpy(Ptr + str_length, data, data_len);
-    str_length += data_len;
-  }
-
-  void write_at_position(int position, uint32 value)
-  {
-    int4store(Ptr + position,value);
-  }
-
-  void qs_append(const char *str, uint32 len);
-  void qs_append(double d);
-  void qs_append(double *d);
-  inline void qs_append(const char c)
-  {
-     Ptr[str_length]= c;
-     str_length++;
-  }
-  void qs_append(int i);
-  void qs_append(uint i);
-
-  /* Inline (general) functions used by the protocol functions */
-
-  inline char *prep_append(uint32 arg_length, uint32 step_alloc)
-  {
-    uint32 new_length= arg_length + str_length;
-    if (new_length > Alloced_length)
-    {
-      if (realloc(new_length + step_alloc))
-        return 0;
-    }
-    uint32 old_length= str_length;
-    str_length+= arg_length;
-    return Ptr+ old_length;			/* Area to use */
-  }
-
-  inline bool append(const char *s, uint32 arg_length, uint32 step_alloc)
-  {
-    uint32 new_length= arg_length + str_length;
-    if (new_length > Alloced_length && realloc(new_length + step_alloc))
-      return true;
-    memcpy(Ptr+str_length, s, arg_length);
-    str_length+= arg_length;
-    return false;
-  }
-  void print(String *print);
-
-  /* Swap two string objects. Efficient way to exchange data without memcpy. */
-  void swap(String &s);
-
-  inline bool uses_buffer_owned_by(const String *s) const
-  {
-    return (s->alloced && Ptr >= s->Ptr && Ptr < s->Ptr + s->str_length);
-  }
-};

=== added file 'config/ac-macros/glib-2.0.m4'
--- config/ac-macros/glib-2.0.m4	1970-01-01 00:00:00 +0000
+++ config/ac-macros/glib-2.0.m4	2008-07-12 20:31:23 +0000
@@ -0,0 +1,211 @@
+# Configure paths for GLIB
+# Owen Taylor     1997-2001
+
+dnl AM_PATH_GLIB_2_0([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
+dnl Test for GLIB, and define GLIB_CFLAGS and GLIB_LIBS, if gmodule, gobject,
+dnl gthread, or gio is specified in MODULES, pass to pkg-config
+dnl
+AC_DEFUN([AM_PATH_GLIB_2_0],
+[dnl 
+dnl Get the cflags and libraries from pkg-config
+dnl
+AC_ARG_ENABLE(glibtest, [  --disable-glibtest      do not try to compile and run a test GLIB program],
+		    , enable_glibtest=yes)
+
+  pkg_config_args=glib-2.0
+  for module in . $4
+  do
+      case "$module" in
+         gmodule) 
+             pkg_config_args="$pkg_config_args gmodule-2.0"
+         ;;
+         gmodule-no-export) 
+             pkg_config_args="$pkg_config_args gmodule-no-export-2.0"
+         ;;
+         gobject) 
+             pkg_config_args="$pkg_config_args gobject-2.0"
+         ;;
+         gthread) 
+             pkg_config_args="$pkg_config_args gthread-2.0"
+         ;;
+         gio*) 
+             pkg_config_args="$pkg_config_args $module-2.0"
+         ;;
+      esac
+  done
+
+  PKG_PROG_PKG_CONFIG([0.16])
+
+  no_glib=""
+
+  if test "x$PKG_CONFIG" = x ; then
+    no_glib=yes
+    PKG_CONFIG=no
+  fi
+
+  min_glib_version=ifelse([$1], ,2.0.0,$1)
+  AC_MSG_CHECKING(for GLIB - version >= $min_glib_version)
+
+  if test x$PKG_CONFIG != xno ; then
+    ## don't try to run the test against uninstalled libtool libs
+    if $PKG_CONFIG --uninstalled $pkg_config_args; then
+	  echo "Will use uninstalled version of GLib found in PKG_CONFIG_PATH"
+	  enable_glibtest=no
+    fi
+
+    if $PKG_CONFIG --atleast-version $min_glib_version $pkg_config_args; then
+	  :
+    else
+	  no_glib=yes
+    fi
+  fi
+
+  if test x"$no_glib" = x ; then
+    GLIB_GENMARSHAL=`$PKG_CONFIG --variable=glib_genmarshal glib-2.0`
+    GOBJECT_QUERY=`$PKG_CONFIG --variable=gobject_query glib-2.0`
+    GLIB_MKENUMS=`$PKG_CONFIG --variable=glib_mkenums glib-2.0`
+
+    GLIB_CFLAGS=`$PKG_CONFIG --cflags $pkg_config_args`
+    GLIB_LIBS=`$PKG_CONFIG --libs $pkg_config_args`
+    glib_config_major_version=`$PKG_CONFIG --modversion glib-2.0 | \
+           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
+    glib_config_minor_version=`$PKG_CONFIG --modversion glib-2.0 | \
+           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
+    glib_config_micro_version=`$PKG_CONFIG --modversion glib-2.0 | \
+           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
+    if test "x$enable_glibtest" = "xyes" ; then
+      ac_save_CFLAGS="$CFLAGS"
+      ac_save_LIBS="$LIBS"
+      CFLAGS="$CFLAGS $GLIB_CFLAGS"
+      LIBS="$GLIB_LIBS $LIBS"
+dnl
+dnl Now check if the installed GLIB is sufficiently new. (Also sanity
+dnl checks the results of pkg-config to some extent)
+dnl
+      rm -f conf.glibtest
+      AC_TRY_RUN([
+#include <glib.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+int 
+main ()
+{
+  int major, minor, micro;
+  char *tmp_version;
+
+  system ("touch conf.glibtest");
+
+  /* HP/UX 9 (%@#!) writes to sscanf strings */
+  tmp_version = g_strdup("$min_glib_version");
+  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
+     printf("%s, bad version string\n", "$min_glib_version");
+     exit(1);
+   }
+
+  if ((glib_major_version != $glib_config_major_version) ||
+      (glib_minor_version != $glib_config_minor_version) ||
+      (glib_micro_version != $glib_config_micro_version))
+    {
+      printf("\n*** 'pkg-config --modversion glib-2.0' returned %d.%d.%d, but GLIB (%d.%d.%d)\n", 
+             $glib_config_major_version, $glib_config_minor_version, $glib_config_micro_version,
+             glib_major_version, glib_minor_version, glib_micro_version);
+      printf ("*** was found! If pkg-config was correct, then it is best\n");
+      printf ("*** to remove the old version of GLib. You may also be able to fix the error\n");
+      printf("*** by modifying your LD_LIBRARY_PATH enviroment variable, or by editing\n");
+      printf("*** /etc/ld.so.conf. Make sure you have run ldconfig if that is\n");
+      printf("*** required on your system.\n");
+      printf("*** If pkg-config was wrong, set the environment variable PKG_CONFIG_PATH\n");
+      printf("*** to point to the correct configuration files\n");
+    } 
+  else if ((glib_major_version != GLIB_MAJOR_VERSION) ||
+	   (glib_minor_version != GLIB_MINOR_VERSION) ||
+           (glib_micro_version != GLIB_MICRO_VERSION))
+    {
+      printf("*** GLIB header files (version %d.%d.%d) do not match\n",
+	     GLIB_MAJOR_VERSION, GLIB_MINOR_VERSION, GLIB_MICRO_VERSION);
+      printf("*** library (version %d.%d.%d)\n",
+	     glib_major_version, glib_minor_version, glib_micro_version);
+    }
+  else
+    {
+      if ((glib_major_version > major) ||
+        ((glib_major_version == major) && (glib_minor_version > minor)) ||
+        ((glib_major_version == major) && (glib_minor_version == minor) && (glib_micro_version >= micro)))
+      {
+        return 0;
+       }
+     else
+      {
+        printf("\n*** An old version of GLIB (%d.%d.%d) was found.\n",
+               glib_major_version, glib_minor_version, glib_micro_version);
+        printf("*** You need a version of GLIB newer than %d.%d.%d. The latest version of\n",
+	       major, minor, micro);
+        printf("*** GLIB is always available from ftp://ftp.gtk.org.\n");
+        printf("***\n");
+        printf("*** If you have already installed a sufficiently new version, this error\n");
+        printf("*** probably means that the wrong copy of the pkg-config shell script is\n");
+        printf("*** being found. The easiest way to fix this is to remove the old version\n");
+        printf("*** of GLIB, but you can also set the PKG_CONFIG environment to point to the\n");
+        printf("*** correct copy of pkg-config. (In this case, you will have to\n");
+        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
+        printf("*** so that the correct libraries are found at run-time))\n");
+      }
+    }
+  return 1;
+}
+],, no_glib=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
+       CFLAGS="$ac_save_CFLAGS"
+       LIBS="$ac_save_LIBS"
+     fi
+  fi
+  if test "x$no_glib" = x ; then
+     AC_MSG_RESULT(yes (version $glib_config_major_version.$glib_config_minor_version.$glib_config_micro_version))
+     ifelse([$2], , :, [$2])     
+  else
+     AC_MSG_RESULT(no)
+     if test "$PKG_CONFIG" = "no" ; then
+       echo "*** A new enough version of pkg-config was not found."
+       echo "*** See http://www.freedesktop.org/software/pkgconfig/"
+     else
+       if test -f conf.glibtest ; then
+        :
+       else
+          echo "*** Could not run GLIB test program, checking why..."
+          ac_save_CFLAGS="$CFLAGS"
+          ac_save_LIBS="$LIBS"
+          CFLAGS="$CFLAGS $GLIB_CFLAGS"
+          LIBS="$LIBS $GLIB_LIBS"
+          AC_TRY_LINK([
+#include <glib.h>
+#include <stdio.h>
+],      [ return ((glib_major_version) || (glib_minor_version) || (glib_micro_version)); ],
+        [ echo "*** The test program compiled, but did not run. This usually means"
+          echo "*** that the run-time linker is not finding GLIB or finding the wrong"
+          echo "*** version of GLIB. If it is not finding GLIB, you'll need to set your"
+          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
+          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
+          echo "*** is required on your system"
+	  echo "***"
+          echo "*** If you have an old version installed, it is best to remove it, although"
+          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH" ],
+        [ echo "*** The test program failed to compile or link. See the file config.log for the"
+          echo "*** exact error that occured. This usually means GLIB is incorrectly installed."])
+          CFLAGS="$ac_save_CFLAGS"
+          LIBS="$ac_save_LIBS"
+       fi
+     fi
+     GLIB_CFLAGS=""
+     GLIB_LIBS=""
+     GLIB_GENMARSHAL=""
+     GOBJECT_QUERY=""
+     GLIB_MKENUMS=""
+     ifelse([$3], , :, [$3])
+  fi
+  AC_SUBST(GLIB_CFLAGS)
+  AC_SUBST(GLIB_LIBS)
+  AC_SUBST(GLIB_GENMARSHAL)
+  AC_SUBST(GOBJECT_QUERY)
+  AC_SUBST(GLIB_MKENUMS)
+  rm -f conf.glibtest
+])

=== modified file 'configure.ac'
--- configure.ac	2008-07-13 20:17:42 +0000
+++ configure.ac	2008-07-15 21:40:58 +0000
@@ -365,6 +365,11 @@
 AC_SUBST(PCRE_LIBS)
 AC_SUBST(PCRE_CFLAGS)
 
+AM_PATH_GLIB_2_0
+if test "x$no_glib" != "x" ; then
+    AC_MSG_ERROR([Couldn't find GLib2. Try installing libglib2.0-dev or glib2-devel])
+fi
+
 dnl Find paths to some shell programs
 AC_PATH_PROG(LN, ln, ln)
 # This must be able to take a -f flag like normal unix ln.

=== modified file 'include/my_global.h'
--- include/my_global.h	2008-07-15 15:58:19 +0000
+++ include/my_global.h	2008-07-16 18:48:24 +0000
@@ -1006,16 +1006,7 @@
 
 #endif /* WORDS_BIGENDIAN */
 
-/* sprintf does not always return the number of bytes :- */
-#ifdef SPRINTF_RETURNS_INT
-#define my_sprintf(buff,args) sprintf args
-#else
-#ifdef SPRINTF_RETURNS_PTR
-#define my_sprintf(buff,args) ((int)(sprintf args - buff))
-#else
-#define my_sprintf(buff,args) ((ulong) sprintf args, (ulong) strlen(buff))
-#endif
-#endif
+/* my_sprintf  was here. RIP */
 
 #if defined(HAVE_CHARSET_utf8mb3) || defined(HAVE_CHARSET_utf8mb4)
 #define MYSQL_UNIVERSAL_CLIENT_CHARSET "utf8"

=== modified file 'libdrizzle/my_time.c'
--- libdrizzle/my_time.c	2008-07-15 06:45:16 +0000
+++ libdrizzle/my_time.c	2008-07-16 18:48:24 +0000
@@ -1010,30 +1010,30 @@
 int my_time_to_str(const MYSQL_TIME *l_time, char *to)
 {
   uint extra_hours= 0;
-  return my_sprintf(to, (to, "%s%02u:%02u:%02u",
+  return sprintf(to, "%s%02u:%02u:%02u",
                          (l_time->neg ? "-" : ""),
                          extra_hours+ l_time->hour,
                          l_time->minute,
-                         l_time->second));
+                         l_time->second);
 }
 
 int my_date_to_str(const MYSQL_TIME *l_time, char *to)
 {
-  return my_sprintf(to, (to, "%04u-%02u-%02u",
+  return sprintf(to, "%04u-%02u-%02u",
                          l_time->year,
                          l_time->month,
-                         l_time->day));
+                         l_time->day);
 }
 
 int my_datetime_to_str(const MYSQL_TIME *l_time, char *to)
 {
-  return my_sprintf(to, (to, "%04u-%02u-%02u %02u:%02u:%02u",
+  return sprintf(to, "%04u-%02u-%02u %02u:%02u:%02u",
                          l_time->year,
                          l_time->month,
                          l_time->day,
                          l_time->hour,
                          l_time->minute,
-                         l_time->second));
+                         l_time->second);
 }
 
 

=== modified file 'mysys/my_getopt.c'
--- mysys/my_getopt.c	2008-07-15 06:45:16 +0000
+++ mysys/my_getopt.c	2008-07-15 21:01:59 +0000
@@ -110,7 +110,7 @@
                    my_get_one_option get_one_option)
 {
   uint opt_found, argvpos= 0, length;
-  bool end_of_options= 0, must_be_var, set_maximum_value,
+  bool end_of_options= 0, must_be_var, set_maximum_value=false,
           option_is_loose;
   char **pos, **pos_end, *optend, *prev_found=NULL,
        *opt_str, key_name[FN_REFLEN];
@@ -264,8 +264,8 @@
                       disabled_my_option : (char*) "1";
 		    break;
 		  case OPT_MAXIMUM:
-		    set_maximum_value= 1;
-		    must_be_var= 1;
+		    set_maximum_value= true;
+		    must_be_var= true;
 		    break;
 		  }
 		  break; /* break from the inner loop, main loop continues */
@@ -489,35 +489,35 @@
 		}
 	      }
               if ((error= setval(optp, optp->value, argument,
-				 set_maximum_value)))
-	      {
+                                 set_maximum_value)))
+              {
                 my_getopt_error_reporter(ERROR_LEVEL,
                                          "%s: Error while setting value '%s' to '%s'",
                                          my_progname, argument, optp->name);
-		return error;
-	      }
-	      get_one_option(optp->id, optp, argument);
-	      break;
-	    }
-	  }
-	  if (!opt_found)
-	  {
-	    if (my_getopt_print_errors)
+                return error;
+              }
+              get_one_option(optp->id, optp, argument);
+              break;
+            }
+          }
+          if (!opt_found)
+          {
+            if (my_getopt_print_errors)
               my_getopt_error_reporter(ERROR_LEVEL,
                                        "%s: unknown option '-%c'", 
                                        my_progname, *optend);
-	    return EXIT_UNKNOWN_OPTION;
-	  }
-	}
-	(*argc)--; /* option handled (short), decrease argument count */
-	continue;
+            return EXIT_UNKNOWN_OPTION;
+          }
+        }
+        (*argc)--; /* option handled (short), decrease argument count */
+        continue;
       }
       if ((error= setval(optp, value, argument, set_maximum_value)))
       {
         my_getopt_error_reporter(ERROR_LEVEL,
                                  "%s: Error while setting value '%s' to '%s'",
                                  my_progname, argument, optp->name);
-	return error;
+        return error;
       }
       get_one_option(optp->id, optp, argument);
 
@@ -586,8 +586,8 @@
   Will set the option value to given value
 */
 
-static int setval(const struct my_option *opts, char* *value, char *argument,
-		  bool set_maximum_value)
+static int setval(const struct my_option *opts, char **value, char *argument,
+                  bool set_maximum_value)
 {
   int err= 0;
 

=== modified file 'server/Makefile.am'
--- server/Makefile.am	2008-07-15 16:15:14 +0000
+++ server/Makefile.am	2008-07-15 21:01:59 +0000
@@ -24,7 +24,7 @@
 			-I$(srcdir) $(openssl_includes) \
 			$(libevent_includes) \
 			-ggdb
-SUBDIRS =		share
+SUBDIRS =		. share
 libexec_PROGRAMS =	drizzled
 EXTRA_PROGRAMS =	gen_lex_hash
 bin_PROGRAMS =		

=== modified file 'server/drizzled.cc'
--- server/drizzled.cc	2008-07-13 20:17:42 +0000
+++ server/drizzled.cc	2008-07-16 18:48:24 +0000
@@ -4078,7 +4078,7 @@
   {
     var->type= SHOW_CHAR;
     var->value= buff;
-    my_sprintf(buff, (buff, "%.3f",active_mi->heartbeat_period));
+    sprintf(buff, "%.3f",active_mi->heartbeat_period);
   }
   else
     var->type= SHOW_UNDEF;

=== modified file 'server/field.cc'
--- server/field.cc	2008-07-15 17:37:59 +0000
+++ server/field.cc	2008-07-16 18:48:24 +0000
@@ -7562,7 +7562,7 @@
   {
     /* DBL_DIG is enough to print '-[digits].E+###' */
     char str_nr[DBL_DIG + 8];
-    uint str_len= my_sprintf(str_nr, (str_nr, "%g", nr));
+    uint str_len= sprintf(str_nr, "%g", nr);
     make_truncated_value_warning(thd, level, str_nr, str_len, ts_type,
                                  field_name);
   }

=== modified file 'server/item_timefunc.cc'
--- server/item_timefunc.cc	2008-07-15 06:45:16 +0000
+++ server/item_timefunc.cc	2008-07-16 18:48:24 +0000
@@ -752,13 +752,12 @@
 	str->append(hours_i < 12 ? "AM" : "PM",2);
 	break;
       case 'r':
-	length= my_sprintf(intbuff, 
-		   (intbuff, 
+	length= sprintf(intbuff, 
 		    ((l_time->hour % 24) < 12) ?
                     "%02d:%02d:%02d AM" : "%02d:%02d:%02d PM",
 		    (l_time->hour+11)%12+1,
 		    l_time->minute,
-		    l_time->second));
+		    l_time->second);
 	str->append(intbuff, length);
 	break;
       case 'S':
@@ -767,12 +766,11 @@
 	str->append_with_prefill(intbuff, length, 2, '0');
 	break;
       case 'T':
-	length= my_sprintf(intbuff, 
-		   (intbuff, 
+	length= sprintf(intbuff, 
 		    "%02d:%02d:%02d", 
 		    l_time->hour, 
 		    l_time->minute,
-		    l_time->second));
+		    l_time->second);
 	str->append(intbuff, length);
 	break;
       case 'U':
@@ -2848,7 +2846,7 @@
     char buf[28];
     char *ptr= int64_t10_to_str(hour, buf, args[0]->unsigned_flag ? 10 : -10);
     int len = (int)(ptr - buf) +
-      my_sprintf(ptr, (ptr, ":%02u:%02u", (uint)minute, (uint)second));
+      sprintf(ptr, ":%02u:%02u", (uint)minute, (uint)second);
     make_truncated_value_warning(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
                                  buf, len, MYSQL_TIMESTAMP_TIME,
                                  NullS);

=== modified file 'server/log_event.cc'
--- server/log_event.cc	2008-07-13 22:45:08 +0000
+++ server/log_event.cc	2008-07-16 18:48:24 +0000
@@ -4497,7 +4497,7 @@
       double real_val;
       char real_buf[FMT_G_BUFSIZE(14)];
       float8get(real_val, val);
-      my_sprintf(real_buf, (real_buf, "%.14g", real_val));
+      sprintf(real_buf, "%.14g", real_val);
       my_b_printf(&cache, ":=%s%s\n", real_buf, print_event_info->delimiter);
       break;
     case INT_RESULT:
@@ -5229,9 +5229,8 @@
 {
   char buf[256];
   uint length;
-  length= (uint) my_sprintf(buf,
-			    (buf, ";file_id=%u;block_len=%u", file_id,
-			     block_len));
+  length= (uint) sprintf(buf, ";file_id=%u;block_len=%u", file_id,
+			     block_len);
   protocol->store(buf, length, &my_charset_bin);
 }
 
@@ -5370,7 +5369,7 @@
 {
   char buf[64];
   uint length;
-  length= (uint) my_sprintf(buf, (buf, ";file_id=%u", (uint) file_id));
+  length= (uint) sprintf(buf, ";file_id=%u", (uint) file_id);
   protocol->store(buf, (int32) length, &my_charset_bin);
 }
 #endif
@@ -5468,7 +5467,7 @@
 {
   char buf[64];
   uint length;
-  length= (uint) my_sprintf(buf, (buf, ";file_id=%u", (uint) file_id));
+  length= (uint) sprintf(buf, ";file_id=%u", (uint) file_id);
   protocol->store(buf, (int32) length, &my_charset_bin);
 }
 

=== modified file 'server/protocol.cc'
--- server/protocol.cc	2008-07-13 22:45:08 +0000
+++ server/protocol.cc	2008-07-16 18:48:24 +0000
@@ -813,16 +813,16 @@
 {
   char buff[40];
   uint length;
-  length= my_sprintf(buff,(buff, "%04d-%02d-%02d %02d:%02d:%02d",
+  length= sprintf(buff, "%04d-%02d-%02d %02d:%02d:%02d",
 			   (int) tm->year,
 			   (int) tm->month,
 			   (int) tm->day,
 			   (int) tm->hour,
 			   (int) tm->minute,
-			   (int) tm->second));
+			   (int) tm->second);
   if (tm->second_part)
-    length+= my_sprintf(buff+length,(buff+length, ".%06d",
-                                     (int)tm->second_part));
+    length+= sprintf(buff+length, ".%06d",
+                                     (int)tm->second_part);
   return net_store_data((uchar*) buff, length);
 }
 
@@ -846,13 +846,13 @@
   char buff[40];
   uint length;
   uint day= (tm->year || tm->month) ? 0 : tm->day;
-  length= my_sprintf(buff,(buff, "%s%02ld:%02d:%02d",
+  length= sprintf(buff, "%s%02ld:%02d:%02d",
 			   tm->neg ? "-" : "",
 			   (long) day*24L+(long) tm->hour,
 			   (int) tm->minute,
-			   (int) tm->second));
+			   (int) tm->second);
   if (tm->second_part)
-    length+= my_sprintf(buff+length,(buff+length, ".%06d", (int)tm->second_part));
+    length+= sprintf(buff+length, ".%06d", (int)tm->second_part);
   return net_store_data((uchar*) buff, length);
 }
 

=== modified file 'server/rpl_mi.cc'
--- server/rpl_mi.cc	2008-07-13 20:34:17 +0000
+++ server/rpl_mi.cc	2008-07-16 18:48:24 +0000
@@ -363,7 +363,7 @@
      of file we don't care about this garbage.
   */
   char heartbeat_buf[sizeof(mi->heartbeat_period) * 4]; // buffer to suffice always
-  my_sprintf(heartbeat_buf, (heartbeat_buf, "%.3f", mi->heartbeat_period));
+  sprintf(heartbeat_buf, "%.3f", mi->heartbeat_period);
   my_b_seek(file, 0L);
   my_b_printf(file,
               "%u\n%s\n%s\n%s\n%s\n%s\n%d\n%d\n%d\n%s\n%s\n%s\n%s\n%s\n%d\n%s\n",

=== modified file 'server/slave.cc'
--- server/slave.cc	2008-07-13 22:45:08 +0000
+++ server/slave.cc	2008-07-16 18:48:24 +0000
@@ -980,7 +980,7 @@
        the period is an uint64_t of nano-secs. 
     */
     llstr((uint64_t) (mi->heartbeat_period*1000000000UL), llbuf);
-    my_sprintf(query, (query, query_format, llbuf));
+    sprintf(query, query_format, llbuf);
 
     if (mysql_real_query(mysql, query, strlen(query))
         && !check_io_slave_killed(mi->io_thd, mi, NULL))

=== modified file 'server/sql_yacc.yy'
--- server/sql_yacc.yy	2008-07-15 16:08:59 +0000
+++ server/sql_yacc.yy	2008-07-16 18:48:24 +0000
@@ -1221,7 +1221,7 @@
                 Lex->mi.heartbeat_period < 0.0)
             {
               char buf[sizeof(SLAVE_MAX_HEARTBEAT_PERIOD*4)];
-              my_sprintf(buf, (buf, "%d seconds", SLAVE_MAX_HEARTBEAT_PERIOD));
+              sprintf(buf, "%d seconds", SLAVE_MAX_HEARTBEAT_PERIOD);
               my_error(ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE,
                        MYF(0),
                        " is negative or exceeds the maximum ",

=== modified file 'storage/archive/Makefile.am'
--- storage/archive/Makefile.am	2008-07-09 16:20:31 +0000
+++ storage/archive/Makefile.am	2008-07-13 21:57:12 +0000
@@ -26,7 +26,6 @@
 MYSQLLIBdir=            $(pkglibdir)
 pkgplugindir =		$(pkglibdir)/plugin
 AM_CPPFLAGS =              -I$(top_srcdir)/include -I$(top_builddir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)
 WRAPLIBS=

=== modified file 'storage/blackhole/Makefile.am'
--- storage/blackhole/Makefile.am	2008-07-07 02:40:36 +0000
+++ storage/blackhole/Makefile.am	2008-07-13 21:57:12 +0000
@@ -21,7 +21,6 @@
 MYSQLLIBdir=            $(pkglibdir)
 pkgplugindir =		$(pkglibdir)/plugin
 AM_CPPFLAGS =		-I$(top_srcdir)/include -I$(top_builddir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)
 WRAPLIBS=

=== modified file 'storage/csv/Makefile.am'
--- storage/csv/Makefile.am	2008-07-07 02:40:36 +0000
+++ storage/csv/Makefile.am	2008-07-13 21:57:12 +0000
@@ -21,7 +21,6 @@
 MYSQLLIBdir=            $(pkglibdir)
 AM_CPPFLAGS =              -I$(top_builddir)/include \
 			-I$(top_srcdir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)
 LDADD =

=== modified file 'storage/heap/Makefile.am'
--- storage/heap/Makefile.am	2008-07-13 21:29:19 +0000
+++ storage/heap/Makefile.am	2008-07-13 21:57:12 +0000
@@ -18,7 +18,6 @@
 MYSQLBASEdir=           $(prefix)
 MYSQLLIBdir=            $(pkglibdir)
 AM_CPPFLAGS =           -I$(top_srcdir)/include -I$(top_builddir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)
 WRAPLIBS=

=== modified file 'storage/innobase/Makefile.am'
--- storage/innobase/Makefile.am	2008-07-07 02:40:36 +0000
+++ storage/innobase/Makefile.am	2008-07-13 21:57:12 +0000
@@ -21,7 +21,6 @@
 MYSQLLIBdir=            $(pkglibdir)
 pkgplugindir =		$(pkglibdir)/plugin
 AM_CPPFLAGS =              -I$(top_srcdir)/include -I$(top_builddir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/storage/innobase/include \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)

=== modified file 'storage/myisam/Makefile.am'
--- storage/myisam/Makefile.am	2008-07-14 22:29:09 +0000
+++ storage/myisam/Makefile.am	2008-07-16 19:10:24 +0000
@@ -13,16 +13,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-if BUILD_DBUG
-  d_dbug = $(top_builddir)/dbug/libdbuglt.la
-endif
-
 MYSQLDATAdir =          $(localstatedir)
 MYSQLSHAREdir =         $(pkgdatadir)
 MYSQLBASEdir =          $(prefix)
 MYSQLLIBdir =           $(pkglibdir)
 AM_CPPFLAGS =           -I$(top_srcdir)/include -I$(top_builddir)/include \
-			-I$(top_srcdir)/regex \
 			-I$(top_srcdir)/server \
                         -I$(srcdir)
 WRAPLIBS=
@@ -30,18 +25,15 @@
 LDADD=			libmyisamutil.la \
 			libmyisamnone.la \
 			$(top_builddir)/mysys/libmysyslt.la \
-			$(d_dbug) \
 			$(top_builddir)/strings/libmystringslt.la -lz
 
 DEFS =                  @DEFS@
 
-EXTRA_DIST =		mi_test_all.res plug.in
-pkgdata_DATA =		mi_test_all mi_test_all.res
+EXTRA_DIST =		plug.in
 
 noinst_LTLIBRARIES =	libmyisam.la libmyisamutil.la \
 			libmyisamha.la libmyisamnone.la
 bin_PROGRAMS =		myisamchk myisamlog myisampack
-noinst_PROGRAMS =	mi_test1 mi_test2 mi_test3
 noinst_HEADERS =	myisamdef.h \
 			ha_myisam.h
 libmyisamutil_la_SOURCES = mi_open.c mi_extra.c mi_info.c mi_rkey.c \
@@ -55,7 +47,7 @@
 			mf_keycache.c mf_keycaches.c \
 			mi_rprev.c mi_rfirst.c mi_rlast.c mi_rsame.c \
 			mi_rsamepos.c mi_panic.c mi_close.c mi_create.c\
-			mi_range.c mi_dbug.c mi_checksum.c mi_log.c \
+			mi_range.c mi_checksum.c mi_log.c \
 			mi_changed.c mi_static.c mi_delete_all.c \
 			mi_delete_table.c mi_rename.c  mi_check.c \
 			mi_keycache.c mi_preload.c \
@@ -63,7 +55,4 @@
 libmyisamha_la_SOURCES = ha_myisam.cc
 libmyisamnone_la_SOURCES = mi_reportnone.c
 libmyisam_la_SOURCES = 
-libmyisam_la_LIBADD = libmyisamha.la libmyisamutil.la
-
-CLEANFILES =		test?.MY? FT?.MY? isam.log
-
+libmyisam_la_LIBADD = libmyisamha.la libmyisamutil.la
\ No newline at end of file

=== modified file 'storage/myisam/ha_myisam.cc'
--- storage/myisam/ha_myisam.cc	2008-07-15 06:45:16 +0000
+++ storage/myisam/ha_myisam.cc	2008-07-16 05:44:59 +0000
@@ -68,8 +68,6 @@
   msg_length= vsnprintf(msgbuf, sizeof(msgbuf), fmt, args);
   msgbuf[sizeof(msgbuf) - 1] = 0; // healthy paranoia
 
-  DBUG_PRINT(msg_type,("message: %s",msgbuf));
-
   if (!thd->vio_ok())
   {
     sql_print_error(msgbuf);
@@ -140,14 +138,13 @@
   HA_KEYSEG *keyseg;
   TABLE_SHARE *share= table_arg->s;
   uint options= share->db_options_in_use;
-  DBUG_ENTER("table2myisam");
   if (!(my_multi_malloc(MYF(MY_WME),
           recinfo_out, (share->fields * 2 + 2) * sizeof(MI_COLUMNDEF),
           keydef_out, share->keys * sizeof(MI_KEYDEF),
           &keyseg,
           (share->key_parts + share->keys) * sizeof(HA_KEYSEG),
           NullS)))
-    DBUG_RETURN(HA_ERR_OUT_OF_MEM); /* purecov: inspected */
+    return(HA_ERR_OUT_OF_MEM); /* purecov: inspected */
   keydef= *keydef_out;
   recinfo= *recinfo_out;
   pos= table_arg->key_info;
@@ -242,8 +239,6 @@
         }
       }
     }
-    DBUG_PRINT("loop", ("found: 0x%lx  recpos: %d  minpos: %d  length: %d",
-                        (long) found, recpos, minpos, length));
     if (recpos != minpos)
     { // Reserved space (Null bits?)
       bzero((char*) recinfo_pos, sizeof(*recinfo_pos));
@@ -282,11 +277,9 @@
     }
     (recinfo_pos++)->length= (uint16) length;
     recpos= minpos + length;
-    DBUG_PRINT("loop", ("length: %d  type: %d",
-                        recinfo_pos[-1].length,recinfo_pos[-1].type));
   }
   *records_out= (uint) (recinfo_pos - recinfo);
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -336,18 +329,13 @@
                      uint t2_keys, uint t2_recs, bool strict)
 {
   uint i, j;
-  DBUG_ENTER("check_definition");
   if ((strict ? t1_keys != t2_keys : t1_keys > t2_keys))
   {
-    DBUG_PRINT("error", ("Number of keys differs: t1_keys=%u, t2_keys=%u",
-                         t1_keys, t2_keys));
-    DBUG_RETURN(1);
+    return(1);
   }
   if (t1_recs != t2_recs)
   {
-    DBUG_PRINT("error", ("Number of recs differs: t1_recs=%u, t2_recs=%u",
-                         t1_recs, t2_recs));
-    DBUG_RETURN(1);
+    return(1);
   }
   for (i= 0; i < t1_keys; i++)
   {
@@ -358,32 +346,19 @@
     else if (t1_keyinfo[i].flag & HA_FULLTEXT ||
              t2_keyinfo[i].flag & HA_FULLTEXT)
     {
-       DBUG_PRINT("error", ("Key %d has different definition", i));
-       DBUG_PRINT("error", ("t1_fulltext= %d, t2_fulltext=%d",
-                            test(t1_keyinfo[i].flag & HA_FULLTEXT),
-                            test(t2_keyinfo[i].flag & HA_FULLTEXT)));
-       DBUG_RETURN(1);
+       return(1);
     }
     if (t1_keyinfo[i].flag & HA_SPATIAL && t2_keyinfo[i].flag & HA_SPATIAL)
       continue;
     else if (t1_keyinfo[i].flag & HA_SPATIAL ||
              t2_keyinfo[i].flag & HA_SPATIAL)
     {
-       DBUG_PRINT("error", ("Key %d has different definition", i));
-       DBUG_PRINT("error", ("t1_spatial= %d, t2_spatial=%d",
-                            test(t1_keyinfo[i].flag & HA_SPATIAL),
-                            test(t2_keyinfo[i].flag & HA_SPATIAL)));
-       DBUG_RETURN(1);
+       return(1);
     }
     if (t1_keyinfo[i].keysegs != t2_keyinfo[i].keysegs ||
         t1_keyinfo[i].key_alg != t2_keyinfo[i].key_alg)
     {
-      DBUG_PRINT("error", ("Key %d has different definition", i));
-      DBUG_PRINT("error", ("t1_keysegs=%d, t1_key_alg=%d",
-                           t1_keyinfo[i].keysegs, t1_keyinfo[i].key_alg));
-      DBUG_PRINT("error", ("t2_keysegs=%d, t2_key_alg=%d",
-                           t2_keyinfo[i].keysegs, t2_keyinfo[i].key_alg));
-      DBUG_RETURN(1);
+      return(1);
     }
     for (j=  t1_keyinfo[i].keysegs; j--;)
     {
@@ -411,18 +386,7 @@
           t1_keysegs[j].null_bit != t2_keysegs[j].null_bit ||
           t1_keysegs[j].length != t2_keysegs[j].length)
       {
-        DBUG_PRINT("error", ("Key segment %d (key %d) has different "
-                             "definition", j, i));
-        DBUG_PRINT("error", ("t1_type=%d, t1_language=%d, t1_null_bit=%d, "
-                             "t1_length=%d",
-                             t1_keysegs[j].type, t1_keysegs[j].language,
-                             t1_keysegs[j].null_bit, t1_keysegs[j].length));
-        DBUG_PRINT("error", ("t2_type=%d, t2_language=%d, t2_null_bit=%d, "
-                             "t2_length=%d",
-                             t2_keysegs[j].type, t2_keysegs[j].language,
-                             t2_keysegs[j].null_bit, t2_keysegs[j].length));
-
-        DBUG_RETURN(1);
+        return(1);
       }
     }
   }
@@ -441,15 +405,10 @@
         t1_rec->length != t2_rec->length ||
         t1_rec->null_bit != t2_rec->null_bit)
     {
-      DBUG_PRINT("error", ("Field %d has different definition", i));
-      DBUG_PRINT("error", ("t1_type=%d, t1_length=%d, t1_null_bit=%d",
-                           t1_rec->type, t1_rec->length, t1_rec->null_bit));
-      DBUG_PRINT("error", ("t2_type=%d, t2_length=%d, t2_null_bit=%d",
-                           t2_rec->type, t2_rec->length, t2_rec->null_bit));
-      DBUG_RETURN(1);
+      return(1);
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -597,8 +556,6 @@
     if ((my_errno= table2myisam(table, &keyinfo, &recinfo, &recs)))
     {
       /* purecov: begin inspected */
-      DBUG_PRINT("error", ("Failed to convert TABLE object to MyISAM "
-                           "key and column definition"));
       goto err;
       /* purecov: end */
     }
@@ -889,7 +846,6 @@
   char fixed_name[FN_REFLEN];
   MYISAM_SHARE* share = file->s;
   ha_rows rows= file->state->records;
-  DBUG_ENTER("ha_myisam::repair");
 
   /*
     Normally this method is entered with a properly opened table. If the
@@ -904,7 +860,7 @@
     sql_print_information("Retrying repair of: '%s' failed. "
                           "Please try REPAIR EXTENDED or myisamchk",
                           table->s->path.str);
-    DBUG_RETURN(HA_ADMIN_FAILED);
+    return(HA_ADMIN_FAILED);
   }
 
   param.db_name=    table->s->db.str;
@@ -921,7 +877,7 @@
       mi_lock_database(file, table->s->tmp_table ? F_EXTRA_LCK : F_WRLCK))
   {
     mi_check_print_error(&param,ER(ER_CANT_LOCK),my_errno);
-    DBUG_RETURN(HA_ADMIN_FAILED);
+    return(HA_ADMIN_FAILED);
   }
 
   if (!do_optimize ||
@@ -1029,7 +985,7 @@
   thd_proc_info(thd, old_proc_info);
   if (!thd->locked_tables)
     mi_lock_database(file,F_UNLCK);
-  DBUG_RETURN(error ? HA_ADMIN_FAILED :
+  return(error ? HA_ADMIN_FAILED :
 	      !optimize_done ? HA_ADMIN_ALREADY_DONE : HA_ADMIN_OK);
 }
 
@@ -1045,12 +1001,11 @@
   int error= HA_ADMIN_OK;
   uint64_t map;
   TABLE_LIST *table_list= table->pos_in_table_list;
-  DBUG_ENTER("ha_myisam::assign_to_keycache");
 
   table->keys_in_use_for_query.clear_all();
 
   if (table_list->process_index_hints(table))
-    DBUG_RETURN(HA_ADMIN_FAILED);
+    return(HA_ADMIN_FAILED);
   map= ~(uint64_t) 0;
   if (!table->keys_in_use_for_query.is_clear_all())
     /* use all keys if there's no list specified by the user through hints */
@@ -1077,7 +1032,7 @@
     param.testflag= 0;
     mi_check_print_error(&param, errmsg);
   }
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -1251,12 +1206,9 @@
 
 void ha_myisam::start_bulk_insert(ha_rows rows)
 {
-  DBUG_ENTER("ha_myisam::start_bulk_insert");
   THD *thd= current_thd;
   ulong size= min(thd->variables.read_buff_size,
                   (ulong) (table->s->avg_row_length*rows));
-  DBUG_PRINT("info",("start_bulk_insert: rows %lu size %lu",
-                     (ulong) rows, size));
 
   /* don't enable row cache if too few rows */
   if (! rows || (rows > MI_MIN_ROWS_TO_USE_WRITE_CACHE))
@@ -1283,7 +1235,7 @@
       mi_init_bulk_insert(file, thd->variables.bulk_insert_buff_size, rows);
     }
   }
-  DBUG_VOID_RETURN;
+  return;
 }
 
 /*
@@ -1315,7 +1267,6 @@
   char *old_query;
   uint old_query_length;
   HA_CHECK_OPT check_opt;
-  DBUG_ENTER("ha_myisam::check_and_repair");
 
   check_opt.init();
   check_opt.flags= T_MEDIUM | T_AUTO_REPAIR;
@@ -1346,7 +1297,7 @@
   thd->query= old_query;
   thd->query_length= old_query_length;
   pthread_mutex_unlock(&LOCK_thread_count);
-  DBUG_RETURN(error);
+  return(error);
 }
 
 bool ha_myisam::is_crashed() const
@@ -1411,7 +1362,7 @@
                               key_part_map keypart_map,
                               enum ha_rkey_function find_flag)
 {
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_key_count);
   int error=mi_rkey(file, buf, active_index, key, keypart_map, find_flag);
   table->status=error ? STATUS_NOT_FOUND: 0;
@@ -1431,18 +1382,17 @@
 int ha_myisam::index_read_last_map(uchar *buf, const uchar *key,
                                    key_part_map keypart_map)
 {
-  DBUG_ENTER("ha_myisam::index_read_last");
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_key_count);
   int error=mi_rkey(file, buf, active_index, key, keypart_map,
                     HA_READ_PREFIX_LAST);
   table->status=error ? STATUS_NOT_FOUND: 0;
-  DBUG_RETURN(error);
+  return(error);
 }
 
 int ha_myisam::index_next(uchar *buf)
 {
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_next_count);
   int error=mi_rnext(file,buf,active_index);
   table->status=error ? STATUS_NOT_FOUND: 0;
@@ -1451,7 +1401,7 @@
 
 int ha_myisam::index_prev(uchar *buf)
 {
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_prev_count);
   int error=mi_rprev(file,buf, active_index);
   table->status=error ? STATUS_NOT_FOUND: 0;
@@ -1460,7 +1410,7 @@
 
 int ha_myisam::index_first(uchar *buf)
 {
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_first_count);
   int error=mi_rfirst(file, buf, active_index);
   table->status=error ? STATUS_NOT_FOUND: 0;
@@ -1469,7 +1419,7 @@
 
 int ha_myisam::index_last(uchar *buf)
 {
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_last_count);
   int error=mi_rlast(file, buf, active_index);
   table->status=error ? STATUS_NOT_FOUND: 0;
@@ -1481,7 +1431,7 @@
 			       uint length __attribute__((unused)))
 {
   int error;
-  DBUG_ASSERT(inited==INDEX);
+  assert(inited==INDEX);
   ha_statistic_increment(&SSV::ha_read_next_count);
   do
   {
@@ -1697,7 +1647,6 @@
   MI_CREATE_INFO create_info;
   TABLE_SHARE *share= table_arg->s;
   uint options= share->db_options_in_use;
-  DBUG_ENTER("ha_myisam::create");
   for (i= 0; i < share->keys; i++)
   {
     if (table_arg->key_info[i].flags & HA_USES_PARSER)
@@ -1707,7 +1656,7 @@
     }
   }
   if ((error= table2myisam(table_arg, &keydef, &recinfo, &records)))
-    DBUG_RETURN(error); /* purecov: inspected */
+    return(error); /* purecov: inspected */
   bzero((char*) &create_info, sizeof(create_info));
   create_info.max_rows= share->max_rows;
   create_info.reloc_rows= share->min_rows;
@@ -1740,7 +1689,7 @@
                    0, (MI_UNIQUEDEF*) 0,
                    &create_info, create_flags);
   my_free((uchar*) recinfo, MYF(0));
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -1952,89 +1901,3 @@
   NULL                        /* config options                  */
 }
 mysql_declare_plugin_end;
-
-
-#ifdef HAVE_QUERY_CACHE
-/**
-  @brief Register a named table with a call back function to the query cache.
-
-  @param thd The thread handle
-  @param table_key A pointer to the table name in the table cache
-  @param key_length The length of the table name
-  @param[out] engine_callback The pointer to the storage engine call back
-    function, currently 0
-  @param[out] engine_data Engine data will be set to 0.
-
-  @note Despite the name of this function, it is used to check each statement
-    before it is cached and not to register a table or callback function.
-
-  @see handler::register_query_cache_table
-
-  @return The error code. The engine_data and engine_callback will be set to 0.
-    @retval true Success
-    @retval false An error occured
-*/
-
-my_bool ha_myisam::register_query_cache_table(THD *thd, char *table_name,
-                                              uint table_name_len,
-                                              qc_engine_callback
-                                              *engine_callback,
-                                              uint64_t *engine_data)
-{
-  DBUG_ENTER("ha_myisam::register_query_cache_table");
-  /*
-    No call back function is needed to determine if a cached statement
-    is valid or not.
-  */
-  *engine_callback= 0;
-
-  /*
-    No engine data is needed.
-  */
-  *engine_data= 0;
-
-  if (file->s->concurrent_insert)
-  {
-    /*
-      If a concurrent INSERT has happened just before the currently
-      processed SELECT statement, the total size of the table is
-      unknown.
-
-      To determine if the table size is known, the current thread's snap
-      shot of the table size with the actual table size are compared.
-
-      If the table size is unknown the SELECT statement can't be cached.
-
-      When concurrent inserts are disabled at table open, mi_open()
-      does not assign a get_status() function. In this case the local
-      ("current") status is never updated. We would wrongly think that
-      we cannot cache the statement.
-    */
-    uint64_t actual_data_file_length;
-    uint64_t current_data_file_length;
-
-    /*
-      POSIX visibility rules specify that "2. Whatever memory values a
-      thread can see when it unlocks a mutex <...> can also be seen by any
-      thread that later locks the same mutex". In this particular case,
-      concurrent insert thread had modified the data_file_length in
-      MYISAM_SHARE before it has unlocked (or even locked)
-      structure_guard_mutex. So, here we're guaranteed to see at least that
-      value after we've locked the same mutex. We can see a later value
-      (modified by some other thread) though, but it's ok, as we only want
-      to know if the variable was changed, the actual new value doesn't matter
-    */
-    actual_data_file_length= file->s->state.state.data_file_length;
-    current_data_file_length= file->save_state.data_file_length;
-
-    if (current_data_file_length != actual_data_file_length)
-    {
-      /* Don't cache current statement. */
-      DBUG_RETURN(false);
-    }
-  }
-
-  /* It is ok to try to cache current statement. */
-  DBUG_RETURN(true);
-}
-#endif

=== removed file 'storage/myisam/make-ccc'
--- storage/myisam/make-ccc	2008-07-15 06:32:36 +0000
+++ storage/myisam/make-ccc	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-rm -f .deps/*.P
-ccc -DMAP_TO_USE_RAID -I./../include -I../include -DDBUG_OFF -fast -O3 -c mi_cache.c mi_changed.c mi_checksum.c mi_close.c mi_create.c mi_dbug.c mi_delete.c mi_delete_all.c mi_delete_table.c mi_dynrec.c mi_extra.c mi_info.c mi_key.c mi_locking.c mi_log.c mi_open.c mi_packrec.c mi_page.c mi_panic.c mi_range.c mi_rename.c mi_rfirst.c mi_rkey.c mi_rlast.c mi_rnext.c mi_rnext_same.c mi_rprev.c mi_rrnd.c mi_rsame.c mi_rsamepos.c mi_scan.c mi_search.c mi_static.c mi_statrec.c mi_unique.c mi_update.c mi_write.c
-make sort.o mi_check.o
-rm libmyisam.a
-ar -cr libmyisam.a mi_cache.o sort.o mi_check.o

=== modified file 'storage/myisam/mf_keycache.c'
--- storage/myisam/mf_keycache.c	2008-07-15 06:45:16 +0000
+++ storage/myisam/mf_keycache.c	2008-07-16 05:44:59 +0000
@@ -130,22 +130,11 @@
     situation, which theoretically should not happen;
     to set timeout equal to <T> seconds add
       #define KEYCACHE_TIMEOUT <T>
-  - to enable the module traps and to send debug information from
-    key cache module to a special debug log add:
-      #define KEYCACHE_DEBUG
-    the name of this debug log file <LOG NAME> can be set through:
-      #define KEYCACHE_DEBUG_LOG  <LOG NAME>
-    if the name is not defined, it's set by default;
-    if the KEYCACHE_DEBUG flag is not set up and we are in a debug
-    mode, i.e. when ! defined(DBUG_OFF), the debug information from the
-    module is sent to the regular debug log.
 
   Example of the settings:
     #define SERIALIZED_READ_FROM_CACHE
     #define MAX_THREADS   100
     #define KEYCACHE_TIMEOUT  1
-    #define KEYCACHE_DEBUG
-    #define KEYCACHE_DEBUG_LOG  "my_key_cache_debug.log"
 */
 
 #define STRUCT_PTR(TYPE, MEMBER, a)                                           \
@@ -225,105 +214,27 @@
                           pthread_mutex_t *mutex);
 static void release_whole_queue(KEYCACHE_WQUEUE *wqueue);
 static void free_block(KEY_CACHE *keycache, BLOCK_LINK *block);
-#if !defined(DBUG_OFF)
-static void test_key_cache(KEY_CACHE *keycache,
-                           const char *where, my_bool lock);
-#endif
 
 #define KEYCACHE_HASH(f, pos)                                                 \
 (((ulong) ((pos) / keycache->key_cache_block_size) +                          \
                                      (ulong) (f)) & (keycache->hash_entries-1))
 #define FILE_HASH(f)                 ((uint) (f) & (CHANGED_BLOCKS_HASH-1))
 
-#define DEFAULT_KEYCACHE_DEBUG_LOG  "keycache_debug.log"
-
-#if defined(KEYCACHE_DEBUG) && ! defined(KEYCACHE_DEBUG_LOG)
-#define KEYCACHE_DEBUG_LOG  DEFAULT_KEYCACHE_DEBUG_LOG
-#endif
-
-#if defined(KEYCACHE_DEBUG_LOG)
-static FILE *keycache_debug_log=NULL;
-static void keycache_debug_print _VARARGS((const char *fmt,...));
-#define KEYCACHE_DEBUG_OPEN                                                   \
-          if (!keycache_debug_log)                                            \
-          {                                                                   \
-            keycache_debug_log= fopen(KEYCACHE_DEBUG_LOG, "w");               \
-            (void) setvbuf(keycache_debug_log, NULL, _IOLBF, BUFSIZ);         \
-          }
-
-#define KEYCACHE_DEBUG_CLOSE                                                  \
-          if (keycache_debug_log)                                             \
-          {                                                                   \
-            fclose(keycache_debug_log);                                       \
-            keycache_debug_log= 0;                                            \
-          }
-#else
-#define KEYCACHE_DEBUG_OPEN
-#define KEYCACHE_DEBUG_CLOSE
-#endif /* defined(KEYCACHE_DEBUG_LOG) */
-
-#if defined(KEYCACHE_DEBUG_LOG) && defined(KEYCACHE_DEBUG)
-#define KEYCACHE_DBUG_PRINT(l, m)                                             \
-            { if (keycache_debug_log) fprintf(keycache_debug_log, "%s: ", l); \
-              keycache_debug_print m; }
-
-#define KEYCACHE_DBUG_ASSERT(a)                                               \
-            { if (! (a) && keycache_debug_log) fclose(keycache_debug_log);    \
-              assert(a); }
-#else
-#define KEYCACHE_DBUG_PRINT(l, m)  DBUG_PRINT(l, m)
-#define KEYCACHE_DBUG_ASSERT(a)    DBUG_ASSERT(a)
-#endif /* defined(KEYCACHE_DEBUG_LOG) && defined(KEYCACHE_DEBUG) */
-
-#if defined(KEYCACHE_DEBUG) || !defined(DBUG_OFF)
-static long keycache_thread_id;
-#define KEYCACHE_THREAD_TRACE(l)                                              \
-             KEYCACHE_DBUG_PRINT(l,("|thread %ld",keycache_thread_id))
-
-#define KEYCACHE_THREAD_TRACE_BEGIN(l)                                        \
-            { struct st_my_thread_var *thread_var= my_thread_var;             \
-              keycache_thread_id= thread_var->id;                             \
-              KEYCACHE_DBUG_PRINT(l,("[thread %ld",keycache_thread_id)) }
-
-#define KEYCACHE_THREAD_TRACE_END(l)                                          \
-            KEYCACHE_DBUG_PRINT(l,("]thread %ld",keycache_thread_id))
-#else
-#define KEYCACHE_THREAD_TRACE_BEGIN(l)
-#define KEYCACHE_THREAD_TRACE_END(l)
-#define KEYCACHE_THREAD_TRACE(l)
-#endif /* defined(KEYCACHE_DEBUG) || !defined(DBUG_OFF) */
-
 #define BLOCK_NUMBER(b)                                                       \
   ((uint) (((char*)(b)-(char *) keycache->block_root)/sizeof(BLOCK_LINK)))
 #define HASH_LINK_NUMBER(h)                                                   \
   ((uint) (((char*)(h)-(char *) keycache->hash_link_root)/sizeof(HASH_LINK)))
 
-#if (defined(KEYCACHE_TIMEOUT)) || defined(KEYCACHE_DEBUG)
+#ifdef KEYCACHE_TIMEOUT
 static int keycache_pthread_cond_wait(pthread_cond_t *cond,
                                       pthread_mutex_t *mutex);
 #else
 #define  keycache_pthread_cond_wait pthread_cond_wait
 #endif
 
-#if defined(KEYCACHE_DEBUG)
-static int keycache_pthread_mutex_lock(pthread_mutex_t *mutex);
-static void keycache_pthread_mutex_unlock(pthread_mutex_t *mutex);
-static int keycache_pthread_cond_signal(pthread_cond_t *cond);
-#else
 #define keycache_pthread_mutex_lock pthread_mutex_lock
 #define keycache_pthread_mutex_unlock pthread_mutex_unlock
 #define keycache_pthread_cond_signal pthread_cond_signal
-#endif /* defined(KEYCACHE_DEBUG) */
-
-#if !defined(DBUG_OFF)
-#if defined(inline)
-#undef inline
-#endif
-#define inline  /* disabled inline for easier debugging */
-static int fail_block(BLOCK_LINK *block);
-static int fail_hlink(HASH_LINK *hlink);
-static int cache_empty(KEY_CACHE *keycache);
-#endif
 
 static inline uint next_power(uint value)
 {
@@ -363,14 +274,11 @@
   ulong blocks, hash_links;
   size_t length;
   int error;
-  DBUG_ENTER("init_key_cache");
-  DBUG_ASSERT(key_cache_block_size >= 512);
+  assert(key_cache_block_size >= 512);
 
-  KEYCACHE_DEBUG_OPEN;
   if (keycache->key_cache_inited && keycache->disk_blocks > 0)
   {
-    DBUG_PRINT("warning",("key cache already in use"));
-    DBUG_RETURN(0);
+    return(0);
   }
 
   keycache->global_cache_w_requests= keycache->global_cache_r_requests= 0;
@@ -394,8 +302,6 @@
 
   keycache->key_cache_mem_size= use_mem;
   keycache->key_cache_block_size= key_cache_block_size;
-  DBUG_PRINT("info", ("key_cache_block_size: %u",
-		      key_cache_block_size));
 
   blocks= (ulong) (use_mem / (sizeof(BLOCK_LINK) + 2 * sizeof(HASH_LINK) +
                               sizeof(HASH_LINK*) * 5/4 + key_cache_block_size));
@@ -477,12 +383,6 @@
 
     keycache->waiting_for_hash_link.last_thread= NULL;
     keycache->waiting_for_block.last_thread= NULL;
-    DBUG_PRINT("exit",
-	       ("disk_blocks: %d  block_root: 0x%lx  hash_entries: %d\
- hash_root: 0x%lx  hash_links: %d  hash_link_root: 0x%lx",
-		keycache->disk_blocks,  (long) keycache->block_root,
-		keycache->hash_entries, (long) keycache->hash_root,
-		keycache->hash_links,   (long) keycache->hash_link_root));
     bzero((uchar*) keycache->changed_blocks,
 	  sizeof(keycache->changed_blocks[0]) * CHANGED_BLOCKS_HASH);
     bzero((uchar*) keycache->file_blocks,
@@ -495,7 +395,7 @@
   }
 
   keycache->blocks= keycache->disk_blocks > 0 ? keycache->disk_blocks : 0;
-  DBUG_RETURN((int) keycache->disk_blocks);
+  return((int) keycache->disk_blocks);
 
 err:
   error= my_errno;
@@ -513,7 +413,7 @@
   }
   my_errno= error;
   keycache->can_be_used= 0;
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -551,16 +451,15 @@
 		     uint age_threshold)
 {
   int blocks;
-  DBUG_ENTER("resize_key_cache");
 
   if (!keycache->key_cache_inited)
-    DBUG_RETURN(keycache->disk_blocks);
+    return(keycache->disk_blocks);
 
   if(key_cache_block_size == keycache->key_cache_block_size &&
      use_mem == keycache->key_cache_mem_size)
   {
     change_key_cache_param(keycache, division_limit, age_threshold);
-    DBUG_RETURN(keycache->disk_blocks);
+    return(keycache->disk_blocks);
   }
 
   keycache_pthread_mutex_lock(&keycache->cache_lock);
@@ -599,7 +498,6 @@
       keycache->can_be_used= 0;
       goto finish;
     }
-    DBUG_ASSERT(cache_empty(keycache));
 
     /* End the flush phase. */
     keycache->resize_in_flush= 0;
@@ -641,7 +539,7 @@
   release_whole_queue(&keycache->resize_queue);
 
   keycache_pthread_mutex_unlock(&keycache->cache_lock);
-  DBUG_RETURN(blocks);
+  return(blocks);
 }
 
 
@@ -685,8 +583,6 @@
 void change_key_cache_param(KEY_CACHE *keycache, uint division_limit,
 			    uint age_threshold)
 {
-  DBUG_ENTER("change_key_cache_param");
-
   keycache_pthread_mutex_lock(&keycache->cache_lock);
   if (division_limit)
     keycache->min_warm_blocks= (keycache->disk_blocks *
@@ -695,7 +591,7 @@
     keycache->age_threshold=   (keycache->disk_blocks *
 				age_threshold / 100);
   keycache_pthread_mutex_unlock(&keycache->cache_lock);
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -713,11 +609,8 @@
 
 void end_key_cache(KEY_CACHE *keycache, my_bool cleanup)
 {
-  DBUG_ENTER("end_key_cache");
-  DBUG_PRINT("enter", ("key_cache: 0x%lx", (long) keycache));
-
   if (!keycache->key_cache_inited)
-    DBUG_VOID_RETURN;
+    return;
 
   if (keycache->disk_blocks > 0)
   {
@@ -733,21 +626,12 @@
     keycache->blocks_changed= 0;
   }
 
-  DBUG_PRINT("status", ("used: %lu  changed: %lu  w_requests: %lu  "
-                        "writes: %lu  r_requests: %lu  reads: %lu",
-                        keycache->blocks_used, keycache->global_blocks_changed,
-                        (ulong) keycache->global_cache_w_requests,
-                        (ulong) keycache->global_cache_write,
-                        (ulong) keycache->global_cache_r_requests,
-                        (ulong) keycache->global_cache_read));
-
   if (cleanup)
   {
     pthread_mutex_destroy(&keycache->cache_lock);
     keycache->key_cache_inited= keycache->can_be_used= 0;
-    KEYCACHE_DEBUG_CLOSE;
   }
-  DBUG_VOID_RETURN;
+  return;
 } /* end_key_cache */
 
 
@@ -773,7 +657,7 @@
 {
   struct st_my_thread_var *last;
 
-  DBUG_ASSERT(!thread->next && !thread->prev);
+  assert(!thread->next && !thread->prev);
   if (! (last= wqueue->last_thread))
   {
     /* Queue is empty */
@@ -808,8 +692,7 @@
 static void unlink_from_queue(KEYCACHE_WQUEUE *wqueue,
                                      struct st_my_thread_var *thread)
 {
-  KEYCACHE_DBUG_PRINT("unlink_from_queue", ("thread %ld", thread->id));
-  DBUG_ASSERT(thread->next && thread->prev);
+  assert(thread->next && thread->prev);
   if (thread->next == thread)
     /* The queue contains only one member */
     wqueue->last_thread= NULL;
@@ -822,13 +705,7 @@
                                       thread->prev);
   }
   thread->next= NULL;
-#if !defined(DBUG_OFF)
-  /*
-    This makes it easier to see it's not in a chain during debugging.
-    And some DBUG_ASSERT() rely on it.
-  */
   thread->prev= NULL;
-#endif
 }
 
 
@@ -862,8 +739,8 @@
   struct st_my_thread_var *thread= my_thread_var;
 
   /* Add to queue. */
-  DBUG_ASSERT(!thread->next);
-  DBUG_ASSERT(!thread->prev); /* Not required, but must be true anyway. */
+  assert(!thread->next);
+  assert(!thread->prev); /* Not required, but must be true anyway. */
   if (! (last= wqueue->last_thread))
     thread->next= thread;
   else
@@ -879,7 +756,6 @@
   */
   do
   {
-    KEYCACHE_DBUG_PRINT("wait", ("suspend thread %ld", thread->id));
     keycache_pthread_cond_wait(&thread->suspend, mutex);
   }
   while (thread->next);
@@ -916,8 +792,6 @@
   do
   {
     thread=next;
-    KEYCACHE_DBUG_PRINT("release_whole_queue: signal",
-                        ("thread %ld", thread->id));
     /* Signal the thread. */
     keycache_pthread_cond_signal(&thread->suspend);
     /* Take thread from queue. */
@@ -934,22 +808,14 @@
 /*
   Unlink a block from the chain of dirty/clean blocks
 */
-
 static inline void unlink_changed(BLOCK_LINK *block)
 {
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
+  assert(block->prev_changed && *block->prev_changed == block);
   if (block->next_changed)
     block->next_changed->prev_changed= block->prev_changed;
   *block->prev_changed= block->next_changed;
-
-#if !defined(DBUG_OFF)
-  /*
-    This makes it easier to see it's not in a chain during debugging.
-    And some DBUG_ASSERT() rely on it.
-  */
   block->next_changed= NULL;
   block->prev_changed= NULL;
-#endif
 }
 
 
@@ -959,8 +825,8 @@
 
 static inline void link_changed(BLOCK_LINK *block, BLOCK_LINK **phead)
 {
-  DBUG_ASSERT(!block->next_changed);
-  DBUG_ASSERT(!block->prev_changed);
+  assert(!block->next_changed);
+  assert(!block->prev_changed);
   block->prev_changed= phead;
   if ((block->next_changed= *phead))
     (*phead)->prev_changed= &block->next_changed;
@@ -997,9 +863,9 @@
                               BLOCK_LINK *block, int file,
                               my_bool unlink_block)
 {
-  DBUG_ASSERT(block->status & BLOCK_IN_USE);
-  DBUG_ASSERT(block->hash_link && block->hash_link->block == block);
-  DBUG_ASSERT(block->hash_link->file == file);
+  assert(block->status & BLOCK_IN_USE);
+  assert(block->hash_link && block->hash_link->block == block);
+  assert(block->hash_link->file == file);
   if (unlink_block)
     unlink_changed(block);
   link_changed(block, &keycache->file_blocks[FILE_HASH(file)]);
@@ -1037,9 +903,9 @@
 static void link_to_changed_list(KEY_CACHE *keycache,
                                  BLOCK_LINK *block)
 {
-  DBUG_ASSERT(block->status & BLOCK_IN_USE);
-  DBUG_ASSERT(!(block->status & BLOCK_CHANGED));
-  DBUG_ASSERT(block->hash_link && block->hash_link->block == block);
+  assert(block->status & BLOCK_IN_USE);
+  assert(!(block->status & BLOCK_CHANGED));
+  assert(block->hash_link && block->hash_link->block == block);
 
   unlink_changed(block);
   link_changed(block,
@@ -1095,12 +961,12 @@
   BLOCK_LINK *ins;
   BLOCK_LINK **pins;
 
-  DBUG_ASSERT((block->status & ~BLOCK_CHANGED) == (BLOCK_READ | BLOCK_IN_USE));
-  DBUG_ASSERT(block->hash_link); /*backptr to block NULL from free_block()*/
-  DBUG_ASSERT(!block->requests);
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
-  DBUG_ASSERT(!block->next_used);
-  DBUG_ASSERT(!block->prev_used);
+  assert((block->status & ~BLOCK_CHANGED) == (BLOCK_READ | BLOCK_IN_USE));
+  assert(block->hash_link); /*backptr to block NULL from free_block()*/
+  assert(!block->requests);
+  assert(block->prev_changed && *block->prev_changed == block);
+  assert(!block->next_used);
+  assert(!block->prev_used);
   if (!hot && keycache->waiting_for_block.last_thread)
   {
     /* Signal that in the LRU warm sub-chain an available block has appeared */
@@ -1120,7 +986,6 @@
       */
       if ((HASH_LINK *) thread->opt_info == hash_link)
       {
-        KEYCACHE_DBUG_PRINT("link_block: signal", ("thread %ld", thread->id));
         keycache_pthread_cond_signal(&thread->suspend);
         unlink_from_queue(&keycache->waiting_for_block, thread);
         block->requests++;
@@ -1151,13 +1016,6 @@
       probably easier to read.
     */
     block->status|= BLOCK_IN_EVICTION;
-    KEYCACHE_THREAD_TRACE("link_block: after signaling");
-#if defined(KEYCACHE_DEBUG)
-    KEYCACHE_DBUG_PRINT("link_block",
-        ("linked,unlinked block %u  status=%x  #requests=%u  #available=%u",
-         BLOCK_NUMBER(block), block->status,
-         block->requests, keycache->blocks_available));
-#endif
     return;
   }
   pins= hot ? &keycache->used_ins : &keycache->used_last;
@@ -1177,16 +1035,6 @@
     keycache->used_last= keycache->used_ins= block->next_used= block;
     block->prev_used= &block->next_used;
   }
-  KEYCACHE_THREAD_TRACE("link_block");
-#if defined(KEYCACHE_DEBUG)
-  keycache->blocks_available++;
-  KEYCACHE_DBUG_PRINT("link_block",
-      ("linked block %u:%1u  status=%x  #requests=%u  #available=%u",
-       BLOCK_NUMBER(block), at_end, block->status,
-       block->requests, keycache->blocks_available));
-  KEYCACHE_DBUG_ASSERT((ulong) keycache->blocks_available <=
-                       keycache->blocks_used);
-#endif
 }
 
 
@@ -1207,11 +1055,11 @@
 
 static void unlink_block(KEY_CACHE *keycache, BLOCK_LINK *block)
 {
-  DBUG_ASSERT((block->status & ~BLOCK_CHANGED) == (BLOCK_READ | BLOCK_IN_USE));
-  DBUG_ASSERT(block->hash_link); /*backptr to block NULL from free_block()*/
-  DBUG_ASSERT(!block->requests);
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
-  DBUG_ASSERT(block->next_used && block->prev_used &&
+  assert((block->status & ~BLOCK_CHANGED) == (BLOCK_READ | BLOCK_IN_USE));
+  assert(block->hash_link); /*backptr to block NULL from free_block()*/
+  assert(!block->requests);
+  assert(block->prev_changed && *block->prev_changed == block);
+  assert(block->next_used && block->prev_used &&
               (block->next_used->prev_used == &block->next_used) &&
               (*block->prev_used == block));
   if (block->next_used == block)
@@ -1227,23 +1075,7 @@
       keycache->used_ins=STRUCT_PTR(BLOCK_LINK, next_used, block->prev_used);
   }
   block->next_used= NULL;
-#if !defined(DBUG_OFF)
-  /*
-    This makes it easier to see it's not in a chain during debugging.
-    And some DBUG_ASSERT() rely on it.
-  */
   block->prev_used= NULL;
-#endif
-
-  KEYCACHE_THREAD_TRACE("unlink_block");
-#if defined(KEYCACHE_DEBUG)
-  KEYCACHE_DBUG_ASSERT(keycache->blocks_available != 0);
-  keycache->blocks_available--;
-  KEYCACHE_DBUG_PRINT("unlink_block",
-    ("unlinked block %u  status=%x   #requests=%u  #available=%u",
-     BLOCK_NUMBER(block), block->status,
-     block->requests, keycache->blocks_available));
-#endif
 }
 
 
@@ -1265,8 +1097,8 @@
 */
 static void reg_requests(KEY_CACHE *keycache, BLOCK_LINK *block, int count)
 {
-  DBUG_ASSERT(block->status & BLOCK_IN_USE);
-  DBUG_ASSERT(block->hash_link);
+  assert(block->status & BLOCK_IN_USE);
+  assert(block->hash_link);
 
   if (!block->requests)
     unlink_block(keycache, block);
@@ -1309,12 +1141,12 @@
 static void unreg_request(KEY_CACHE *keycache,
                           BLOCK_LINK *block, int at_end)
 {
-  DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-  DBUG_ASSERT(block->hash_link); /*backptr to block NULL from free_block()*/
-  DBUG_ASSERT(block->requests);
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
-  DBUG_ASSERT(!block->next_used);
-  DBUG_ASSERT(!block->prev_used);
+  assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+  assert(block->hash_link); /*backptr to block NULL from free_block()*/
+  assert(block->requests);
+  assert(block->prev_changed && *block->prev_changed == block);
+  assert(!block->next_used);
+  assert(!block->prev_used);
   if (! --block->requests)
   {
     my_bool hot;
@@ -1327,8 +1159,6 @@
       if (block->temperature == BLOCK_WARM)
         keycache->warm_blocks--;
       block->temperature= BLOCK_HOT;
-      KEYCACHE_DBUG_PRINT("unreg_request", ("#warm_blocks: %lu",
-                           keycache->warm_blocks));
     }
     link_block(keycache, block, hot, (my_bool)at_end);
     block->last_hit_time= keycache->keycache_time;
@@ -1359,8 +1189,6 @@
         keycache->warm_blocks++;
         block->temperature= BLOCK_WARM;
       }
-      KEYCACHE_DBUG_PRINT("unreg_request", ("#warm_blocks: %lu",
-                           keycache->warm_blocks));
     }
   }
 }
@@ -1371,12 +1199,12 @@
 
 static void remove_reader(BLOCK_LINK *block)
 {
-  DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-  DBUG_ASSERT(block->hash_link && block->hash_link->block == block);
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
-  DBUG_ASSERT(!block->next_used);
-  DBUG_ASSERT(!block->prev_used);
-  DBUG_ASSERT(block->hash_link->requests);
+  assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+  assert(block->hash_link && block->hash_link->block == block);
+  assert(block->prev_changed && *block->prev_changed == block);
+  assert(!block->next_used);
+  assert(!block->prev_used);
+  assert(block->hash_link->requests);
   if (! --block->hash_link->requests && block->condvar)
     keycache_pthread_cond_signal(block->condvar);
 }
@@ -1391,23 +1219,20 @@
                              BLOCK_LINK *block)
 {
   struct st_my_thread_var *thread= my_thread_var;
-  DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-  DBUG_ASSERT(!(block->status & (BLOCK_ERROR | BLOCK_IN_FLUSH |
+  assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+  assert(!(block->status & (BLOCK_ERROR | BLOCK_IN_FLUSH |
                                  BLOCK_CHANGED)));
-  DBUG_ASSERT(block->hash_link);
-  DBUG_ASSERT(block->hash_link->block == block);
+  assert(block->hash_link);
+  assert(block->hash_link->block == block);
   /* Linked in file_blocks or changed_blocks hash. */
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
+  assert(block->prev_changed && *block->prev_changed == block);
   /* Not linked in LRU ring. */
-  DBUG_ASSERT(!block->next_used);
-  DBUG_ASSERT(!block->prev_used);
+  assert(!block->next_used);
+  assert(!block->prev_used);
   while (block->hash_link->requests)
   {
-    KEYCACHE_DBUG_PRINT("wait_for_readers: wait",
-                        ("suspend thread %ld  block %u",
-                         thread->id, BLOCK_NUMBER(block)));
     /* There must be no other waiter. We have no queue here. */
-    DBUG_ASSERT(!block->condvar);
+    assert(!block->condvar);
     block->condvar= &thread->suspend;
     keycache_pthread_cond_wait(&thread->suspend, &keycache->cache_lock);
     block->condvar= NULL;
@@ -1435,9 +1260,7 @@
 
 static void unlink_hash(KEY_CACHE *keycache, HASH_LINK *hash_link)
 {
-  KEYCACHE_DBUG_PRINT("unlink_hash", ("fd: %u  pos_ %lu  #requests=%u",
-      (uint) hash_link->file,(ulong) hash_link->diskpos, hash_link->requests));
-  KEYCACHE_DBUG_ASSERT(hash_link->requests == 0);
+  assert(hash_link->requests == 0);
   if ((*hash_link->prev= hash_link->next))
     hash_link->next->prev= hash_link->prev;
   hash_link->block= NULL;
@@ -1465,7 +1288,6 @@
       */
       if (page->file == hash_link->file && page->filepos == hash_link->diskpos)
       {
-        KEYCACHE_DBUG_PRINT("unlink_hash: signal", ("thread %ld", thread->id));
         keycache_pthread_cond_signal(&thread->suspend);
         unlink_from_queue(&keycache->waiting_for_hash_link, thread);
       }
@@ -1489,12 +1311,6 @@
                                 int file, my_off_t filepos)
 {
   register HASH_LINK *hash_link, **start;
-#if defined(KEYCACHE_DEBUG)
-  int cnt;
-#endif
-
-  KEYCACHE_DBUG_PRINT("get_hash_link", ("fd: %u  pos: %lu",
-                      (uint) file,(ulong) filepos));
 
 restart:
   /*
@@ -1503,28 +1319,11 @@
      hash_link points to the first member of the list
   */
   hash_link= *(start= &keycache->hash_root[KEYCACHE_HASH(file, filepos)]);
-#if defined(KEYCACHE_DEBUG)
-  cnt= 0;
-#endif
   /* Look for an element for the pair (file, filepos) in the bucket chain */
   while (hash_link &&
          (hash_link->diskpos != filepos || hash_link->file != file))
   {
     hash_link= hash_link->next;
-#if defined(KEYCACHE_DEBUG)
-    cnt++;
-    if (! (cnt <= keycache->hash_links_used))
-    {
-      int i;
-      for (i=0, hash_link= *start ;
-           i < cnt ; i++, hash_link= hash_link->next)
-      {
-        KEYCACHE_DBUG_PRINT("get_hash_link", ("fd: %u  pos: %lu",
-            (uint) hash_link->file,(ulong) hash_link->diskpos));
-      }
-    }
-    KEYCACHE_DBUG_ASSERT(cnt <= keycache->hash_links_used);
-#endif
   }
   if (! hash_link)
   {
@@ -1543,13 +1342,10 @@
       /* Wait for a free hash link */
       struct st_my_thread_var *thread= my_thread_var;
       KEYCACHE_PAGE page;
-      KEYCACHE_DBUG_PRINT("get_hash_link", ("waiting"));
       page.file= file;
       page.filepos= filepos;
       thread->opt_info= (void *) &page;
       link_into_queue(&keycache->waiting_for_hash_link, thread);
-      KEYCACHE_DBUG_PRINT("get_hash_link: wait",
-                        ("suspend thread %ld", thread->id));
       keycache_pthread_cond_wait(&thread->suspend,
                                  &keycache->cache_lock);
       thread->opt_info= NULL;
@@ -1612,25 +1408,13 @@
   int error= 0;
   int page_status;
 
-  DBUG_ENTER("find_key_block");
-  KEYCACHE_THREAD_TRACE("find_key_block:begin");
-  DBUG_PRINT("enter", ("fd: %d  pos: %lu  wrmode: %d",
-                       file, (ulong) filepos, wrmode));
-  KEYCACHE_DBUG_PRINT("find_key_block", ("fd: %d  pos: %lu  wrmode: %d",
-                                         file, (ulong) filepos,
-                                         wrmode));
-#if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
-  DBUG_EXECUTE("check_keycache2",
-               test_key_cache(keycache, "start of find_key_block", 0););
-#endif
-
 restart:
   /*
     If the flush phase of a resize operation fails, the cache is left
     unusable. This will be detected only after "goto restart".
   */
   if (!keycache->can_be_used)
-    DBUG_RETURN(0);
+    return(0);
 
   /*
     Find the hash_link for the requested file block (file, filepos). We
@@ -1656,7 +1440,7 @@
           - not changed (clean).
   */
   hash_link= get_hash_link(keycache, file, filepos);
-  DBUG_ASSERT((hash_link->file == file) && (hash_link->diskpos == filepos));
+  assert((hash_link->file == file) && (hash_link->diskpos == filepos));
 
   page_status= -1;
   if ((block= hash_link->block) &&
@@ -1695,7 +1479,7 @@
         */
         hash_link->requests--;
         unlink_hash(keycache, hash_link);
-        DBUG_RETURN(0);
+        return(0);
       }
 
       /*
@@ -1714,8 +1498,6 @@
       link_into_queue(&keycache->waiting_for_block, thread);
       do
       {
-        KEYCACHE_DBUG_PRINT("find_key_block: wait",
-                            ("suspend thread %ld", thread->id));
         keycache_pthread_cond_wait(&thread->suspend,
                                    &keycache->cache_lock);
       } while (thread->next);
@@ -1762,7 +1544,7 @@
         only. Waiting here on COND_FOR_REQUESTED works in all
         situations.
       */
-      DBUG_ASSERT(((block->hash_link != hash_link) &&
+      assert(((block->hash_link != hash_link) &&
                    (block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH))) ||
                   ((block->hash_link == hash_link) &&
                    !(block->status & BLOCK_READ)));
@@ -1777,9 +1559,9 @@
         again in eviction because we registered an request on it before
         starting to wait.
       */
-      DBUG_ASSERT(block->hash_link == hash_link);
-      DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-      DBUG_ASSERT(!(block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH)));
+      assert(block->hash_link == hash_link);
+      assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+      assert(!(block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH)));
     }
     /*
       The block is in the cache. Assigned to the hash_link. Valid data.
@@ -1791,17 +1573,17 @@
     {
       /* A reader can just read the block. */
       *page_st= PAGE_READ;
-      DBUG_ASSERT((hash_link->file == file) &&
+      assert((hash_link->file == file) &&
                   (hash_link->diskpos == filepos) &&
                   (block->hash_link == hash_link));
-      DBUG_RETURN(block);
+      return(block);
     }
 
     /*
       This is a writer. No two writers for the same block can exist.
       This must be assured by locks outside of the key cache.
     */
-    DBUG_ASSERT(!(block->status & BLOCK_FOR_UPDATE) || fail_block(block));
+    assert(!(block->status & BLOCK_FOR_UPDATE));
 
     while (block->status & BLOCK_IN_FLUSH)
     {
@@ -1825,9 +1607,9 @@
         unreg_request(keycache, block, 1);
         goto restart;
       }
-      DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-      DBUG_ASSERT(!(block->status & BLOCK_FOR_UPDATE) || fail_block(block));
-      DBUG_ASSERT(block->hash_link == hash_link);
+      assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+      assert(!(block->status & BLOCK_FOR_UPDATE));
+      assert(block->hash_link == hash_link);
     }
 
     if (block->status & BLOCK_CHANGED)
@@ -1840,10 +1622,10 @@
         not yet been selected for flush, we can still add our changes.
       */
       *page_st= PAGE_READ;
-      DBUG_ASSERT((hash_link->file == file) &&
+      assert((hash_link->file == file) &&
                   (hash_link->diskpos == filepos) &&
                   (block->hash_link == hash_link));
-      DBUG_RETURN(block);
+      return(block);
     }
 
     /*
@@ -1911,7 +1693,7 @@
                (block->hash_link->file == file) &&
                (block->hash_link->diskpos == filepos));
     }
-    DBUG_RETURN(0);
+    return(0);
   }
 
   if (page_status == PAGE_READ &&
@@ -1926,13 +1708,7 @@
       (BLOCK_IN_SWITCH), readers of the block have not finished yet
       (BLOCK_REASSIGNED), or the evicting thread did not yet awake after
       the block has been selected for it (BLOCK_IN_EVICTION).
-    */
 
-    KEYCACHE_DBUG_PRINT("find_key_block",
-                        ("request for old page in block %u "
-                         "wrmode: %d  block->status: %d",
-                         BLOCK_NUMBER(block), wrmode, block->status));
-    /*
        Only reading requests can proceed until the old dirty page is flushed,
        all others are to be suspended, then resubmitted
     */
@@ -1960,13 +1736,9 @@
         as soon as possible. Again we must wait so that we don't find
         the same hash_link + block again and again.
       */
-      DBUG_ASSERT(hash_link->requests);
+      assert(hash_link->requests);
       hash_link->requests--;
-      KEYCACHE_DBUG_PRINT("find_key_block",
-                          ("request waiting for old page to be saved"));
       wait_on_queue(&block->wqueue[COND_FOR_SAVED], &keycache->cache_lock);
-      KEYCACHE_DBUG_PRINT("find_key_block",
-                          ("request for old page resubmitted"));
       /*
         The block is no longer assigned to this hash_link.
         Get another one.
@@ -2001,7 +1773,7 @@
         else
         {
           /* There are some never used blocks, take first of them */
-          DBUG_ASSERT(keycache->blocks_used <
+          assert(keycache->blocks_used <
                       (ulong) keycache->disk_blocks);
           block= &keycache->block_root[keycache->blocks_used];
           block->buffer= ADD_TO_PTR(keycache->block_mem,
@@ -2009,14 +1781,14 @@
                                      keycache->key_cache_block_size),
                                     uchar*);
           keycache->blocks_used++;
-          DBUG_ASSERT(!block->next_used);
+          assert(!block->next_used);
         }
-        DBUG_ASSERT(!block->prev_used);
-        DBUG_ASSERT(!block->next_changed);
-        DBUG_ASSERT(!block->prev_changed);
-        DBUG_ASSERT(!block->hash_link);
-        DBUG_ASSERT(!block->status);
-        DBUG_ASSERT(!block->requests);
+        assert(!block->prev_used);
+        assert(!block->next_changed);
+        assert(!block->prev_changed);
+        assert(!block->hash_link);
+        assert(!block->status);
+        assert(!block->requests);
         keycache->blocks_unused--;
         block->status= BLOCK_IN_USE;
         block->length= 0;
@@ -2029,9 +1801,6 @@
         hash_link->block= block;
         link_to_file_list(keycache, block, file, 0);
         page_status= PAGE_TO_BE_READ;
-        KEYCACHE_DBUG_PRINT("find_key_block",
-                            ("got free or never used block %u",
-                             BLOCK_NUMBER(block)));
       }
       else
       {
@@ -2059,18 +1828,16 @@
           link_into_queue(&keycache->waiting_for_block, thread);
           do
           {
-            KEYCACHE_DBUG_PRINT("find_key_block: wait",
-                                ("suspend thread %ld", thread->id));
             keycache_pthread_cond_wait(&thread->suspend,
                                        &keycache->cache_lock);
           }
           while (thread->next);
           thread->opt_info= NULL;
           /* Assert that block has a request registered. */
-          DBUG_ASSERT(hash_link->block->requests);
+          assert(hash_link->block->requests);
           /* Assert that block is not in LRU ring. */
-          DBUG_ASSERT(!hash_link->block->next_used);
-          DBUG_ASSERT(!hash_link->block->prev_used);
+          assert(!hash_link->block->next_used);
+          assert(!hash_link->block->prev_used);
         }
         /*
           If we waited above, hash_link->block has been assigned by
@@ -2089,7 +1856,7 @@
             Register a request on the block. This unlinks it from the
             LRU ring and protects it against eviction.
           */
-          DBUG_ASSERT(!block->requests);
+          assert(!block->requests);
           reg_requests(keycache, block,1);
           /*
             We do not need to set block->status|= BLOCK_IN_EVICTION here
@@ -2113,14 +1880,10 @@
 	  /* this is a primary request for a new page */
           block->status|= BLOCK_IN_SWITCH;
 
-          KEYCACHE_DBUG_PRINT("find_key_block",
-                        ("got block %u for new page", BLOCK_NUMBER(block)));
-
           if (block->status & BLOCK_CHANGED)
           {
 	    /* The block contains a dirty page - push it out of the cache */
 
-            KEYCACHE_DBUG_PRINT("find_key_block", ("block is dirty"));
             if (block->status & BLOCK_IN_FLUSH)
             {
               /*
@@ -2136,8 +1899,8 @@
                 The block is marked BLOCK_IN_SWITCH. It should be left
                 alone except for reading. No free, no write.
               */
-              DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
-              DBUG_ASSERT(!(block->status & (BLOCK_REASSIGNED |
+              assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
+              assert(!(block->status & (BLOCK_REASSIGNED |
                                              BLOCK_CHANGED |
                                              BLOCK_FOR_UPDATE)));
             }
@@ -2148,11 +1911,11 @@
                 BLOCK_IN_EVICTION may be true or not. Other flags must
                 have a fixed value.
               */
-              DBUG_ASSERT((block->status & ~BLOCK_IN_EVICTION) ==
+              assert((block->status & ~BLOCK_IN_EVICTION) ==
                           (BLOCK_READ | BLOCK_IN_SWITCH |
                            BLOCK_IN_FLUSH | BLOCK_IN_FLUSHWRITE |
                            BLOCK_CHANGED | BLOCK_IN_USE));
-              DBUG_ASSERT(block->hash_link);
+              assert(block->hash_link);
 
               keycache_pthread_mutex_unlock(&keycache->cache_lock);
               /*
@@ -2166,10 +1929,10 @@
               keycache_pthread_mutex_lock(&keycache->cache_lock);
 
               /* Block status must not have changed. */
-              DBUG_ASSERT((block->status & ~BLOCK_IN_EVICTION) ==
+              assert((block->status & ~BLOCK_IN_EVICTION) ==
                           (BLOCK_READ | BLOCK_IN_SWITCH |
                            BLOCK_IN_FLUSH | BLOCK_IN_FLUSHWRITE |
-                           BLOCK_CHANGED | BLOCK_IN_USE) || fail_block(block));
+                           BLOCK_CHANGED | BLOCK_IN_USE));
               keycache->global_cache_write++;
             }
           }
@@ -2179,7 +1942,7 @@
             The block comes from the LRU ring. It must have a hash_link
             assigned.
           */
-          DBUG_ASSERT(block->hash_link);
+          assert(block->hash_link);
           if (block->hash_link)
           {
             /*
@@ -2206,10 +1969,10 @@
 	      a page in the cache in a sweep, without yielding control)
             */
             wait_for_readers(keycache, block);
-            DBUG_ASSERT(block->hash_link && block->hash_link->block == block &&
+            assert(block->hash_link && block->hash_link->block == block &&
                         block->prev_changed);
             /* The reader must not have been a writer. */
-            DBUG_ASSERT(!(block->status & BLOCK_CHANGED));
+            assert(!(block->status & BLOCK_CHANGED));
 
             /* Wake flushers that might have found the block in between. */
             release_whole_queue(&block->wqueue[COND_FOR_SAVED]);
@@ -2233,8 +1996,8 @@
           link_to_file_list(keycache, block, file, 0);
           page_status= PAGE_TO_BE_READ;
 
-          KEYCACHE_DBUG_ASSERT(block->hash_link->block == block);
-          KEYCACHE_DBUG_ASSERT(hash_link->block->hash_link == hash_link);
+          assert(block->hash_link->block == block);
+          assert(hash_link->block->hash_link == hash_link);
         }
         else
         {
@@ -2252,10 +2015,6 @@
             attached to the same hash_link and as such destined for the
             same file block.
           */
-          KEYCACHE_DBUG_PRINT("find_key_block",
-                              ("block->hash_link: %p  hash_link: %p  "
-                               "block->status: %u", block->hash_link,
-                               hash_link, block->status ));
           page_status= (((block->hash_link == hash_link) &&
                          (block->status & BLOCK_READ)) ?
                         PAGE_READ : PAGE_WAIT_TO_BE_READ);
@@ -2284,46 +2043,33 @@
         Register a request on the block. This is another protection
         against eviction.
       */
-      DBUG_ASSERT(((block->hash_link != hash_link) &&
+      assert(((block->hash_link != hash_link) &&
                    (block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH))) ||
                   ((block->hash_link == hash_link) &&
                    !(block->status & BLOCK_READ)) ||
                   ((block->status & BLOCK_READ) &&
                    !(block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH))));
       reg_requests(keycache, block, 1);
-      KEYCACHE_DBUG_PRINT("find_key_block",
-                          ("block->hash_link: %p  hash_link: %p  "
-                           "block->status: %u", block->hash_link,
-                           hash_link, block->status ));
       page_status= (((block->hash_link == hash_link) &&
                      (block->status & BLOCK_READ)) ?
                     PAGE_READ : PAGE_WAIT_TO_BE_READ);
     }
   }
 
-  KEYCACHE_DBUG_ASSERT(page_status != -1);
+  assert(page_status != -1);
   /* Same assert basically, but be very sure. */
-  KEYCACHE_DBUG_ASSERT(block);
+  assert(block);
   /* Assert that block has a request and is not in LRU ring. */
-  DBUG_ASSERT(block->requests);
-  DBUG_ASSERT(!block->next_used);
-  DBUG_ASSERT(!block->prev_used);
+  assert(block->requests);
+  assert(!block->next_used);
+  assert(!block->prev_used);
   /* Assert that we return the correct block. */
-  DBUG_ASSERT((page_status == PAGE_WAIT_TO_BE_READ) ||
+  assert((page_status == PAGE_WAIT_TO_BE_READ) ||
               ((block->hash_link->file == file) &&
                (block->hash_link->diskpos == filepos)));
   *page_st=page_status;
-  KEYCACHE_DBUG_PRINT("find_key_block",
-                      ("fd: %d  pos: %lu  block->status: %u  page_status: %d",
-                       file, (ulong) filepos, block->status,
-                       page_status));
 
-#if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
-  DBUG_EXECUTE("check_keycache2",
-               test_key_cache(keycache, "end of find_key_block",0););
-#endif
-  KEYCACHE_THREAD_TRACE("find_key_block:end");
-  DBUG_RETURN(block);
+  return(block);
 }
 
 
@@ -2359,7 +2105,6 @@
 
   /* On entry cache_lock is locked */
 
-  KEYCACHE_THREAD_TRACE("read_block");
   if (primary)
   {
     /*
@@ -2368,15 +2113,10 @@
       request for the block become secondary requests. For a primary
       request the block must be properly initialized.
     */
-    DBUG_ASSERT(((block->status & ~BLOCK_FOR_UPDATE) == BLOCK_IN_USE) ||
-                fail_block(block));
-    DBUG_ASSERT((block->length == 0) || fail_block(block));
-    DBUG_ASSERT((block->offset == keycache->key_cache_block_size) ||
-                fail_block(block));
-    DBUG_ASSERT((block->requests > 0) || fail_block(block));
-
-    KEYCACHE_DBUG_PRINT("read_block",
-                        ("page to be read by primary request"));
+    assert(((block->status & ~BLOCK_FOR_UPDATE) == BLOCK_IN_USE));
+    assert((block->length == 0));
+    assert((block->offset == keycache->key_cache_block_size));
+    assert((block->requests > 0));
 
     keycache->global_cache_read++;
     /* Page is not in buffer yet, is to be read from disk */
@@ -2391,13 +2131,11 @@
       The block can now have been marked for free (in case of
       FLUSH_RELEASE). Otherwise the state must be unchanged.
     */
-    DBUG_ASSERT(((block->status & ~(BLOCK_REASSIGNED |
-                                    BLOCK_FOR_UPDATE)) == BLOCK_IN_USE) ||
-                fail_block(block));
-    DBUG_ASSERT((block->length == 0) || fail_block(block));
-    DBUG_ASSERT((block->offset == keycache->key_cache_block_size) ||
-                fail_block(block));
-    DBUG_ASSERT((block->requests > 0) || fail_block(block));
+    assert(((block->status & ~(BLOCK_REASSIGNED |
+                                    BLOCK_FOR_UPDATE)) == BLOCK_IN_USE));
+    assert((block->length == 0));
+    assert((block->offset == keycache->key_cache_block_size));
+    assert((block->requests > 0));
 
     if (got_length < min_length)
       block->status|= BLOCK_ERROR;
@@ -2412,8 +2150,6 @@
         keycache->key_cache_block_size.
       */
     }
-    KEYCACHE_DBUG_PRINT("read_block",
-                        ("primary request: new page in cache"));
     /* Signal that all pending requests for this page now can be processed */
     release_whole_queue(&block->wqueue[COND_FOR_REQUESTED]);
   }
@@ -2428,11 +2164,7 @@
       for the requested file block nor the file and position. So we have
       to assert this in the caller.
     */
-    KEYCACHE_DBUG_PRINT("read_block",
-                      ("secondary request waiting for new page to be read"));
     wait_on_queue(&block->wqueue[COND_FOR_REQUESTED], &keycache->cache_lock);
-    KEYCACHE_DBUG_PRINT("read_block",
-                        ("secondary request: new page in cache"));
   }
 }
 
@@ -2474,9 +2206,6 @@
   my_bool locked_and_incremented= false;
   int error=0;
   uchar *start= buff;
-  DBUG_ENTER("key_cache_read");
-  DBUG_PRINT("enter", ("fd: %u  pos: %lu  length: %u",
-               (uint) file, (ulong) filepos, length));
 
   if (keycache->key_cache_inited)
   {
@@ -2527,7 +2256,7 @@
       /* Do not read beyond the end of the cache block. */
       read_length= length;
       set_if_smaller(read_length, keycache->key_cache_block_size-offset);
-      KEYCACHE_DBUG_ASSERT(read_length > 0);
+      assert(read_length > 0);
 
       /* Request the cache block that matches file/pos. */
       keycache->global_cache_r_requests++;
@@ -2558,10 +2287,10 @@
             requested file block. It does not hurt to check it for
             primary requests too.
           */
-          DBUG_ASSERT(keycache->can_be_used);
-          DBUG_ASSERT(block->hash_link->file == file);
-          DBUG_ASSERT(block->hash_link->diskpos == filepos);
-          DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+          assert(keycache->can_be_used);
+          assert(block->hash_link->file == file);
+          assert(block->hash_link->diskpos == filepos);
+          assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
         }
         else if (block->length < read_length + offset)
         {
@@ -2579,7 +2308,7 @@
       if (!((status= block->status) & BLOCK_ERROR))
       {
         {
-          DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+          assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
 #if !defined(SERIALIZED_READ_FROM_CACHE)
           keycache_pthread_mutex_unlock(&keycache->cache_lock);
 #endif
@@ -2592,7 +2321,7 @@
 
 #if !defined(SERIALIZED_READ_FROM_CACHE)
           keycache_pthread_mutex_lock(&keycache->cache_lock);
-          DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+          assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
 #endif
         }
       }
@@ -2639,7 +2368,7 @@
     dec_counter_for_resize_op(keycache);
     keycache_pthread_mutex_unlock(&keycache->cache_lock);
   }
-  DBUG_RETURN(error ? (uchar*) 0 : start);
+  return(error ? (uchar*) 0 : start);
 }
 
 
@@ -2668,9 +2397,6 @@
                      uchar *buff, uint length)
 {
   int error= 0;
-  DBUG_ENTER("key_cache_insert");
-  DBUG_PRINT("enter", ("fd: %u  pos: %lu  length: %u",
-               (uint) file,(ulong) filepos, length));
 
   if (keycache->key_cache_inited)
   {
@@ -2710,7 +2436,7 @@
       /* Do not load beyond the end of the cache block. */
       read_length= length;
       set_if_smaller(read_length, keycache->key_cache_block_size-offset);
-      KEYCACHE_DBUG_ASSERT(read_length > 0);
+      assert(read_length > 0);
 
       /* The block has been read by the caller already. */
       keycache->global_cache_read++;
@@ -2766,10 +2492,10 @@
             requested file block. It does not hurt to check it for
             primary requests too.
           */
-          DBUG_ASSERT(keycache->can_be_used);
-          DBUG_ASSERT(block->hash_link->file == file);
-          DBUG_ASSERT(block->hash_link->diskpos == filepos);
-          DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+          assert(keycache->can_be_used);
+          assert(block->hash_link->file == file);
+          assert(block->hash_link->diskpos == filepos);
+          assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
         }
         else if (page_st == PAGE_TO_BE_READ)
         {
@@ -2777,9 +2503,9 @@
             This is a new block in the cache. If we come here, we have
             data for the whole block.
           */
-          DBUG_ASSERT(block->hash_link->requests);
-          DBUG_ASSERT(block->status & BLOCK_IN_USE);
-          DBUG_ASSERT((page_st == PAGE_TO_BE_READ) ||
+          assert(block->hash_link->requests);
+          assert(block->status & BLOCK_IN_USE);
+          assert((page_st == PAGE_TO_BE_READ) ||
                       (block->status & BLOCK_READ));
 
 #if !defined(SERIALIZED_READ_FROM_CACHE)
@@ -2798,8 +2524,8 @@
 
 #if !defined(SERIALIZED_READ_FROM_CACHE)
           keycache_pthread_mutex_lock(&keycache->cache_lock);
-          DBUG_ASSERT(block->status & BLOCK_IN_USE);
-          DBUG_ASSERT((page_st == PAGE_TO_BE_READ) ||
+          assert(block->status & BLOCK_IN_USE);
+          assert((page_st == PAGE_TO_BE_READ) ||
                       (block->status & BLOCK_READ));
 #endif
           /*
@@ -2816,8 +2542,6 @@
             only a writer may set block->offset down from
             keycache->key_cache_block_size.
           */
-          KEYCACHE_DBUG_PRINT("key_cache_insert",
-                              ("primary request: new page in cache"));
           /* Signal all pending requests. */
           release_whole_queue(&block->wqueue[COND_FOR_REQUESTED]);
         }
@@ -2833,7 +2557,7 @@
             with the new data. If the condition is met, we can simply
             ignore the block.
           */
-          DBUG_ASSERT((page_st == PAGE_READ) &&
+          assert((page_st == PAGE_READ) &&
                       (read_length + offset <= block->length));
         }
 
@@ -2842,9 +2566,9 @@
           requested file block. It does not hurt to check it for primary
           requests too.
         */
-        DBUG_ASSERT(block->hash_link->file == file);
-        DBUG_ASSERT(block->hash_link->diskpos == filepos);
-        DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+        assert(block->hash_link->file == file);
+        assert(block->hash_link->diskpos == filepos);
+        assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
       } /* end of if (!(block->status & BLOCK_ERROR)) */
 
 
@@ -2872,7 +2596,7 @@
       dec_counter_for_resize_op(keycache);
     keycache_pthread_mutex_unlock(&keycache->cache_lock);
   }
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -2913,12 +2637,6 @@
 {
   my_bool locked_and_incremented= false;
   int error=0;
-  DBUG_ENTER("key_cache_write");
-  DBUG_PRINT("enter",
-             ("fd: %u  pos: %lu  length: %u  block_length: %u"
-              "  key_block_length: %u",
-              (uint) file, (ulong) filepos, length, block_length,
-              keycache ? keycache->key_cache_block_size : 0));
 
   if (!dont_write)
   {
@@ -2928,15 +2646,10 @@
     keycache->global_cache_w_requests++;
     keycache->global_cache_write++;
     if (pwrite(file, buff, length, filepos) == 0)
-      DBUG_RETURN(1);
+      return(1);
     /* purecov: end */
   }
 
-#if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
-  DBUG_EXECUTE("check_keycache",
-               test_key_cache(keycache, "start of key_cache_write", 1););
-#endif
-
   if (keycache->key_cache_inited)
   {
     /* Key cache is used */
@@ -2985,7 +2698,7 @@
       /* Do not write beyond the end of the cache block. */
       read_length= length;
       set_if_smaller(read_length, keycache->key_cache_block_size-offset);
-      KEYCACHE_DBUG_ASSERT(read_length > 0);
+      assert(read_length > 0);
 
       /* Request the cache block that matches file/pos. */
       keycache->global_cache_w_requests++;
@@ -3037,8 +2750,8 @@
                    offset + read_length >= keycache->key_cache_block_size?
                    offset : keycache->key_cache_block_size,
                    offset, (page_st == PAGE_TO_BE_READ));
-        DBUG_ASSERT(keycache->can_be_used);
-        DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+        assert(keycache->can_be_used);
+        assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
         /*
           Prevent block from flushing and from being selected for to be
           freed. This must be set when we release the cache_lock.
@@ -3050,10 +2763,10 @@
         The block should always be assigned to the requested file block
         here. It need not be BLOCK_READ when overwriting the whole block.
       */
-      DBUG_ASSERT(block->hash_link->file == file);
-      DBUG_ASSERT(block->hash_link->diskpos == filepos);
-      DBUG_ASSERT(block->status & BLOCK_IN_USE);
-      DBUG_ASSERT((page_st == PAGE_TO_BE_READ) || (block->status & BLOCK_READ));
+      assert(block->hash_link->file == file);
+      assert(block->hash_link->diskpos == filepos);
+      assert(block->status & BLOCK_IN_USE);
+      assert((page_st == PAGE_TO_BE_READ) || (block->status & BLOCK_READ));
       /*
         The block to be written must not be marked BLOCK_REASSIGNED.
         Otherwise it could be freed in dirty state or reused without
@@ -3062,7 +2775,7 @@
         the flusher could clear BLOCK_CHANGED without flushing the
         new changes again.
       */
-      DBUG_ASSERT(!(block->status & BLOCK_REASSIGNED));
+      assert(!(block->status & BLOCK_REASSIGNED));
 
       while (block->status & BLOCK_IN_FLUSHWRITE)
       {
@@ -3076,11 +2789,11 @@
           another hash_link until we release our request on it.
         */
         wait_on_queue(&block->wqueue[COND_FOR_SAVED], &keycache->cache_lock);
-        DBUG_ASSERT(keycache->can_be_used);
-        DBUG_ASSERT(block->status & (BLOCK_READ | BLOCK_IN_USE));
+        assert(keycache->can_be_used);
+        assert(block->status & (BLOCK_READ | BLOCK_IN_USE));
         /* Still must not be marked for free. */
-        DBUG_ASSERT(!(block->status & BLOCK_REASSIGNED));
-        DBUG_ASSERT(block->hash_link && (block->hash_link->block == block));
+        assert(!(block->status & BLOCK_REASSIGNED));
+        assert(block->hash_link && (block->hash_link->block == block));
       }
 
       /*
@@ -3181,11 +2894,7 @@
     dec_counter_for_resize_op(keycache);
     keycache_pthread_mutex_unlock(&keycache->cache_lock);
   }
-#if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
-  DBUG_EXECUTE("exec",
-               test_key_cache(keycache, "end of key_cache_write", 1););
-#endif
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -3218,10 +2927,6 @@
 
 static void free_block(KEY_CACHE *keycache, BLOCK_LINK *block)
 {
-  KEYCACHE_THREAD_TRACE("free block");
-  KEYCACHE_DBUG_PRINT("free_block",
-                      ("block %u to be freed, hash_link %p",
-                       BLOCK_NUMBER(block), block->hash_link));
   /*
     Assert that the block is not free already. And that it is in a clean
     state. Note that the block might just be assigned to a hash_link and
@@ -3229,24 +2934,24 @@
     is registered in the hash_link and free_block() will wait for it
     below.
   */
-  DBUG_ASSERT((block->status & BLOCK_IN_USE) &&
+  assert((block->status & BLOCK_IN_USE) &&
               !(block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH |
                                  BLOCK_REASSIGNED | BLOCK_IN_FLUSH |
                                  BLOCK_CHANGED | BLOCK_FOR_UPDATE)));
   /* Assert that the block is in a file_blocks chain. */
-  DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
+  assert(block->prev_changed && *block->prev_changed == block);
   /* Assert that the block is not in the LRU ring. */
-  DBUG_ASSERT(!block->next_used && !block->prev_used);
+  assert(!block->next_used && !block->prev_used);
   /*
     IMHO the below condition (if()) makes no sense. I can't see how it
     could be possible that free_block() is entered with a NULL hash_link
     pointer. The only place where it can become NULL is in free_block()
     (or before its first use ever, but for those blocks free_block() is
     not called). I don't remove the conditional as it cannot harm, but
-    place an DBUG_ASSERT to confirm my hypothesis. Eventually the
+    place an assert to confirm my hypothesis. Eventually the
     condition (if()) can be removed.
   */
-  DBUG_ASSERT(block->hash_link && block->hash_link->block == block);
+  assert(block->hash_link && block->hash_link->block == block);
   if (block->hash_link)
   {
     /*
@@ -3262,14 +2967,14 @@
       checks. An additional requirement is that it must be read now
       (BLOCK_READ).
     */
-    DBUG_ASSERT(block->hash_link && block->hash_link->block == block);
-    DBUG_ASSERT((block->status & (BLOCK_READ | BLOCK_IN_USE |
+    assert(block->hash_link && block->hash_link->block == block);
+    assert((block->status & (BLOCK_READ | BLOCK_IN_USE |
                                   BLOCK_REASSIGNED)) &&
                 !(block->status & (BLOCK_IN_EVICTION | BLOCK_IN_SWITCH |
                                    BLOCK_IN_FLUSH | BLOCK_CHANGED |
                                    BLOCK_FOR_UPDATE)));
-    DBUG_ASSERT(block->prev_changed && *block->prev_changed == block);
-    DBUG_ASSERT(!block->prev_used);
+    assert(block->prev_changed && *block->prev_changed == block);
+    assert(!block->prev_used);
     /*
       Unset BLOCK_REASSIGNED again. If we hand the block to an evicting
       thread (through unreg_request() below), other threads must not see
@@ -3292,7 +2997,7 @@
     operation in this case. Assert that there are no other requests
     registered.
   */
-  DBUG_ASSERT(block->requests == 1);
+  assert(block->requests == 1);
   unreg_request(keycache, block, 0);
   /*
     Note that even without releasing the cache lock it is possible that
@@ -3304,7 +3009,7 @@
     return;
 
   /* Here the block must be in the LRU ring. Unlink it again. */
-  DBUG_ASSERT(block->next_used && block->prev_used &&
+  assert(block->next_used && block->prev_used &&
               *block->prev_used == block);
   unlink_block(keycache, block);
   if (block->temperature == BLOCK_WARM)
@@ -3321,13 +3026,11 @@
   block->status= 0;
   block->length= 0;
   block->offset= keycache->key_cache_block_size;
-  KEYCACHE_THREAD_TRACE("free block");
-  KEYCACHE_DBUG_PRINT("free_block", ("block is freed"));
 
   /* Enforced by unlink_changed(), but just to be sure. */
-  DBUG_ASSERT(!block->next_changed && !block->prev_changed);
+  assert(!block->next_changed && !block->prev_changed);
   /* Enforced by unlink_block(): not in LRU ring nor in free_block_list. */
-  DBUG_ASSERT(!block->next_used && !block->prev_used);
+  assert(!block->next_used && !block->prev_used);
   /* Insert the free block in the free list. */
   block->next_used= keycache->free_block_list;
   keycache->free_block_list= block;
@@ -3377,9 +3080,6 @@
   for ( ; cache != end ; cache++)
   {
     BLOCK_LINK *block= *cache;
-
-    KEYCACHE_DBUG_PRINT("flush_cached_blocks",
-                        ("block %u to be flushed", BLOCK_NUMBER(block)));
     /*
       If the block contents is going to be changed, we abandon the flush
       for this block. flush_key_blocks_int() will restart its search and
@@ -3388,10 +3088,10 @@
     if (!(block->status & BLOCK_FOR_UPDATE))
     {
       /* Blocks coming here must have a certain status. */
-      DBUG_ASSERT(block->hash_link);
-      DBUG_ASSERT(block->hash_link->block == block);
-      DBUG_ASSERT(block->hash_link->file == file);
-      DBUG_ASSERT((block->status & ~BLOCK_IN_EVICTION) ==
+      assert(block->hash_link);
+      assert(block->hash_link->block == block);
+      assert(block->hash_link->file == file);
+      assert((block->status & ~BLOCK_IN_EVICTION) ==
                   (BLOCK_READ | BLOCK_IN_FLUSH | BLOCK_CHANGED | BLOCK_IN_USE));
       block->status|= BLOCK_IN_FLUSHWRITE;
       keycache_pthread_mutex_unlock(&keycache->cache_lock);
@@ -3409,10 +3109,10 @@
       }
       block->status&= ~BLOCK_IN_FLUSHWRITE;
       /* Block must not have changed status except BLOCK_FOR_UPDATE. */
-      DBUG_ASSERT(block->hash_link);
-      DBUG_ASSERT(block->hash_link->block == block);
-      DBUG_ASSERT(block->hash_link->file == file);
-      DBUG_ASSERT((block->status & ~(BLOCK_FOR_UPDATE | BLOCK_IN_EVICTION)) ==
+      assert(block->hash_link);
+      assert(block->hash_link->block == block);
+      assert(block->hash_link->file == file);
+      assert((block->status & ~(BLOCK_FOR_UPDATE | BLOCK_IN_EVICTION)) ==
                   (BLOCK_READ | BLOCK_IN_FLUSH | BLOCK_CHANGED | BLOCK_IN_USE));
       /*
         Set correct status and link in right queue for free or later use.
@@ -3486,14 +3186,6 @@
   BLOCK_LINK *cache_buff[FLUSH_CACHE],**cache;
   int last_errno= 0;
   int last_errcnt= 0;
-  DBUG_ENTER("flush_key_blocks_int");
-  DBUG_PRINT("enter",("file: %d  blocks_used: %lu  blocks_changed: %lu",
-              file, keycache->blocks_used, keycache->blocks_changed));
-
-#if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
-    DBUG_EXECUTE("check_keycache",
-                 test_key_cache(keycache, "start of flush_key_blocks", 0););
-#endif
 
   cache= cache_buff;
   if (keycache->disk_blocks > 0 &&
@@ -3507,9 +3199,6 @@
     BLOCK_LINK *last_in_flush;
     BLOCK_LINK *last_for_update;
     BLOCK_LINK *block, *next;
-#if defined(KEYCACHE_DEBUG)
-    uint cnt=0;
-#endif
 
     if (type != FLUSH_IGNORE_CHANGED)
     {
@@ -3526,7 +3215,7 @@
             !(block->status & BLOCK_IN_FLUSH))
         {
           count++;
-          KEYCACHE_DBUG_ASSERT(count<= keycache->blocks_used);
+          assert(count<= keycache->blocks_used);
         }
       }
       /*
@@ -3555,10 +3244,6 @@
          block ;
          block= next)
     {
-#if defined(KEYCACHE_DEBUG)
-      cnt++;
-      KEYCACHE_DBUG_ASSERT(cnt <= keycache->blocks_used);
-#endif
       next= block->next_changed;
       if (block->hash_link->file == file)
       {
@@ -3622,7 +3307,7 @@
             else
             {
               /* It's a temporary file */
-              DBUG_ASSERT(!(block->status & BLOCK_REASSIGNED));
+              assert(!(block->status & BLOCK_REASSIGNED));
 
               /*
                 free_block() must not be called with BLOCK_CHANGED. Note
@@ -3743,15 +3428,8 @@
     */
     while (first_in_switch)
     {
-#if defined(KEYCACHE_DEBUG)
-      cnt= 0;
-#endif
       wait_on_queue(&first_in_switch->wqueue[COND_FOR_SAVED],
                     &keycache->cache_lock);
-#if defined(KEYCACHE_DEBUG)
-      cnt++;
-      KEYCACHE_DBUG_ASSERT(cnt <= keycache->blocks_used);
-#endif
       /*
         Do not restart here. We have flushed all blocks that were
         changed when entering this function and were not marked for
@@ -3782,7 +3460,7 @@
           next= block->next_changed;
 
           /* Changed blocks cannot appear in the file_blocks hash. */
-          DBUG_ASSERT(!(block->status & BLOCK_CHANGED));
+          assert(!(block->status & BLOCK_CHANGED));
           if (block->hash_link->file == file)
           {
             /* We must skip blocks that will be changed. */
@@ -3808,7 +3486,7 @@
 
               total_found++;
               found++;
-              KEYCACHE_DBUG_ASSERT(found <= keycache->blocks_used);
+              assert(found <= keycache->blocks_used);
 
               /*
                 Register a request. This unlinks the block from the LRU
@@ -3830,7 +3508,7 @@
                 next_hash_link= next->hash_link;
                 next_diskpos=   next_hash_link->diskpos;
                 next_file=      next_hash_link->file;
-                DBUG_ASSERT(next == next_hash_link->block);
+                assert(next == next_hash_link->block);
               }
 
               free_block(keycache, block);
@@ -3877,7 +3555,7 @@
       if (last_for_update)
       {
         /* We did not wait. Block must not have changed status. */
-        DBUG_ASSERT(last_for_update->status & BLOCK_FOR_UPDATE);
+        assert(last_for_update->status & BLOCK_FOR_UPDATE);
         wait_on_queue(&last_for_update->wqueue[COND_FOR_REQUESTED],
                       &keycache->cache_lock);
         goto restart;
@@ -3890,7 +3568,7 @@
       if (last_in_switch)
       {
         /* We did not wait. Block must not have changed status. */
-        DBUG_ASSERT(last_in_switch->status & (BLOCK_IN_EVICTION |
+        assert(last_in_switch->status & (BLOCK_IN_EVICTION |
                                               BLOCK_IN_SWITCH |
                                               BLOCK_REASSIGNED));
         wait_on_queue(&last_in_switch->wqueue[COND_FOR_SAVED],
@@ -3902,16 +3580,12 @@
 
   } /* if (keycache->disk_blocks > 0 */
 
-#ifndef DBUG_OFF
-  DBUG_EXECUTE("check_keycache",
-               test_key_cache(keycache, "end of flush_key_blocks", 0););
-#endif
 err:
   if (cache != cache_buff)
     my_free((uchar*) cache, MYF(0));
   if (last_errno)
     errno=last_errno;                /* Return first error */
-  DBUG_RETURN(last_errno != 0);
+  return(last_errno != 0);
 }
 
 
@@ -3934,11 +3608,9 @@
                      File file, enum flush_type type)
 {
   int res= 0;
-  DBUG_ENTER("flush_key_blocks");
-  DBUG_PRINT("enter", ("keycache: 0x%lx", (long) keycache));
 
   if (!keycache->key_cache_inited)
-    DBUG_RETURN(0);
+    return(0);
 
   keycache_pthread_mutex_lock(&keycache->cache_lock);
   /* While waiting for lock, keycache could have been ended. */
@@ -3949,7 +3621,7 @@
     dec_counter_for_resize_op(keycache);
   }
   keycache_pthread_mutex_unlock(&keycache->cache_lock);
-  DBUG_RETURN(res);
+  return(res);
 }
 
 
@@ -3991,7 +3663,6 @@
   uint          total_found;
   uint          found;
   uint          idx;
-  DBUG_ENTER("flush_all_key_blocks");
 
   do
   {
@@ -4026,7 +3697,7 @@
           */
           if (flush_key_blocks_int(keycache, block->hash_link->file,
                                    FLUSH_FORCE_WRITE))
-            DBUG_RETURN(1);
+            return(1);
         }
       }
 
@@ -4060,7 +3731,7 @@
           found++;
           if (flush_key_blocks_int(keycache, block->hash_link->file,
                                    FLUSH_RELEASE))
-            DBUG_RETURN(1);
+            return(1);
         }
       }
 
@@ -4073,17 +3744,7 @@
       before the resize started (BLOCK_FOR_UPDATE). Re-check the hashes.
     */
   } while (total_found);
-
-#ifndef DBUG_OFF
-  /* Now there should not exist any block any more. */
-  for (idx= 0; idx < CHANGED_BLOCKS_HASH; idx++)
-  {
-    DBUG_ASSERT(!keycache->changed_blocks[idx]);
-    DBUG_ASSERT(!keycache->file_blocks[idx]);
-  }
-#endif
-
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -4106,34 +3767,17 @@
 int reset_key_cache_counters(const char *name __attribute__((unused)),
                              KEY_CACHE *key_cache)
 {
-  DBUG_ENTER("reset_key_cache_counters");
   if (!key_cache->key_cache_inited)
   {
-    DBUG_PRINT("info", ("Key cache %s not initialized.", name));
-    DBUG_RETURN(0);
+    return(0);
   }
-  DBUG_PRINT("info", ("Resetting counters for key cache %s.", name));
-
   key_cache->global_blocks_changed= 0;   /* Key_blocks_not_flushed */
   key_cache->global_cache_r_requests= 0; /* Key_read_requests */
   key_cache->global_cache_read= 0;       /* Key_reads */
   key_cache->global_cache_w_requests= 0; /* Key_write_requests */
   key_cache->global_cache_write= 0;      /* Key_writes */
-  DBUG_RETURN(0);
-}
-
-
-#ifndef DBUG_OFF
-/*
-  Test if disk-cache is ok
-*/
-static void test_key_cache(KEY_CACHE *keycache __attribute__((unused)),
-                           const char *where __attribute__((unused)),
-                           my_bool lock __attribute__((unused)))
-{
-  /* TODO */
-}
-#endif
+  return(0);
+}
 
 #if defined(KEYCACHE_TIMEOUT)
 
@@ -4231,11 +3875,6 @@
   fclose(keycache_dump_file);
 }
 
-#endif /* defined(KEYCACHE_TIMEOUT) */
-
-#if defined(KEYCACHE_TIMEOUT)
-
-
 static int keycache_pthread_cond_wait(pthread_cond_t *cond,
                                       pthread_mutex_t *mutex)
 {
@@ -4243,9 +3882,6 @@
   struct timeval  now;            /* time when we started waiting        */
   struct timespec timeout;        /* timeout value for the wait function */
   struct timezone tz;
-#if defined(KEYCACHE_DEBUG)
-  int cnt=0;
-#endif
 
   /* Get current time */
   gettimeofday(&now, &tz);
@@ -4257,165 +3893,13 @@
    1 nanosecond = 1000 micro seconds
  */
   timeout.tv_nsec= now.tv_usec * 1000;
-  KEYCACHE_THREAD_TRACE_END("started waiting");
-#if defined(KEYCACHE_DEBUG)
-  cnt++;
-  if (cnt % 100 == 0)
-    fprintf(keycache_debug_log, "waiting...\n");
-    fflush(keycache_debug_log);
-#endif
   rc= pthread_cond_timedwait(cond, mutex, &timeout);
-  KEYCACHE_THREAD_TRACE_BEGIN("finished waiting");
   if (rc == ETIMEDOUT || rc == ETIME)
   {
-#if defined(KEYCACHE_DEBUG)
-    fprintf(keycache_debug_log,"aborted by keycache timeout\n");
-    fclose(keycache_debug_log);
-    abort();
-#endif
     keycache_dump();
   }
 
-#if defined(KEYCACHE_DEBUG)
-  KEYCACHE_DBUG_ASSERT(rc != ETIMEDOUT);
-#else
   assert(rc != ETIMEDOUT);
-#endif
-  return rc;
-}
-#else
-#if defined(KEYCACHE_DEBUG)
-static int keycache_pthread_cond_wait(pthread_cond_t *cond,
-                                      pthread_mutex_t *mutex)
-{
-  int rc;
-  KEYCACHE_THREAD_TRACE_END("started waiting");
-  rc= pthread_cond_wait(cond, mutex);
-  KEYCACHE_THREAD_TRACE_BEGIN("finished waiting");
-  return rc;
-}
-#endif
+  return rc;
+}
 #endif /* defined(KEYCACHE_TIMEOUT) */
-
-#if defined(KEYCACHE_DEBUG)
-
-
-static int keycache_pthread_mutex_lock(pthread_mutex_t *mutex)
-{
-  int rc;
-  rc= pthread_mutex_lock(mutex);
-  KEYCACHE_THREAD_TRACE_BEGIN("");
-  return rc;
-}
-
-
-static void keycache_pthread_mutex_unlock(pthread_mutex_t *mutex)
-{
-  KEYCACHE_THREAD_TRACE_END("");
-  pthread_mutex_unlock(mutex);
-}
-
-
-static int keycache_pthread_cond_signal(pthread_cond_t *cond)
-{
-  int rc;
-  KEYCACHE_THREAD_TRACE("signal");
-  rc= pthread_cond_signal(cond);
-  return rc;
-}
-
-
-#if defined(KEYCACHE_DEBUG_LOG)
-
-
-static void keycache_debug_print(const char * fmt,...)
-{
-  va_list args;
-  va_start(args,fmt);
-  if (keycache_debug_log)
-  {
-    VOID(vfprintf(keycache_debug_log, fmt, args));
-    VOID(fputc('\n',keycache_debug_log));
-  }
-  va_end(args);
-}
-#endif /* defined(KEYCACHE_DEBUG_LOG) */
-
-#if defined(KEYCACHE_DEBUG_LOG)
-
-
-void keycache_debug_log_close(void)
-{
-  if (keycache_debug_log)
-    fclose(keycache_debug_log);
-}
-#endif /* defined(KEYCACHE_DEBUG_LOG) */
-
-#endif /* defined(KEYCACHE_DEBUG) */
-
-#if !defined(DBUG_OFF)
-#define F_B_PRT(_f_, _v_) DBUG_PRINT("assert_fail", (_f_, _v_))
-
-static int fail_block(BLOCK_LINK *block)
-{
-  F_B_PRT("block->next_used:    %lx\n", (ulong) block->next_used);
-  F_B_PRT("block->prev_used:    %lx\n", (ulong) block->prev_used);
-  F_B_PRT("block->next_changed: %lx\n", (ulong) block->next_changed);
-  F_B_PRT("block->prev_changed: %lx\n", (ulong) block->prev_changed);
-  F_B_PRT("block->hash_link:    %lx\n", (ulong) block->hash_link);
-  F_B_PRT("block->status:       %u\n", block->status);
-  F_B_PRT("block->length:       %u\n", block->length);
-  F_B_PRT("block->offset:       %u\n", block->offset);
-  F_B_PRT("block->requests:     %u\n", block->requests);
-  F_B_PRT("block->temperature:  %u\n", block->temperature);
-  return 0; /* Let the assert fail. */
-}
-
-static int fail_hlink(HASH_LINK *hlink)
-{
-  F_B_PRT("hlink->next:    %lx\n", (ulong) hlink->next);
-  F_B_PRT("hlink->prev:    %lx\n", (ulong) hlink->prev);
-  F_B_PRT("hlink->block:   %lx\n", (ulong) hlink->block);
-  F_B_PRT("hlink->diskpos: %lu\n", (ulong) hlink->diskpos);
-  F_B_PRT("hlink->file:    %d\n", hlink->file);
-  return 0; /* Let the assert fail. */
-}
-
-static int cache_empty(KEY_CACHE *keycache)
-{
-  int errcnt= 0;
-  int idx;
-  if (keycache->disk_blocks <= 0)
-    return 1;
-  for (idx= 0; idx < keycache->disk_blocks; idx++)
-  {
-    BLOCK_LINK *block= keycache->block_root + idx;
-    if (block->status || block->requests || block->hash_link)
-    {
-      fprintf(stderr, "block index: %u\n", idx);
-      fail_block(block);
-      errcnt++;
-    }
-  }
-  for (idx= 0; idx < keycache->hash_links; idx++)
-  {
-    HASH_LINK *hash_link= keycache->hash_link_root + idx;
-    if (hash_link->requests || hash_link->block)
-    {
-      fprintf(stderr, "hash_link index: %u\n", idx);
-      fail_hlink(hash_link);
-      errcnt++;
-    }
-  }
-  if (errcnt)
-  {
-    fprintf(stderr, "blocks: %d  used: %lu\n",
-            keycache->disk_blocks, keycache->blocks_used);
-    fprintf(stderr, "hash_links: %d  used: %d\n",
-            keycache->hash_links, keycache->hash_links_used);
-    fprintf(stderr, "\n");
-  }
-  return !errcnt;
-}
-#endif
-

=== modified file 'storage/myisam/mf_keycaches.c'
--- storage/myisam/mf_keycaches.c	2008-07-06 07:41:07 +0000
+++ storage/myisam/mf_keycaches.c	2008-07-16 04:17:11 +0000
@@ -70,9 +70,8 @@
 
 static void safe_hash_entry_free(SAFE_HASH_ENTRY *entry)
 {
-  DBUG_ENTER("free_assign_entry");
   my_free((uchar*) entry, MYF(0));
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -107,18 +106,17 @@
 static my_bool safe_hash_init(SAFE_HASH *hash, uint elements,
 			      uchar *default_value)
 {
-  DBUG_ENTER("safe_hash");
   if (hash_init(&hash->hash, &my_charset_bin, elements,
 		0, 0, (hash_get_key) safe_hash_entry_get,
 		(void (*)(void*)) safe_hash_entry_free, 0))
   {
     hash->default_value= 0;
-    DBUG_RETURN(1);
+    return(1);
   }
   my_rwlock_init(&hash->mutex, 0);
   hash->default_value= default_value;
   hash->root= 0;
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -150,7 +148,6 @@
 static uchar *safe_hash_search(SAFE_HASH *hash, const uchar *key, uint length)
 {
   uchar *result;
-  DBUG_ENTER("safe_hash_search");
   rw_rdlock(&hash->mutex);
   result= hash_search(&hash->hash, key, length);
   rw_unlock(&hash->mutex);
@@ -158,8 +155,7 @@
     result= hash->default_value;
   else
     result= ((SAFE_HASH_ENTRY*) result)->data;
-  DBUG_PRINT("exit",("data: 0x%lx", (long) result));
-  DBUG_RETURN(result);
+  return(result);
 }
 
 
@@ -188,8 +184,6 @@
 {
   SAFE_HASH_ENTRY *entry;
   my_bool error= 0;
-  DBUG_ENTER("safe_hash_set");
-  DBUG_PRINT("enter",("key: %.*s  data: 0x%lx", length, key, (long) data));
 
   rw_wrlock(&hash->mutex);
   entry= (SAFE_HASH_ENTRY*) hash_search(&hash->hash, key, length);
@@ -242,7 +236,7 @@
 
 end:
   rw_unlock(&hash->mutex);
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -264,7 +258,6 @@
 static void safe_hash_change(SAFE_HASH *hash, uchar *old_data, uchar *new_data)
 {
   SAFE_HASH_ENTRY *entry, *next;
-  DBUG_ENTER("safe_hash_set");
 
   rw_wrlock(&hash->mutex);
 
@@ -285,7 +278,7 @@
   }
 
   rw_unlock(&hash->mutex);
-  DBUG_VOID_RETURN;
+  return;
 }
 
 

=== modified file 'storage/myisam/mi_cache.c'
--- storage/myisam/mi_cache.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_cache.c	2008-07-15 20:22:55 +0000
@@ -41,7 +41,6 @@
   uint read_length,in_buff_length;
   my_off_t offset;
   uchar *in_buff_pos;
-  DBUG_ENTER("_mi_read_cache");
 
   if (pos < info->pos_in_file)
   {
@@ -50,9 +49,9 @@
       read_length=(uint) (info->pos_in_file-pos);
     info->seek_not_done=1;
     if (my_pread(info->file,buff,read_length,pos,MYF(MY_NABP)))
-      DBUG_RETURN(1);
+      return(1);
     if (!(length-=read_length))
-      DBUG_RETURN(0);
+      return(0);
     pos+=read_length;
     buff+=read_length;
   }
@@ -64,7 +63,7 @@
     in_buff_length= min(length, (size_t) (info->read_end-in_buff_pos));
     memcpy(buff,info->request_pos+(uint) offset,(size_t) in_buff_length);
     if (!(length-=in_buff_length))
-      DBUG_RETURN(0);
+      return(0);
     pos+=in_buff_length;
     buff+=in_buff_length;
   }
@@ -82,26 +81,23 @@
     else
       info->read_pos=info->read_end;			/* All block used */
     if (!(*info->read_function)(info,buff,length))
-      DBUG_RETURN(0);
+      return(0);
     read_length=info->error;
   }
   else
   {
     info->seek_not_done=1;
     if ((read_length=my_pread(info->file,buff,length,pos,MYF(0))) == length)
-      DBUG_RETURN(0);
+      return(0);
   }
   if (!(flag & READING_HEADER) || (int) read_length == -1 ||
       read_length+in_buff_length < 3)
   {
-    DBUG_PRINT("error",
-               ("Error %d reading next-multi-part block (Got %d bytes)",
-                my_errno, (int) read_length));
     if (!my_errno || my_errno == -1)
       my_errno=HA_ERR_WRONG_IN_RECORD;
-    DBUG_RETURN(1);
+    return(1);
   }
   bzero(buff+read_length,MI_BLOCK_INFO_HEADER_LENGTH - in_buff_length -
         read_length);
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_read_cache */

=== modified file 'storage/myisam/mi_changed.c'
--- storage/myisam/mi_changed.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_changed.c	2008-07-15 20:23:33 +0000
@@ -22,12 +22,10 @@
 int mi_is_changed(MI_INFO *info)
 {
   int result;
-  DBUG_ENTER("mi_is_changed");
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(-1);
+    return(-1);
   VOID(_mi_writeinfo(info,0));
   result=(int) info->data_changed;
   info->data_changed=0;
-  DBUG_PRINT("exit",("result: %d",result));
-  DBUG_RETURN(result);
+  return(result);
 }

=== modified file 'storage/myisam/mi_check.c'
--- storage/myisam/mi_check.c	2008-07-15 19:53:56 +0000
+++ storage/myisam/mi_check.c	2008-07-16 16:52:09 +0000
@@ -139,7 +139,6 @@
   uint delete_link_length;
   my_off_t empty, next_link, old_link= 0;
   char buff[22],buff2[22];
-  DBUG_ENTER("chk_del");
 
   param->record_checksum=0;
   delete_link_length=((info->s->options & HA_OPTION_PACK_RECORD) ? 20 :
@@ -164,7 +163,7 @@
     for (i= info->state->del ; i > 0L && next_link != HA_OFFSET_ERROR ; i--)
     {
       if (*killed_ptr(param))
-        DBUG_RETURN(1);
+        return(1);
       if (test_flag & T_VERBOSE)
 	printf(" %9s",llstr(next_link,buff));
       if (next_link >= info->state->data_file_length)
@@ -175,7 +174,7 @@
 	if (test_flag & T_VERBOSE) puts("");
 	mi_check_print_error(param,"Can't read delete-link at filepos: %s",
 		    llstr(next_link,buff));
-	DBUG_RETURN(1);
+	return(1);
       }
       if (*buff != '\0')
       {
@@ -229,13 +228,13 @@
       goto wrong;
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 
 wrong:
   param->testflag|=T_RETRY_WITHOUT_QUICK;
   if (test_flag & T_VERBOSE) puts("");
   mi_check_print_error(param,"record delete-link-chain corrupted");
-  DBUG_RETURN(1);
+  return(1);
 } /* chk_del */
 
 
@@ -248,8 +247,6 @@
   ha_rows records;
   char llbuff[21], llbuff2[21];
   uchar *buff;
-  DBUG_ENTER("check_k_link");
-  DBUG_PRINT("enter", ("block_size: %u", block_size));
 
   if (param->testflag & T_VERBOSE)
     printf("block_size %4u:", block_size); /* purecov: tested */
@@ -259,7 +256,7 @@
   while (next_link != HA_OFFSET_ERROR && records > 0)
   {
     if (*killed_ptr(param))
-      DBUG_RETURN(1);
+      return(1);
     if (param->testflag & T_VERBOSE)
       printf("%16s",llstr(next_link,llbuff));
 
@@ -271,7 +268,7 @@
                            "key block size: %u  file_length: %s",
                            llstr(next_link, llbuff), block_size,
                            llstr(info->state->key_file_length, llbuff2));
-      DBUG_RETURN(1);
+      return(1);
       /* purecov: end */
     }
 
@@ -282,7 +279,7 @@
       mi_check_print_error(param, "Mis-aligned key block: %s  "
                            "minimum key block length: %u",
                            llstr(next_link, llbuff), MI_MIN_KEY_BLOCK_LENGTH);
-      DBUG_RETURN(1);
+      return(1);
       /* purecov: end */
     }
 
@@ -299,7 +296,7 @@
       /* purecov: begin tested */
       mi_check_print_error(param, "key cache read error for block: %s",
 			   llstr(next_link,llbuff));
-      DBUG_RETURN(1);
+      return(1);
       /* purecov: end */
     }
     next_link=mi_sizekorr(buff);
@@ -313,7 +310,7 @@
     else
       puts("");
   }
-  DBUG_RETURN (next_link != HA_OFFSET_ERROR);
+  return (next_link != HA_OFFSET_ERROR);
 } /* check_k_link */
 
 
@@ -324,7 +321,6 @@
   int error=0;
   register my_off_t skr,size;
   char buff[22],buff2[22];
-  DBUG_ENTER("chk_size");
 
   if (!(param->testflag & T_SILENT)) puts("- check file-size");
 
@@ -389,7 +385,7 @@
     mi_check_print_warning(param, "Datafile is almost full, %10s of %10s used",
 			   llstr(info->state->data_file_length,buff),
 			   llstr(info->s->base.max_data_file_length-1,buff2));
-  DBUG_RETURN(error);
+  return(error);
 } /* chk_size */
 
 
@@ -405,7 +401,6 @@
   MYISAM_SHARE *share=info->s;
   MI_KEYDEF *keyinfo;
   char buff[22],buff2[22];
-  DBUG_ENTER("chk_key");
 
   if (!(param->testflag & T_SILENT))
     puts("- check key delete-chain");
@@ -416,7 +411,7 @@
     {
       if (param->testflag & T_VERBOSE) puts("");
       mi_check_print_error(param,"key delete-link-chain corrupted");
-      DBUG_RETURN(-1);
+      return(-1);
     }
 
   if (!(param->testflag & T_SILENT)) puts("- check index reference");
@@ -460,7 +455,7 @@
       mi_check_print_error(param,"Can't read indexpage from filepos: %s",
 		  llstr(share->state.key_root[key],buff));
       if (!(param->testflag & T_INFO))
-	DBUG_RETURN(-1);
+	return(-1);
       result= -1;
       continue;
     }
@@ -471,7 +466,7 @@
     param->max_level=0;
     if (chk_index(param,info,keyinfo,share->state.key_root[key],info->buff,
 		  &keys, param->key_crc+key,1))
-      DBUG_RETURN(-1);
+      return(-1);
     if(!(keyinfo->flag & (HA_FULLTEXT | HA_SPATIAL)))
     {
       if (keys != info->state->records)
@@ -479,7 +474,7 @@
 	mi_check_print_error(param,"Found %s keys of %s",llstr(keys,buff),
 		    llstr(info->state->records,buff2));
 	if (!(param->testflag & T_INFO))
-	DBUG_RETURN(-1);
+	return(-1);
 	result= -1;
 	continue;
       }
@@ -496,7 +491,7 @@
 	else
 	  mi_check_print_error(param,"Key 1 doesn't point at all records");
 	if (!(param->testflag & T_INFO))
-	  DBUG_RETURN(-1);
+	  return(-1);
 	result= -1;
 	continue;
       }
@@ -574,7 +569,7 @@
     param->record_checksum=old_record_checksum-init_checksum;	/* Remove delete links */
   else
     param->record_checksum=0;
-  DBUG_RETURN(result);
+  return(result);
 } /* chk_key */
 
 
@@ -583,7 +578,6 @@
                      ha_checksum *key_checksum, uint level)
 {
   char llbuff[22],llbuff2[22];
-  DBUG_ENTER("chk_index_down");
 
   /* Key blocks must lay within the key file length entirely. */
   if (page + keyinfo->block_length > info->state->key_file_length)
@@ -625,11 +619,11 @@
   if (chk_index(param,info,keyinfo,page,buff,keys,key_checksum,level))
     goto err;
 
-  DBUG_RETURN(0);
+  return(0);
 
   /* purecov: begin tested */
 err:
-  DBUG_RETURN(1);
+  return(1);
   /* purecov: end */
 }
 
@@ -735,13 +729,11 @@
   my_off_t next_page,record;
   char llbuff[22];
   uint diff_pos[2];
-  DBUG_ENTER("chk_index");
-  DBUG_DUMP("buff",(uchar*) buff,mi_getint(buff));
 
   if (!(temp_buff=(uchar*) my_alloca((uint) keyinfo->block_length)))
   {
     mi_check_print_error(param,"Not enough memory for keyblock");
-    DBUG_RETURN(-1);
+    return(-1);
   }
 
   if (keyinfo->flag & HA_NOSAME)
@@ -781,7 +773,7 @@
     if (keypos >= endpos ||
 	(key_length=(*keyinfo->get_key)(keyinfo,nod_flag,&keypos,key)) == 0)
       break;
-    DBUG_ASSERT(key_length <= sizeof(key));
+    assert(key_length <= sizeof(key));
     if (keypos > endpos)
     {
       mi_check_print_error(param,"Wrong key block length at page: %s",llstr(page,llbuff));
@@ -791,10 +783,6 @@
 	(flag=ha_key_cmp(keyinfo->seg,info->lastkey,key,key_length,
 			 comp_flag, diff_pos)) >=0)
     {
-      DBUG_DUMP("old",(uchar*) info->lastkey, info->lastkey_length);
-      DBUG_DUMP("new",(uchar*) key, key_length);
-      DBUG_DUMP("new_in_page",(uchar*) old_keypos,(uint) (keypos-old_keypos));
-
       if (comp_flag & SEARCH_FIND && flag == 0)
 	mi_check_print_error(param,"Found duplicated key at page %s",llstr(page,llbuff));
       else
@@ -829,15 +817,7 @@
     record= _mi_dpos(info,0,key+key_length);
     if (record >= info->state->data_file_length)
     {
-#ifndef DBUG_OFF
-      char llbuff2[22], llbuff3[22];
-#endif
       mi_check_print_error(param,"Found key at page %s that points to record outside datafile",llstr(page,llbuff));
-      DBUG_PRINT("test",("page: %s  record: %s  filelength: %s",
-			 llstr(page,llbuff),llstr(record,llbuff2),
-			 llstr(info->state->data_file_length,llbuff3)));
-      DBUG_DUMP("key",(uchar*) key,key_length);
-      DBUG_DUMP("new_in_page",(uchar*) old_keypos,(uint) (keypos-old_keypos));
       goto err;
     }
     param->record_checksum+=(ha_checksum) record;
@@ -849,10 +829,10 @@
     goto err;
   }
   my_afree((uchar*) temp_buff);
-  DBUG_RETURN(0);
+  return(0);
  err:
   my_afree((uchar*) temp_buff);
-  DBUG_RETURN(1);
+  return(1);
 } /* chk_index */
 
 
@@ -861,7 +841,6 @@
 static ha_checksum calc_checksum(ha_rows count)
 {
   uint64_t sum,a,b;
-  DBUG_ENTER("calc_checksum");
 
   sum=0;
   a=count; b=count+1;
@@ -875,8 +854,7 @@
       sum+=a;
     a<<=1; b>>=1;
   }
-  DBUG_PRINT("exit",("sum: %lx",(ulong) sum));
-  DBUG_RETURN((ha_checksum) sum);
+  return((ha_checksum) sum);
 } /* calc_checksum */
 
 
@@ -886,14 +864,12 @@
 {
   uint length;
   HA_KEYSEG *keyseg;
-  DBUG_ENTER("isam_key_length");
 
   length= info->s->rec_reflength;
   for (keyseg=keyinfo->seg ; keyseg->type ; keyseg++)
     length+= keyseg->length;
 
-  DBUG_PRINT("exit",("length: %d",length));
-  DBUG_RETURN(length);
+  return(length);
 } /* key_length */
 
 
@@ -913,7 +889,6 @@
   my_bool static_row_size;
   MI_KEYDEF *keyinfo;
   MI_BLOCK_INFO block_info;
-  DBUG_ENTER("chk_data_link");
 
   if (!(param->testflag & T_SILENT))
   {
@@ -926,7 +901,7 @@
   if (!mi_alloc_rec_buff(info, -1, &record))
   {
     mi_check_print_error(param,"Not enough memory for record");
-    DBUG_RETURN(-1);
+    return(-1);
   }
   records=del_blocks=0;
   used=link_used=splits=del_length=0;
@@ -1327,13 +1302,13 @@
 	   llstr(empty,llbuff),llstr(link_used,llbuff2));
   }
   my_free(mi_get_rec_buff_ptr(info, record), MYF(0));
-  DBUG_RETURN (error);
+  return (error);
  err:
   mi_check_print_error(param,"got error: %d when reading datafile at record: %s",my_errno, llstr(records,llbuff));
  err2:
   my_free(mi_get_rec_buff_ptr(info, record), MYF(0));
   param->testflag|=T_RETRY_WITHOUT_QUICK;
-  DBUG_RETURN(1);
+  return(1);
 } /* chk_data_link */
 
 
@@ -1396,7 +1371,6 @@
   MI_STATE_INFO *state= &share->state;
   uint i;
   int error;
-  DBUG_ENTER("mi_drop_all_indexes");
 
   /*
     If any of the disabled indexes has a key block assigned, we must
@@ -1407,12 +1381,8 @@
   */
   if (!force && (param->testflag & T_CREATE_MISSING_KEYS))
   {
-    DBUG_PRINT("repair", ("creating missing indexes"));
     for (i= 0; i < share->base.keys; i++)
     {
-      DBUG_PRINT("repair", ("index #: %u  key_root: 0x%lx  active: %d",
-                            i, (long) state->key_root[i],
-                            mi_is_key_active(state->key_map, i)));
       if ((state->key_root[i] != HA_OFFSET_ERROR) &&
           !mi_is_key_active(state->key_map, i))
       {
@@ -1421,7 +1391,6 @@
           We would lose its block(s) if would just recreate it.
           So we need to drop and recreate all indexes.
         */
-        DBUG_PRINT("repair", ("nonempty and disabled: recreate all"));
         break;
       }
     }
@@ -1432,7 +1401,6 @@
         Flush dirty blocks of this index file from key cache and remove
         all blocks of this index file from key cache.
       */
-      DBUG_PRINT("repair", ("all disabled are empty: create missing"));
       error= flush_key_blocks(share->key_cache, share->kfile,
                               FLUSH_FORCE_WRITE);
       goto end;
@@ -1443,7 +1411,6 @@
       disabled indexes and enable them.
     */
     mi_clear_all_keys_active(state->key_map);
-    DBUG_PRINT("repair", ("declared all indexes disabled"));
   }
 
   /* Remove all key blocks of this index file from key cache. */
@@ -1462,11 +1429,10 @@
   /* Reset index file length to end of index file header. */
   info->state->key_file_length= share->base.keystart;
 
-  DBUG_PRINT("repair", ("dropped all indexes"));
   /* error= 0; set by last (error= flush_key_bocks()). */
 
  end:
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -1484,7 +1450,6 @@
   char llbuff[22],llbuff2[22];
   SORT_INFO sort_info;
   MI_SORT_PARAM sort_param;
-  DBUG_ENTER("mi_repair");
 
   bzero((char *)&sort_info, sizeof(sort_info));
   bzero((char *)&sort_param, sizeof(sort_param));
@@ -1593,7 +1558,6 @@
     {
       if (my_errno != HA_ERR_FOUND_DUPP_KEY)
 	goto err;
-      DBUG_DUMP("record",(uchar*) sort_param.record,share->base.pack_reclength);
       mi_check_print_info(param,"Duplicate key %2d for record at %10s against new record at %10s",
 			  info->errkey+1,
 			  llstr(sort_param.start_recpos,llbuff),
@@ -1602,8 +1566,6 @@
       {
 	VOID(_mi_make_key(info,(uint) info->errkey,info->lastkey,
 			  sort_param.record,0L));
-	_mi_print_key(stdout,share->keyinfo[info->errkey].seg,info->lastkey,
-		      USE_WHOLE_KEY);
       }
       sort_info.dupp++;
       if ((param->testflag & (T_FORCE_UNIQUENESS|T_QUICK)) == T_QUICK)
@@ -1729,7 +1691,7 @@
   }
   share->state.changed|= (STATE_NOT_OPTIMIZED_KEYS | STATE_NOT_SORTED_PAGES |
 			  STATE_NOT_ANALYZED);
-  DBUG_RETURN(got_error);
+  return(got_error);
 }
 
 
@@ -1742,7 +1704,6 @@
   MI_INFO  *info=   sort_param->sort_info->info;
   uchar    *buff=   sort_param->record;
   my_off_t filepos= sort_param->filepos;
-  DBUG_ENTER("writekeys");
 
   key=info->lastkey+info->s->base.max_key_length;
   for (i=0 ; i < info->s->base.keys ; i++)
@@ -1756,7 +1717,7 @@
       }
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 
  err:
   if (my_errno == HA_ERR_FOUND_DUPP_KEY)
@@ -1777,8 +1738,7 @@
   /* Remove checksum that was added to glob_crc in sort_get_next_record */
   if (sort_param->calc_checksum)
     sort_param->sort_info->param->glob_crc-= info->checksum;
-  DBUG_PRINT("error",("errno: %d",my_errno));
-  DBUG_RETURN(-1);
+  return(-1);
 } /* writekeys */
 
 
@@ -1790,7 +1750,6 @@
   register uint i;
   uchar *key;
   uint key_length;
-  DBUG_ENTER("movepoint");
 
   key=info->lastkey+info->s->base.max_key_length;
   for (i=0 ; i < info->s->base.keys; i++)
@@ -1806,25 +1765,25 @@
 	if (_mi_search(info,keyinfo,key,USE_WHOLE_KEY,
 		       (uint) (SEARCH_SAME | SEARCH_SAVE_BUFF),
 		       info->s->state.key_root[i]))
-	  DBUG_RETURN(-1);
+	  return(-1);
 	nod_flag=mi_test_if_nod(info->buff);
 	_mi_dpointer(info,info->int_keypos-nod_flag-
 		     info->s->rec_reflength,newpos);
 	if (_mi_write_keypage(info,keyinfo,info->last_keypage,
                               DFLT_INIT_HITS,info->buff))
-	  DBUG_RETURN(-1);
+	  return(-1);
       }
       else
       {					/* Change old key to new */
 	if (_mi_ck_delete(info,i,key,key_length))
-	  DBUG_RETURN(-1);
+	  return(-1);
 	key_length=_mi_make_key(info,i,key,record,newpos);
 	if (_mi_ck_write(info,i,key,key_length))
-	  DBUG_RETURN(-1);
+	  return(-1);
       }
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* movepoint */
 
 
@@ -1871,7 +1830,6 @@
   int old_lock;
   MYISAM_SHARE *share=info->s;
   MI_STATE_INFO old_state;
-  DBUG_ENTER("mi_sort_index");
 
   /* cannot sort index files with R-tree indexes */
   for (key= 0,keyinfo= &share->keyinfo[0]; key < share->base.keys ;
@@ -1888,7 +1846,7 @@
   {
     mi_check_print_error(param,"Can't create new tempfile: '%s'",
 			 param->temp_filename);
-    DBUG_RETURN(-1);
+    return(-1);
   }
   if (filecopy(param, new_file,share->kfile,0L,
 	       (ulong) share->base.keystart, "headerblock"))
@@ -1947,13 +1905,13 @@
     info->s->state.key_del[key]=  HA_OFFSET_ERROR;
 
   info->s->state.changed&= ~STATE_NOT_SORTED_PAGES;
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   VOID(my_close(new_file,MYF(MY_WME)));
 err2:
   VOID(my_delete(param->temp_filename,MYF(MY_WME)));
-  DBUG_RETURN(-1);
+  return(-1);
 } /* mi_sort_index */
 
 
@@ -1967,7 +1925,6 @@
   uchar key[HA_MAX_POSSIBLE_KEY_BUFF];
   my_off_t new_page_pos,next_page;
   char llbuff[22];
-  DBUG_ENTER("sort_one_index");
 
   new_page_pos=param->new_file_pos;
   param->new_file_pos+=keyinfo->block_length;
@@ -1975,7 +1932,7 @@
   if (!(buff=(uchar*) my_alloca((uint) keyinfo->block_length)))
   {
     mi_check_print_error(param,"Not enough memory for key block");
-    DBUG_RETURN(-1);
+    return(-1);
   }
   if (!_mi_fetch_keypage(info,keyinfo,pagepos,DFLT_INIT_HITS,buff,0))
   {
@@ -1996,18 +1953,13 @@
 	_mi_kpointer(info,keypos-nod_flag,param->new_file_pos); /* Save new pos */
 	if (sort_one_index(param,info,keyinfo,next_page,new_file))
 	{
-	  DBUG_PRINT("error",
-		     ("From page: %ld, keyoffset: %lu  used_length: %d",
-		      (ulong) pagepos, (ulong) (keypos - buff),
-		      (int) used_length));
-	  DBUG_DUMP("buff",(uchar*) buff,used_length);
 	  goto err;
 	}
       }
       if (keypos >= endpos ||
 	  (key_length=(*keyinfo->get_key)(keyinfo,nod_flag,&keypos,key)) == 0)
 	break;
-      DBUG_ASSERT(keypos <= endpos);
+      assert(keypos <= endpos);
     }
   }
 
@@ -2021,10 +1973,10 @@
     goto err;
   }
   my_afree((uchar*) buff);
-  DBUG_RETURN(0);
+  return(0);
 err:
   my_afree((uchar*) buff);
-  DBUG_RETURN(1);
+  return(1);
 } /* sort_one_index */
 
 
@@ -2051,6 +2003,7 @@
 } /* change_to_newfile */
 
 
+
 	/* Copy a block between two files */
 
 int filecopy(MI_CHECK *param, File to,File from,my_off_t start,
@@ -2058,7 +2011,6 @@
 {
   char tmp_buff[IO_SIZE],*buff;
   ulong buff_length;
-  DBUG_ENTER("filecopy");
 
   buff_length=(ulong) min(param->write_buffer_length,length);
   if (!(buff=my_malloc(buff_length,MYF(0))))
@@ -2079,13 +2031,13 @@
     goto err;
   if (buff != tmp_buff)
     my_free(buff,MYF(0));
-  DBUG_RETURN(0);
+  return(0);
 err:
   if (buff != tmp_buff)
     my_free(buff,MYF(0));
   mi_check_print_error(param,"Can't copy %s to tempfile, error %d",
 		       type,my_errno);
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -2120,7 +2072,6 @@
   char llbuff[22];
   SORT_INFO sort_info;
   uint64_t key_map= 0;
-  DBUG_ENTER("mi_repair_by_sort");
 
   start_records=info->state->records;
   got_error=1;
@@ -2253,8 +2204,6 @@
 	     (char*) (share->state.rec_per_key_part +
 		      (uint) (rec_per_key_part - param->rec_per_key_part)),
 	     sort_param.keyinfo->keysegs*sizeof(*rec_per_key_part));
-      DBUG_PRINT("repair", ("skipping seemingly disabled index #: %u",
-                            sort_param.key));
       continue;
     }
 
@@ -2303,7 +2252,6 @@
                        (uint64_t) info->state->records);
     /* Enable this index in the permanent (not the copied) key_map. */
     mi_set_key_active(share->state.key_map, sort_param.key);
-    DBUG_PRINT("repair", ("set enabled index #: %u", sort_param.key));
 
     if (sort_param.fix_datafile)
     {
@@ -2439,7 +2387,7 @@
     share->state.header.options[0]&= (uchar) ~HA_OPTION_COMPRESS_RECORD;
     share->pack.header_length=0;
   }
-  DBUG_RETURN(got_error);
+  return(got_error);
 }
 
 /*
@@ -2504,7 +2452,6 @@
   uint64_t key_map= 0;
   pthread_attr_t thr_attr;
   ulong max_pack_reclength;
-  DBUG_ENTER("mi_repair_parallel");
 
   start_records=info->state->records;
   got_error=1;
@@ -2549,7 +2496,6 @@
       position 'new_header_length'.
     }
   */
-  DBUG_PRINT("info", ("is quick repair: %d", rep_quick));
   bzero((char*)&sort_info,sizeof(sort_info));
   /* Initialize pthread structures before goto err. */
   pthread_mutex_init(&sort_info.mutex, MY_MUTEX_INIT_FAST);
@@ -2765,8 +2711,6 @@
     */
     sort_param[i].read_cache= ((rep_quick || !i) ? param->read_cache :
                                new_data_cache);
-    DBUG_PRINT("io_cache_share", ("thread: %u  read_cache: 0x%lx",
-                                  i, (long) &sort_param[i].read_cache));
 
     /*
       two approaches: the same amount of memory for each thread
@@ -2788,7 +2732,6 @@
       /* Cleanup: Detach from the share. Avoid others to be blocked. */
       if (io_share.total_threads)
         remove_io_thread(&sort_param[i].read_cache);
-      DBUG_PRINT("error", ("Cannot start a repair thread"));
       sort_info.got_error=1;
     }
     else
@@ -2952,7 +2895,7 @@
     share->state.header.options[0]&= (uchar) ~HA_OPTION_COMPRESS_RECORD;
     share->pack.header_length=0;
   }
-  DBUG_RETURN(got_error);
+  return(got_error);
 }
 
 	/* Read next record and return next key */
@@ -2962,16 +2905,15 @@
   int error;
   SORT_INFO *sort_info=sort_param->sort_info;
   MI_INFO *info=sort_info->info;
-  DBUG_ENTER("sort_key_read");
 
   if ((error=sort_get_next_record(sort_param)))
-    DBUG_RETURN(error);
+    return(error);
   if (info->state->records == sort_info->max_records)
   {
     mi_check_print_error(sort_info->param,
 			 "Key %d - Found too many records; Can't continue",
                          sort_param->key+1);
-    DBUG_RETURN(1);
+    return(1);
   }
   sort_param->real_key_length=
     (info->s->rec_reflength+
@@ -2981,7 +2923,7 @@
   bzero(key+sort_param->real_key_length,
 	(sort_param->key_length-sort_param->real_key_length));
 #endif
-  DBUG_RETURN(sort_write_record(sort_param));
+  return(sort_write_record(sort_param));
 } /* sort_key_read */
 
 
@@ -3029,10 +2971,9 @@
   MI_INFO *info=sort_info->info;
   MYISAM_SHARE *share=info->s;
   char llbuff[22],llbuff2[22];
-  DBUG_ENTER("sort_get_next_record");
 
   if (*killed_ptr(param))
-    DBUG_RETURN(1);
+    return(1);
 
   switch (share->data_file_type) {
   case STATIC_RECORD:
@@ -3045,7 +2986,7 @@
 	  param->out_flag |= O_DATA_LOST;
         param->retry_repair=1;
         param->testflag|=T_RETRY_WITHOUT_QUICK;
-	DBUG_RETURN(-1);
+	return(-1);
       }
       sort_param->start_recpos=sort_param->pos;
       if (!sort_param->fix_datafile)
@@ -3060,7 +3001,7 @@
 	if (sort_param->calc_checksum)
 	  param->glob_crc+= (info->checksum=
 			     mi_static_checksum(info,sort_param->record));
-	DBUG_RETURN(0);
+	return(0);
       }
       if (!sort_param->fix_datafile && sort_param->master)
       {
@@ -3111,14 +3052,14 @@
 				llstr(sort_param->start_recpos,llbuff),errno);
 	    goto try_next;
 	  }
-	  DBUG_RETURN(-1);
+	  return(-1);
 	}
 	if (searching && ! sort_param->fix_datafile)
 	{
 	  param->error_printed=1;
           param->retry_repair=1;
           param->testflag|=T_RETRY_WITHOUT_QUICK;
-	  DBUG_RETURN(1);	/* Something wrong with data */
+	  return(1);	/* Something wrong with data */
 	}
 	b_type=_mi_get_block_info(&block_info,-1,pos);
 	if ((b_type & (BLOCK_ERROR | BLOCK_FATAL_ERROR)) ||
@@ -3250,7 +3191,7 @@
 		mi_check_print_error(param,"Not enough memory for blob at %s (need %lu)",
 				     llstr(sort_param->start_recpos,llbuff),
 				     (ulong) block_info.rec_len);
-		DBUG_RETURN(1);
+		return(1);
 	      }
 	      else
 	      {
@@ -3332,7 +3273,7 @@
 			 sort_param->find_length) != MY_FILE_ERROR)
       {
 	if (sort_param->read_cache.error < 0)
-	  DBUG_RETURN(1);
+	  return(1);
 	if (sort_param->calc_checksum)
 	  info->checksum= mi_checksum(info, sort_param->record);
 	if ((param->testflag & (T_EXTEND | T_REP)) || searching)
@@ -3350,7 +3291,7 @@
 	}
 	if (sort_param->calc_checksum)
 	  param->glob_crc+= info->checksum;
-	DBUG_RETURN(0);
+	return(0);
       }
       if (!searching)
         mi_check_print_info(param,"Key %d - Found wrong stored record at %s",
@@ -3366,22 +3307,22 @@
       if (_mi_read_cache(&sort_param->read_cache,(uchar*) block_info.header,
 			 sort_param->pos,
 			 share->pack.ref_length,READING_NEXT))
-	DBUG_RETURN(-1);
+	return(-1);
       if (searching && ! sort_param->fix_datafile)
       {
 	param->error_printed=1;
         param->retry_repair=1;
         param->testflag|=T_RETRY_WITHOUT_QUICK;
-	DBUG_RETURN(1);		/* Something wrong with data */
+	return(1);		/* Something wrong with data */
       }
       sort_param->start_recpos=sort_param->pos;
       if (_mi_pack_get_block_info(info, &sort_param->bit_buff, &block_info,
                                   &sort_param->rec_buff, -1, sort_param->pos))
-	DBUG_RETURN(-1);
+	return(-1);
       if (!block_info.rec_len &&
 	  sort_param->pos + MEMMAP_EXTRA_MARGIN ==
 	  sort_param->read_cache.end_of_file)
-	DBUG_RETURN(-1);
+	return(-1);
       if (block_info.rec_len < (uint) share->min_pack_length ||
 	  block_info.rec_len > (uint) share->max_pack_length)
       {
@@ -3420,12 +3361,12 @@
       if (sort_param->calc_checksum)
 	param->glob_crc+= (info->checksum=
                            mi_checksum(info, sort_param->record));
-      DBUG_RETURN(0);
+      return(0);
     }
   case BLOCK_RECORD:
     assert(0);                                  /* Impossible */
   }
-  DBUG_RETURN(1);                               /* Impossible */
+  return(1);                               /* Impossible */
 }
 
 
@@ -3455,7 +3396,6 @@
   MI_CHECK *param=sort_info->param;
   MI_INFO *info=sort_info->info;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("sort_write_record");
 
   if (sort_param->fix_datafile)
   {
@@ -3465,7 +3405,7 @@
 		     share->base.pack_reclength))
       {
 	mi_check_print_error(param,"%d when writing to datafile",my_errno);
-	DBUG_RETURN(1);
+	return(1);
       }
       sort_param->filepos+=share->base.pack_reclength;
       info->s->state.split++;
@@ -3486,7 +3426,7 @@
 	  if (!(sort_info->buff=my_realloc(sort_info->buff, (uint) reclength,
 					   MYF(MY_FREE_ON_ERROR |
 					       MY_ALLOW_ZERO_PTR))))
-	    DBUG_RETURN(1);
+	    return(1);
 	  sort_info->buff_length=reclength;
 	}
 	from= sort_info->buff+ALIGN_SIZE(MI_MAX_DYN_BLOCK_HEADER);
@@ -3511,7 +3451,7 @@
 				  &from,&reclength,&flag))
 	{
 	  mi_check_print_error(param,"%d when writing to datafile",my_errno);
-	  DBUG_RETURN(1);
+	  return(1);
 	}
 	sort_param->filepos+=block_length;
 	info->s->state.split++;
@@ -3529,7 +3469,7 @@
 	  my_b_write(&info->rec_cache,(uchar*) sort_param->rec_buff,reclength))
       {
 	mi_check_print_error(param,"%d when writing to datafile",my_errno);
-	DBUG_RETURN(1);
+	return(1);
       }
       /* sort_info->param->glob_crc+=info->checksum; */
       sort_param->filepos+=reclength+length;
@@ -3550,7 +3490,7 @@
       VOID(fflush(stdout));
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* sort_write_record */
 
 
@@ -3613,18 +3553,8 @@
 						    lastkey),
 				 llbuff2));
     param->testflag|=T_RETRY_WITHOUT_QUICK;
-    if (sort_info->param->testflag & T_VERBOSE)
-      _mi_print_key(stdout,sort_param->seg,(uchar*) a, USE_WHOLE_KEY);
     return (sort_delete_record(sort_param));
   }
-#ifndef DBUG_OFF
-  if (cmp > 0)
-  {
-    mi_check_print_error(param,
-			 "Internal error: Keys are not in order from sort");
-    return(1);
-  }
-#endif
   return (sort_insert_key(sort_param,sort_info->key_block,
 			  (uchar*) a, HA_OFFSET_ERROR));
 } /* sort_key_write */
@@ -3653,7 +3583,6 @@
   MI_KEYDEF *keyinfo=sort_param->keyinfo;
   SORT_INFO *sort_info= sort_param->sort_info;
   MI_CHECK *param=sort_info->param;
-  DBUG_ENTER("sort_insert_key");
 
   anc_buff=key_block->buff;
   info=sort_info->info;
@@ -3667,7 +3596,7 @@
     if (key_block == sort_info->key_block_end)
     {
       mi_check_print_error(param,"To many key-block-levels; Try increasing sort_key_blocks");
-      DBUG_RETURN(1);
+      return(1);
     }
     a_length=2+nod_flag;
     key_block->end_pos=anc_buff+2;
@@ -3691,7 +3620,7 @@
   {
     VOID(_mi_move_key(keyinfo,key_block->lastkey,key));
     key_block->last_length=a_length-t_length;
-    DBUG_RETURN(0);
+    return(0);
   }
 
 	/* Fill block with end-zero and write filled block */
@@ -3700,26 +3629,25 @@
 	keyinfo->block_length- key_block->last_length);
   key_file_length=info->state->key_file_length;
   if ((filepos=_mi_new(info,keyinfo,DFLT_INIT_HITS)) == HA_OFFSET_ERROR)
-    DBUG_RETURN(1);
+    return(1);
 
   /* If we read the page from the key cache, we have to write it back to it */
   if (key_file_length == info->state->key_file_length)
   {
     if (_mi_write_keypage(info, keyinfo, filepos, DFLT_INIT_HITS, anc_buff))
-      DBUG_RETURN(1);
+      return(1);
   }
   else if (my_pwrite(info->s->kfile,(uchar*) anc_buff,
 		     (uint) keyinfo->block_length,filepos, param->myf_rw))
-    DBUG_RETURN(1);
-  DBUG_DUMP("buff",(uchar*) anc_buff,mi_getint(anc_buff));
+    return(1);
 
 	/* Write separator-key to block in next level */
   if (sort_insert_key(sort_param,key_block+1,key_block->lastkey,filepos))
-    DBUG_RETURN(1);
+    return(1);
 
 	/* clear old block and write new key in it */
   key_block->inited=0;
-  DBUG_RETURN(sort_insert_key(sort_param, key_block,key,prev_block));
+  return(sort_insert_key(sort_param, key_block,key,prev_block));
 } /* sort_insert_key */
 
 
@@ -3733,19 +3661,18 @@
   SORT_INFO *sort_info=sort_param->sort_info;
   MI_CHECK *param=sort_info->param;
   MI_INFO *info=sort_info->info;
-  DBUG_ENTER("sort_delete_record");
 
   if ((param->testflag & (T_FORCE_UNIQUENESS|T_QUICK)) == T_QUICK)
   {
     mi_check_print_error(param,
 			 "Quick-recover aborted; Run recovery without switch -q or with switch -qq");
-    DBUG_RETURN(1);
+    return(1);
   }
   if (info->s->options & HA_OPTION_COMPRESS_RECORD)
   {
     mi_check_print_error(param,
 			 "Recover aborted; Can't run standard recovery on compressed tables with errors in data-file. Use switch 'myisamchk --safe-recover' to fix it\n",stderr);;
-    DBUG_RETURN(1);
+    return(1);
   }
 
   old_file=info->dfile;
@@ -3758,7 +3685,7 @@
     {
       mi_check_print_error(param,"Can't read record to be removed");
       info->dfile=old_file;
-      DBUG_RETURN(1);
+      return(1);
     }
 
     for (i=0 ; i < sort_info->current_key ; i++)
@@ -3768,7 +3695,7 @@
       {
 	mi_check_print_error(param,"Can't delete key %d from record to be removed",i+1);
 	info->dfile=old_file;
-	DBUG_RETURN(1);
+	return(1);
       }
     }
     if (sort_param->calc_checksum)
@@ -3777,7 +3704,7 @@
   error=flush_io_cache(&info->rec_cache) || (*info->s->delete_record)(info);
   info->dfile=old_file;				/* restore actual value */
   info->state->records--;
-  DBUG_RETURN(error);
+  return(error);
 } /* sort_delete_record */
 
 	/* Fix all pending blocks and flush everything to disk */
@@ -3791,7 +3718,6 @@
   myf myf_rw=sort_info->param->myf_rw;
   MI_INFO *info=sort_info->info;
   MI_KEYDEF *keyinfo=sort_param->keyinfo;
-  DBUG_ENTER("flush_pending_blocks");
 
   filepos= HA_OFFSET_ERROR;			/* if empty file */
   nod_flag=0;
@@ -3804,23 +3730,22 @@
     key_file_length=info->state->key_file_length;
     bzero((uchar*) key_block->buff+length, keyinfo->block_length-length);
     if ((filepos=_mi_new(info,keyinfo,DFLT_INIT_HITS)) == HA_OFFSET_ERROR)
-      DBUG_RETURN(1);
+      return(1);
 
     /* If we read the page from the key cache, we have to write it back */
     if (key_file_length == info->state->key_file_length)
     {
       if (_mi_write_keypage(info, keyinfo, filepos,
                             DFLT_INIT_HITS, key_block->buff))
-	DBUG_RETURN(1);
+	return(1);
     }
     else if (my_pwrite(info->s->kfile,(uchar*) key_block->buff,
 		       (uint) keyinfo->block_length,filepos, myf_rw))
-      DBUG_RETURN(1);
-    DBUG_DUMP("buff",(uchar*) key_block->buff,length);
+      return(1);
     nod_flag=1;
   }
   info->s->state.key_root[sort_param->key]=filepos; /* Last is root for tree */
-  DBUG_RETURN(0);
+  return(0);
 } /* flush_pending_blocks */
 
 	/* alloc space and pointers for key_blocks */
@@ -3830,7 +3755,6 @@
 {
   register uint i;
   SORT_KEY_BLOCKS *block;
-  DBUG_ENTER("alloc_key_blocks");
 
   if (!(block=(SORT_KEY_BLOCKS*) my_malloc((sizeof(SORT_KEY_BLOCKS)+
 					    buffer_length+IO_SIZE)*blocks,
@@ -3844,7 +3768,7 @@
     block[i].inited=0;
     block[i].buff=(uchar*) (block+blocks)+(buffer_length+IO_SIZE)*i;
   }
-  DBUG_RETURN(block);
+  return(block);
 } /* alloc_key_blocks */
 
 
@@ -3876,7 +3800,6 @@
   ha_rows max_records;
   uint64_t file_length,tmp_length;
   MI_CREATE_INFO create_info;
-  DBUG_ENTER("recreate_table");
 
   error=1;					/* Default error */
   info= **org_info;
@@ -3886,7 +3809,7 @@
   unpack= (share.options & HA_OPTION_COMPRESS_RECORD) &&
     (param->testflag & T_UNPACK);
   if (!(keyinfo=(MI_KEYDEF*) my_alloca(sizeof(MI_KEYDEF)*share.base.keys)))
-    DBUG_RETURN(0);
+    return(0);
   memcpy((uchar*) keyinfo,(uchar*) share.keyinfo,
 	 (size_t) (sizeof(MI_KEYDEF)*share.base.keys));
 
@@ -3895,14 +3818,14 @@
 				       (key_parts+share.base.keys))))
   {
     my_afree((uchar*) keyinfo);
-    DBUG_RETURN(1);
+    return(1);
   }
   if (!(recdef=(MI_COLUMNDEF*)
 	my_alloca(sizeof(MI_COLUMNDEF)*(share.base.fields+1))))
   {
     my_afree((uchar*) keyinfo);
     my_afree((uchar*) keysegs);
-    DBUG_RETURN(1);
+    return(1);
   }
   if (!(uniquedef=(MI_UNIQUEDEF*)
 	my_alloca(sizeof(MI_UNIQUEDEF)*(share.state.header.uniques+1))))
@@ -3910,7 +3833,7 @@
     my_afree((uchar*) recdef);
     my_afree((uchar*) keyinfo);
     my_afree((uchar*) keysegs);
-    DBUG_RETURN(1);
+    return(1);
   }
 
   /* Copy the column definitions */
@@ -4029,7 +3952,7 @@
   my_afree((uchar*) keyinfo);
   my_afree((uchar*) recdef);
   my_afree((uchar*) keysegs);
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -4132,7 +4055,6 @@
 			       my_bool repair_only)
 {
   uchar *record= 0;
-  DBUG_ENTER("update_auto_increment_key");
 
   if (!info->s->base.auto_key ||
       ! mi_is_key_active(info->s->state.key_map, info->s->base.auto_key - 1))
@@ -4141,7 +4063,7 @@
       mi_check_print_info(param,
 			  "Table: %s doesn't have an auto increment key\n",
 			  param->isam_file_name);
-    DBUG_VOID_RETURN;
+    return;
   }
   if (!(param->testflag & T_SILENT) &&
       !(param->testflag & T_REP))
@@ -4153,7 +4075,7 @@
   if (!mi_alloc_rec_buff(info, -1, &record))
   {
     mi_check_print_error(param,"Not enough memory for extra record");
-    DBUG_VOID_RETURN;
+    return;
   }
 
   mi_extra(info,HA_EXTRA_KEYREAD,0);
@@ -4164,7 +4086,7 @@
       mi_extra(info,HA_EXTRA_NO_KEYREAD,0);
       my_free(mi_get_rec_buff_ptr(info, record), MYF(0));
       mi_check_print_error(param,"%d when reading last record",my_errno);
-      DBUG_VOID_RETURN;
+      return;
     }
     if (!repair_only)
       info->s->state.auto_increment=param->auto_increment_value;
@@ -4179,7 +4101,7 @@
   mi_extra(info,HA_EXTRA_NO_KEYREAD,0);
   my_free(mi_get_rec_buff_ptr(info, record), MYF(0));
   update_state_info(param, info, UPDATE_AUTO_INC);
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -4310,7 +4232,7 @@
   MI_KEYDEF    *key=share->keyinfo;
   uint          i;
 
-  DBUG_ASSERT(info->state->records == 0 &&
+  assert(info->state->records == 0 &&
               (!rows || rows >= MI_MIN_ROWS_TO_DISABLE_INDEXES));
   for (i=0 ; i < share->base.keys ; i++,key++)
   {

=== modified file 'storage/myisam/mi_close.c'
--- storage/myisam/mi_close.c	2008-07-06 15:03:34 +0000
+++ storage/myisam/mi_close.c	2008-07-15 20:04:02 +0000
@@ -26,10 +26,6 @@
 {
   int error=0,flag;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_close");
-  DBUG_PRINT("enter",("base: 0x%lx  reopen: %u  locks: %u",
-		      (long) info, (uint) share->reopen,
-                      (uint) share->tot_locks));
 
   pthread_mutex_lock(&THR_LOCK_myisam);
   if (info->lock_type == F_EXTRA_LCK)
@@ -112,7 +108,7 @@
 
   if (error)
   {
-    DBUG_RETURN(my_errno=error);
+    return(my_errno=error);
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* mi_close */

=== modified file 'storage/myisam/mi_create.c'
--- storage/myisam/mi_create.c	2008-07-15 06:45:16 +0000
+++ storage/myisam/mi_create.c	2008-07-16 05:44:59 +0000
@@ -55,9 +55,6 @@
   ulong *rec_per_key_part;
   my_off_t key_root[HA_MAX_POSSIBLE_KEY],key_del[MI_MAX_KEY_BLOCK_SIZE];
   MI_CREATE_INFO tmp_create_info;
-  DBUG_ENTER("mi_create");
-  DBUG_PRINT("enter", ("keys: %u  columns: %u  uniques: %u  flags: %u",
-                      keys, columns, uniques, flags));
 
   if (!ci)
   {
@@ -67,7 +64,7 @@
 
   if (keys + uniques > MI_MAX_KEY || columns == 0)
   {
-    DBUG_RETURN(my_errno=HA_WRONG_CREATE_OPTION);
+    return(my_errno=HA_WRONG_CREATE_OPTION);
   }
   errpos= 0;
   options= 0;
@@ -91,7 +88,7 @@
   if (!(rec_per_key_part=
 	(ulong*) my_malloc((keys + uniques)*MI_MAX_KEY_SEG*sizeof(long),
 			   MYF(MY_WME | MY_ZEROFILL))))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
 	/* Start by checking fields and field-types used */
 
@@ -306,7 +303,7 @@
 	}
 	if (keyseg->flag & HA_SPACE_PACK)
 	{
-          DBUG_ASSERT(!(keyseg->flag & HA_VAR_LENGTH_PART));
+          assert(!(keyseg->flag & HA_VAR_LENGTH_PART));
 	  keydef->flag |= HA_SPACE_PACK_USED | HA_VAR_LENGTH_KEY;
 	  options|=HA_OPTION_PACK_KEYS;		/* Using packed keys */
 	  length++;				/* At least one length byte */
@@ -319,7 +316,7 @@
 	}
 	if (keyseg->flag & (HA_VAR_LENGTH_PART | HA_BLOB_PART))
 	{
-          DBUG_ASSERT(!test_all_bits(keyseg->flag,
+          assert(!test_all_bits(keyseg->flag,
                                     (HA_VAR_LENGTH_PART | HA_BLOB_PART)));
 	  keydef->flag|=HA_VAR_LENGTH_KEY;
 	  length++;				/* At least one length byte */
@@ -409,7 +406,6 @@
 			       uniques * MI_UNIQUEDEF_SIZE +
 			       (key_segs + unique_key_parts)*HA_KEYSEG_SIZE+
 			       columns*MI_COLUMNDEF_SIZE);
-  DBUG_PRINT("info", ("info_length: %u", info_length));
   /* There are only 16 bits for the total header length. */
   if (info_length > 65535)
   {
@@ -603,21 +599,11 @@
     errpos=3;
   }
 
-  DBUG_PRINT("info", ("write state info and base info"));
   if (mi_state_info_write(file, &share.state, 2) ||
       mi_base_info_write(file, &share.base))
     goto err;
-#ifndef DBUG_OFF
-  if ((uint) my_tell(file,MYF(0)) != base_pos+ MI_BASE_INFO_SIZE)
-  {
-    uint pos=(uint) my_tell(file,MYF(0));
-    DBUG_PRINT("warning",("base_length: %d  != used_length: %d",
-			  base_pos+ MI_BASE_INFO_SIZE, pos));
-  }
-#endif
 
   /* Write key and keyseg definitions */
-  DBUG_PRINT("info", ("write key and keyseg definitions"));
   for (i=0 ; i < share.base.keys - uniques; i++)
   {
     uint sp_segs= 0;
@@ -649,7 +635,6 @@
   }
 
   /* Save unique definition */
-  DBUG_PRINT("info", ("write unique definitions"));
   for (i=0 ; i < share.state.header.uniques ; i++)
   {
     HA_KEYSEG *keyseg_end;
@@ -680,22 +665,11 @@
 	goto err;
     }
   }
-  DBUG_PRINT("info", ("write field definitions"));
   for (i=0 ; i < share.base.fields ; i++)
     if (mi_recinfo_write(file, &recinfo[i]))
       goto err;
 
-#ifndef DBUG_OFF
-  if ((uint) my_tell(file,MYF(0)) != info_length)
-  {
-    uint pos= (uint) my_tell(file,MYF(0));
-    DBUG_PRINT("warning",("info_length: %d  != used_length: %d",
-			  info_length, pos));
-  }
-#endif
-
 	/* Enlarge files */
-  DBUG_PRINT("info", ("enlarge to keystart: %lu", (ulong) share.base.keystart));
   if (ftruncate(file, (off_t) share.base.keystart))
     goto err;
 
@@ -714,7 +688,7 @@
   if (my_close(file,MYF(0)))
     goto err;
   my_free((char*) rec_per_key_part,MYF(0));
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   pthread_mutex_unlock(&THR_LOCK_myisam);
@@ -738,13 +712,13 @@
 			     MYF(0));
   }
   my_free((char*) rec_per_key_part, MYF(0));
-  DBUG_RETURN(my_errno=save_errno);		/* return the fatal errno */
+  return(my_errno=save_errno);		/* return the fatal errno */
 }
 
 
 uint mi_get_pointer_length(uint64_t file_length, uint def)
 {
-  DBUG_ASSERT(def >= 2 && def <= 7);
+  assert(def >= 2 && def <= 7);
   if (file_length)				/* If not default */
   {
 #ifdef NOT_YET_READY_FOR_8_BYTE_POINTERS

=== removed file 'storage/myisam/mi_dbug.c'
--- storage/myisam/mi_dbug.c	2008-07-13 22:45:08 +0000
+++ storage/myisam/mi_dbug.c	1970-01-01 00:00:00 +0000
@@ -1,194 +0,0 @@
-/* Copyright (C) 2000-2005 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* Support rutiner with are using with dbug */
-
-#include "myisamdef.h"
-
-	/* Print a key in user understandable format */
-
-void _mi_print_key(FILE *stream, register HA_KEYSEG *keyseg,
-		   const uchar *key, uint length)
-{
-  int flag;
-  short int s_1;
-  long	int l_1;
-  float f_1;
-  double d_1;
-  const uchar *end;
-  const uchar *key_end=key+length;
-
-  VOID(fputs("Key: \"",stream));
-  flag=0;
-  for (; keyseg->type && key < key_end ;keyseg++)
-  {
-    if (flag++)
-      VOID(putc('-',stream));
-    end= key+ keyseg->length;
-    if (keyseg->flag & HA_NULL_PART)
-    {
-      /* A NULL value is encoded by a 1-byte flag. Zero means NULL. */
-      if (! *(key++))
-      {
-	fprintf(stream,"NULL");
-	continue;
-      }
-    }
-
-    switch (keyseg->type) {
-    case HA_KEYTYPE_BINARY:
-      if (!(keyseg->flag & HA_SPACE_PACK) && keyseg->length == 1)
-      {						/* packed binary digit */
-	VOID(fprintf(stream,"%d",(uint) *key++));
-	break;
-      }
-      /* fall through */
-    case HA_KEYTYPE_TEXT:
-    case HA_KEYTYPE_NUM:
-      if (keyseg->flag & HA_SPACE_PACK)
-      {
-	VOID(fprintf(stream,"%.*s",(int) *key,key+1));
-	key+= (int) *key+1;
-      }
-      else
-      {
-	VOID(fprintf(stream,"%.*s",(int) keyseg->length,key));
-	key=end;
-      }
-      break;
-    case HA_KEYTYPE_INT8:
-      VOID(fprintf(stream,"%d",(int) *((signed char*) key)));
-      key=end;
-      break;
-    case HA_KEYTYPE_SHORT_INT:
-      s_1= mi_sint2korr(key);
-      VOID(fprintf(stream,"%d",(int) s_1));
-      key=end;
-      break;
-    case HA_KEYTYPE_USHORT_INT:
-      {
-	ushort u_1;
-	u_1= mi_uint2korr(key);
-	VOID(fprintf(stream,"%u",(uint) u_1));
-	key=end;
-	break;
-      }
-    case HA_KEYTYPE_LONG_INT:
-      l_1=mi_sint4korr(key);
-      VOID(fprintf(stream,"%ld",l_1));
-      key=end;
-      break;
-    case HA_KEYTYPE_ULONG_INT:
-      l_1=mi_sint4korr(key);
-      VOID(fprintf(stream,"%lu",(ulong) l_1));
-      key=end;
-      break;
-    case HA_KEYTYPE_INT24:
-      VOID(fprintf(stream,"%ld",(long) mi_sint3korr(key)));
-      key=end;
-      break;
-    case HA_KEYTYPE_UINT24:
-      VOID(fprintf(stream,"%lu",(ulong) mi_uint3korr(key)));
-      key=end;
-      break;
-    case HA_KEYTYPE_FLOAT:
-      mi_float4get(f_1,key);
-      VOID(fprintf(stream,"%g",(double) f_1));
-      key=end;
-      break;
-    case HA_KEYTYPE_DOUBLE:
-      mi_float8get(d_1,key);
-      VOID(fprintf(stream,"%g",d_1));
-      key=end;
-      break;
-    case HA_KEYTYPE_LONGLONG:
-    {
-      char buff[21];
-      int64_t2str(mi_sint8korr(key),buff,-10);
-      VOID(fprintf(stream,"%s",buff));
-      key=end;
-      break;
-    }
-    case HA_KEYTYPE_ULONGLONG:
-    {
-      char buff[21];
-      int64_t2str(mi_sint8korr(key),buff,10);
-      VOID(fprintf(stream,"%s",buff));
-      key=end;
-      break;
-    }
-    case HA_KEYTYPE_BIT:
-    {
-      uint i;
-      fputs("0x",stream);
-      for (i=0 ; i < keyseg->length ; i++)
-        fprintf(stream, "%02x", (uint) *key++);
-      key= end;
-      break;
-    }
-
-    case HA_KEYTYPE_VARTEXT1:                   /* VARCHAR and TEXT */
-    case HA_KEYTYPE_VARTEXT2:                   /* VARCHAR and TEXT */
-    case HA_KEYTYPE_VARBINARY1:                 /* VARBINARY and BLOB */
-    case HA_KEYTYPE_VARBINARY2:                 /* VARBINARY and BLOB */
-    {
-      uint tmp_length;
-      get_key_length(tmp_length,key);
-      /*
-	The following command sometimes gives a warning from valgrind.
-	Not yet sure if the bug is in valgrind, glibc or mysqld
-      */
-      VOID(fprintf(stream,"%.*s",(int) tmp_length,key));
-      key+=tmp_length;
-      break;
-    }
-    default: break;			/* This never happens */
-    }
-  }
-  VOID(fputs("\"\n",stream));
-  return;
-} /* print_key */
-
-
-#ifdef EXTRA_DEBUG 
-
-my_bool check_table_is_closed(const char *name, const char *where)
-{
-  char filename[FN_REFLEN];
-  LIST *pos;
-  DBUG_ENTER("check_table_is_closed");
-
-  pthread_mutex_lock(&THR_LOCK_myisam);
-
-  (void) fn_format(filename,name,"",MI_NAME_IEXT,4+16+32);
-  for (pos=myisam_open_list ; pos ; pos=pos->next)
-  {
-    MI_INFO *info=(MI_INFO*) pos->data;
-    MYISAM_SHARE *share=info->s;
-    if (!strcmp(share->unique_file_name,filename))
-    {
-      if (share->last_version)
-      {
-	fprintf(stderr,"Warning:  Table: %s is open on %s\n", name,where);
-	DBUG_PRINT("warning",("Table: %s is open on %s", name,where));
-        pthread_mutex_unlock(&THR_LOCK_myisam);
-	DBUG_RETURN(1);
-      }
-    }
-  }
-  pthread_mutex_unlock(&THR_LOCK_myisam);
-  DBUG_RETURN(0);
-}
-#endif /* EXTRA_DEBUG */

=== modified file 'storage/myisam/mi_delete.c'
--- storage/myisam/mi_delete.c	2008-07-06 07:32:43 +0000
+++ storage/myisam/mi_delete.c	2008-07-15 20:45:09 +0000
@@ -39,26 +39,18 @@
   char lastpos[8];
 
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_delete");
 
 	/* Test if record is in datafile */
-
-  DBUG_EXECUTE_IF("myisam_pretend_crashed_table_on_usage",
-                  mi_print_error(info->s, HA_ERR_CRASHED);
-                  DBUG_RETURN(my_errno= HA_ERR_CRASHED););
-  DBUG_EXECUTE_IF("my_error_test_undefined_error",
-                  mi_print_error(info->s, INT_MAX);
-                  DBUG_RETURN(my_errno= INT_MAX););
   if (!(info->update & HA_STATE_AKTIV))
   {
-    DBUG_RETURN(my_errno=HA_ERR_KEY_NOT_FOUND);	/* No database read */
+    return(my_errno=HA_ERR_KEY_NOT_FOUND);	/* No database read */
   }
   if (share->options & HA_OPTION_READ_ONLY_DATA)
   {
-    DBUG_RETURN(my_errno=EACCES);
+    return(my_errno=EACCES);
   }
   if (_mi_readinfo(info,F_WRLCK,1))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   if (info->s->calc_checksum)
     info->checksum=(*info->s->calc_checksum)(info,record);
   if ((*share->compare_record)(info,record))
@@ -97,11 +89,10 @@
   VOID(_mi_writeinfo(info,WRITEINFO_UPDATE_KEYFILE));
   if (info->invalidator != 0)
   {
-    DBUG_PRINT("info", ("invalidator... '%s' (delete)", info->filename));
     (*info->invalidator)(info->filename);
     info->invalidator=0;
   }
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   save_errno=my_errno;
@@ -121,7 +112,7 @@
     my_errno=HA_ERR_CRASHED;
   }
 
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* mi_delete */
 
 
@@ -142,20 +133,17 @@
   uint nod_flag;
   my_off_t old_root;
   uchar *root_buff;
-  DBUG_ENTER("_mi_ck_real_delete");
 
   if ((old_root=*root) == HA_OFFSET_ERROR)
   {
     mi_print_error(info->s, HA_ERR_CRASHED);
-    DBUG_RETURN(my_errno=HA_ERR_CRASHED);
+    return(my_errno=HA_ERR_CRASHED);
   }
   if (!(root_buff= (uchar*) my_alloca((uint) keyinfo->block_length+
 				      MI_MAX_KEY_BUFF*2)))
   {
-    DBUG_PRINT("error",("Couldn't allocate memory"));
-    DBUG_RETURN(my_errno=ENOMEM);
+    return(my_errno=ENOMEM);
   }
-  DBUG_PRINT("info",("root_page: %ld", (long) old_root));
   if (!_mi_fetch_keypage(info,keyinfo,old_root,DFLT_INIT_HITS,root_buff,0))
   {
     error= -1;
@@ -165,7 +153,6 @@
   {
     if (error == 2)
     {
-      DBUG_PRINT("test",("Enlarging of root when deleting"));
       error=_mi_enlarge_root(info,keyinfo,key,root);
     }
     else /* error == 1 */
@@ -187,8 +174,7 @@
   }
 err:
   my_afree((uchar*) root_buff);
-  DBUG_PRINT("exit",("Return: %d",error));
-  DBUG_RETURN(error);
+  return(error);
 } /* _mi_ck_real_delete */
 
 
@@ -210,16 +196,13 @@
   uchar *leaf_buff,*keypos;
   my_off_t leaf_page= 0, next_block;
   uchar lastkey[MI_MAX_KEY_BUFF];
-  DBUG_ENTER("d_search");
-  DBUG_DUMP("page",(uchar*) anc_buff,mi_getint(anc_buff));
 
   search_key_length= (comp_flag & SEARCH_FIND) ? key_length : USE_WHOLE_KEY;
   flag=(*keyinfo->bin_search)(info,keyinfo,anc_buff,key, search_key_length,
                               comp_flag, &keypos, lastkey, &last_key);
   if (flag == MI_FOUND_WRONG_KEY)
   {
-    DBUG_PRINT("error",("Found wrong key"));
-    DBUG_RETURN(-1);
+    return(-1);
   }
   nod_flag=mi_test_if_nod(anc_buff);
 
@@ -230,10 +213,8 @@
     if (!(leaf_buff= (uchar*) my_alloca((uint) keyinfo->block_length+
 					MI_MAX_KEY_BUFF*2)))
     {
-      DBUG_PRINT("error",("Couldn't allocate memory"));
       my_errno=ENOMEM;
-      DBUG_PRINT("exit",("Return: %d",-1));
-      DBUG_RETURN(-1);
+      return(-1);
     }
     if (!_mi_fetch_keypage(info,keyinfo,leaf_page,DFLT_INIT_HITS,leaf_buff,0))
       goto err;
@@ -243,7 +224,6 @@
   {
     if (!nod_flag)
     {
-      DBUG_PRINT("error",("Didn't find key"));
       mi_print_error(info->s, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;		/* This should newer happend */
       goto err;
@@ -267,11 +247,10 @@
     {						/* On leaf page */
       if (_mi_write_keypage(info,keyinfo,page,DFLT_INIT_HITS,anc_buff))
       {
-        DBUG_PRINT("exit",("Return: %d",-1));
-	DBUG_RETURN(-1);
+	return(-1);
       }
       /* Page will be update later if we return 1 */
-      DBUG_RETURN(test(length <= (info->quick_mode ? MI_MIN_KEYBLOCK_LENGTH :
+      return(test(length <= (info->quick_mode ? MI_MIN_KEYBLOCK_LENGTH :
 				  (uint) keyinfo->underflow_block_length)));
     }
     save_flag=1;
@@ -285,7 +264,6 @@
       ret_value= underflow(info,keyinfo,anc_buff,leaf_page,leaf_buff,keypos);
     else
     {				/* This happens only with packed keys */
-      DBUG_PRINT("test",("Enlarging of key when deleting"));
       if (!_mi_get_last_key(info,keyinfo,anc_buff,lastkey,keypos,&length))
       {
 	goto err;
@@ -301,18 +279,12 @@
   }
   if (save_flag && ret_value != 1)
     ret_value|=_mi_write_keypage(info,keyinfo,page,DFLT_INIT_HITS,anc_buff);
-  else
-  {
-    DBUG_DUMP("page",(uchar*) anc_buff,mi_getint(anc_buff));
-  }
   my_afree((uchar*) leaf_buff);
-  DBUG_PRINT("exit",("Return: %d",ret_value));
-  DBUG_RETURN(ret_value);
+  return(ret_value);
 
 err:
   my_afree((uchar*) leaf_buff);
-  DBUG_PRINT("exit",("Error: %d",my_errno));
-  DBUG_RETURN (-1);
+  return (-1);
 } /* d_search */
 
 
@@ -330,27 +302,22 @@
   uchar keybuff[MI_MAX_KEY_BUFF],*endpos,*next_buff,*key_start, *prev_key;
   MYISAM_SHARE *share=info->s;
   MI_KEY_PARAM s_temp;
-  DBUG_ENTER("del");
-  DBUG_PRINT("enter",("leaf_page: %ld  keypos: 0x%lx", (long) leaf_page,
-		      (ulong) keypos));
-  DBUG_DUMP("leaf_buff",(uchar*) leaf_buff,mi_getint(leaf_buff));
 
   endpos=leaf_buff+mi_getint(leaf_buff);
   if (!(key_start=_mi_get_last_key(info,keyinfo,leaf_buff,keybuff,endpos,
 				   &tmp)))
-    DBUG_RETURN(-1);
+    return(-1);
 
   if ((nod_flag=mi_test_if_nod(leaf_buff)))
   {
     next_page= _mi_kpos(nod_flag,endpos);
     if (!(next_buff= (uchar*) my_alloca((uint) keyinfo->block_length+
 					MI_MAX_KEY_BUFF*2)))
-      DBUG_RETURN(-1);
+      return(-1);
     if (!_mi_fetch_keypage(info,keyinfo,next_page,DFLT_INIT_HITS,next_buff,0))
       ret_value= -1;
     else
     {
-      DBUG_DUMP("next_page",(uchar*) next_buff,mi_getint(next_buff));
       if ((ret_value=del(info,keyinfo,key,anc_buff,next_page,next_buff,
 			 keypos,next_block,ret_key)) >0)
       {
@@ -366,7 +333,6 @@
 	}
 	else
 	{
-	  DBUG_PRINT("test",("Inserting of key when deleting"));
 	  if (!_mi_get_last_key(info,keyinfo,leaf_buff,keybuff,endpos,
 				&tmp))
 	    goto err;
@@ -378,7 +344,7 @@
 	goto err;
     }
     my_afree((uchar*) next_buff);
-    DBUG_RETURN(ret_value);
+    return(ret_value);
   }
 
 	/* Remove last key from leaf page */
@@ -411,11 +377,11 @@
   _mi_kpointer(info,keypos - share->base.key_reflength,next_block);
   mi_putint(anc_buff,a_length+length,share->base.key_reflength);
 
-  DBUG_RETURN( mi_getint(leaf_buff) <=
+  return( mi_getint(leaf_buff) <=
 	       (info->quick_mode ? MI_MIN_KEYBLOCK_LENGTH :
 		(uint) keyinfo->underflow_block_length));
 err:
-  DBUG_RETURN(-1);
+  return(-1);
 } /* del */
 
 
@@ -436,11 +402,6 @@
         *after_key;
   MI_KEY_PARAM s_temp;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("underflow");
-  DBUG_PRINT("enter",("leaf_page: %ld  keypos: 0x%lx",(long) leaf_page,
-		      (ulong) keypos));
-  DBUG_DUMP("anc_buff",(uchar*) anc_buff,mi_getint(anc_buff));
-  DBUG_DUMP("leaf_buff",(uchar*) leaf_buff,mi_getint(leaf_buff));
 
   buff=info->buff;
   info->buff_used=1;
@@ -456,8 +417,6 @@
   if ((keypos < anc_buff+anc_length && (info->state->records & 1)) ||
       keypos == anc_buff+2+key_reflength)
   {					/* Use page right of anc-page */
-    DBUG_PRINT("test",("use right page"));
-
     if (keyinfo->flag & HA_BINARY_PACK_KEY)
     {
       if (!(next_keypos=_mi_get_key(info, keyinfo,
@@ -476,7 +435,6 @@
     if (!_mi_fetch_keypage(info,keyinfo,next_page,DFLT_INIT_HITS,buff,0))
       goto err;
     buff_length=mi_getint(buff);
-    DBUG_DUMP("next",(uchar*) buff,buff_length);
 
     /* find keys to make a big key-page */
     bmove((uchar*) next_keypos-key_reflength,(uchar*) buff+2,
@@ -518,8 +476,6 @@
     else
     {						/* Page is full */
       endpos=anc_buff+anc_length;
-      DBUG_PRINT("test",("anc_buff: 0x%lx  endpos: 0x%lx",
-                         (long) anc_buff, (long) endpos));
       if (keypos != anc_buff+2+key_reflength &&
 	  !_mi_get_last_key(info,keyinfo,anc_buff,anc_key,keypos,&length))
 	goto err;
@@ -567,12 +523,10 @@
     }
     if (_mi_write_keypage(info,keyinfo,leaf_page,DFLT_INIT_HITS,leaf_buff))
       goto err;
-    DBUG_RETURN(anc_length <= ((info->quick_mode ? MI_MIN_BLOCK_LENGTH :
+    return(anc_length <= ((info->quick_mode ? MI_MIN_BLOCK_LENGTH :
 				(uint) keyinfo->underflow_block_length)));
   }
 
-  DBUG_PRINT("test",("use left page"));
-
   keypos=_mi_get_last_key(info,keyinfo,anc_buff,anc_key,keypos,&length);
   if (!keypos)
     goto err;
@@ -581,7 +535,6 @@
       goto err;
   buff_length=mi_getint(buff);
   endpos=buff+buff_length;
-  DBUG_DUMP("prev",(uchar*) buff,buff_length);
 
   /* find keys to make a big key-page */
   bmove((uchar*) next_keypos - key_reflength,(uchar*) leaf_buff+2,
@@ -637,8 +590,6 @@
       goto err;
     _mi_kpointer(info,leaf_key+key_length,leaf_page);
     /* Save key in anc_buff */
-    DBUG_DUMP("anc_buff",(uchar*) anc_buff,anc_length);
-    DBUG_DUMP("key_to_anc",(uchar*) leaf_key,key_length);
 
     temp_pos=anc_buff+anc_length;
     t_length=(*keyinfo->pack_key)(keyinfo,key_reflength,
@@ -659,11 +610,9 @@
       bmove((uchar*) leaf_buff+2,(uchar*) half_pos-nod_flag,(size_t) nod_flag);
     if (!(length=(*keyinfo->get_key)(keyinfo,nod_flag,&half_pos,leaf_key)))
       goto err;
-    DBUG_DUMP("key_to_leaf",(uchar*) leaf_key,length);
     t_length=(*keyinfo->pack_key)(keyinfo,nod_flag, (uchar*) 0,
 				  (uchar*) 0, (uchar*) 0, leaf_key, &s_temp);
     length=(uint) ((buff+buff_length)-half_pos);
-    DBUG_PRINT("info",("t_length: %d  length: %d",t_length,(int) length));
     bmove((uchar*) leaf_buff+p_length+t_length,(uchar*) half_pos,
 	  (size_t) length);
     (*keyinfo->store_key)(keyinfo,leaf_buff+p_length,&s_temp);
@@ -674,10 +623,10 @@
   }
   if (_mi_write_keypage(info,keyinfo,next_page,DFLT_INIT_HITS,buff))
     goto err;
-  DBUG_RETURN(anc_length <= (uint) keyinfo->block_length/2);
+  return(anc_length <= (uint) keyinfo->block_length/2);
 
 err:
-  DBUG_RETURN(-1);
+  return(-1);
 } /* underflow */
 
 
@@ -696,8 +645,6 @@
 {
   int s_length;
   uchar *start;
-  DBUG_ENTER("remove_key");
-  DBUG_PRINT("enter",("keypos: 0x%lx  page_end: 0x%lx",(long) keypos, (long) page_end));
 
   start=keypos;
   if (!(keyinfo->flag &
@@ -712,7 +659,7 @@
   {					 /* Let keypos point at next key */
     /* Calculate length of key */
     if (!(*keyinfo->get_key)(keyinfo,nod_flag,&keypos,lastkey))
-      DBUG_RETURN(0);				/* Error */
+      return(0);				/* Error */
 
     if (next_block && nod_flag)
       *next_block= _mi_kpos(nod_flag,keypos);
@@ -810,5 +757,5 @@
   end:
   bmove((uchar*) start,(uchar*) start+s_length,
 	(uint) (page_end-start-s_length));
-  DBUG_RETURN((uint) s_length);
+  return((uint) s_length);
 } /* remove_key */

=== modified file 'storage/myisam/mi_delete_all.c'
--- storage/myisam/mi_delete_all.c	2008-07-02 14:38:50 +0000
+++ storage/myisam/mi_delete_all.c	2008-07-15 20:45:41 +0000
@@ -23,14 +23,13 @@
   uint i;
   MYISAM_SHARE *share=info->s;
   MI_STATE_INFO *state=&share->state;
-  DBUG_ENTER("mi_delete_all_rows");
 
   if (share->options & HA_OPTION_READ_ONLY_DATA)
   {
-    DBUG_RETURN(my_errno=EACCES);
+    return(my_errno=EACCES);
   }
   if (_mi_readinfo(info,F_WRLCK,1))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   if (_mi_mark_file_changed(info))
     goto err;
 
@@ -65,13 +64,13 @@
   if (share->file_map)
     mi_dynmap_file(info, (my_off_t) 0);
 #endif
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   {
     int save_errno=my_errno;
     VOID(_mi_writeinfo(info,WRITEINFO_UPDATE_KEYFILE));
     info->update|=HA_STATE_WRITTEN;	/* Buffer changed */
-    DBUG_RETURN(my_errno=save_errno);
+    return(my_errno=save_errno);
   }
 } /* mi_delete */

=== modified file 'storage/myisam/mi_delete_table.c'
--- storage/myisam/mi_delete_table.c	2008-07-06 15:03:34 +0000
+++ storage/myisam/mi_delete_table.c	2008-07-15 20:45:59 +0000
@@ -22,11 +22,10 @@
 int mi_delete_table(const char *name)
 {
   char from[FN_REFLEN];
-  DBUG_ENTER("mi_delete_table");
 
   fn_format(from,name,"",MI_NAME_IEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
   if (my_delete_with_symlink(from, MYF(MY_WME)))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   fn_format(from,name,"",MI_NAME_DEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
-  DBUG_RETURN(my_delete_with_symlink(from, MYF(MY_WME)) ? my_errno : 0);
+  return(my_delete_with_symlink(from, MYF(MY_WME)) ? my_errno : 0);
 }

=== modified file 'storage/myisam/mi_dynrec.c'
--- storage/myisam/mi_dynrec.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_dynrec.c	2008-07-16 05:44:59 +0000
@@ -63,11 +63,9 @@
 
 my_bool mi_dynmap_file(MI_INFO *info, my_off_t size)
 {
-  DBUG_ENTER("mi_dynmap_file");
   if (size > (my_off_t) (~((size_t) 0)) - MEMMAP_EXTRA_MARGIN)
   {
-    DBUG_PRINT("warning", ("File is too large for mmap"));
-    DBUG_RETURN(1);
+    return(1);
   }
   /*
     I wonder if it is good to use MAP_NORESERVE. From the Linux man page:
@@ -86,13 +84,13 @@
   if (info->s->file_map == (uchar*) MAP_FAILED)
   {
     info->s->file_map= NULL;
-    DBUG_RETURN(1);
+    return(1);
   }
 #if defined(HAVE_MADVISE)
   madvise((char*) info->s->file_map, size, MADV_RANDOM);
 #endif
   info->s->mmaped_length= size;
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -136,7 +134,6 @@
 size_t mi_mmap_pread(MI_INFO *info, uchar *Buffer,
                     size_t Count, my_off_t offset, myf MyFlags)
 {
-  DBUG_PRINT("info", ("mi_read with mmap %d\n", info->dfile));
   if (info->s->concurrent_insert)
     rw_rdlock(&info->s->mmap_lock);
 
@@ -191,7 +188,6 @@
 size_t mi_mmap_pwrite(MI_INFO *info, const uchar *Buffer,
                       size_t Count, my_off_t offset, myf MyFlags)
 {
-  DBUG_PRINT("info", ("mi_write with mmap %d\n", info->dfile));
   if (info->s->concurrent_insert)
     rw_rdlock(&info->s->mmap_lock);
 
@@ -265,9 +261,7 @@
   }
   reclength2= _mi_rec_pack(info,rec_buff+ALIGN_SIZE(MI_MAX_DYN_BLOCK_HEADER),
 			   record);
-  DBUG_PRINT("info",("reclength: %lu  reclength2: %lu",
-		     reclength, reclength2));
-  DBUG_ASSERT(reclength2 <= reclength);
+  assert(reclength2 <= reclength);
   error=write_dynamic_record(info,rec_buff+ALIGN_SIZE(MI_MAX_DYN_BLOCK_HEADER),
 			     reclength2);
   my_afree(rec_buff);
@@ -321,7 +315,6 @@
   int flag;
   ulong length;
   my_off_t filepos;
-  DBUG_ENTER("write_dynamic_record");
 
   flag=0;
 
@@ -343,7 +336,7 @@
         reclength + MI_MAX_DYN_BLOCK_HEADER)
     {
       my_errno=HA_ERR_RECORD_FILE_FULL;
-      DBUG_RETURN(1);
+      return(1);
     }
   }
 
@@ -358,9 +351,9 @@
       goto err;
   } while (reclength);
 
-  DBUG_RETURN(0);
+  return(0);
 err:
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -373,7 +366,6 @@
 {
   MI_BLOCK_INFO block_info;
   ulong tmp;
-  DBUG_ENTER("_mi_find_writepos");
 
   if (info->s->state.dellink != HA_OFFSET_ERROR &&
       !info->append_insert_at_end)
@@ -385,9 +377,8 @@
     if (!(_mi_get_block_info(&block_info,info->dfile,info->s->state.dellink) &
 	   BLOCK_DELETED))
     {
-      DBUG_PRINT("error",("Delete link crashed"));
       my_errno=HA_ERR_WRONG_IN_RECORD;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     info->s->state.dellink=block_info.next_filepos;
     info->state->del--;
@@ -408,7 +399,7 @@
 	(info->s->base.max_data_file_length - tmp))
     {
       my_errno=HA_ERR_RECORD_FILE_FULL;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     if (tmp > MI_MAX_BLOCK_LENGTH)
       tmp=MI_MAX_BLOCK_LENGTH;
@@ -417,7 +408,7 @@
     info->s->state.split++;
     info->update|=HA_STATE_WRITE_AT_END;
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_find_writepos */
 
 
@@ -430,7 +421,6 @@
 
 static my_bool unlink_deleted_block(MI_INFO *info, MI_BLOCK_INFO *block_info)
 {
-  DBUG_ENTER("unlink_deleted_block");
   if (block_info->filepos == info->s->state.dellink)
   {
     /* First deleted block;  We can just use this ! */
@@ -443,22 +433,22 @@
     /* Unlink block from the previous block */
     if (!(_mi_get_block_info(&tmp,info->dfile,block_info->prev_filepos)
 	  & BLOCK_DELETED))
-      DBUG_RETURN(1);				/* Something is wrong */
+      return(1);				/* Something is wrong */
     mi_sizestore(tmp.header+4,block_info->next_filepos);
     if (info->s->file_write(info, tmp.header+4,8,
 		  block_info->prev_filepos+4, MYF(MY_NABP)))
-      DBUG_RETURN(1);
+      return(1);
     /* Unlink block from next block */
     if (block_info->next_filepos != HA_OFFSET_ERROR)
     {
       if (!(_mi_get_block_info(&tmp,info->dfile,block_info->next_filepos)
 	    & BLOCK_DELETED))
-	DBUG_RETURN(1);				/* Something is wrong */
+	return(1);				/* Something is wrong */
       mi_sizestore(tmp.header+12,block_info->prev_filepos);
       if (info->s->file_write(info, tmp.header+12,8,
 		    block_info->next_filepos+12,
 		    MYF(MY_NABP)))
-	DBUG_RETURN(1);
+	return(1);
     }
   }
   /* We now have one less deleted block */
@@ -473,7 +463,7 @@
   */
   if (info->nextpos == block_info->filepos)
     info->nextpos+=block_info->block_len;
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -496,7 +486,6 @@
 				       my_off_t filepos)
 {
   MI_BLOCK_INFO block_info;
-  DBUG_ENTER("update_backward_delete_link");
 
   if (delete_block != HA_OFFSET_ERROR)
   {
@@ -507,15 +496,15 @@
       uchar buff[8];
       mi_sizestore(buff,filepos);
       if (info->s->file_write(info,buff, 8, delete_block+12, MYF(MY_NABP)))
-	DBUG_RETURN(1);				/* Error on write */
+	return(1);				/* Error on write */
     }
     else
     {
       my_errno=HA_ERR_WRONG_IN_RECORD;
-      DBUG_RETURN(1);				/* Wrong delete link */
+      return(1);				/* Wrong delete link */
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 	/* Delete datarecord from database */
@@ -528,7 +517,6 @@
   MI_BLOCK_INFO block_info,del_block;
   int error;
   my_bool remove_next_block;
-  DBUG_ENTER("delete_dynamic_record");
 
   /* First add a link from the last block to the new one */
   error= update_backward_delete_link(info, info->s->state.dellink, filepos);
@@ -544,7 +532,7 @@
 	MI_MIN_BLOCK_LENGTH)
     {
       my_errno=HA_ERR_WRONG_IN_RECORD;
-      DBUG_RETURN(1);
+      return(1);
     }
     /* Check if next block is a delete block */
     del_block.second_read=0;
@@ -566,7 +554,7 @@
       mi_sizestore(block_info.header+12,block_info.next_filepos);
     if (info->s->file_write(info,(uchar*) block_info.header,20,filepos,
 		  MYF(MY_NABP)))
-      DBUG_RETURN(1);
+      return(1);
     info->s->state.dellink = filepos;
     info->state->del++;
     info->state->empty+=length;
@@ -577,7 +565,7 @@
       error=1;
   } while (!(b_type & BLOCK_LAST));
 
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -595,7 +583,6 @@
   uchar *pos,*record_end;
   my_off_t  next_delete_block;
   uchar temp[MI_SPLIT_LENGTH+MI_DYN_DELETE_BLOCK_HEADER];
-  DBUG_ENTER("_mi_write_part_record");
 
   next_delete_block=HA_OFFSET_ERROR;
 
@@ -689,7 +676,6 @@
     }
     length=	  *reclength+head_length;	/* Write only what is needed */
   }
-  DBUG_DUMP("header",(uchar*) temp,head_length);
 
 	/* Make a long block for one write */
   record_end= *record+length-head_length;
@@ -764,10 +750,9 @@
       goto err;
   }
 
-  DBUG_RETURN(0);
+  return(0);
 err:
-  DBUG_PRINT("exit",("errno: %d",my_errno));
-  DBUG_RETURN(1);
+  return(1);
 } /*_mi_write_part_record */
 
 
@@ -780,7 +765,6 @@
   uint error;
   ulong length;
   MI_BLOCK_INFO block_info;
-  DBUG_ENTER("update_dynamic_record");
 
   flag=block_info.second_read=0;
   /*
@@ -806,7 +790,6 @@
     if ((error=_mi_get_block_info(&block_info,info->dfile,filepos))
         & (BLOCK_DELETED | BLOCK_ERROR | BLOCK_SYNC_ERROR | BLOCK_FATAL_ERROR))
     {
-      DBUG_PRINT("error",("Got wrong block info"));
       if (!(error & BLOCK_FATAL_ERROR))
         my_errno=HA_ERR_WRONG_IN_RECORD;
       goto err;
@@ -837,7 +820,6 @@
 	  & (BLOCK_DELETED | BLOCK_ERROR | BLOCK_SYNC_ERROR |
 	     BLOCK_FATAL_ERROR))
       {
-	DBUG_PRINT("error",("Got wrong block info"));
 	if (!(error & BLOCK_FATAL_ERROR))
 	  my_errno=HA_ERR_WRONG_IN_RECORD;
 	goto err;
@@ -856,7 +838,6 @@
 	    info->s->base.max_data_file_length-tmp)
 	{
 	  /* extend file */
-	  DBUG_PRINT("info",("Extending file with %d bytes",tmp));
 	  if (info->nextpos == info->state->data_file_length)
 	    info->nextpos+= tmp;
 	  info->state->data_file_length+= tmp;
@@ -879,7 +860,6 @@
 	      BLOCK_DELETED)
 	  {
 	    /* Use; Unlink it and extend the current block */
-	    DBUG_PRINT("info",("Extending current block"));
 	    if (unlink_deleted_block(info,&del_block))
 	      goto err;
 	    if ((length+=del_block.block_len) > MI_MAX_BLOCK_LENGTH)
@@ -895,7 +875,7 @@
 
 	      if (update_backward_delete_link(info, info->s->state.dellink,
 					      next_pos))
-		DBUG_RETURN(1);
+		return(1);
 
 	      /* create delete link for data that didn't fit into the page */
 	      del_block.header[0]=0;
@@ -904,7 +884,7 @@
 	      bfill(del_block.header+12,8,255);
 	      if (info->s->file_write(info,(uchar*) del_block.header,20, next_pos,
 			    MYF(MY_NABP)))
-		DBUG_RETURN(1);
+		return(1);
 	      info->s->state.dellink= next_pos;
 	      info->s->state.split++;
 	      info->state->del++;
@@ -933,9 +913,9 @@
   if (block_info.next_filepos != HA_OFFSET_ERROR)
     if (delete_dynamic_record(info,block_info.next_filepos,1))
       goto err;
-  DBUG_RETURN(0);
+  return(0);
 err:
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -949,7 +929,6 @@
   enum en_fieldtype type;
   register MI_COLUMNDEF *rec;
   MI_BLOB	*blob;
-  DBUG_ENTER("_mi_rec_pack");
 
   flag=0 ; bit=1;
   startpos=packpos=to; to+= info->s->base.pack_bits; blob=info->blobs;
@@ -1056,8 +1035,7 @@
     *packpos= (uchar) flag;
   if (info->s->calc_checksum)
     *to++= (uchar) info->checksum;
-  DBUG_PRINT("exit",("packed length: %d",(int) (to-startpos)));
-  DBUG_RETURN((uint) (to-startpos));
+  return((uint) (to-startpos));
 } /* _mi_rec_pack */
 
 
@@ -1074,7 +1052,6 @@
   uchar		*pos,*end,*packpos,*to;
   enum en_fieldtype type;
   register MI_COLUMNDEF *rec;
-  DBUG_ENTER("_mi_rec_check");
 
   packpos=rec_buff; to= rec_buff+info->s->base.pack_bits;
   rec=info->s->rec;
@@ -1176,13 +1153,12 @@
     goto err;
   if (with_checksum && ((uchar) info->checksum != (uchar) *to))
   {
-    DBUG_PRINT("error",("wrong checksum for row"));
     goto err;
   }
-  DBUG_RETURN(0);
+  return(0);
 
 err:
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -1198,7 +1174,6 @@
   enum en_fieldtype type;
   uchar *from_end,*to_end,*packpos;
   register MI_COLUMNDEF *rec,*end_field;
-  DBUG_ENTER("_mi_rec_unpack");
 
   to_end=to + info->s->base.reclength;
   from_end=from+found_length;
@@ -1314,14 +1289,11 @@
   if (info->s->calc_checksum)
     from++;
   if (to == to_end && from == from_end && (bit == 1 || !(flag & ~(bit-1))))
-    DBUG_RETURN(found_length);
+    return(found_length);
 
 err:
   my_errno= HA_ERR_WRONG_IN_RECORD;
-  DBUG_PRINT("error",("to_end: 0x%lx -> 0x%lx  from_end: 0x%lx -> 0x%lx",
-		      (long) to, (long) to_end, (long) from, (long) from_end));
-  DBUG_DUMP("from",(uchar*) info->rec_buff,info->s->base.min_pack_length);
-  DBUG_RETURN(MY_FILE_ERROR);
+  return(MY_FILE_ERROR);
 } /* _mi_rec_unpack */
 
 
@@ -1421,7 +1393,6 @@
   uchar *to= NULL;
   MI_BLOCK_INFO block_info;
   File file;
-  DBUG_ENTER("mi_read_dynamic_record");
 
   if (filepos != HA_OFFSET_ERROR)
   {
@@ -1501,17 +1472,17 @@
 
     info->update|= HA_STATE_AKTIV;	/* We have a aktive record */
     fast_mi_writeinfo(info);
-    DBUG_RETURN(_mi_rec_unpack(info,buf,info->rec_buff,block_info.rec_len) !=
+    return(_mi_rec_unpack(info,buf,info->rec_buff,block_info.rec_len) !=
 		MY_FILE_ERROR ? 0 : -1);
   }
   fast_mi_writeinfo(info);
-  DBUG_RETURN(-1);			/* Wrong data to read */
+  return(-1);			/* Wrong data to read */
 
 panic:
   my_errno=HA_ERR_WRONG_IN_RECORD;
 err:
   VOID(_mi_writeinfo(info,0));
-  DBUG_RETURN(-1);
+  return(-1);
 }
 
 	/* compare unique constraint between stored rows */
@@ -1521,10 +1492,9 @@
 {
   uchar *rec_buff,*old_record;
   int error;
-  DBUG_ENTER("_mi_cmp_dynamic_unique");
 
   if (!(old_record=my_alloca(info->s->base.reclength)))
-    DBUG_RETURN(1);
+    return(1);
 
   /* Don't let the compare destroy blobs that may be in use */
   rec_buff=info->rec_buff;
@@ -1539,7 +1509,7 @@
     info->rec_buff=rec_buff;
   }
   my_afree(old_record);
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -1551,13 +1521,12 @@
   my_off_t filepos;
   uchar *buffer;
   MI_BLOCK_INFO block_info;
-  DBUG_ENTER("_mi_cmp_dynamic_record");
 
   if (info->opt_flag & WRITE_CACHE_USED)
   {
     info->update&= ~(HA_STATE_WRITE_AT_END | HA_STATE_EXTEND_BLOCK);
     if (flush_io_cache(&info->rec_cache))
-      DBUG_RETURN(-1);
+      return(-1);
   }
   info->rec_cache.seek_not_done=1;
 
@@ -1570,7 +1539,7 @@
     {
       if (!(buffer=(uchar*) my_alloca(info->s->base.pack_reclength+
 				     _my_calc_total_blob_length(info,record))))
-	DBUG_RETURN(-1);
+	return(-1);
     }
     reclength=_mi_rec_pack(info,buffer,record);
     record= buffer;
@@ -1617,7 +1586,7 @@
 err:
   if (buffer != info->rec_buff)
     my_afree((uchar*) buffer);
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 }
 
 
@@ -1628,7 +1597,6 @@
 {
   uint next_length;
   uchar temp_buff[IO_SIZE*2];
-  DBUG_ENTER("_mi_cmp_buffer");
 
   next_length= IO_SIZE*2 - (uint) (filepos & (IO_SIZE-1));
 
@@ -1644,9 +1612,9 @@
   }
   if (my_pread(file,temp_buff,length,filepos,MYF(MY_NABP)))
     goto err;
-  DBUG_RETURN(memcmp(buff,temp_buff,length));
+  return(memcmp(buff,temp_buff,length));
 err:
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -1693,7 +1661,6 @@
   uchar *to= NULL;
   MI_BLOCK_INFO block_info;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_read_rnd_dynamic_record");
 
   info_read=0;
 
@@ -1738,7 +1705,7 @@
       if (info->opt_flag & WRITE_CACHE_USED &&
 	  info->rec_cache.pos_in_file < filepos + MI_BLOCK_INFO_HEADER_LENGTH &&
 	  flush_io_cache(&info->rec_cache))
-	DBUG_RETURN(my_errno);
+	return(my_errno);
       info->rec_cache.seek_not_done=1;
       b_type=_mi_get_block_info(&block_info,info->dfile,filepos);
     }
@@ -1841,15 +1808,15 @@
   fast_mi_writeinfo(info);
   if (_mi_rec_unpack(info,buf,info->rec_buff,block_info.rec_len) !=
       MY_FILE_ERROR)
-    DBUG_RETURN(0);
-  DBUG_RETURN(my_errno);			/* Wrong record */
+    return(0);
+  return(my_errno);			/* Wrong record */
 
 panic:
   my_errno=HA_ERR_WRONG_IN_RECORD;		/* Something is fatal wrong */
 err:
   save_errno=my_errno;
   VOID(_mi_writeinfo(info,0));
-  DBUG_RETURN(my_errno=save_errno);
+  return(my_errno=save_errno);
 }
 
 
@@ -1872,7 +1839,6 @@
 	sizeof(info->header))
       goto err;
   }
-  DBUG_DUMP("header",header,MI_BLOCK_INFO_HEADER_LENGTH);
   if (info->second_read)
   {
     if (info->header[0] <= 6 || info->header[0] == 13)

=== modified file 'storage/myisam/mi_extra.c'
--- storage/myisam/mi_extra.c	2008-07-14 04:46:28 +0000
+++ storage/myisam/mi_extra.c	2008-07-16 05:44:59 +0000
@@ -42,8 +42,6 @@
   int error=0;
   ulong cache_size;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_extra");
-  DBUG_PRINT("enter",("function: %d",(int) function));
 
   switch (function) {
   case HA_EXTRA_RESET_STATE:		/* Reset state (don't free buffers) */
@@ -361,7 +359,6 @@
     {
       if (mi_dynmap_file(info, share->state.state.data_file_length))
       {
-        DBUG_PRINT("warning",("mmap failed: errno: %d",errno));
         error= my_errno= errno;
       }
       else
@@ -383,7 +380,7 @@
     tmp[0]=function;
     myisam_log_command(MI_LOG_EXTRA,info,(uchar*) tmp,1,error);
   }
-  DBUG_RETURN(error);
+  return(error);
 } /* mi_extra */
 
 
@@ -421,7 +418,6 @@
 {
   int error= 0;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_reset");
   /*
     Free buffers and reset the following flags:
     EXTRA_CACHE, EXTRA_WRITE_CACHE, EXTRA_KEYREAD, EXTRA_QUICK
@@ -448,5 +444,5 @@
   info->page_changed= 1;
   info->update= ((info->update & HA_STATE_CHANGED) | HA_STATE_NEXT_FOUND |
                  HA_STATE_PREV_FOUND);
-  DBUG_RETURN(error);
+  return(error);
 }

=== modified file 'storage/myisam/mi_info.c'
--- storage/myisam/mi_info.c	2008-07-13 22:21:51 +0000
+++ storage/myisam/mi_info.c	2008-07-16 05:44:59 +0000
@@ -35,11 +35,10 @@
 {
   struct stat state;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_status");
 
   x->recpos  = info->lastpos;
   if (flag == HA_STATUS_POS)
-    DBUG_RETURN(0);				/* Compatible with ISAM */
+    return(0);				/* Compatible with ISAM */
   if (!(flag & HA_STATUS_NO_LOCK))
   {
     pthread_mutex_lock(&share->intern_lock);
@@ -95,7 +94,7 @@
     if (!x->auto_increment)			/* This shouldn't happen */
       x->auto_increment= ~(uint64_t) 0;
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -121,12 +120,10 @@
 void mi_report_error(int errcode, const char *file_name)
 {
   size_t        lgt;
-  DBUG_ENTER("mi_report_error");
-  DBUG_PRINT("enter",("errcode %d, table '%s'", errcode, file_name));
 
   if ((lgt= strlen(file_name)) > 64)
     file_name+= lgt - 64;
   my_error(errcode, MYF(ME_NOREFRESH), file_name);
-  DBUG_VOID_RETURN;
+  return;
 }
 

=== modified file 'storage/myisam/mi_key.c'
--- storage/myisam/mi_key.c	2008-07-13 22:45:08 +0000
+++ storage/myisam/mi_key.c	2008-07-16 05:44:59 +0000
@@ -54,7 +54,6 @@
   uchar *start;
   register HA_KEYSEG *keyseg;
   my_bool is_ft= info->s->keyinfo[keynr].flag & HA_FULLTEXT;
-  DBUG_ENTER("_mi_make_key");
 
   start=key;
   for (keyseg=info->s->keyinfo[keynr].seg ; keyseg->type ;keyseg++)
@@ -175,12 +174,7 @@
     key+= length;
   }
   _mi_dpointer(info,key,filepos);
-  DBUG_PRINT("exit",("keynr: %d",keynr));
-  DBUG_DUMP("key",(uchar*) start,(uint) (key-start)+keyseg->length);
-  DBUG_EXECUTE("key",
-	       _mi_print_key(DBUG_FILE,info->s->keyinfo[keynr].seg,start,
-			     (uint) (key-start)););
-  DBUG_RETURN((uint) (key-start));		/* Return keylength */
+  return((uint) (key-start));		/* Return keylength */
 } /* _mi_make_key */
 
 
@@ -208,10 +202,9 @@
   uchar *start_key=key;
   HA_KEYSEG *keyseg;
   my_bool is_ft= info->s->keyinfo[keynr].flag & HA_FULLTEXT;
-  DBUG_ENTER("_mi_pack_key");
 
   /* only key prefixes are supported */
-  DBUG_ASSERT(((keypart_map+1) & keypart_map) == 0);
+  assert(((keypart_map+1) & keypart_map) == 0);
 
   for (keyseg= info->s->keyinfo[keynr].seg ; keyseg->type && keypart_map;
        old+= keyseg->length, keyseg++)
@@ -282,7 +275,7 @@
   if (last_used_keyseg)
     *last_used_keyseg= keyseg;
 
-  DBUG_RETURN((uint) (key-start_key));
+  return((uint) (key-start_key));
 } /* _mi_pack_key */
 
 
@@ -313,7 +306,6 @@
   uchar *pos,*key_end;
   register HA_KEYSEG *keyseg;
   uchar *blob_ptr;
-  DBUG_ENTER("_mi_put_key_in_record");
 
   blob_ptr= (uchar*) info->lastkey2;             /* Place to put blob parts */
   key=(uchar*) info->lastkey;                    /* KEy that was read */
@@ -437,10 +429,10 @@
       key+= keyseg->length;
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 
 err:
-  DBUG_RETURN(1);				/* Crashed row */
+  return(1);				/* Crashed row */
 } /* _mi_put_key_in_record */
 
 
@@ -565,7 +557,7 @@
     value= uint8korr(key);
     break;
   default:
-    DBUG_ASSERT(0);
+    assert(0);
     value=0;                                    /* Error */
     break;
   }

=== modified file 'storage/myisam/mi_keycache.c'
--- storage/myisam/mi_keycache.c	2008-07-13 22:21:51 +0000
+++ storage/myisam/mi_keycache.c	2008-07-16 05:44:59 +0000
@@ -52,16 +52,13 @@
 {
   int error= 0;
   MYISAM_SHARE* share= info->s;
-  DBUG_ENTER("mi_assign_to_key_cache");
-  DBUG_PRINT("enter",("old_key_cache_handle: 0x%lx  new_key_cache_handle: 0x%lx",
-		      (long) share->key_cache, (long) key_cache));
 
   /*
     Skip operation if we didn't change key cache. This can happen if we
     call this for all open instances of the same table
   */
   if (share->key_cache == key_cache)
-    DBUG_RETURN(0);
+    return(0);
 
   /*
     First flush all blocks for the table in the old key cache.
@@ -109,7 +106,7 @@
 			  share->key_cache))
     error= my_errno;
   pthread_mutex_unlock(&share->intern_lock);
-  DBUG_RETURN(error);
+  return(error);
 }
 
 
@@ -138,7 +135,6 @@
 			 KEY_CACHE *new_key_cache)
 {
   LIST *pos;
-  DBUG_ENTER("mi_change_key_cache");
 
   /*
     Lock list to ensure that no one can close the table while we manipulate it
@@ -159,5 +155,5 @@
   */
   multi_key_cache_change(old_key_cache, new_key_cache);
   pthread_mutex_unlock(&THR_LOCK_myisam);
-  DBUG_VOID_RETURN;
+  return;
 }

=== modified file 'storage/myisam/mi_locking.c'
--- storage/myisam/mi_locking.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_locking.c	2008-07-16 05:44:59 +0000
@@ -34,23 +34,17 @@
   uint count;
   MYISAM_SHARE *share=info->s;
   uint flag;
-  DBUG_ENTER("mi_lock_database");
-  DBUG_PRINT("enter",("lock_type: %d  old lock %d  r_locks: %u  w_locks: %u "
-                      "global_changed:  %d  open_count: %u  name: '%s'",
-                      lock_type, info->lock_type, share->r_locks,
-                      share->w_locks,
-                      share->global_changed, share->state.open_count,
-                      share->index_file_name));
+
   if (share->options & HA_OPTION_READ_ONLY_DATA ||
       info->lock_type == lock_type)
-    DBUG_RETURN(0);
+    return(0);
   if (lock_type == F_EXTRA_LCK)                 /* Used by TMP tables */
   {
     ++share->w_locks;
     ++share->tot_locks;
     info->lock_type= lock_type;
     info->s->in_use= list_add(info->s->in_use, &info->in_use);
-    DBUG_RETURN(0);
+    return(0);
   }
 
   flag=error=0;
@@ -83,8 +77,6 @@
       }
       if (!count)
       {
-	DBUG_PRINT("info",("changed: %u  w_locks: %u",
-			   (uint) share->changed, share->w_locks));
 	if (share->changed && !share->w_locks)
 	{
 #ifdef HAVE_MMAP
@@ -160,6 +152,11 @@
 	if (mi_state_info_read_dsk(share->kfile, &share->state, 1))
 	{
 	  error=my_errno;
+	  break;
+	}
+	if (mi_state_info_read_dsk(share->kfile, &share->state, 1))
+	{
+	  error=my_errno;
 	  my_errno=error;
 	  break;
 	}
@@ -231,7 +228,7 @@
   myisam_log_command(MI_LOG_LOCK,info,(uchar*) &lock_type,sizeof(lock_type),
 		     error);
 #endif
-  DBUG_RETURN(error);
+  return(error);
 } /* mi_lock_database */
 
 
@@ -252,22 +249,11 @@
 void mi_get_status(void* param, int concurrent_insert)
 {
   MI_INFO *info=(MI_INFO*) param;
-  DBUG_ENTER("mi_get_status");
-  DBUG_PRINT("info",("key_file: %ld  data_file: %ld  concurrent_insert: %d",
-		     (long) info->s->state.state.key_file_length,
-		     (long) info->s->state.state.data_file_length,
-                     concurrent_insert));
-#ifndef DBUG_OFF
-  if (info->state->key_file_length > info->s->state.state.key_file_length ||
-      info->state->data_file_length > info->s->state.state.data_file_length)
-    DBUG_PRINT("warning",("old info:  key_file: %ld  data_file: %ld",
-			  (long) info->state->key_file_length,
-			  (long) info->state->data_file_length));
-#endif
+
   info->save_state=info->s->state.state;
   info->state= &info->save_state;
   info->append_insert_at_end= concurrent_insert;
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -282,16 +268,6 @@
   */
   if (info->state == &info->save_state)
   {
-#ifndef DBUG_OFF
-    DBUG_PRINT("info",("updating status:  key_file: %ld  data_file: %ld",
-		       (long) info->state->key_file_length,
-		       (long) info->state->data_file_length));
-    if (info->state->key_file_length < info->s->state.state.key_file_length ||
-	info->state->data_file_length < info->s->state.state.data_file_length)
-      DBUG_PRINT("warning",("old info:  key_file: %ld  data_file: %ld",
-			    (long) info->s->state.state.key_file_length,
-			    (long) info->s->state.state.data_file_length));
-#endif
     info->s->state.state= *info->state;
     info->state= &info->s->state.state;
   }
@@ -356,9 +332,6 @@
     external lock (in other words: w_locks == 1 means no other threads has
     a write lock)
   */
-  DBUG_PRINT("info",("dellink: %ld  r_locks: %u  w_locks: %u",
-                     (long) info->s->state.dellink, (uint) info->s->r_locks,
-                     (uint) info->s->w_locks));
   return (my_bool) !(info->s->state.dellink == HA_OFFSET_ERROR ||
                      (myisam_concurrent_insert == 2 && info->s->r_locks &&
                       info->s->w_locks == 1));
@@ -371,8 +344,6 @@
 
 int _mi_readinfo(register MI_INFO *info, int lock_type, int check_keybuffer)
 {
-  DBUG_ENTER("_mi_readinfo");
-
   if (info->lock_type == F_UNLCK)
   {
     MYISAM_SHARE *share=info->s;
@@ -382,7 +353,7 @@
       {
 	int error=my_errno ? my_errno : -1;
 	my_errno=error;
-	DBUG_RETURN(1);
+	return(1);
       }
     }
     if (check_keybuffer)
@@ -392,9 +363,9 @@
   else if (lock_type == F_WRLCK && info->lock_type == F_RDLCK)
   {
     my_errno=EACCES;				/* Not allowed to change */
-    DBUG_RETURN(-1);				/* when have read_lock() */
+    return(-1);				/* when have read_lock() */
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_readinfo */
 
 
@@ -407,9 +378,6 @@
 {
   int error,olderror;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_writeinfo");
-  DBUG_PRINT("info",("operation: %u  tot_locks: %u", operation,
-		     share->tot_locks));
 
   error=0;
   if (share->tot_locks == 0)
@@ -434,7 +402,7 @@
   }
   else if (operation)
     share->changed= 1;			/* Mark keyfile changed */
-  DBUG_RETURN(error);
+  return(error);
 } /* _mi_writeinfo */
 
 
@@ -448,7 +416,6 @@
       share->state.unique  != info->last_unique ||
       share->state.update_count != info->last_loop)
   {						/* Keyfile has changed */
-    DBUG_PRINT("info",("index file changed"));
     if (share->state.process != share->this_process)
       VOID(flush_key_blocks(share->key_cache, share->kfile, FLUSH_RELEASE));
     share->last_process=share->state.process;
@@ -485,7 +452,6 @@
 {
   uchar buff[3];
   register MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_mark_file_changed");
 
   if (!(share->state.changed & STATE_CHANGED) || ! share->global_changed)
   {
@@ -500,12 +466,12 @@
     {
       mi_int2store(buff,share->state.open_count);
       buff[2]=1;				/* Mark that it's changed */
-      DBUG_RETURN(my_pwrite(share->kfile,buff,sizeof(buff),
+      return(my_pwrite(share->kfile,buff,sizeof(buff),
                             sizeof(share->state.header),
                             MYF(MY_NABP)));
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 

=== modified file 'storage/myisam/mi_log.c'
--- storage/myisam/mi_log.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_log.c	2008-07-16 05:44:59 +0000
@@ -32,7 +32,6 @@
 {
   int error=0;
   char buff[FN_REFLEN];
-  DBUG_ENTER("mi_log");
 
   log_type=activate_log;
   if (activate_log)
@@ -45,7 +44,7 @@
 						"",".log",4),
 				      0,(O_RDWR | O_BINARY | O_APPEND),MYF(0)))
 	  < 0)
-	DBUG_RETURN(my_errno);
+	return(my_errno);
     }
   }
   else if (myisam_log_file >= 0)
@@ -53,7 +52,7 @@
     error=my_close(myisam_log_file,MYF(0)) ? my_errno : 0 ;
     myisam_log_file= -1;
   }
-  DBUG_RETURN(error);
+  return(error);
 }
 
 

=== modified file 'storage/myisam/mi_open.c'
--- storage/myisam/mi_open.c	2008-07-15 06:45:16 +0000
+++ storage/myisam/mi_open.c	2008-07-16 05:44:59 +0000
@@ -72,7 +72,6 @@
   ulong rec_per_key_part[HA_MAX_POSSIBLE_KEY*MI_MAX_KEY_SEG];
   my_off_t key_root[HA_MAX_POSSIBLE_KEY],key_del[MI_MAX_KEY_BLOCK_SIZE];
   uint64_t max_key_file_length, max_data_file_length;
-  DBUG_ENTER("mi_open");
 
   kfile= -1;
   lock_error=1;
@@ -93,12 +92,6 @@
     share_buff.key_cache= multi_key_cache_search((uchar*) name_buff,
                                                  strlen(name_buff));
 
-    DBUG_EXECUTE_IF("myisam_pretend_crashed_table_on_open",
-                    if (strstr(name, "/t1"))
-                    {
-                      my_errno= HA_ERR_CRASHED;
-                      goto err;
-                    });
     if ((kfile=my_open(name_buff,(open_mode=O_RDWR) | O_SHARE,MYF(0))) < 0)
     {
       if ((errno != EROFS && errno != EACCES) ||
@@ -117,9 +110,6 @@
     if (memcmp((uchar*) share->state.header.file_version,
 	       (uchar*) myisam_file_magic, 4))
     {
-      DBUG_PRINT("error",("Wrong header in %s",name_buff));
-      DBUG_DUMP("error_dump",(uchar*) share->state.header.file_version,
-		head_length);
       my_errno=HA_ERR_NOT_A_TABLE;
       goto err;
     }
@@ -131,14 +121,12 @@
           HA_OPTION_TMP_TABLE | HA_OPTION_DELAY_KEY_WRITE |
           HA_OPTION_RELIES_ON_SQL_LAYER))
     {
-      DBUG_PRINT("error",("wrong options: 0x%lx", share->options));
       my_errno=HA_ERR_OLD_FILE;
       goto err;
     }
     if ((share->options & HA_OPTION_RELIES_ON_SQL_LAYER) &&
         ! (open_flags & HA_OPEN_FROM_SQL_LAYER))
     {
-      DBUG_PRINT("error", ("table cannot be openned from non-sql layer"));
       my_errno= HA_ERR_UNSUPPORTED;
       goto err;
     }
@@ -173,21 +161,10 @@
     fulltext_keys= (uint) share->state.header.fulltext_keys;
     key_parts= mi_uint2korr(share->state.header.key_parts);
     unique_key_parts= mi_uint2korr(share->state.header.unique_key_parts);
-    if (len != MI_STATE_INFO_SIZE)
-    {
-      DBUG_PRINT("warning",
-		 ("saved_state_info_length: %d  state_info_length: %d",
-		  len,MI_STATE_INFO_SIZE));
-    }
     share->state_diff_length=len-MI_STATE_INFO_SIZE;
 
     mi_state_info_read(disk_cache, &share->state);
     len= mi_uint2korr(share->state.header.base_info_length);
-    if (len != MI_BASE_INFO_SIZE)
-    {
-      DBUG_PRINT("warning",("saved_base_info_length: %d  base_info_length: %d",
-			    len,MI_BASE_INFO_SIZE));
-    }
     disk_pos= my_n_base_info_read(disk_cache + base_pos, &share->base);
     share->state.state_length=base_pos;
 
@@ -196,10 +173,6 @@
 	 ((open_flags & HA_OPEN_ABORT_IF_CRASHED) &&
 	  (share->state.open_count))))
     {
-      DBUG_PRINT("error",("Table is marked as crashed. open_flags: %u  "
-                          "changed: %u  open_count: %u",
-                          open_flags, share->state.changed,
-                          share->state.open_count));
       my_errno=((share->state.changed & STATE_CRASHED_ON_REPAIR) ?
 		HA_ERR_CRASHED_ON_REPAIR : HA_ERR_CRASHED_ON_USAGE);
       goto err;
@@ -215,7 +188,6 @@
     if (share->base.max_key_length > MI_MAX_KEY_BUFF || keys > MI_MAX_KEY ||
 	key_parts > MI_MAX_KEY * MI_MAX_KEY_SEG)
     {
-      DBUG_PRINT("error",("Wrong key info:  Max_key_length: %d  keys: %d  key_parts: %d", share->base.max_key_length, keys, key_parts));
       my_errno=HA_ERR_UNSUPPORTED;
       goto err;
     }
@@ -235,7 +207,6 @@
 #endif
     if (share->base.raid_type)
     {
-      DBUG_PRINT("error",("Table uses RAID but we don't have RAID support"));
       my_errno=HA_ERR_UNSUPPORTED;
       goto err;
     }
@@ -552,7 +523,7 @@
     intern_filename(name_buff,share->index_file_name);
     _myisam_log(MI_LOG_OPEN, m_info, (uchar*) name_buff, strlen(name_buff));
   }
-  DBUG_RETURN(m_info);
+  return(m_info);
 
 err:
   save_errno=my_errno ? my_errno : HA_ERR_END_OF_FILE;
@@ -586,7 +557,7 @@
   }
   pthread_mutex_unlock(&THR_LOCK_myisam);
   my_errno=save_errno;
-  DBUG_RETURN (NULL);
+  return (NULL);
 } /* mi_open */
 
 
@@ -755,7 +726,6 @@
   uchar *ptr=buff;
   uint	i, keys= (uint) state->header.keys,
 	key_blocks=state->header.max_block_size_index;
-  DBUG_ENTER("mi_state_info_write");
 
   memcpy_fixed(ptr,&state->header,sizeof(state->header));
   ptr+=sizeof(state->header);
@@ -806,9 +776,9 @@
   }
 
   if (pWrite & 1)
-    DBUG_RETURN(my_pwrite(file, buff, (size_t) (ptr-buff), 0L,
+    return(my_pwrite(file, buff, (size_t) (ptr-buff), 0L,
 			  MYF(MY_NABP | MY_THREADSAFE)) != 0);
-  DBUG_RETURN(my_write(file, buff, (size_t) (ptr-buff),
+  return(my_write(file, buff, (size_t) (ptr-buff),
 		       MYF(MY_NABP)) != 0);
 }
 

=== modified file 'storage/myisam/mi_packrec.c'
--- storage/myisam/mi_packrec.c	2008-07-14 04:46:28 +0000
+++ storage/myisam/mi_packrec.c	2008-07-16 05:44:59 +0000
@@ -141,7 +141,6 @@
   uchar header[HEAD_LENGTH];
   MYISAM_SHARE *share=info->s;
   MI_BIT_BUFF bit_buff;
-  DBUG_ENTER("_mi_read_pack_info");
 
   if (myisam_quick_table_bits < 4)
     myisam_quick_table_bits=4;
@@ -177,16 +176,6 @@
   share->base.min_block_length=share->min_pack_length+1;
   if (share->min_pack_length > 254)
     share->base.min_block_length+=2;
-  DBUG_PRINT("info", ("fixed header length:   %u", HEAD_LENGTH));
-  DBUG_PRINT("info", ("total header length:   %lu", share->pack.header_length));
-  DBUG_PRINT("info", ("pack file version:     %u", share->pack.version));
-  DBUG_PRINT("info", ("min pack length:       %lu", share->min_pack_length));
-  DBUG_PRINT("info", ("max pack length:       %lu", share->max_pack_length));
-  DBUG_PRINT("info", ("elements of all trees: %lu", elements));
-  DBUG_PRINT("info", ("distinct values bytes: %lu", intervall_length));
-  DBUG_PRINT("info", ("number of code trees:  %u", trees));
-  DBUG_PRINT("info", ("bytes for record lgt:  %u", share->pack.ref_length));
-  DBUG_PRINT("info", ("record pointer length: %u", rec_reflength));
 
   /*
     Memory segment #1:
@@ -234,9 +223,6 @@
     share->rec[i].huff_tree=share->decode_trees+(uint) get_bits(&bit_buff,
 								huff_tree_bits);
     share->rec[i].unpack=get_unpack_function(share->rec+i);
-    DBUG_PRINT("info", ("col: %2u  type: %2u  pack: %u  slbits: %2u",
-                        i, share->rec[i].base_type, share->rec[i].pack_type,
-                        share->rec[i].space_length_bits));
   }
   skip_to_next_byte(&bit_buff);
   /*
@@ -285,7 +271,7 @@
   if (bit_buff.error || bit_buff.pos < bit_buff.end)
     goto err3;
 
-  DBUG_RETURN(0);
+  return(0);
 
 err3:
   my_errno=HA_ERR_WRONG_IN_RECORD;
@@ -294,7 +280,7 @@
 err1:
   my_free((uchar*) share->decode_trees,MYF(0));
 err0:
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -323,7 +309,6 @@
   uint min_chr,elements,char_bits,offset_bits,size,intervall_length,table_bits,
   next_free_offset;
   uint16 *ptr,*end;
-  DBUG_ENTER("read_huff_table");
 
   if (!get_bits(bit_buff,1))
   {
@@ -334,16 +319,9 @@
     offset_bits=get_bits(bit_buff,5);
     intervall_length=0;
     ptr=tmp_buff;
-    DBUG_PRINT("info", ("byte value compression"));
-    DBUG_PRINT("info", ("minimum byte value:    %u", min_chr));
-    DBUG_PRINT("info", ("number of tree nodes:  %u", elements));
-    DBUG_PRINT("info", ("bits for values:       %u", char_bits));
-    DBUG_PRINT("info", ("bits for tree offsets: %u", offset_bits));
     if (elements > 256)
     {
-      DBUG_PRINT("error", ("ERROR: illegal number of tree elements: %u",
-                           elements));
-      DBUG_RETURN(1);
+      return(1);
     }
   }
   else
@@ -356,16 +334,8 @@
     offset_bits=get_bits(bit_buff,5);
     decode_tree->quick_table_bits=0;
     ptr= *decode_table;
-    DBUG_PRINT("info", ("distinct column value compression"));
-    DBUG_PRINT("info", ("number of tree nodes:  %u", elements));
-    DBUG_PRINT("info", ("value buffer length:   %u", intervall_length));
-    DBUG_PRINT("info", ("bits for value index:  %u", char_bits));
-    DBUG_PRINT("info", ("bits for tree offsets: %u", offset_bits));
   }
   size=elements*2-2;
-  DBUG_PRINT("info", ("tree size in uint16:   %u", size));
-  DBUG_PRINT("info", ("tree size in bytes:    %u",
-                      size * (uint) sizeof(uint16)));
 
   for (end=ptr+size ; ptr < end ; ptr++)
   {
@@ -374,8 +344,7 @@
       *ptr= (uint16) get_bits(bit_buff,offset_bits);
       if ((ptr + *ptr >= end) || !*ptr)
       {
-        DBUG_PRINT("error", ("ERROR: illegal pointer in decode tree"));
-        DBUG_RETURN(1);
+        return(1);
       }
     }
     else
@@ -391,10 +360,9 @@
     /* Find longest Huffman code from begin to end of tree in bits. */
     table_bits= find_longest_bitstream(tmp_buff, ptr);
     if (table_bits >= OFFSET_TABLE_SIZE)
-      DBUG_RETURN(1);
+      return(1);
     if (table_bits > myisam_quick_table_bits)
       table_bits=myisam_quick_table_bits;
-    DBUG_PRINT("info", ("table bits:            %u", table_bits));
 
     next_free_offset= (1 << table_bits);
     make_quick_table(*decode_table,tmp_buff,&next_free_offset,0,table_bits,
@@ -417,7 +385,7 @@
     bit_buff->pos+=intervall_length;
     bit_buff->bits=0;
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
@@ -464,8 +432,6 @@
 			     uint *next_free_offset, uint value, uint bits,
 			     uint max_bits)
 {
-  DBUG_ENTER("make_quick_table");
-
   /*
     When down the table to the requested maximum, copy the rest of the
     Huffman table.
@@ -483,7 +449,7 @@
     */
     *next_free_offset= copy_decode_table(to_table, *next_free_offset,
                                          decode_table);
-    DBUG_VOID_RETURN;
+    return;
   }
 
   /* Descent on the left side. Left side bits are clear (0). */
@@ -522,7 +488,7 @@
     fill_quick_table(to_table + value, bits, max_bits, (uint) *decode_table);
   }
 
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -554,7 +520,6 @@
 			     uint value)
 {
   uint16 *end;
-  DBUG_ENTER("fill_quick_table");
 
   /*
     Bits 1..8 of value represent the decoded byte value.
@@ -567,7 +532,7 @@
   {
     *table= (uint16) value;
   }
-  DBUG_VOID_RETURN;
+  return;
 }
 
 
@@ -591,7 +556,6 @@
 			      uint16 *decode_table)
 {
   uint prev_offset= offset;
-  DBUG_ENTER("copy_decode_table");
 
   /* Descent on the left side. */
   if (!(*decode_table & IS_CHAR))
@@ -623,7 +587,7 @@
     /* Copy the byte value. */
     to_pos[prev_offset+1]= *decode_table;
   }
-  DBUG_RETURN(offset);
+  return(offset);
 }
 
 
@@ -661,7 +625,6 @@
     uint16 *next= table + *table;
     if (next > end || next == table)
     {
-      DBUG_PRINT("error", ("ERROR: illegal pointer in decode tree"));
       return OFFSET_TABLE_SIZE;
     }
     length= find_longest_bitstream(next, end) + 1;
@@ -672,7 +635,6 @@
     uint16 *next= table + *table;
     if (next > end || next == table)
     {
-      DBUG_PRINT("error", ("ERROR: illegal pointer in decode tree"));
       return OFFSET_TABLE_SIZE;
     }
     length2= find_longest_bitstream(next, end) + 1;
@@ -700,10 +662,9 @@
 {
   MI_BLOCK_INFO block_info;
   File file;
-  DBUG_ENTER("mi_read_pack_record");
 
   if (filepos == HA_OFFSET_ERROR)
-    DBUG_RETURN(-1);			/* _search() didn't find record */
+    return(-1);			/* _search() didn't find record */
 
   file=info->dfile;
   if (_mi_pack_get_block_info(info, &info->bit_buff, &block_info,
@@ -713,12 +674,12 @@
 	      block_info.rec_len - block_info.offset, MYF(MY_NABP)))
     goto panic;
   info->update|= HA_STATE_AKTIV;
-  DBUG_RETURN(_mi_pack_rec_unpack(info, &info->bit_buff, buf,
+  return(_mi_pack_rec_unpack(info, &info->bit_buff, buf,
                                   info->rec_buff, block_info.rec_len));
 panic:
   my_errno=HA_ERR_WRONG_IN_RECORD;
 err:
-  DBUG_RETURN(-1);
+  return(-1);
 }
 
 
@@ -730,7 +691,6 @@
   register MI_COLUMNDEF *end;
   MI_COLUMNDEF *current_field;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_pack_rec_unpack");
 
   init_bit_buffer(bit_buff, (uchar*) from, reclength);
 
@@ -744,9 +704,9 @@
   }
   if (!bit_buff->error &&
       bit_buff->pos - bit_buff->bits / 8 == bit_buff->end)
-    DBUG_RETURN(0);
+    return(0);
   info->update&= ~HA_STATE_AKTIV;
-  DBUG_RETURN(my_errno=HA_ERR_WRONG_IN_RECORD);
+  return(my_errno=HA_ERR_WRONG_IN_RECORD);
 } /* _mi_pack_rec_unpack */
 
 
@@ -1292,7 +1252,6 @@
   uint b_type;
   MI_BLOCK_INFO block_info;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_read_rnd_pack_record");
 
   if (filepos >= info->state->data_file_length)
   {
@@ -1314,13 +1273,6 @@
                                    &info->rec_buff, info->dfile, filepos);
   if (b_type)
     goto err;					/* Error code is already set */
-#ifndef DBUG_OFF
-  if (block_info.rec_len > share->max_pack_length)
-  {
-    my_errno=HA_ERR_WRONG_IN_RECORD;
-    goto err;
-  }
-#endif
 
   if (info->opt_flag & READ_CACHE_USED)
   {
@@ -1341,10 +1293,10 @@
   info->nextpos=block_info.filepos+block_info.rec_len;
   info->update|= HA_STATE_AKTIV | HA_STATE_KEY_CHANGED;
 
-  DBUG_RETURN (_mi_pack_rec_unpack(info, &info->bit_buff, buf,
+  return (_mi_pack_rec_unpack(info, &info->bit_buff, buf,
                                    info->rec_buff, block_info.rec_len));
  err:
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 }
 
 
@@ -1367,7 +1319,6 @@
     VOID(my_seek(file,filepos,MY_SEEK_SET,MYF(0)));
     if (my_read(file, header,ref_length,MYF(MY_NABP)))
       return BLOCK_FATAL_ERROR;
-    DBUG_DUMP("header",(uchar*) header,ref_length);
   }
   head_length= read_pack_length((uint) myisam->s->pack.version, header,
                                 &info->rec_len);
@@ -1482,23 +1433,21 @@
 my_bool _mi_memmap_file(MI_INFO *info)
 {
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_memmap_file");
 
   if (!info->s->file_map)
   {
     if (my_seek(info->dfile,0L,MY_SEEK_END,MYF(0)) <
         share->state.state.data_file_length+MEMMAP_EXTRA_MARGIN)
     {
-      DBUG_PRINT("warning",("File isn't extended for memmap"));
-      DBUG_RETURN(0);
+      return(0);
     }
     if (mi_dynmap_file(info, share->state.state.data_file_length))
-      DBUG_RETURN(0);
+      return(0);
   }
   info->opt_flag|= MEMMAP_USED;
   info->read_record= share->read_record= _mi_read_mempack_record;
   share->read_rnd= _mi_read_rnd_mempack_record;
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
@@ -1535,17 +1484,16 @@
   MI_BLOCK_INFO block_info;
   MYISAM_SHARE *share=info->s;
   uchar *pos;
-  DBUG_ENTER("mi_read_mempack_record");
 
   if (filepos == HA_OFFSET_ERROR)
-    DBUG_RETURN(-1);			/* _search() didn't find record */
+    return(-1);			/* _search() didn't find record */
 
   if (!(pos= (uchar*) _mi_mempack_get_block_info(info, &info->bit_buff,
                                                 &block_info, &info->rec_buff,
 						(uchar*) share->file_map+
 						filepos)))
-    DBUG_RETURN(-1);
-  DBUG_RETURN(_mi_pack_rec_unpack(info, &info->bit_buff, buf,
+    return(-1);
+  return(_mi_pack_rec_unpack(info, &info->bit_buff, buf,
                                   pos, block_info.rec_len));
 }
 
@@ -1559,7 +1507,6 @@
   MI_BLOCK_INFO block_info;
   MYISAM_SHARE *share=info->s;
   uchar *pos,*start;
-  DBUG_ENTER("_mi_read_rnd_mempack_record");
 
   if (filepos >= share->state.state.data_file_length)
   {
@@ -1572,22 +1519,15 @@
 						(start=share->file_map+
 						 filepos))))
     goto err;
-#ifndef DBUG_OFF
-  if (block_info.rec_len > info->s->max_pack_length)
-  {
-    my_errno=HA_ERR_WRONG_IN_RECORD;
-    goto err;
-  }
-#endif
   info->packed_length=block_info.rec_len;
   info->lastpos=filepos;
   info->nextpos=filepos+(uint) (pos-start)+block_info.rec_len;
   info->update|= HA_STATE_AKTIV | HA_STATE_KEY_CHANGED;
 
-  DBUG_RETURN (_mi_pack_rec_unpack(info, &info->bit_buff, buf,
+  return (_mi_pack_rec_unpack(info, &info->bit_buff, buf,
                                    pos, block_info.rec_len));
  err:
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 }
 
 #endif /* HAVE_MMAP */
@@ -1610,7 +1550,7 @@
   *(uchar*) block_buff=255;
   if (version == 1) /* old format */
   {
-    DBUG_ASSERT(length <= 0xFFFFFF);
+    assert(length <= 0xFFFFFF);
     int3store(block_buff + 1, (ulong) length);
     return 4;
   }

=== modified file 'storage/myisam/mi_page.c'
--- storage/myisam/mi_page.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_page.c	2008-07-15 20:53:08 +0000
@@ -25,8 +25,6 @@
 {
   uchar *tmp;
   uint page_size;
-  DBUG_ENTER("_mi_fetch_keypage");
-  DBUG_PRINT("enter",("page: %ld", (long) page));
 
   tmp=(uchar*) key_cache_read(info->s->key_cache,
                              info->s->kfile, page, level, (uchar*) buff,
@@ -37,25 +35,21 @@
     info->buff_used=1;
   else if (!tmp)
   {
-    DBUG_PRINT("error",("Got errno: %d from key_cache_read",my_errno));
     info->last_keypage=HA_OFFSET_ERROR;
     mi_print_error(info->s, HA_ERR_CRASHED);
     my_errno=HA_ERR_CRASHED;
-    DBUG_RETURN(0);
+    return(0);
   }
   info->last_keypage=page;
   page_size=mi_getint(tmp);
   if (page_size < 4 || page_size > keyinfo->block_length)
   {
-    DBUG_PRINT("error",("page %lu had wrong page length: %u",
-			(ulong) page, page_size));
-    DBUG_DUMP("page", (uchar*) tmp, keyinfo->block_length);
     info->last_keypage = HA_OFFSET_ERROR;
     mi_print_error(info->s, HA_ERR_CRASHED);
     my_errno = HA_ERR_CRASHED;
     tmp = 0;
   }
-  DBUG_RETURN(tmp);
+  return(tmp);
 } /* _mi_fetch_keypage */
 
 
@@ -65,22 +59,15 @@
 		      my_off_t page, int level, uchar *buff)
 {
   register uint length;
-  DBUG_ENTER("_mi_write_keypage");
 
 #ifndef FAST					/* Safety check */
   if (page < info->s->base.keystart ||
       page+keyinfo->block_length > info->state->key_file_length ||
       (page & (MI_MIN_KEY_BLOCK_LENGTH-1)))
   {
-    DBUG_PRINT("error",("Trying to write inside key status region: key_start: %lu  length: %lu  page: %lu",
-			(long) info->s->base.keystart,
-			(long) info->state->key_file_length,
-			(long) page));
     my_errno=EINVAL;
-    DBUG_RETURN((-1));
+    return((-1));
   }
-  DBUG_PRINT("page",("write page at: %lu",(long) page));
-  DBUG_DUMP("buff",(uchar*) buff,mi_getint(buff));
 #endif
 
   if ((length=keyinfo->block_length) > IO_SIZE*2 &&
@@ -93,7 +80,7 @@
     length=keyinfo->block_length;
   }
 #endif
-  DBUG_RETURN((key_cache_write(info->s->key_cache,
+  return((key_cache_write(info->s->key_cache,
                          info->s->kfile,page, level, (uchar*) buff,length,
 			 (uint) keyinfo->block_length,
 			 (int) ((info->lock_type != F_UNLCK) ||
@@ -108,14 +95,12 @@
 {
   my_off_t old_link;
   uchar buff[8];
-  DBUG_ENTER("_mi_dispose");
-  DBUG_PRINT("enter",("pos: %ld", (long) pos));
 
   old_link= info->s->state.key_del[keyinfo->block_size_index];
   info->s->state.key_del[keyinfo->block_size_index]= pos;
   mi_sizestore(buff,old_link);
   info->s->state.changed|= STATE_NOT_SORTED_PAGES;
-  DBUG_RETURN(key_cache_write(info->s->key_cache,
+  return(key_cache_write(info->s->key_cache,
                               info->s->kfile, pos , level, buff,
 			      sizeof(buff),
 			      (uint) keyinfo->block_length,
@@ -129,7 +114,6 @@
 {
   my_off_t pos;
   uchar buff[8];
-  DBUG_ENTER("_mi_new");
 
   if ((pos= info->s->state.key_del[keyinfo->block_size_index]) ==
       HA_OFFSET_ERROR)
@@ -138,7 +122,7 @@
 	info->s->base.max_key_file_length - keyinfo->block_length)
     {
       my_errno=HA_ERR_INDEX_FILE_FULL;
-      DBUG_RETURN(HA_OFFSET_ERROR);
+      return(HA_OFFSET_ERROR);
     }
     pos=info->state->key_file_length;
     info->state->key_file_length+= keyinfo->block_length;
@@ -155,6 +139,5 @@
       info->s->state.key_del[keyinfo->block_size_index]= mi_sizekorr(buff);
   }
   info->s->state.changed|= STATE_NOT_SORTED_PAGES;
-  DBUG_PRINT("exit",("Pos: %ld",(long) pos));
-  DBUG_RETURN(pos);
+  return(pos);
 } /* _mi_new */

=== modified file 'storage/myisam/mi_panic.c'
--- storage/myisam/mi_panic.c	2008-07-14 04:46:28 +0000
+++ storage/myisam/mi_panic.c	2008-07-16 05:44:59 +0000
@@ -28,7 +28,6 @@
   int error=0;
   LIST *list_element,*next_open;
   MI_INFO *info;
-  DBUG_ENTER("mi_panic");
 
   pthread_mutex_lock(&THR_LOCK_myisam);
   for (list_element=myisam_open_list ; list_element ; list_element=next_open)
@@ -107,6 +106,6 @@
   }
   pthread_mutex_unlock(&THR_LOCK_myisam);
   if (!error)
-    DBUG_RETURN(0);
-  DBUG_RETURN(my_errno=error);
+    return(0);
+  return(my_errno=error);
 } /* mi_panic */

=== modified file 'storage/myisam/mi_preload.c'
--- storage/myisam/mi_preload.c	2008-07-13 22:21:51 +0000
+++ storage/myisam/mi_preload.c	2008-07-16 05:44:59 +0000
@@ -48,10 +48,9 @@
   MI_KEYDEF *keyinfo= share->keyinfo;
   my_off_t key_file_length= share->state.state.key_file_length;
   my_off_t pos= share->base.keystart;
-  DBUG_ENTER("mi_preload");
 
   if (!keys || !mi_is_any_key_active(key_map) || key_file_length == pos)
-    DBUG_RETURN(0);
+    return(0);
 
   block_length= keyinfo[0].block_length;
 
@@ -61,7 +60,7 @@
     for (i= 1 ; i < keys ; i++)
     {
       if (keyinfo[i].block_length != block_length)
-        DBUG_RETURN(my_errno= HA_ERR_NON_UNIQUE_BLOCK_SIZE);
+        return(my_errno= HA_ERR_NON_UNIQUE_BLOCK_SIZE);
     }
   }
   else
@@ -71,7 +70,7 @@
   set_if_bigger(length, block_length);
 
   if (!(buff= (uchar *) my_malloc(length, MYF(MY_WME))))
-    DBUG_RETURN(my_errno= HA_ERR_OUT_OF_MEM);
+    return(my_errno= HA_ERR_OUT_OF_MEM);
 
   if (flush_key_blocks(share->key_cache,share->kfile, FLUSH_RELEASE))
     goto err;
@@ -113,10 +112,10 @@
   while (pos != key_file_length);
 
   my_free((char*) buff, MYF(0));
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   my_free((char*) buff, MYF(MY_ALLOW_ZERO_PTR));
-  DBUG_RETURN(my_errno= errno);
+  return(my_errno= errno);
 }
 

=== modified file 'storage/myisam/mi_range.c'
--- storage/myisam/mi_range.c	2008-07-06 06:01:07 +0000
+++ storage/myisam/mi_range.c	2008-07-15 20:58:06 +0000
@@ -47,13 +47,12 @@
                             key_range *min_key, key_range *max_key)
 {
   ha_rows start_pos,end_pos,res;
-  DBUG_ENTER("mi_records_in_range");
 
   if ((inx = _mi_check_index(info,inx)) < 0)
-    DBUG_RETURN(HA_POS_ERROR);
+    return(HA_POS_ERROR);
 
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(HA_POS_ERROR);
+    return(HA_POS_ERROR);
   info->update&= (HA_STATE_CHANGED+HA_STATE_ROW_CHANGED);
   if (info->s->concurrent_insert)
     rw_rdlock(&info->s->key_root_lock[inx]);
@@ -77,8 +76,7 @@
     rw_unlock(&info->s->key_root_lock[inx]);
   fast_mi_writeinfo(info);
 
-  DBUG_PRINT("info",("records: %ld",(ulong) (res)));
-  DBUG_RETURN(res);
+  return(res);
 }
 
 
@@ -93,15 +91,11 @@
   uchar *key_buff;
   double pos;
 
-  DBUG_ENTER("_mi_record_pos");
-  DBUG_PRINT("enter",("search_flag: %d",search_flag));
-  DBUG_ASSERT(keypart_map);
+  assert(keypart_map);
 
   key_buff=info->lastkey+info->s->base.max_key_length;
   key_len=_mi_pack_key(info,inx,key_buff,(uchar*) key, keypart_map,
 		       (HA_KEYSEG**) 0);
-  DBUG_EXECUTE("key",_mi_print_key(DBUG_FILE,keyinfo->seg,
-				    (uchar*) key_buff,key_len););
   nextflag=myisam_read_vec[search_flag];
   if (!(nextflag & (SEARCH_FIND | SEARCH_NO_FIND | SEARCH_LAST)))
     key_len=USE_WHOLE_KEY;
@@ -145,10 +139,9 @@
 		     info->s->state.key_root[inx]);
   if (pos >= 0.0)
   {
-    DBUG_PRINT("exit",("pos: %ld",(ulong) (pos*info->state->records)));
-    DBUG_RETURN((ulong) (pos*info->state->records+0.5));
+    return((ulong) (pos*info->state->records+0.5));
   }
-  DBUG_RETURN(HA_POS_ERROR);
+  return(HA_POS_ERROR);
 }
 
 
@@ -165,10 +158,9 @@
   my_bool after_key;
   uchar *keypos,*buff;
   double offset;
-  DBUG_ENTER("_mi_search_pos");
 
   if (pos == HA_OFFSET_ERROR)
-    DBUG_RETURN(0.5);
+    return(0.5);
 
   if (!(buff=_mi_fetch_keypage(info,keyinfo,pos,DFLT_INIT_HITS,info->buff,1)))
     goto err;
@@ -180,7 +172,7 @@
   if (flag)
   {
     if (flag == MI_FOUND_WRONG_KEY)
-      DBUG_RETURN(-1);				/* error */
+      return(-1);				/* error */
     /*
       Didn't found match. keypos points at next (bigger) key
       Try to find a smaller, better matching key.
@@ -190,7 +182,7 @@
       offset= 1.0;
     else if ((offset=_mi_search_pos(info,keyinfo,key,key_len,nextflag,
 				    _mi_kpos(nod_flag,keypos))) < 0)
-      DBUG_RETURN(offset);
+      return(offset);
   }
   else
   {
@@ -209,15 +201,12 @@
       */
       if ((offset=_mi_search_pos(info,keyinfo,key,key_len,SEARCH_FIND,
 				 _mi_kpos(nod_flag,keypos))) < 0)
-	DBUG_RETURN(offset);			/* Read error */
+	return(offset);			/* Read error */
     }
   }
-  DBUG_PRINT("info",("keynr: %d  offset: %g  max_keynr: %d  nod: %d  flag: %d",
-		     keynr,offset,max_keynr,nod_flag,flag));
-  DBUG_RETURN((keynr+offset)/(max_keynr+1));
+  return((keynr+offset)/(max_keynr+1));
 err:
-  DBUG_PRINT("exit",("Error: %d",my_errno));
-  DBUG_RETURN (-1.0);
+  return (-1.0);
 }
 
 

=== modified file 'storage/myisam/mi_rename.c'
--- storage/myisam/mi_rename.c	2008-07-06 15:03:34 +0000
+++ storage/myisam/mi_rename.c	2008-07-16 02:35:15 +0000
@@ -22,13 +22,12 @@
 int mi_rename(const char *old_name, const char *new_name)
 {
   char from[FN_REFLEN],to[FN_REFLEN];
-  DBUG_ENTER("mi_rename");
 
   fn_format(from,old_name,"",MI_NAME_IEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
   fn_format(to,new_name,"",MI_NAME_IEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
   if (my_rename_with_symlink(from, to, MYF(MY_WME)))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   fn_format(from,old_name,"",MI_NAME_DEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
   fn_format(to,new_name,"",MI_NAME_DEXT,MY_UNPACK_FILENAME|MY_APPEND_EXT);
-  DBUG_RETURN(my_rename_with_symlink(from, to,MYF(MY_WME)) ? my_errno : 0);
+  return(my_rename_with_symlink(from, to,MYF(MY_WME)) ? my_errno : 0);
 }

=== modified file 'storage/myisam/mi_rfirst.c'
--- storage/myisam/mi_rfirst.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rfirst.c	2008-07-16 02:35:15 +0000
@@ -19,8 +19,7 @@
 
 int mi_rfirst(MI_INFO *info, uchar *buf, int inx)
 {
-  DBUG_ENTER("mi_rfirst");
   info->lastpos= HA_OFFSET_ERROR;
   info->update|= HA_STATE_PREV_FOUND;
-  DBUG_RETURN(mi_rnext(info,buf,inx));
+  return(mi_rnext(info,buf,inx));
 } /* mi_rfirst */

=== modified file 'storage/myisam/mi_rkey.c'
--- storage/myisam/mi_rkey.c	2008-07-06 06:01:07 +0000
+++ storage/myisam/mi_rkey.c	2008-07-16 02:35:15 +0000
@@ -30,12 +30,9 @@
   uint pack_key_length, use_key_length, nextflag;
   uint myisam_search_flag;
   int res= 0;
-  DBUG_ENTER("mi_rkey");
-  DBUG_PRINT("enter", ("base: 0x%lx  buf: 0x%lx  inx: %d  search_flag: %d",
-                       (long) info, (long) buf, inx, search_flag));
 
   if ((inx = _mi_check_index(info,inx)) < 0)
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
   info->last_key_func= search_flag;
@@ -55,7 +52,7 @@
   }
   else
   {
-    DBUG_ASSERT(keypart_map);
+    assert(keypart_map);
     /* Save the packed key for later use in the second buffer of lastkey. */
     key_buff=info->lastkey+info->s->base.max_key_length;
     pack_key_length=_mi_pack_key(info,(uint) inx, key_buff, (uchar*) key,
@@ -64,8 +61,6 @@
     info->pack_key_length= pack_key_length;
     info->last_used_keyseg= (uint16) (last_used_keyseg -
                                       info->s->keyinfo[inx].seg);
-    DBUG_EXECUTE("key",_mi_print_key(DBUG_FILE, keyinfo->seg,
-				     key_buff, pack_key_length););
   }
 
   if (fast_mi_readinfo(info))
@@ -140,7 +135,7 @@
         info->lastpos= HA_OFFSET_ERROR;
         if (share->concurrent_insert)
           rw_unlock(&share->key_root_lock[inx]);
-        DBUG_RETURN((my_errno= HA_ERR_KEY_NOT_FOUND));
+        return((my_errno= HA_ERR_KEY_NOT_FOUND));
       }
       /*
         Error if no row found within the data file. (Bug #29838)
@@ -167,12 +162,12 @@
 
   /* Check if we don't want to have record back, only error message */
   if (!buf)
-    DBUG_RETURN(info->lastpos == HA_OFFSET_ERROR ? my_errno : 0);
+    return(info->lastpos == HA_OFFSET_ERROR ? my_errno : 0);
 
   if (!(*info->read_record)(info,info->lastpos,buf))
   {
     info->update|= HA_STATE_AKTIV;		/* Record is read */
-    DBUG_RETURN(0);
+    return(0);
   }
 
   info->lastpos = HA_OFFSET_ERROR;		/* Didn't find key */
@@ -186,5 +181,5 @@
   if (search_flag == HA_READ_AFTER_KEY)
     info->update|=HA_STATE_NEXT_FOUND;		/* Previous gives last row */
 err:
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* _mi_rkey */

=== modified file 'storage/myisam/mi_rlast.c'
--- storage/myisam/mi_rlast.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rlast.c	2008-07-16 02:35:15 +0000
@@ -19,8 +19,7 @@
 
 int mi_rlast(MI_INFO *info, uchar *buf, int inx)
 {
-  DBUG_ENTER("mi_rlast");
   info->lastpos= HA_OFFSET_ERROR;
   info->update|= HA_STATE_NEXT_FOUND;
-  DBUG_RETURN(mi_rprev(info,buf,inx));
+  return(mi_rprev(info,buf,inx));
 } /* mi_rlast */

=== modified file 'storage/myisam/mi_rnext.c'
--- storage/myisam/mi_rnext.c	2008-07-06 06:01:07 +0000
+++ storage/myisam/mi_rnext.c	2008-07-16 02:35:15 +0000
@@ -27,16 +27,15 @@
   int error,changed;
   uint flag;
   int res= 0;
-  DBUG_ENTER("mi_rnext");
 
   if ((inx = _mi_check_index(info,inx)) < 0)
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   flag=SEARCH_BIGGER;				/* Read next */
   if (info->lastpos == HA_OFFSET_ERROR && info->update & HA_STATE_PREV_FOUND)
     flag=0;					/* Read first */
 
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   if (info->s->concurrent_insert)
     rw_rdlock(&info->s->key_root_lock[inx]);
   changed=_mi_test_if_changed(info);
@@ -85,7 +84,7 @@
       if (info->s->concurrent_insert)
         rw_unlock(&info->s->key_root_lock[inx]);
       info->lastpos= HA_OFFSET_ERROR;
-      DBUG_RETURN(my_errno= HA_ERR_END_OF_FILE);
+      return(my_errno= HA_ERR_END_OF_FILE);
     }
   }
   
@@ -103,13 +102,12 @@
   }
   else if (!buf)
   {
-    DBUG_RETURN(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
+    return(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
   }
   else if (!(*info->read_record)(info,info->lastpos,buf))
   {
     info->update|= HA_STATE_AKTIV;		/* Record is read */
-    DBUG_RETURN(0);
+    return(0);
   }
-  DBUG_PRINT("error",("Got error: %d,  errno: %d",error, my_errno));
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* mi_rnext */

=== modified file 'storage/myisam/mi_rnext_same.c'
--- storage/myisam/mi_rnext_same.c	2008-07-06 06:01:07 +0000
+++ storage/myisam/mi_rnext_same.c	2008-07-16 02:35:15 +0000
@@ -28,13 +28,12 @@
   int error;
   uint inx,not_used[2];
   MI_KEYDEF *keyinfo;
-  DBUG_ENTER("mi_rnext_same");
 
   if ((int) (inx=info->lastinx) < 0 || info->lastpos == HA_OFFSET_ERROR)
-    DBUG_RETURN(my_errno=HA_ERR_WRONG_INDEX);
+    return(my_errno=HA_ERR_WRONG_INDEX);
   keyinfo=info->s->keyinfo+inx;
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
   if (info->s->concurrent_insert)
     rw_rdlock(&info->s->key_root_lock[inx]);
@@ -81,12 +80,12 @@
   }
   else if (!buf)
   {
-    DBUG_RETURN(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
+    return(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
   }
   else if (!(*info->read_record)(info,info->lastpos,buf))
   {
     info->update|= HA_STATE_AKTIV;		/* Record is read */
-    DBUG_RETURN(0);
+    return(0);
   }
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* mi_rnext_same */

=== modified file 'storage/myisam/mi_rprev.c'
--- storage/myisam/mi_rprev.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rprev.c	2008-07-16 02:35:15 +0000
@@ -27,16 +27,15 @@
   int error,changed;
   register uint flag;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("mi_rprev");
 
   if ((inx = _mi_check_index(info,inx)) < 0)
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   flag=SEARCH_SMALLER;				/* Read previous */
   if (info->lastpos == HA_OFFSET_ERROR && info->update & HA_STATE_NEXT_FOUND)
     flag=0;					/* Read last */
 
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   changed=_mi_test_if_changed(info);
   if (share->concurrent_insert)
     rw_rdlock(&share->key_root_lock[inx]);
@@ -76,12 +75,12 @@
   }
   else if (!buf)
   {
-    DBUG_RETURN(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
+    return(info->lastpos==HA_OFFSET_ERROR ? my_errno : 0);
   }
   else if (!(*info->read_record)(info,info->lastpos,buf))
   {
     info->update|= HA_STATE_AKTIV;		/* Record is read */
-    DBUG_RETURN(0);
+    return(0);
   }
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* mi_rprev */

=== modified file 'storage/myisam/mi_rrnd.c'
--- storage/myisam/mi_rrnd.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rrnd.c	2008-07-16 02:35:15 +0000
@@ -32,7 +32,6 @@
 int mi_rrnd(MI_INFO *info, uchar *buf, register my_off_t filepos)
 {
   my_bool skip_deleted_blocks;
-  DBUG_ENTER("mi_rrnd");
 
   skip_deleted_blocks=0;
 
@@ -53,7 +52,7 @@
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
 
   if (info->opt_flag & WRITE_CACHE_USED && flush_io_cache(&info->rec_cache))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
-  DBUG_RETURN ((*info->s->read_rnd)(info,buf,filepos,skip_deleted_blocks));
+  return ((*info->s->read_rnd)(info,buf,filepos,skip_deleted_blocks));
 }

=== modified file 'storage/myisam/mi_rsame.c'
--- storage/myisam/mi_rsame.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rsame.c	2008-07-16 02:35:15 +0000
@@ -27,21 +27,19 @@
 
 int mi_rsame(MI_INFO *info, uchar *record, int inx)
 {
-  DBUG_ENTER("mi_rsame");
-
   if (inx != -1 && ! mi_is_key_active(info->s->state.key_map, inx))
   {
-    DBUG_RETURN(my_errno=HA_ERR_WRONG_INDEX);
+    return(my_errno=HA_ERR_WRONG_INDEX);
   }
   if (info->lastpos == HA_OFFSET_ERROR || info->update & HA_STATE_DELETED)
   {
-    DBUG_RETURN(my_errno=HA_ERR_KEY_NOT_FOUND);	/* No current record */
+    return(my_errno=HA_ERR_KEY_NOT_FOUND);	/* No current record */
   }
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
 
   /* Read row from data file */
   if (fast_mi_readinfo(info))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
   if (inx >= 0)
   {
@@ -58,8 +56,8 @@
   }
 
   if (!(*info->read_record)(info,info->lastpos,record))
-    DBUG_RETURN(0);
+    return(0);
   if (my_errno == HA_ERR_RECORD_DELETED)
     my_errno=HA_ERR_KEY_NOT_FOUND;
-  DBUG_RETURN(my_errno);
+  return(my_errno);
 } /* mi_rsame */

=== modified file 'storage/myisam/mi_rsamepos.c'
--- storage/myisam/mi_rsamepos.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_rsamepos.c	2008-07-16 02:35:15 +0000
@@ -29,13 +29,10 @@
 
 int mi_rsame_with_pos(MI_INFO *info, uchar *record, int inx, my_off_t filepos)
 {
-  DBUG_ENTER("mi_rsame_with_pos");
-  DBUG_PRINT("enter",("index: %d  filepos: %ld", inx, (long) filepos));
-
   if (inx < -1 ||
       (inx >= 0 && ! mi_is_key_active(info->s->state.key_map, inx)))
   {
-    DBUG_RETURN(my_errno=HA_ERR_WRONG_INDEX);
+    return(my_errno=HA_ERR_WRONG_INDEX);
   }
 
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
@@ -43,7 +40,7 @@
   {
     if (my_errno == HA_ERR_RECORD_DELETED)
       my_errno=HA_ERR_KEY_NOT_FOUND;
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   }
   info->lastpos=filepos;
   info->lastinx=inx;
@@ -53,5 +50,5 @@
 				      info->lastpos);
     info->update|=HA_STATE_KEY_CHANGED;		/* Don't use indexposition */
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* mi_rsame_pos */

=== modified file 'storage/myisam/mi_scan.c'
--- storage/myisam/mi_scan.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_scan.c	2008-07-16 02:52:24 +0000
@@ -19,12 +19,11 @@
 
 int mi_scan_init(register MI_INFO *info)
 {
-  DBUG_ENTER("mi_scan_init");
   info->nextpos=info->s->pack.header_length;	/* Read first record */
   info->lastinx= -1;				/* Can't forward or backward */
   if (info->opt_flag & WRITE_CACHE_USED && flush_io_cache(&info->rec_cache))
-    DBUG_RETURN(my_errno);
-  DBUG_RETURN(0);
+    return(my_errno);
+  return(0);
 }
 
 /*
@@ -38,8 +37,7 @@
 
 int mi_scan(MI_INFO *info, uchar *buf)
 {
-  DBUG_ENTER("mi_scan");
   /* Init all but update-flag */
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
-  DBUG_RETURN ((*info->s->read_rnd)(info,buf,info->nextpos,1));
+  return((*info->s->read_rnd)(info,buf,info->nextpos,1));
 }

=== modified file 'storage/myisam/mi_search.c'
--- storage/myisam/mi_search.c	2008-07-11 15:49:04 +0000
+++ storage/myisam/mi_search.c	2008-07-16 19:46:20 +0000
@@ -61,29 +61,24 @@
   uint nod_flag;
   uchar *keypos,*maxpos;
   uchar lastkey[MI_MAX_KEY_BUFF],*buff;
-  DBUG_ENTER("_mi_search");
-  DBUG_PRINT("enter",("pos: %lu  nextflag: %u  lastpos: %lu",
-                      (ulong) pos, nextflag, (ulong) info->lastpos));
-  DBUG_EXECUTE("key",_mi_print_key(DBUG_FILE,keyinfo->seg,key,key_len););
 
   if (pos == HA_OFFSET_ERROR)
   {
     my_errno=HA_ERR_KEY_NOT_FOUND;                      /* Didn't find key */
     info->lastpos= HA_OFFSET_ERROR;
     if (!(nextflag & (SEARCH_SMALLER | SEARCH_BIGGER | SEARCH_LAST)))
-      DBUG_RETURN(-1);                          /* Not found ; return error */
-    DBUG_RETURN(1);                             /* Search at upper levels */
+      return(-1);                          /* Not found ; return error */
+    return(1);                             /* Search at upper levels */
   }
 
   if (!(buff=_mi_fetch_keypage(info,keyinfo,pos,DFLT_INIT_HITS,info->buff,
                                test(!(nextflag & SEARCH_SAVE_BUFF)))))
     goto err;
-  DBUG_DUMP("page",(uchar*) buff,mi_getint(buff));
 
   flag=(*keyinfo->bin_search)(info,keyinfo,buff,key,key_len,nextflag,
                               &keypos,lastkey, &last_key);
   if (flag == MI_FOUND_WRONG_KEY)
-    DBUG_RETURN(-1);
+    return(-1);
   nod_flag=mi_test_if_nod(buff);
   maxpos=buff+mi_getint(buff)-1;
 
@@ -91,16 +86,16 @@
   {
     if ((error=_mi_search(info,keyinfo,key,key_len,nextflag,
                           _mi_kpos(nod_flag,keypos))) <= 0)
-      DBUG_RETURN(error);
+      return(error);
 
     if (flag >0)
     {
       if (nextflag & (SEARCH_SMALLER | SEARCH_LAST) &&
           keypos == buff+2+nod_flag)
-        DBUG_RETURN(1);                                 /* Bigger than key */
+        return(1);                                 /* Bigger than key */
     }
     else if (nextflag & SEARCH_BIGGER && keypos >= maxpos)
-      DBUG_RETURN(1);                                   /* Smaller than key */
+      return(1);                                   /* Smaller than key */
   }
   else
   {
@@ -111,7 +106,7 @@
       if ((error=_mi_search(info,keyinfo,key,key_len,SEARCH_FIND,
                             _mi_kpos(nod_flag,keypos))) >= 0 ||
           my_errno != HA_ERR_KEY_NOT_FOUND)
-        DBUG_RETURN(error);
+        return(error);
       info->last_keypage= HA_OFFSET_ERROR;              /* Buffer not in mem */
     }
   }
@@ -156,14 +151,12 @@
   info->page_changed=0;
   info->buff_used= (info->buff != buff);        /* If we have to reread buff */
 
-  DBUG_PRINT("exit",("found key at %lu",(ulong) info->lastpos));
-  DBUG_RETURN(0);
+  return(0);
 
 err:
-  DBUG_PRINT("exit",("Error: %d",my_errno));
   info->lastpos= HA_OFFSET_ERROR;
   info->page_changed=1;
-  DBUG_RETURN (-1);
+  return (-1);
 } /* _mi_search */
 
 
@@ -179,12 +172,10 @@
   register int start,mid,end,save_end;
   int flag;
   uint totlength,nod_flag,not_used[2];
-  DBUG_ENTER("_mi_bin_search");
 
   totlength=keyinfo->keylength+(nod_flag=mi_test_if_nod(page));
   start=0; mid=1;
   save_end=end=(int) ((mi_getint(page)-2-nod_flag)/totlength-1);
-  DBUG_PRINT("test",("mi_getint: %d  end: %d",mi_getint(page),end));
   page+=2+nod_flag;
 
   while (start != end)
@@ -204,8 +195,7 @@
     start++;                    /* point at next, bigger key */
   *ret_pos=page+(uint) start*totlength;
   *last_key= end == save_end;
-  DBUG_PRINT("exit",("flag: %d  keypos: %d",flag,start));
-  DBUG_RETURN(flag);
+  return(flag);
 } /* _mi_bin_search */
 
 
@@ -242,7 +232,6 @@
   int flag=0;
   uint nod_flag,length=0,not_used[2];
   uchar t_buff[MI_MAX_KEY_BUFF],*end;
-  DBUG_ENTER("_mi_seq_search");
 
   end= page+mi_getint(page);
   nod_flag=mi_test_if_nod(page);
@@ -256,26 +245,18 @@
     {
       mi_print_error(info->s, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_PRINT("error",
-                 ("Found wrong key:  length: %u  page: 0x%lx  end: 0x%lx",
-                  length, (long) page, (long) end));
-      DBUG_RETURN(MI_FOUND_WRONG_KEY);
+      return(MI_FOUND_WRONG_KEY);
     }
     if ((flag=ha_key_cmp(keyinfo->seg,t_buff,key,key_len,comp_flag,
                          not_used)) >= 0)
       break;
-#ifdef EXTRA_DEBUG
-    DBUG_PRINT("loop",("page: 0x%lx  key: '%s'  flag: %d", (long) page, t_buff,
-                       flag));
-#endif
     memcpy(buff,t_buff,length);
     *ret_pos=page;
   }
   if (flag == 0)
     memcpy(buff,t_buff,length);                 /* Result is first key */
   *last_key= page == end;
-  DBUG_PRINT("exit",("flag: %d  ret_pos: 0x%lx", flag, (long) *ret_pos));
-  DBUG_RETURN(flag);
+  return(flag);
 } /* _mi_seq_search */
 
 
@@ -290,15 +271,15 @@
   */
   int flag=0, my_flag=-1;
   uint nod_flag, length=0, len, matched, cmplen, kseg_len;
-  uint prefix_len,suffix_len;
-  int key_len_skip, seg_len_pack, key_len_left;
+  uint prefix_len=0,suffix_len;
+  int key_len_skip, seg_len_pack=0, key_len_left;
   uchar *end, *kseg, *vseg;
   uchar *sort_order=keyinfo->seg->charset->sort_order;
   uchar tt_buff[MI_MAX_KEY_BUFF+2], *t_buff=tt_buff+2;
   uchar *saved_from=NULL, *saved_to=NULL, *saved_vseg=NULL;
   uint  saved_length=0, saved_prefix_len=0;
   uint  length_pack;
-  DBUG_ENTER("_mi_prefix_search");
+
 
   t_buff[0]=0;                                  /* Avoid bugs */
   end= page+mi_getint(page);
@@ -312,7 +293,6 @@
   key_len_left=(int) key_len- (int) key_len_skip;
   /* If key_len is 0, then lenght_pack is 1, then key_len_left is -1. */
   cmplen=(key_len_left>=0) ? kseg_len : key_len-length_pack;
-  DBUG_PRINT("info",("key: '%.*s'",kseg_len,kseg));
 
   /*
     Keys are compressed the following way:
@@ -374,8 +354,6 @@
     saved_vseg=vseg;
     saved_prefix_len=prefix_len;
 
-    DBUG_PRINT("loop",("page: '%.*s%.*s'",prefix_len,t_buff+seg_len_pack,
-		       suffix_len,vseg));
     {
       uchar *from=vseg+suffix_len;
       HA_KEYSEG *keyseg;
@@ -407,10 +385,7 @@
     {
       mi_print_error(info->s, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_PRINT("error",
-                 ("Found wrong key:  length: %u  page: 0x%lx  end: %lx",
-                  length, (long) page, (long) end));
-      DBUG_RETURN(MI_FOUND_WRONG_KEY);
+      return(MI_FOUND_WRONG_KEY);
     }
 
     if (matched >= prefix_len)
@@ -485,7 +460,7 @@
 	  for (vseg_end= vseg + (len-cmplen) ;
 	       vseg < vseg_end && *vseg == (uchar) ' ';
 	       vseg++, matched++) ;
-	  DBUG_ASSERT(vseg < vseg_end);
+	  assert(vseg < vseg_end);
 
 	  if (*vseg > (uchar) ' ')
 	  {
@@ -511,7 +486,7 @@
 	      visited and 0 otherwise,  i.e. flag <=0 here always !!!
 	    */
 	fix_flag:
-	    DBUG_ASSERT(flag <= 0);
+	    assert(flag <= 0);
 	    if (nextflag & (SEARCH_NO_FIND | SEARCH_LAST))
 	      flag=(nextflag & (SEARCH_BIGGER | SEARCH_LAST)) ? -1 : 1;
 	    if (flag>=0)
@@ -543,8 +518,7 @@
 
   *last_key= page == end;
 
-  DBUG_PRINT("exit",("flag: %d  ret_pos: 0x%lx", flag, (long) *ret_pos));
-  DBUG_RETURN(flag);
+  return(flag);
 } /* _mi_prefix_search */
 
 
@@ -804,10 +778,6 @@
 	  key+= length;				/* Same diff_key as prev */
 	  if (length > keyseg->length)
 	  {
-	    DBUG_PRINT("error",
-                       ("Found too long null packed key: %u of %u at 0x%lx",
-                        length, keyseg->length, (long) *page_pos));
-	    DBUG_DUMP("key",(uchar*) *page_pos,16);
             mi_print_error(keyinfo->share, HA_ERR_CRASHED);
 	    my_errno=HA_ERR_CRASHED;
 	    return 0;
@@ -862,9 +832,6 @@
       }
       if (length > (uint) keyseg->length)
       {
-        DBUG_PRINT("error",("Found too long packed key: %u of %u at 0x%lx",
-                            length, keyseg->length, (long) *page_pos));
-        DBUG_DUMP("key",(uchar*) *page_pos,16);
         mi_print_error(keyinfo->share, HA_ERR_CRASHED);
         my_errno=HA_ERR_CRASHED;
         return 0;                               /* Error */
@@ -908,7 +875,6 @@
   register HA_KEYSEG *keyseg;
   uchar *start_key,*page,*page_end,*from,*from_end;
   uint length,tmp;
-  DBUG_ENTER("_mi_get_binary_pack_key");
 
   page= *page_pos;
   page_end=page+MI_MAX_KEY_BUFF+1;
@@ -933,13 +899,9 @@
   {
     if (length > keyinfo->maxlength)
     {
-      DBUG_PRINT("error",
-                 ("Found too long binary packed key: %u of %u at 0x%lx",
-                  length, keyinfo->maxlength, (long) *page_pos));
-      DBUG_DUMP("key",(uchar*) *page_pos,16);
       mi_print_error(keyinfo->share, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_RETURN(0);                                 /* Wrong key */
+      return(0);                                 /* Wrong key */
     }
     /* Key is packed against prev key, take prefix from prev key. */
     from= key;
@@ -992,8 +954,6 @@
       length-=tmp;
       from=page; from_end=page_end;
     }
-    DBUG_PRINT("info",("key: 0x%lx  from: 0x%lx  length: %u",
-		       (long) key, (long) from, length));
     memmove((uchar*) key, (uchar*) from, (size_t) length);
     key+=length;
     from+=length;
@@ -1020,16 +980,15 @@
     */
     if (from_end != page_end)
     {
-      DBUG_PRINT("error",("Error when unpacking key"));
       mi_print_error(keyinfo->share, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_RETURN(0);                                 /* Error */
+      return(0);                                 /* Error */
     }
     /* Copy data pointer and, if appropriate, key block pointer. */
     memcpy((uchar*) key,(uchar*) from,(size_t) length);
     *page_pos= from+length;
   }
-  DBUG_RETURN((uint) (key-start_key)+keyseg->length);
+  return((uint) (key-start_key)+keyseg->length);
 }
 
 
@@ -1040,13 +999,12 @@
                    uchar *key, uchar *keypos, uint *return_key_length)
 {
   uint nod_flag;
-  DBUG_ENTER("_mi_get_key");
 
   nod_flag=mi_test_if_nod(page);
   if (! (keyinfo->flag & (HA_VAR_LENGTH_KEY | HA_BINARY_PACK_KEY)))
   {
     bmove((uchar*) key,(uchar*) keypos,keyinfo->keylength+nod_flag);
-    DBUG_RETURN(keypos+keyinfo->keylength+nod_flag);
+    return(keypos+keyinfo->keylength+nod_flag);
   }
   else
   {
@@ -1059,13 +1017,11 @@
       {
         mi_print_error(info->s, HA_ERR_CRASHED);
         my_errno=HA_ERR_CRASHED;
-        DBUG_RETURN(0);
+        return(0);
       }
     }
   }
-  DBUG_PRINT("exit",("page: 0x%lx  length: %u", (long) page,
-                     *return_key_length));
-  DBUG_RETURN(page);
+  return(page);
 } /* _mi_get_key */
 
 
@@ -1077,7 +1033,6 @@
                                 uint *return_key_length)
 {
   uint nod_flag;
-  DBUG_ENTER("_mi_get_prev_key");
 
   nod_flag=mi_test_if_nod(page);
   if (! (keyinfo->flag & (HA_VAR_LENGTH_KEY | HA_BINARY_PACK_KEY)))
@@ -1085,7 +1040,7 @@
     *return_key_length=keyinfo->keylength;
     bmove((uchar*) key,(uchar*) keypos- *return_key_length-nod_flag,
           *return_key_length);
-    DBUG_RETURN(0);
+    return(0);
   }
   else
   {
@@ -1098,11 +1053,11 @@
       {
         mi_print_error(info->s, HA_ERR_CRASHED);
         my_errno=HA_ERR_CRASHED;
-        DBUG_RETURN(1);
+        return(1);
       }
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_get_key */
 
 
@@ -1115,9 +1070,6 @@
 {
   uint nod_flag;
   uchar *lastpos;
-  DBUG_ENTER("_mi_get_last_key");
-  DBUG_PRINT("enter",("page: 0x%lx  endpos: 0x%lx", (long) page,
-                      (long) endpos));
 
   nod_flag=mi_test_if_nod(page);
   if (! (keyinfo->flag & (HA_VAR_LENGTH_KEY | HA_BINARY_PACK_KEY)))
@@ -1137,17 +1089,13 @@
       *return_key_length=(*keyinfo->get_key)(keyinfo,nod_flag,&page,lastkey);
       if (*return_key_length == 0)
       {
-        DBUG_PRINT("error",("Couldn't find last key:  page: 0x%lx",
-                            (long) page));
         mi_print_error(info->s, HA_ERR_CRASHED);
         my_errno=HA_ERR_CRASHED;
-        DBUG_RETURN(0);
+        return(0);
       }
     }
   }
-  DBUG_PRINT("exit",("lastpos: 0x%lx  length: %u", (long) lastpos,
-                     *return_key_length));
-  DBUG_RETURN(lastpos);
+  return(lastpos);
 } /* _mi_get_last_key */
 
 
@@ -1230,11 +1178,6 @@
   int error;
   uint nod_flag;
   uchar lastkey[MI_MAX_KEY_BUFF];
-  DBUG_ENTER("_mi_search_next");
-  DBUG_PRINT("enter",("nextflag: %u  lastpos: %lu  int_keypos: %lu",
-                      nextflag, (ulong) info->lastpos,
-                      (ulong) info->int_keypos));
-  DBUG_EXECUTE("key",_mi_print_key(DBUG_FILE,keyinfo->seg,key,key_length););
 
   /* Force full read if we are at last key or if we are not on a leaf
      and the key tree has changed since we used it last time
@@ -1247,14 +1190,14 @@
       info->page_changed ||
       (info->int_keytree_version != keyinfo->version &&
        (info->int_nod_flag || info->buff_used)))
-    DBUG_RETURN(_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
+    return(_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
                            nextflag | SEARCH_SAVE_BUFF, pos));
 
   if (info->buff_used)
   {
     if (!_mi_fetch_keypage(info,keyinfo,info->last_search_keypage,
                            DFLT_INIT_HITS,info->buff,0))
-      DBUG_RETURN(-1);
+      return(-1);
     info->buff_used=0;
   }
 
@@ -1268,12 +1211,12 @@
     {
       if ((error=_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
                             nextflag | SEARCH_SAVE_BUFF, tmp_pos)) <=0)
-        DBUG_RETURN(error);
+        return(error);
     }
     memcpy(lastkey,key,key_length);
     if (!(info->lastkey_length=(*keyinfo->get_key)(keyinfo,nod_flag,
                                                    &info->int_keypos,lastkey)))
-      DBUG_RETURN(-1);
+      return(-1);
   }
   else                                                  /* Previous key */
   {
@@ -1282,24 +1225,23 @@
     info->int_keypos=_mi_get_last_key(info,keyinfo,info->buff,lastkey,
                                       info->int_keypos, &length);
     if (!info->int_keypos)
-      DBUG_RETURN(-1);
+      return(-1);
     if (info->int_keypos == info->buff+2)
-      DBUG_RETURN(_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
+      return(_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
                              nextflag | SEARCH_SAVE_BUFF, pos));
     if ((error=_mi_search(info,keyinfo,key, USE_WHOLE_KEY,
 			  nextflag | SEARCH_SAVE_BUFF,
                           _mi_kpos(nod_flag,info->int_keypos))) <= 0)
-      DBUG_RETURN(error);
+      return(error);
 
     /* QQ: We should be able to optimize away the following call */
     if (! _mi_get_last_key(info,keyinfo,info->buff,lastkey,
                            info->int_keypos,&info->lastkey_length))
-      DBUG_RETURN(-1);
+      return(-1);
   }
   memcpy(info->lastkey,lastkey,info->lastkey_length);
   info->lastpos=_mi_dpos(info,0,info->lastkey+info->lastkey_length);
-  DBUG_PRINT("exit",("found key at %lu",(ulong) info->lastpos));
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_search_next */
 
 
@@ -1311,13 +1253,12 @@
 {
   uint nod_flag;
   uchar *page;
-  DBUG_ENTER("_mi_search_first");
 
   if (pos == HA_OFFSET_ERROR)
   {
     my_errno=HA_ERR_KEY_NOT_FOUND;
     info->lastpos= HA_OFFSET_ERROR;
-    DBUG_RETURN(-1);
+    return(-1);
   }
 
   do
@@ -1325,7 +1266,7 @@
     if (!_mi_fetch_keypage(info,keyinfo,pos,DFLT_INIT_HITS,info->buff,0))
     {
       info->lastpos= HA_OFFSET_ERROR;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     nod_flag=mi_test_if_nod(info->buff);
     page=info->buff+2+nod_flag;
@@ -1333,7 +1274,7 @@
 
   if (!(info->lastkey_length=(*keyinfo->get_key)(keyinfo,nod_flag,&page,
                                                  info->lastkey)))
-    DBUG_RETURN(-1);                            /* Crashed */
+    return(-1);                            /* Crashed */
 
   info->int_keypos=page; info->int_maxpos=info->buff+mi_getint(info->buff)-1;
   info->int_nod_flag=nod_flag;
@@ -1342,8 +1283,7 @@
   info->page_changed=info->buff_used=0;
   info->lastpos=_mi_dpos(info,0,info->lastkey+info->lastkey_length);
 
-  DBUG_PRINT("exit",("found key at %lu", (ulong) info->lastpos));
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_search_first */
 
 
@@ -1355,13 +1295,12 @@
 {
   uint nod_flag;
   uchar *buff,*page;
-  DBUG_ENTER("_mi_search_last");
 
   if (pos == HA_OFFSET_ERROR)
   {
     my_errno=HA_ERR_KEY_NOT_FOUND;                      /* Didn't find key */
     info->lastpos= HA_OFFSET_ERROR;
-    DBUG_RETURN(-1);
+    return(-1);
   }
 
   buff=info->buff;
@@ -1370,7 +1309,7 @@
     if (!_mi_fetch_keypage(info,keyinfo,pos,DFLT_INIT_HITS,buff,0))
     {
       info->lastpos= HA_OFFSET_ERROR;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     page= buff+mi_getint(buff);
     nod_flag=mi_test_if_nod(buff);
@@ -1378,7 +1317,7 @@
 
   if (!_mi_get_last_key(info,keyinfo,buff,info->lastkey,page,
                         &info->lastkey_length))
-    DBUG_RETURN(-1);
+    return(-1);
   info->lastpos=_mi_dpos(info,0,info->lastkey+info->lastkey_length);
   info->int_keypos=info->int_maxpos=page;
   info->int_nod_flag=nod_flag;
@@ -1386,8 +1325,7 @@
   info->last_search_keypage=info->last_keypage;
   info->page_changed=info->buff_used=0;
 
-  DBUG_PRINT("exit",("found key at %lu",(ulong) info->lastpos));
-  DBUG_RETURN(0);
+  return(0);
 } /* _mi_search_last */
 
 
@@ -1571,8 +1509,6 @@
   }
   s_temp->totlength=(uint) length;
   s_temp->prev_length=0;
-  DBUG_PRINT("test",("tot_length: %u  length: %d  uniq_key_length: %u",
-                     key_length, length, s_temp->key_length));
 
         /* If something after that hasn't length=0, test if we can combine */
   if ((s_temp->next_key_pos=next_key))
@@ -1676,8 +1612,6 @@
         ref_length=0;
         next_length_pack=0;
       }
-      DBUG_PRINT("test",("length: %d  next_key: 0x%lx", length,
-                         (long) next_key));
 
       {
         uint tmp_length;

=== modified file 'storage/myisam/mi_statrec.c'
--- storage/myisam/mi_statrec.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_statrec.c	2008-07-16 05:44:59 +0000
@@ -17,7 +17,6 @@
 
 #include "myisamdef.h"
 
-
 int _mi_write_static_record(MI_INFO *info, const uchar *record)
 {
   uchar temp[8];				/* max pointer length */
@@ -112,13 +111,11 @@
 
 int _mi_cmp_static_record(register MI_INFO *info, register const uchar *old)
 {
-  DBUG_ENTER("_mi_cmp_static_record");
-
   if (info->opt_flag & WRITE_CACHE_USED)
   {
     if (flush_io_cache(&info->rec_cache))
     {
-      DBUG_RETURN(-1);
+      return(-1);
     }
     info->rec_cache.seek_not_done=1;		/* We have done a seek */
   }
@@ -129,30 +126,26 @@
     if (info->s->file_read(info, info->rec_buff, info->s->base.reclength,
 		 info->lastpos,
 		 MYF(MY_NABP)))
-      DBUG_RETURN(-1);
+      return(-1);
     if (memcmp(info->rec_buff, old,
 	       (uint) info->s->base.reclength))
     {
-      DBUG_DUMP("read",old,info->s->base.reclength);
-      DBUG_DUMP("disk",info->rec_buff,info->s->base.reclength);
       my_errno=HA_ERR_RECORD_CHANGED;		/* Record have changed */
-      DBUG_RETURN(1);
+      return(1);
     }
   }
-  DBUG_RETURN(0);
+  return(0);
 }
 
 
 int _mi_cmp_static_unique(MI_INFO *info, MI_UNIQUEDEF *def,
 			  const uchar *record, my_off_t pos)
 {
-  DBUG_ENTER("_mi_cmp_static_unique");
-
   info->rec_cache.seek_not_done=1;		/* We have done a seek */
   if (info->s->file_read(info, info->rec_buff, info->s->base.reclength,
 	       pos, MYF(MY_NABP)))
-    DBUG_RETURN(-1);
-  DBUG_RETURN(mi_unique_comp(def, record, info->rec_buff,
+    return(-1);
+  return(mi_unique_comp(def, record, info->rec_buff,
 			     def->null_are_equal));
 }
 
@@ -203,14 +196,13 @@
   int locked,error,cache_read;
   uint cache_length;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_read_rnd_static_record");
 
   cache_read=0;
   cache_length=0;
   if (info->opt_flag & WRITE_CACHE_USED &&
       (info->rec_cache.pos_in_file <= filepos || skip_deleted_blocks) &&
       flush_io_cache(&info->rec_cache))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   if (info->opt_flag & READ_CACHE_USED)
   {						/* Cache in use */
     if (filepos == my_b_tell(&info->rec_cache) &&
@@ -228,7 +220,7 @@
     if (filepos >= info->state->data_file_length)
     {						/* Test if new records */
       if (_mi_readinfo(info,F_RDLCK,0))
-	DBUG_RETURN(my_errno);
+	return(my_errno);
       locked=1;
     }
     else
@@ -242,11 +234,8 @@
   }
   if (filepos >= info->state->data_file_length)
   {
-    DBUG_PRINT("test",("filepos: %ld (%ld)  records: %ld  del: %ld",
-		       (long) filepos/share->base.reclength, (long) filepos,
-		       (long) info->state->records, (long) info->state->del));
     fast_mi_writeinfo(info);
-    DBUG_RETURN(my_errno=HA_ERR_END_OF_FILE);
+    return(my_errno=HA_ERR_END_OF_FILE);
   }
   info->lastpos= filepos;
   info->nextpos= filepos+share->base.pack_reclength;
@@ -260,7 +249,7 @@
       else
 	error=my_errno;
     }
-    DBUG_RETURN(error);
+    return(error);
   }
 
 	/* Read record with cacheing */
@@ -277,14 +266,14 @@
   {
     if (!buf[0])
     {						/* Record is removed */
-      DBUG_RETURN(my_errno=HA_ERR_RECORD_DELETED);
+      return(my_errno=HA_ERR_RECORD_DELETED);
     }
 						/* Found and may be updated */
     info->update|= HA_STATE_AKTIV | HA_STATE_KEY_CHANGED;
-    DBUG_RETURN(0);
+    return(0);
   }
   /* my_errno should be set if rec_cache.error == -1 */
   if (info->rec_cache.error != -1 || my_errno == 0)
     my_errno=HA_ERR_WRONG_IN_RECORD;
-  DBUG_RETURN(my_errno);			/* Something wrong (EOF?) */
+  return(my_errno);			/* Something wrong (EOF?) */
 }

=== removed file 'storage/myisam/mi_test1.c'
--- storage/myisam/mi_test1.c	2008-07-13 21:40:41 +0000
+++ storage/myisam/mi_test1.c	1970-01-01 00:00:00 +0000
@@ -1,682 +0,0 @@
-/* Copyright (C) 2000-2005 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* Testing of the basic functions of a MyISAM table */
-
-#include "myisam.h"
-#include <my_getopt.h>
-#include <m_string.h>
-
-#define MAX_REC_LENGTH 1024
-
-static void usage(void);
-
-static int rec_pointer_size=0, flags[50];
-static int key_field=FIELD_SKIP_PRESPACE,extra_field=FIELD_SKIP_ENDSPACE;
-static int key_type=HA_KEYTYPE_NUM;
-static int create_flag=0;
-
-static uint insert_count, update_count, remove_count;
-static uint pack_keys=0, pack_seg=0, key_length;
-static uint unique_key=HA_NOSAME;
-static my_bool key_cacheing, null_fields, silent, skip_update, opt_unique,
-               verbose;
-static MI_COLUMNDEF recinfo[4];
-static MI_KEYDEF keyinfo[10];
-static HA_KEYSEG keyseg[10];
-static HA_KEYSEG uniqueseg[10];
-
-static int run_test(const char *filename);
-static void get_options(int argc, char *argv[]);
-static void create_key(uchar *key,uint rownr);
-static void create_record(uchar *record,uint rownr);
-static void update_record(uchar *record);
-
-int main(int argc,char *argv[])
-{
-  MY_INIT(argv[0]);
-  my_init();
-  if (key_cacheing)
-    init_key_cache(dflt_key_cache,KEY_CACHE_BLOCK_SIZE,IO_SIZE*16,0,0);
-  get_options(argc,argv);
-
-  exit(run_test("test1"));
-}
-
-
-static int run_test(const char *filename)
-{
-  MI_INFO *file;
-  int i,j,error,deleted,rec_length,uniques=0;
-  ha_rows found,row_count;
-  my_off_t pos;
-  uchar record[MAX_REC_LENGTH],key[MAX_REC_LENGTH],read_record[MAX_REC_LENGTH];
-  MI_UNIQUEDEF uniquedef;
-  MI_CREATE_INFO create_info;
-
-  bzero((char*) recinfo,sizeof(recinfo));
-
-  /* First define 2 columns */
-  recinfo[0].type=FIELD_NORMAL; recinfo[0].length=1; /* For NULL bits */
-  recinfo[1].type=key_field;
-  recinfo[1].length= (key_field == FIELD_BLOB ? 4+portable_sizeof_char_ptr :
-		      key_length);
-  if (key_field == FIELD_VARCHAR)
-    recinfo[1].length+= HA_VARCHAR_PACKLENGTH(key_length);;
-  recinfo[2].type=extra_field;
-  recinfo[2].length= (extra_field == FIELD_BLOB ? 4 + portable_sizeof_char_ptr : 24);
-  if (extra_field == FIELD_VARCHAR)
-    recinfo[2].length+= HA_VARCHAR_PACKLENGTH(recinfo[2].length);
-  if (opt_unique)
-  {
-    recinfo[3].type=FIELD_CHECK;
-    recinfo[3].length=MI_UNIQUE_HASH_LENGTH;
-  }
-  rec_length=recinfo[0].length+recinfo[1].length+recinfo[2].length+
-    recinfo[3].length;
-
-  if (key_type == HA_KEYTYPE_VARTEXT1 &&
-      key_length > 255)
-    key_type= HA_KEYTYPE_VARTEXT2;
-
-  /* Define a key over the first column */
-  keyinfo[0].seg=keyseg;
-  keyinfo[0].keysegs=1;
-  keyinfo[0].block_length= 0;                   /* Default block length */
-  keyinfo[0].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[0].seg[0].type= key_type;
-  keyinfo[0].seg[0].flag= pack_seg;
-  keyinfo[0].seg[0].start=1;
-  keyinfo[0].seg[0].length=key_length;
-  keyinfo[0].seg[0].null_bit= null_fields ? 2 : 0;
-  keyinfo[0].seg[0].null_pos=0;
-  keyinfo[0].seg[0].language= default_charset_info->number;
-  if (pack_seg & HA_BLOB_PART)
-  {
-    keyinfo[0].seg[0].bit_start=4;		/* Length of blob length */
-  }
-  keyinfo[0].flag = (uint8) (pack_keys | unique_key);
-
-  bzero((uchar*) flags,sizeof(flags));
-  if (opt_unique)
-  {
-    uint start;
-    uniques=1;
-    bzero((char*) &uniquedef,sizeof(uniquedef));
-    bzero((char*) uniqueseg,sizeof(uniqueseg));
-    uniquedef.seg=uniqueseg;
-    uniquedef.keysegs=2;
-
-    /* Make a unique over all columns (except first NULL fields) */
-    for (i=0, start=1 ; i < 2 ; i++)
-    {
-      uniqueseg[i].start=start;
-      start+=recinfo[i+1].length;
-      uniqueseg[i].length=recinfo[i+1].length;
-      uniqueseg[i].language= default_charset_info->number;
-    }
-    uniqueseg[0].type= key_type;
-    uniqueseg[0].null_bit= null_fields ? 2 : 0;
-    uniqueseg[1].type= HA_KEYTYPE_TEXT;
-    if (extra_field == FIELD_BLOB)
-    {
-      uniqueseg[1].length=0;			/* The whole blob */
-      uniqueseg[1].bit_start=4;			/* long blob */
-      uniqueseg[1].flag|= HA_BLOB_PART;
-    }
-    else if (extra_field == FIELD_VARCHAR)
-      uniqueseg[1].flag|= HA_VAR_LENGTH_PART;
-  }
-  else
-    uniques=0;
-
-  if (!silent)
-    printf("- Creating isam-file\n");
-  bzero((char*) &create_info,sizeof(create_info));
-  create_info.max_rows=(ulong) (rec_pointer_size ?
-				(1L << (rec_pointer_size*8))/40 :
-				0);
-  if (mi_create(filename,1,keyinfo,3+opt_unique,recinfo,
-		uniques, &uniquedef, &create_info,
-		create_flag))
-    goto err;
-  if (!(file=mi_open(filename,2,HA_OPEN_ABORT_IF_LOCKED)))
-    goto err;
-  if (!silent)
-    printf("- Writing key:s\n");
-
-  my_errno=0;
-  row_count=deleted=0;
-  for (i=49 ; i>=1 ; i-=2 )
-  {
-    if (insert_count-- == 0) { VOID(mi_close(file)) ; exit(0) ; }
-    j=i%25 +1;
-    create_record(record,j);
-    error=mi_write(file,record);
-    if (!error)
-      row_count++;
-    flags[j]=1;
-    if (verbose || error)
-      printf("J= %2d  mi_write: %d  errno: %d\n", j,error,my_errno);
-  }
-
-  /* Insert 2 rows with null values */
-  if (null_fields)
-  {
-    create_record(record,0);
-    error=mi_write(file,record);
-    if (!error)
-      row_count++;
-    if (verbose || error)
-      printf("J= NULL  mi_write: %d  errno: %d\n", error,my_errno);
-    error=mi_write(file,record);
-    if (!error)
-      row_count++;
-    if (verbose || error)
-      printf("J= NULL  mi_write: %d  errno: %d\n", error,my_errno);
-    flags[0]=2;
-  }
-
-  if (!skip_update)
-  {
-    if (opt_unique)
-    {
-      if (!silent)
-	printf("- Checking unique constraint\n");
-      create_record(record,j);
-      if (!mi_write(file,record) || my_errno != HA_ERR_FOUND_DUPP_UNIQUE)
-      {
-	printf("unique check failed\n");
-      }
-    }
-    if (!silent)
-      printf("- Updating rows\n");
-
-    /* Update first last row to force extend of file */
-    if (mi_rsame(file,read_record,-1))
-    {
-      printf("Can't find last row with mi_rsame\n");
-    }
-    else
-    {
-      memcpy(record,read_record,rec_length);
-      update_record(record);
-      if (mi_update(file,read_record,record))
-      {
-	printf("Can't update last row: %.*s\n",
-	       keyinfo[0].seg[0].length,read_record+1);
-      }
-    }
-
-    /* Read through all rows and update them */
-    pos=(my_off_t) 0;
-    found=0;
-    while ((error=mi_rrnd(file,read_record,pos)) == 0)
-    {
-      if (update_count-- == 0) { VOID(mi_close(file)) ; exit(0) ; }
-      memcpy(record,read_record,rec_length);
-      update_record(record);
-      if (mi_update(file,read_record,record))
-      {
-	printf("Can't update row: %.*s, error: %d\n",
-	       keyinfo[0].seg[0].length,record+1,my_errno);
-      }
-      found++;
-      pos=HA_OFFSET_ERROR;
-    }
-    if (found != row_count)
-      printf("Found %ld of %ld rows\n", (ulong) found, (ulong) row_count);
-  }
-
-  if (!silent)
-    printf("- Reopening file\n");
-  if (mi_close(file)) goto err;
-  if (!(file=mi_open(filename,2,HA_OPEN_ABORT_IF_LOCKED))) goto err;
-  if (!skip_update)
-  {
-    if (!silent)
-      printf("- Removing keys\n");
-
-    for (i=0 ; i <= 10 ; i++)
-    {
-      /* testing */
-      if (remove_count-- == 0) { VOID(mi_close(file)) ; exit(0) ; }
-      j=i*2;
-      if (!flags[j])
-	continue;
-      create_key(key,j);
-      my_errno=0;
-      if ((error = mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,
-                           HA_READ_KEY_EXACT)))
-      {
-	if (verbose || (flags[j] >= 1 ||
-			(error && my_errno != HA_ERR_KEY_NOT_FOUND)))
-	  printf("key: '%.*s'  mi_rkey:  %3d  errno: %3d\n",
-		 (int) key_length,key+test(null_fields),error,my_errno);
-      }
-      else
-      {
-	error=mi_delete(file,read_record);
-	if (verbose || error)
-	  printf("key: '%.*s'  mi_delete: %3d  errno: %3d\n",
-		 (int) key_length, key+test(null_fields), error, my_errno);
-	if (! error)
-	{
-	  deleted++;
-	  flags[j]--;
-	}
-      }
-    }
-  }
-  if (!silent)
-    printf("- Reading rows with key\n");
-  for (i=0 ; i <= 25 ; i++)
-  {
-    create_key(key,i);
-    my_errno=0;
-    error=mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT);
-    if (verbose ||
-	(error == 0 && flags[i] == 0 && unique_key) ||
-	(error && (flags[i] != 0 || my_errno != HA_ERR_KEY_NOT_FOUND)))
-    {
-      printf("key: '%.*s'  mi_rkey: %3d  errno: %3d  record: %s\n",
-	     (int) key_length,key+test(null_fields),error,my_errno,record+1);
-    }
-  }
-
-  if (!silent)
-    printf("- Reading rows with position\n");
-  for (i=1,found=0 ; i <= 30 ; i++)
-  {
-    my_errno=0;
-    if ((error=mi_rrnd(file,read_record,i == 1 ? 0L : HA_OFFSET_ERROR)) == -1)
-    {
-      if (found != row_count-deleted)
-	printf("Found only %ld of %ld rows\n", (ulong) found,
-	       (ulong) (row_count - deleted));
-      break;
-    }
-    if (!error)
-      found++;
-    if (verbose || (error != 0 && error != HA_ERR_RECORD_DELETED &&
-		    error != HA_ERR_END_OF_FILE))
-    {
-      printf("pos: %2d  mi_rrnd: %3d  errno: %3d  record: %s\n",
-	     i-1,error,my_errno,read_record+1);
-    }
-  }
-  if (mi_close(file)) goto err;
-  my_end(MY_CHECK_ERROR);
-
-  return (0);
-err:
-  printf("got error: %3d when using myisam-database\n",my_errno);
-  return 1;			/* skip warning */
-}
-
-
-static void create_key_part(uchar *key,uint rownr)
-{
-  if (!unique_key)
-    rownr&=7;					/* Some identical keys */
-  if (keyinfo[0].seg[0].type == HA_KEYTYPE_NUM)
-  {
-    sprintf((char*) key,"%*d",keyinfo[0].seg[0].length,rownr);
-  }
-  else if (keyinfo[0].seg[0].type == HA_KEYTYPE_VARTEXT1 ||
-           keyinfo[0].seg[0].type == HA_KEYTYPE_VARTEXT2)
-  {						/* Alpha record */
-    /* Create a key that may be easily packed */
-    bfill(key,keyinfo[0].seg[0].length,rownr < 10 ? 'A' : 'B');
-    sprintf((char*) key+keyinfo[0].seg[0].length-2,"%-2d",rownr);
-    if ((rownr & 7) == 0)
-    {
-      /* Change the key to force a unpack of the next key */
-      bfill(key+3,keyinfo[0].seg[0].length-4,rownr < 10 ? 'a' : 'b');
-    }
-  }
-  else
-  {						/* Alpha record */
-    if (keyinfo[0].seg[0].flag & HA_SPACE_PACK)
-      sprintf((char*) key,"%-*d",keyinfo[0].seg[0].length,rownr);
-    else
-    {
-      /* Create a key that may be easily packed */
-      bfill(key,keyinfo[0].seg[0].length,rownr < 10 ? 'A' : 'B');
-      sprintf((char*) key+keyinfo[0].seg[0].length-2,"%-2d",rownr);
-      if ((rownr & 7) == 0)
-      {
-	/* Change the key to force a unpack of the next key */
-	key[1]= (rownr < 10 ? 'a' : 'b');
-      }
-    }
-  }
-}
-
-
-static void create_key(uchar *key,uint rownr)
-{
-  if (keyinfo[0].seg[0].null_bit)
-  {
-    if (rownr == 0)
-    {
-      key[0]=1;					/* null key */
-      key[1]=0;					/* Fore easy print of key */
-      return;
-    }
-    *key++=0;
-  }
-  if (keyinfo[0].seg[0].flag & (HA_BLOB_PART | HA_VAR_LENGTH_PART))
-  {
-    uint tmp;
-    create_key_part(key+2,rownr);
-    tmp=strlen((char*) key+2);
-    int2store(key,tmp);
-  }
-  else
-    create_key_part(key,rownr);
-}
-
-
-static uchar blob_key[MAX_REC_LENGTH];
-static uchar blob_record[MAX_REC_LENGTH+20*20];
-
-
-static void create_record(uchar *record,uint rownr)
-{
-  uchar *pos;
-  bzero((char*) record,MAX_REC_LENGTH);
-  record[0]=1;					/* delete marker */
-  if (rownr == 0 && keyinfo[0].seg[0].null_bit)
-    record[0]|=keyinfo[0].seg[0].null_bit;	/* Null key */
-
-  pos=record+1;
-  if (recinfo[1].type == FIELD_BLOB)
-  {
-    uint tmp;
-    uchar *ptr;
-    create_key_part(blob_key,rownr);
-    tmp=strlen((char*) blob_key);
-    int4store(pos,tmp);
-    ptr=blob_key;
-    memcpy_fixed(pos+4,&ptr,sizeof(char*));
-    pos+=recinfo[1].length;
-  }
-  else if (recinfo[1].type == FIELD_VARCHAR)
-  {
-    uint tmp, pack_length= HA_VARCHAR_PACKLENGTH(recinfo[1].length-1);
-    create_key_part(pos+pack_length,rownr);
-    tmp= strlen((char*) pos+pack_length);
-    if (pack_length == 1)
-      *(uchar*) pos= (uchar) tmp;
-    else
-      int2store(pos,tmp);
-    pos+= recinfo[1].length;
-  }
-  else
-  {
-    create_key_part(pos,rownr);
-    pos+=recinfo[1].length;
-  }
-  if (recinfo[2].type == FIELD_BLOB)
-  {
-    uint tmp;
-    uchar *ptr;;
-    sprintf((char*) blob_record,"... row: %d", rownr);
-    strappend((char*) blob_record,max(MAX_REC_LENGTH-rownr,10),' ');
-    tmp=strlen((char*) blob_record);
-    int4store(pos,tmp);
-    ptr=blob_record;
-    memcpy_fixed(pos+4,&ptr,sizeof(char*));
-  }
-  else if (recinfo[2].type == FIELD_VARCHAR)
-  {
-    uint tmp, pack_length= HA_VARCHAR_PACKLENGTH(recinfo[1].length-1);
-    sprintf((char*) pos+pack_length, "... row: %d", rownr);
-    tmp= strlen((char*) pos+pack_length);
-    if (pack_length == 1)
-      *pos= (uchar) tmp;
-    else
-      int2store(pos,tmp);
-  }
-  else
-  {
-    sprintf((char*) pos,"... row: %d", rownr);
-    strappend((char*) pos,recinfo[2].length,' ');
-  }
-}
-
-/* change row to test re-packing of rows and reallocation of keys */
-
-static void update_record(uchar *record)
-{
-  uchar *pos=record+1;
-  if (recinfo[1].type == FIELD_BLOB)
-  {
-    uchar *column,*ptr;
-    int length;
-    length=uint4korr(pos);			/* Long blob */
-    memcpy_fixed(&column,pos+4,sizeof(char*));
-    memcpy(blob_key,column,length);		/* Move old key */
-    ptr=blob_key;
-    memcpy_fixed(pos+4,&ptr,sizeof(char*));	/* Store pointer to new key */
-    if (keyinfo[0].seg[0].type != HA_KEYTYPE_NUM)
-      default_charset_info->cset->casedn(default_charset_info,
-                                         (char*) blob_key, length,
-                                         (char*) blob_key, length);
-    pos+=recinfo[1].length;
-  }
-  else if (recinfo[1].type == FIELD_VARCHAR)
-  {
-    uint pack_length= HA_VARCHAR_PACKLENGTH(recinfo[1].length-1);
-    uint length= pack_length == 1 ? (uint) *(uchar*) pos : uint2korr(pos);
-    default_charset_info->cset->casedn(default_charset_info,
-                                       (char*) pos + pack_length, length,
-                                       (char*) pos + pack_length, length);
-    pos+=recinfo[1].length;
-  }
-  else
-  {
-    if (keyinfo[0].seg[0].type != HA_KEYTYPE_NUM)
-      default_charset_info->cset->casedn(default_charset_info,
-                                         (char*) pos, keyinfo[0].seg[0].length,
-                                         (char*) pos, keyinfo[0].seg[0].length);
-    pos+=recinfo[1].length;
-  }
-
-  if (recinfo[2].type == FIELD_BLOB)
-  {
-    uchar *column;
-    int length;
-    length=uint4korr(pos);
-    memcpy_fixed(&column,pos+4,sizeof(char*));
-    memcpy(blob_record,column,length);
-    bfill(blob_record+length,20,'.');	/* Make it larger */
-    length+=20;
-    int4store(pos,length);
-    column= blob_record;
-    memcpy_fixed(pos+4,&column,sizeof(char*));
-  }
-  else if (recinfo[2].type == FIELD_VARCHAR)
-  {
-    /* Second field is longer than 10 characters */
-    uint pack_length= HA_VARCHAR_PACKLENGTH(recinfo[1].length-1);
-    uint length= pack_length == 1 ? (uint) *(uchar*) pos : uint2korr(pos);
-    bfill(pos+pack_length+length,recinfo[2].length-length-pack_length,'.');
-    length=recinfo[2].length-pack_length;
-    if (pack_length == 1)
-      *(uchar*) pos= (uchar) length;
-    else
-      int2store(pos,length);
-  }
-  else
-  {
-    bfill(pos+recinfo[2].length-10,10,'.');
-  }
-}
-
-
-static struct my_option my_long_options[] =
-{
-  {"checksum", 'c', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-#ifndef DBUG_OFF
-  {"debug", '#', "Undocumented",
-   0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
-#endif
-  {"delete_rows", 'd', "Undocumented", (char**) &remove_count,
-   (char**) &remove_count, 0, GET_UINT, REQUIRED_ARG, 1000, 0, 0, 0, 0, 0},
-  {"help", '?', "Display help and exit",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"insert_rows", 'i', "Undocumented", (char**) &insert_count,
-   (char**) &insert_count, 0, GET_UINT, REQUIRED_ARG, 1000, 0, 0, 0, 0, 0},
-  {"key_alpha", 'a', "Use a key of type HA_KEYTYPE_TEXT",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_binary_pack", 'B', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_blob", 'b', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_cache", 'K', "Undocumented", (char**) &key_cacheing,
-   (char**) &key_cacheing, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_length", 'k', "Undocumented", (char**) &key_length, (char**) &key_length,
-   0, GET_UINT, REQUIRED_ARG, 6, 0, 0, 0, 0, 0},
-  {"key_multiple", 'm', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_prefix_pack", 'P', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_space_pack", 'p', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"key_varchar", 'w', "Test VARCHAR keys",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"null_fields", 'N', "Define fields with NULL",
-   (char**) &null_fields, (char**) &null_fields, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
-  {"row_fixed_size", 'S', "Undocumented",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"row_pointer_size", 'R', "Undocumented", (char**) &rec_pointer_size,
-   (char**) &rec_pointer_size, 0, GET_INT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
-  {"silent", 's', "Undocumented",
-   (char**) &silent, (char**) &silent, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"skip_update", 'U', "Undocumented", (char**) &skip_update,
-   (char**) &skip_update, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"unique", 'C', "Undocumented", (char**) &opt_unique, (char**) &opt_unique, 0,
-   GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"update_rows", 'u', "Undocumented", (char**) &update_count,
-   (char**) &update_count, 0, GET_UINT, REQUIRED_ARG, 1000, 0, 0, 0, 0, 0},
-  {"verbose", 'v', "Be more verbose", (char**) &verbose, (char**) &verbose, 0,
-   GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
-  {"version", 'V', "Print version number and exit",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-  { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
-};
-
-
-static bool
-get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
-	       char *argument __attribute__((unused)))
-{
-  switch(optid) {
-  case 'a':
-    key_type= HA_KEYTYPE_TEXT;
-    break;
-  case 'c':
-    create_flag|= HA_CREATE_CHECKSUM;
-    break;
-  case 'R':				/* Length of record pointer */
-    if (rec_pointer_size > 3)
-      rec_pointer_size=0;
-    break;
-  case 'P':
-    pack_keys= HA_PACK_KEY;		/* Use prefix compression */
-    break;
-  case 'B':
-    pack_keys= HA_BINARY_PACK_KEY;	/* Use binary compression */
-    break;
-  case 'S':
-    if (key_field == FIELD_VARCHAR)
-    {
-      create_flag=0;			/* Static sized varchar */
-    }
-    else if (key_field != FIELD_BLOB)
-    {
-      key_field=FIELD_NORMAL;		/* static-size record */
-      extra_field=FIELD_NORMAL;
-    }
-    break;
-  case 'p':
-    pack_keys=HA_PACK_KEY;		/* Use prefix + space packing */
-    pack_seg=HA_SPACE_PACK;
-    key_type=HA_KEYTYPE_TEXT;
-    break;
-  case 'm':
-    unique_key=0;
-    break;
-  case 'b':
-    key_field=FIELD_BLOB;			/* blob key */
-    extra_field= FIELD_BLOB;
-    pack_seg|= HA_BLOB_PART;
-    key_type= HA_KEYTYPE_VARTEXT1;
-    break;
-  case 'k':
-    if (key_length < 4 || key_length > MI_MAX_KEY_LENGTH)
-    {
-      fprintf(stderr,"Wrong key length\n");
-      exit(1);
-    }
-    break;
-  case 'w':
-    key_field=FIELD_VARCHAR;			/* varchar keys */
-    extra_field= FIELD_VARCHAR;
-    key_type= HA_KEYTYPE_VARTEXT1;
-    pack_seg|= HA_VAR_LENGTH_PART;
-    create_flag|= HA_PACK_RECORD;
-    break;
-  case 'K':                                     /* Use key cacheing */
-    key_cacheing=1;
-    break;
-  case 'V':
-    printf("test1 Ver 1.2 \n");
-    exit(0);
-  case '#':
-    DBUG_PUSH (argument);
-    break;
-  case '?':
-    usage();
-    exit(1);
-  }
-  return 0;
-}
-
-
-/* Read options */
-
-static void get_options(int argc, char *argv[])
-{
-  int ho_error;
-
-  if ((ho_error=handle_options(&argc, &argv, my_long_options, get_one_option)))
-    exit(ho_error);
-
-  return;
-} /* get options */
-
-
-static void usage(void)
-{
-  printf("Usage: %s [options]\n\n", my_progname);
-  my_print_help(my_long_options);
-  my_print_variables(my_long_options);
-}
-

=== removed file 'storage/myisam/mi_test2.c'
--- storage/myisam/mi_test2.c	2008-07-08 01:31:43 +0000
+++ storage/myisam/mi_test2.c	1970-01-01 00:00:00 +0000
@@ -1,1055 +0,0 @@
-/* Copyright (C) 2000-2006 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* Test av isam-databas: stor test */
-
-#ifndef USE_MY_FUNC		/* We want to be able to dbug this !! */
-#define USE_MY_FUNC
-#endif
-#ifdef DBUG_OFF
-#undef DBUG_OFF
-#endif
-#include "myisamdef.h"
-#include <m_ctype.h>
-#include <my_bit.h>
-
-#define STANDARD_LENGTH 37
-#define MYISAM_KEYS 6
-#define MAX_PARTS 4
-#if !defined(labs)
-#define labs(a) abs(a)
-#endif
-
-static void get_options(int argc, char *argv[]);
-static uint rnd(uint max_value);
-static void fix_length(uchar *record,uint length);
-static void put_blob_in_record(uchar *blob_pos,char **blob_buffer);
-static void copy_key(struct st_myisam_info *info,uint inx,
-		     uchar *record,uchar *key);
-
-static	int verbose=0,testflag=0,
-	    first_key=0,async_io=0,key_cacheing=0,write_cacheing=0,locking=0,
-            rec_pointer_size=0,pack_fields=1,use_log=0,silent=0,
-            opt_quick_mode=0;
-static int pack_seg=HA_SPACE_PACK,pack_type=HA_PACK_KEY,remove_count=-1,
-	   create_flag=0;
-static ulong key_cache_size=IO_SIZE*16;
-static uint key_cache_block_size= KEY_CACHE_BLOCK_SIZE;
-
-static uint keys=MYISAM_KEYS,recant=1000;
-static uint use_blob=0;
-static uint16 key1[1001],key3[5000];
-static uchar record[300],record2[300],key[100],key2[100];
-static uchar read_record[300],read_record2[300],read_record3[300];
-static HA_KEYSEG glob_keyseg[MYISAM_KEYS][MAX_PARTS];
-
-		/* Test program */
-
-int main(int argc, char *argv[])
-{
-  uint i;
-  int j,n1,n2,n3,error,k;
-  uint write_count,update,dupp_keys,opt_delete,start,length,blob_pos,
-       reclength,ant,found_parts;
-  my_off_t lastpos;
-  ha_rows range_records,records;
-  MI_INFO *file;
-  MI_KEYDEF keyinfo[10];
-  MI_COLUMNDEF recinfo[10];
-  MI_ISAMINFO info;
-  const char *filename;
-  char *blob_buffer;
-  MI_CREATE_INFO create_info;
-  MY_INIT(argv[0]);
-
-  filename= "test2";
-  get_options(argc,argv);
-  if (! async_io)
-    my_disable_async_io=1;
-
-  reclength=STANDARD_LENGTH+60+(use_blob ? 8 : 0);
-  blob_pos=STANDARD_LENGTH+60;
-  keyinfo[0].seg= &glob_keyseg[0][0];
-  keyinfo[0].seg[0].start=0;
-  keyinfo[0].seg[0].length=6;
-  keyinfo[0].seg[0].type=HA_KEYTYPE_TEXT;
-  keyinfo[0].seg[0].language= default_charset_info->number;
-  keyinfo[0].seg[0].flag=(uint8) pack_seg;
-  keyinfo[0].seg[0].null_bit=0;
-  keyinfo[0].seg[0].null_pos=0;
-  keyinfo[0].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[0].keysegs=1;
-  keyinfo[0].flag = pack_type;
-  keyinfo[0].block_length= 0;                   /* Default block length */
-  keyinfo[1].seg= &glob_keyseg[1][0];
-  keyinfo[1].seg[0].start=7;
-  keyinfo[1].seg[0].length=6;
-  keyinfo[1].seg[0].type=HA_KEYTYPE_BINARY;
-  keyinfo[1].seg[0].flag=0;
-  keyinfo[1].seg[0].null_bit=0;
-  keyinfo[1].seg[0].null_pos=0;
-  keyinfo[1].seg[1].start=0;			/* two part key */
-  keyinfo[1].seg[1].length=6;
-  keyinfo[1].seg[1].type=HA_KEYTYPE_NUM;
-  keyinfo[1].seg[1].flag=HA_REVERSE_SORT;
-  keyinfo[1].seg[1].null_bit=0;
-  keyinfo[1].seg[1].null_pos=0;
-  keyinfo[1].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[1].keysegs=2;
-  keyinfo[1].flag =0;
-  keyinfo[1].block_length= MI_MIN_KEY_BLOCK_LENGTH;  /* Diff blocklength */
-  keyinfo[2].seg= &glob_keyseg[2][0];
-  keyinfo[2].seg[0].start=12;
-  keyinfo[2].seg[0].length=8;
-  keyinfo[2].seg[0].type=HA_KEYTYPE_BINARY;
-  keyinfo[2].seg[0].flag=HA_REVERSE_SORT;
-  keyinfo[2].seg[0].null_bit=0;
-  keyinfo[2].seg[0].null_pos=0;
-  keyinfo[2].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[2].keysegs=1;
-  keyinfo[2].flag =HA_NOSAME;
-  keyinfo[2].block_length= 0;                   /* Default block length */
-  keyinfo[3].seg= &glob_keyseg[3][0];
-  keyinfo[3].seg[0].start=0;
-  keyinfo[3].seg[0].length=reclength-(use_blob ? 8 : 0);
-  keyinfo[3].seg[0].type=HA_KEYTYPE_TEXT;
-  keyinfo[3].seg[0].language=default_charset_info->number;
-  keyinfo[3].seg[0].flag=(uint8) pack_seg;
-  keyinfo[3].seg[0].null_bit=0;
-  keyinfo[3].seg[0].null_pos=0;
-  keyinfo[3].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[3].keysegs=1;
-  keyinfo[3].flag = pack_type;
-  keyinfo[3].block_length= 0;                   /* Default block length */
-  keyinfo[4].seg= &glob_keyseg[4][0];
-  keyinfo[4].seg[0].start=0;
-  keyinfo[4].seg[0].length=5;
-  keyinfo[4].seg[0].type=HA_KEYTYPE_TEXT;
-  keyinfo[4].seg[0].language=default_charset_info->number;
-  keyinfo[4].seg[0].flag=0;
-  keyinfo[4].seg[0].null_bit=0;
-  keyinfo[4].seg[0].null_pos=0;
-  keyinfo[4].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[4].keysegs=1;
-  keyinfo[4].flag = pack_type;
-  keyinfo[4].block_length= 0;                   /* Default block length */
-  keyinfo[5].seg= &glob_keyseg[5][0];
-  keyinfo[5].seg[0].start=0;
-  keyinfo[5].seg[0].length=4;
-  keyinfo[5].seg[0].type=HA_KEYTYPE_TEXT;
-  keyinfo[5].seg[0].language=default_charset_info->number;
-  keyinfo[5].seg[0].flag=pack_seg;
-  keyinfo[5].seg[0].null_bit=0;
-  keyinfo[5].seg[0].null_pos=0;
-  keyinfo[5].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[5].keysegs=1;
-  keyinfo[5].flag = pack_type;
-  keyinfo[5].block_length= 0;                   /* Default block length */
-
-  recinfo[0].type=pack_fields ? FIELD_SKIP_PRESPACE : 0;
-  recinfo[0].length=7;
-  recinfo[0].null_bit=0;
-  recinfo[0].null_pos=0;
-  recinfo[1].type=pack_fields ? FIELD_SKIP_PRESPACE : 0;
-  recinfo[1].length=5;
-  recinfo[1].null_bit=0;
-  recinfo[1].null_pos=0;
-  recinfo[2].type=pack_fields ? FIELD_SKIP_PRESPACE : 0;
-  recinfo[2].length=9;
-  recinfo[2].null_bit=0;
-  recinfo[2].null_pos=0;
-  recinfo[3].type=FIELD_NORMAL;
-  recinfo[3].length=STANDARD_LENGTH-7-5-9-4;
-  recinfo[3].null_bit=0;
-  recinfo[3].null_pos=0;
-  recinfo[4].type=pack_fields ? FIELD_SKIP_ZERO : 0;
-  recinfo[4].length=4;
-  recinfo[4].null_bit=0;
-  recinfo[4].null_pos=0;
-  recinfo[5].type=pack_fields ? FIELD_SKIP_ENDSPACE : 0;
-  recinfo[5].length=60;
-  recinfo[5].null_bit=0;
-  recinfo[5].null_pos=0;
-  if (use_blob)
-  {
-    recinfo[6].type=FIELD_BLOB;
-    recinfo[6].length=4+portable_sizeof_char_ptr;
-    recinfo[6].null_bit=0;
-    recinfo[6].null_pos=0;
-  }
-
-  write_count=update=dupp_keys=opt_delete=0;
-  blob_buffer=0;
-
-  for (i=1000 ; i>0 ; i--) key1[i]=0;
-  for (i=4999 ; i>0 ; i--) key3[i]=0;
-
-  if (!silent)
-    printf("- Creating isam-file\n");
-  /*  DBUG_PUSH(""); */
-  /* my_delete(filename,MYF(0)); */	/* Remove old locks under gdb */
-  file= 0;
-  bzero((char*) &create_info,sizeof(create_info));
-  create_info.max_rows=(ha_rows) (rec_pointer_size ?
-				  (1L << (rec_pointer_size*8))/
-				  reclength : 0);
-  create_info.reloc_rows=(ha_rows) 100;
-  if (mi_create(filename,keys,&keyinfo[first_key],
-		use_blob ? 7 : 6, &recinfo[0],
-		0,(MI_UNIQUEDEF*) 0,
-		&create_info,create_flag))
-    goto err;
-  if (use_log)
-    mi_log(1);
-  if (!(file=mi_open(filename,2,HA_OPEN_ABORT_IF_LOCKED)))
-    goto err;
-  if (!silent)
-    printf("- Writing key:s\n");
-  if (key_cacheing)
-    init_key_cache(dflt_key_cache,key_cache_block_size,key_cache_size,0,0);
-  if (locking)
-    mi_lock_database(file,F_WRLCK);
-  if (write_cacheing)
-    mi_extra(file,HA_EXTRA_WRITE_CACHE,0);
-  if (opt_quick_mode)
-    mi_extra(file,HA_EXTRA_QUICK,0);
-
-  for (i=0 ; i < recant ; i++)
-  {
-    n1=rnd(1000); n2=rnd(100); n3=rnd(5000);
-    sprintf((char*) record,"%6d:%4d:%8d:Pos: %4d    ",n1,n2,n3,write_count);
-    int4store(record+STANDARD_LENGTH-4,(long) i);
-    fix_length(record,(uint) STANDARD_LENGTH+rnd(60));
-    put_blob_in_record(record+blob_pos,&blob_buffer);
-    DBUG_PRINT("test",("record: %d",i));
-
-    if (mi_write(file,record))
-    {
-      if (my_errno != HA_ERR_FOUND_DUPP_KEY || key3[n3] == 0)
-      {
-	printf("Error: %d in write at record: %d\n",my_errno,i);
-	goto err;
-      }
-      if (verbose) printf("   Double key: %d\n",n3);
-    }
-    else
-    {
-      if (key3[n3] == 1 && first_key <3 && first_key+keys >= 3)
-      {
-	printf("Error: Didn't get error when writing second key: '%8d'\n",n3);
-	goto err;
-      }
-      write_count++; key1[n1]++; key3[n3]=1;
-    }
-
-    /* Check if we can find key without flushing database */
-    if (i == recant/2)
-    {
-      for (j=rnd(1000)+1 ; j>0 && key1[j] == 0 ; j--) ;
-      if (!j)
-	for (j=999 ; j>0 && key1[j] == 0 ; j--) ;
-      sprintf((char*) key,"%6d",j);
-      if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      {
-	printf("Test in loop: Can't find key: \"%s\"\n",key);
-	goto err;
-      }
-    }
-  }
-  if (testflag==1) goto end;
-
-  if (write_cacheing)
-  {
-    if (mi_extra(file,HA_EXTRA_NO_CACHE,0))
-    {
-      puts("got error from mi_extra(HA_EXTRA_NO_CACHE)");
-      goto end;
-    }
-  }
-  if (key_cacheing)
-    resize_key_cache(dflt_key_cache,key_cache_block_size,key_cache_size*2,0,0);
-
-  if (!silent)
-    printf("- Delete\n");
-  for (i=0 ; i<recant/10 ; i++)
-  {
-    for (j=rnd(1000)+1 ; j>0 && key1[j] == 0 ; j--) ;
-    if (j != 0)
-    {
-      sprintf((char*) key,"%6d",j);
-      if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      {
-	printf("can't find key1: \"%s\"\n",key);
-	goto err;
-      }
-      if (opt_delete == (uint) remove_count)		/* While testing */
-	goto end;
-      if (mi_delete(file,read_record))
-      {
-	printf("error: %d; can't delete record: \"%s\"\n", my_errno,read_record);
-	goto err;
-      }
-      opt_delete++;
-      key1[atoi((char*) read_record+keyinfo[0].seg[0].start)]--;
-      key3[atoi((char*) read_record+keyinfo[2].seg[0].start)]=0;
-    }
-    else
-      puts("Warning: Skipping delete test because no dupplicate keys");
-  }
-  if (testflag==2) goto end;
-
-  if (!silent)
-    printf("- Update\n");
-  for (i=0 ; i<recant/10 ; i++)
-  {
-    n1=rnd(1000); n2=rnd(100); n3=rnd(5000);
-    sprintf((char*) record2,"%6d:%4d:%8d:XXX: %4d     ",n1,n2,n3,update);
-    int4store(record2+STANDARD_LENGTH-4,(long) i);
-    fix_length(record2,(uint) STANDARD_LENGTH+rnd(60));
-
-    for (j=rnd(1000)+1 ; j>0 && key1[j] == 0 ; j--) ;
-    if (j != 0)
-    {
-      sprintf((char*) key,"%6d",j);
-      if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      {
-	printf("can't find key1: \"%s\"\n",(char*) key);
-	goto err;
-      }
-      if (use_blob)
-      {
-	if (i & 1)
-	  put_blob_in_record(record+blob_pos,&blob_buffer);
-	else
-	  bmove(record+blob_pos,read_record+blob_pos,8);
-      }
-      if (mi_update(file,read_record,record2))
-      {
-	if (my_errno != HA_ERR_FOUND_DUPP_KEY || key3[n3] == 0)
-	{
-	  printf("error: %d; can't update:\nFrom: \"%s\"\nTo:   \"%s\"\n",
-		 my_errno,read_record,record2);
-	  goto err;
-	}
-	if (verbose)
-	  printf("Double key when tried to update:\nFrom: \"%s\"\nTo:   \"%s\"\n",record,record2);
-      }
-      else
-      {
-	key1[atoi((char*) read_record+keyinfo[0].seg[0].start)]--;
-	key3[atoi((char*) read_record+keyinfo[2].seg[0].start)]=0;
-	key1[n1]++; key3[n3]=1;
-	update++;
-      }
-    }
-  }
-  if (testflag == 3)
-    goto end;
-
-  for (i=999, dupp_keys=j=0 ; i>0 ; i--)
-  {
-    if (key1[i] > dupp_keys)
-    {
-      dupp_keys=key1[i]; j=i;
-    }
-  }
-  sprintf((char*) key,"%6d",j);
-  start=keyinfo[0].seg[0].start;
-  length=keyinfo[0].seg[0].length;
-  if (dupp_keys)
-  {
-    if (!silent)
-      printf("- Same key: first - next -> last - prev -> first\n");
-    DBUG_PRINT("progpos",("first - next -> last - prev -> first"));
-    if (verbose) printf("	 Using key: \"%s\"  Keys: %d\n",key,dupp_keys);
-
-    if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      goto err;
-    if (mi_rsame(file,read_record2,-1))
-      goto err;
-    if (memcmp(read_record,read_record2,reclength) != 0)
-    {
-      printf("mi_rsame didn't find same record\n");
-      goto end;
-    }
-    info.recpos=mi_position(file);
-    if (mi_rfirst(file,read_record2,0) ||
-	mi_rsame_with_pos(file,read_record2,0,info.recpos) ||
-	memcmp(read_record,read_record2,reclength) != 0)
-    {
-      printf("mi_rsame_with_pos didn't find same record\n");
-      goto end;
-    }
-    {
-      int skr=mi_rnext(file,read_record2,0);
-      if ((skr && my_errno != HA_ERR_END_OF_FILE) ||
-	  mi_rprev(file,read_record2,-1) ||
-	  memcmp(read_record,read_record2,reclength) != 0)
-      {
-	printf("mi_rsame_with_pos lost position\n");
-	goto end;
-      }
-    }
-    ant=1;
-    while (mi_rnext(file,read_record2,0) == 0 &&
-	   memcmp(read_record2+start,key,length) == 0) ant++;
-    if (ant != dupp_keys)
-    {
-      printf("next: Found: %d keys of %d\n",ant,dupp_keys);
-      goto end;
-    }
-    ant=0;
-    while (mi_rprev(file,read_record3,0) == 0 &&
-	   bcmp(read_record3+start,key,length) == 0) ant++;
-    if (ant != dupp_keys)
-    {
-      printf("prev: Found: %d records of %d\n",ant,dupp_keys);
-      goto end;
-    }
-
-    /* Check of mi_rnext_same */
-    if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      goto err;
-    ant=1;
-    while (!mi_rnext_same(file,read_record3) && ant < dupp_keys+10)
-      ant++;
-    if (ant != dupp_keys || my_errno != HA_ERR_END_OF_FILE)
-    {
-      printf("mi_rnext_same: Found: %d records of %d\n",ant,dupp_keys);
-      goto end;
-    }
-  }
-
-  if (!silent)
-    printf("- All keys: first - next -> last - prev -> first\n");
-  DBUG_PRINT("progpos",("All keys: first - next -> last - prev -> first"));
-  ant=1;
-  if (mi_rfirst(file,read_record,0))
-  {
-    printf("Can't find first record\n");
-    goto end;
-  }
-  while ((error=mi_rnext(file,read_record3,0)) == 0 && ant < write_count+10)
-    ant++;
-  if (ant != write_count - opt_delete || error != HA_ERR_END_OF_FILE)
-  {
-    printf("next: I found: %d records of %d (error: %d)\n",
-	   ant, write_count - opt_delete, error);
-    goto end;
-  }
-  if (mi_rlast(file,read_record2,0) ||
-      bcmp(read_record2,read_record3,reclength))
-  {
-    printf("Can't find last record\n");
-    DBUG_DUMP("record2",(uchar*) read_record2,reclength);
-    DBUG_DUMP("record3",(uchar*) read_record3,reclength);
-    goto end;
-  }
-  ant=1;
-  while (mi_rprev(file,read_record3,0) == 0 && ant < write_count+10)
-    ant++;
-  if (ant != write_count - opt_delete)
-  {
-    printf("prev: I found: %d records of %d\n",ant,write_count);
-    goto end;
-  }
-  if (bcmp(read_record,read_record3,reclength))
-  {
-    printf("Can't find first record\n");
-    goto end;
-  }
-
-  if (!silent)
-    printf("- Test if: Read first - next - prev - prev - next == first\n");
-  DBUG_PRINT("progpos",("- Read first - next - prev - prev - next == first"));
-  if (mi_rfirst(file,read_record,0) ||
-      mi_rnext(file,read_record3,0) ||
-      mi_rprev(file,read_record3,0) ||
-      mi_rprev(file,read_record3,0) == 0 ||
-      mi_rnext(file,read_record3,0))
-      goto err;
-  if (bcmp(read_record,read_record3,reclength) != 0)
-     printf("Can't find first record\n");
-
-  if (!silent)
-    printf("- Test if: Read last - prev - next - next - prev == last\n");
-  DBUG_PRINT("progpos",("Read last - prev - next - next - prev == last"));
-  if (mi_rlast(file,read_record2,0) ||
-      mi_rprev(file,read_record3,0) ||
-      mi_rnext(file,read_record3,0) ||
-      mi_rnext(file,read_record3,0) == 0 ||
-      mi_rprev(file,read_record3,0))
-      goto err;
-  if (bcmp(read_record2,read_record3,reclength))
-     printf("Can't find last record\n");
-#ifdef NOT_ANYMORE
-  if (!silent)
-    puts("- Test read key-part");
-  strmov(key2,key);
-  for(i=strlen(key2) ; i-- > 1 ;)
-  {
-    key2[i]=0;
-
-    /* The following row is just to catch some bugs in the key code */
-    bzero((char*) file->lastkey,file->s->base.max_key_length*2);
-    if (mi_rkey(file,read_record,0,key2,(uint) i,HA_READ_PREFIX))
-      goto err;
-    if (bcmp(read_record+start,key,(uint) i))
-    {
-      puts("Didn't find right record");
-      goto end;
-    }
-  }
-#endif
-  if (dupp_keys > 2)
-  {
-    if (!silent)
-      printf("- Read key (first) - next - delete - next -> last\n");
-    DBUG_PRINT("progpos",("first - next - delete - next -> last"));
-    if (mi_rkey(file,read_record,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      goto err;
-    if (mi_rnext(file,read_record3,0)) goto err;
-    if (mi_delete(file,read_record3)) goto err;
-    opt_delete++;
-    ant=1;
-    while (mi_rnext(file,read_record3,0) == 0 &&
-	   bcmp(read_record3+start,key,length) == 0) ant++;
-    if (ant != dupp_keys-1)
-    {
-      printf("next: I can only find: %d keys of %d\n",ant,dupp_keys-1);
-      goto end;
-    }
-  }
-  if (dupp_keys>4)
-  {
-    if (!silent)
-      printf("- Read last of key - prev - delete - prev -> first\n");
-    DBUG_PRINT("progpos",("last - prev - delete - prev -> first"));
-    if (mi_rprev(file,read_record3,0)) goto err;
-    if (mi_rprev(file,read_record3,0)) goto err;
-    if (mi_delete(file,read_record3)) goto err;
-    opt_delete++;
-    ant=1;
-    while (mi_rprev(file,read_record3,0) == 0 &&
-	   bcmp(read_record3+start,key,length) == 0) ant++;
-    if (ant != dupp_keys-2)
-    {
-      printf("next: I can only find: %d keys of %d\n",ant,dupp_keys-2);
-      goto end;
-    }
-  }
-  if (dupp_keys > 6)
-  {
-    if (!silent)
-      printf("- Read first - delete - next -> last\n");
-    DBUG_PRINT("progpos",("first - delete - next -> last"));
-    if (mi_rkey(file,read_record3,0,key,HA_WHOLE_KEY,HA_READ_KEY_EXACT))
-      goto err;
-    if (mi_delete(file,read_record3)) goto err;
-    opt_delete++;
-    ant=1;
-    if (mi_rnext(file,read_record,0))
-      goto err;					/* Skall finnas poster */
-    while (mi_rnext(file,read_record3,0) == 0 &&
-	   bcmp(read_record3+start,key,length) == 0) ant++;
-    if (ant != dupp_keys-3)
-    {
-      printf("next: I can only find: %d keys of %d\n",ant,dupp_keys-3);
-      goto end;
-    }
-
-    if (!silent)
-      printf("- Read last - delete - prev -> first\n");
-    DBUG_PRINT("progpos",("last - delete - prev -> first"));
-    if (mi_rprev(file,read_record3,0)) goto err;
-    if (mi_delete(file,read_record3)) goto err;
-    opt_delete++;
-    ant=0;
-    while (mi_rprev(file,read_record3,0) == 0 &&
-	   bcmp(read_record3+start,key,length) == 0) ant++;
-    if (ant != dupp_keys-4)
-    {
-      printf("next: I can only find: %d keys of %d\n",ant,dupp_keys-4);
-      goto end;
-    }
-  }
-
-  if (!silent)
-    puts("- Test if: Read rrnd - same");
-  DBUG_PRINT("progpos",("Read rrnd - same"));
-  for (i=0 ; i < write_count ; i++)
-  {
-    if (mi_rrnd(file,read_record,i == 0 ? 0L : HA_OFFSET_ERROR) == 0)
-      break;
-  }
-  if (i == write_count)
-    goto err;
-
-  bmove(read_record2,read_record,reclength);
-  for (i=min(2,keys) ; i-- > 0 ;)
-  {
-    if (mi_rsame(file,read_record2,(int) i)) goto err;
-    if (bcmp(read_record,read_record2,reclength) != 0)
-    {
-      printf("is_rsame didn't find same record\n");
-      goto end;
-    }
-  }
-  if (!silent)
-    puts("- Test mi_records_in_range");
-  mi_status(file,&info,HA_STATUS_VARIABLE);
-  for (i=0 ; i < info.keys ; i++)
-  {
-    key_range min_key, max_key;
-    if (mi_rfirst(file,read_record,(int) i) ||
-	mi_rlast(file,read_record2,(int) i))
-      goto err;
-    copy_key(file,(uint) i,(uchar*) read_record,(uchar*) key);
-    copy_key(file,(uint) i,(uchar*) read_record2,(uchar*) key2);
-    min_key.key= key;
-    min_key.keypart_map= HA_WHOLE_KEY;
-    min_key.flag= HA_READ_KEY_EXACT;
-    max_key.key= key2;
-    max_key.keypart_map= HA_WHOLE_KEY;
-    max_key.flag= HA_READ_AFTER_KEY;
-
-    range_records= mi_records_in_range(file,(int) i, &min_key, &max_key);
-    if (range_records < info.records*8/10 ||
-	range_records > info.records*12/10)
-    {
-      printf("mi_records_range returned %ld; Should be about %ld\n",
-	     (long) range_records,(long) info.records);
-      goto end;
-    }
-    if (verbose)
-    {
-      printf("mi_records_range returned %ld;  Exact is %ld  (diff: %4.2g %%)\n",
-	     (long) range_records, (long) info.records,
-	     labs((long) range_records - (long) info.records)*100.0/
-	     info.records);
-    }
-  }
-  for (i=0 ; i < 5 ; i++)
-  {
-    for (j=rnd(1000)+1 ; j>0 && key1[j] == 0 ; j--) ;
-    for (k=rnd(1000)+1 ; k>0 && key1[k] == 0 ; k--) ;
-    if (j != 0 && k != 0)
-    {
-      key_range min_key, max_key;
-      if (j > k)
-	swap_variables(int, j, k);
-      sprintf((char*) key,"%6d",j);
-      sprintf((char*) key2,"%6d",k);
-
-      min_key.key= key;
-      min_key.length= USE_WHOLE_KEY;
-      min_key.flag= HA_READ_AFTER_KEY;
-      max_key.key= key2;
-      max_key.length= USE_WHOLE_KEY;
-      max_key.flag= HA_READ_BEFORE_KEY;
-      range_records= mi_records_in_range(file, 0, &min_key, &max_key);
-      records=0;
-      for (j++ ; j < k ; j++)
-	records+=key1[j];
-      if ((long) range_records < (long) records*7/10-2 ||
-	  (long) range_records > (long) records*14/10+2)
-      {
-	printf("mi_records_range for key: %d returned %lu; Should be about %lu\n",
-	       i, (ulong) range_records, (ulong) records);
-	goto end;
-      }
-      if (verbose && records)
-      {
-	printf("mi_records_range returned %lu;  Exact is %lu  (diff: %4.2g %%)\n",
-	       (ulong) range_records, (ulong) records,
-	       labs((long) range_records-(long) records)*100.0/records);
-
-      }
-    }
-    }
-
-  if (!silent)
-    printf("- mi_info\n");
-  mi_status(file,&info,HA_STATUS_VARIABLE | HA_STATUS_CONST);
-  if (info.records != write_count-opt_delete || info.deleted > opt_delete + update
-      || info.keys != keys)
-  {
-    puts("Wrong info from mi_info");
-    printf("Got: records: %lu  delete: %lu  i_keys: %d\n",
-	   (ulong) info.records, (ulong) info.deleted, info.keys);
-  }
-  if (verbose)
-  {
-    char buff[80];
-    get_date(buff,3,info.create_time);
-    printf("info: Created %s\n",buff);
-    get_date(buff,3,info.check_time);
-    printf("info: checked %s\n",buff);
-    get_date(buff,3,info.update_time);
-    printf("info: Modified %s\n",buff);
-  }
-
-  mi_panic(HA_PANIC_WRITE);
-  mi_panic(HA_PANIC_READ);
-  if (mi_is_changed(file))
-    puts("Warning: mi_is_changed reported that datafile was changed");
-
-  if (!silent)
-    printf("- mi_extra(CACHE) + mi_rrnd.... + mi_extra(NO_CACHE)\n");
-  if (mi_reset(file) || mi_extra(file,HA_EXTRA_CACHE,0))
-  {
-    if (locking || (!use_blob && !pack_fields))
-    {
-      puts("got error from mi_extra(HA_EXTRA_CACHE)");
-      goto end;
-    }
-  }
-  ant=0;
-  while ((error=mi_rrnd(file,record,HA_OFFSET_ERROR)) != HA_ERR_END_OF_FILE &&
-	 ant < write_count + 10)
-	ant+= error ? 0 : 1;
-  if (ant != write_count-opt_delete)
-  {
-    printf("rrnd with cache: I can only find: %d records of %d\n",
-	   ant,write_count-opt_delete);
-    goto end;
-  }
-  if (mi_extra(file,HA_EXTRA_NO_CACHE,0))
-  {
-    puts("got error from mi_extra(HA_EXTRA_NO_CACHE)");
-    goto end;
-  }
-
-  ant=0;
-  mi_scan_init(file);
-  while ((error=mi_scan(file,record)) != HA_ERR_END_OF_FILE &&
-	 ant < write_count + 10)
-	ant+= error ? 0 : 1;
-  if (ant != write_count-opt_delete)
-  {
-    printf("scan with cache: I can only find: %d records of %d\n",
-	   ant,write_count-opt_delete);
-    goto end;
-  }
-
-  if (testflag == 4) goto end;
-
-  if (!silent)
-    printf("- Removing keys\n");
-  DBUG_PRINT("progpos",("Removing keys"));
-  lastpos = HA_OFFSET_ERROR;
-  /* DBUG_POP(); */
-  mi_reset(file);
-  found_parts=0;
-  while ((error=mi_rrnd(file,read_record,HA_OFFSET_ERROR)) !=
-	 HA_ERR_END_OF_FILE)
-  {
-    info.recpos=mi_position(file);
-    if (lastpos >= info.recpos && lastpos != HA_OFFSET_ERROR)
-    {
-      printf("mi_rrnd didn't advance filepointer; old: %ld, new: %ld\n",
-	     (long) lastpos, (long) info.recpos);
-      goto err;
-    }
-    lastpos=info.recpos;
-    if (error == 0)
-    {
-      if (opt_delete == (uint) remove_count)		/* While testing */
-	goto end;
-      if (mi_rsame(file,read_record,-1))
-      {
-	printf("can't find record %lx\n",(long) info.recpos);
-	goto err;
-      }
-      if (use_blob)
-      {
-	ulong blob_length,pos;
-	uchar *ptr;
-	longget(blob_length,read_record+blob_pos+4);
-	ptr=(uchar*) blob_length;
-	longget(blob_length,read_record+blob_pos);
-	for (pos=0 ; pos < blob_length ; pos++)
-	{
-	  if (ptr[pos] != (uchar) (blob_length+pos))
-	  {
-	    printf("found blob with wrong info at %ld\n",(long) lastpos);
-	    use_blob=0;
-	    break;
-	  }
-	}
-      }
-      if (mi_delete(file,read_record))
-      {
-	printf("can't delete record: %6.6s,  delete_count: %d\n",
-	       read_record, opt_delete);
-	goto err;
-      }
-      opt_delete++;
-    }
-    else
-      found_parts++;
-  }
-  if (my_errno != HA_ERR_END_OF_FILE && my_errno != HA_ERR_RECORD_DELETED)
-    printf("error: %d from mi_rrnd\n",my_errno);
-  if (write_count != opt_delete)
-  {
-    printf("Deleted only %d of %d records (%d parts)\n",opt_delete,write_count,
-	   found_parts);
-    goto err;
-  }
-end:
-  if (mi_close(file))
-    goto err;
-  mi_panic(HA_PANIC_CLOSE);			/* Should close log */
-  if (!silent)
-  {
-    printf("\nFollowing test have been made:\n");
-    printf("Write records: %d\nUpdate records: %d\nSame-key-read: %d\nDelete records: %d\n", write_count,update,dupp_keys,opt_delete);
-    if (rec_pointer_size)
-      printf("Record pointer size:  %d\n",rec_pointer_size);
-    printf("myisam_block_size:    %lu\n", myisam_block_size);
-    if (key_cacheing)
-    {
-      puts("Key cache used");
-      printf("key_cache_block_size: %u\n", key_cache_block_size);
-      if (write_cacheing)
-	puts("Key cache resized");
-    }
-    if (write_cacheing)
-      puts("Write cacheing used");
-    if (write_cacheing)
-      puts("quick mode");
-    if (async_io && locking)
-      puts("Asyncron io with locking used");
-    else if (locking)
-      puts("Locking used");
-    if (use_blob)
-      puts("blobs used");
-    printf("key cache status: \n\
-blocks used:%10lu\n\
-not flushed:%10lu\n\
-w_requests: %10lu\n\
-writes:     %10lu\n\
-r_requests: %10lu\n\
-reads:      %10lu\n",
-           dflt_key_cache->blocks_used,
-           dflt_key_cache->global_blocks_changed,
-           (ulong) dflt_key_cache->global_cache_w_requests,
-           (ulong) dflt_key_cache->global_cache_write,
-           (ulong) dflt_key_cache->global_cache_r_requests,
-           (ulong) dflt_key_cache->global_cache_read);
-  }
-  end_key_cache(dflt_key_cache,1);
-  if (blob_buffer)
-    my_free(blob_buffer,MYF(0));
-  my_end(silent ? MY_CHECK_ERROR : MY_CHECK_ERROR | MY_GIVE_INFO);
-  return(0);
-err:
-  printf("got error: %d when using MyISAM-database\n",my_errno);
-  if (file)
-    VOID(mi_close(file));
-  return(1);
-} /* main */
-
-
-	/* l{ser optioner */
-	/* OBS! intierar endast DEBUG - ingen debuggning h{r ! */
-
-static void get_options(int argc, char **argv)
-{
-  char *pos,*progname;
-
-  progname= argv[0];
-
-  while (--argc >0 && *(pos = *(++argv)) == '-' ) {
-    switch(*++pos) {
-    case 'B':
-      pack_type= HA_BINARY_PACK_KEY;
-      break;
-    case 'b':
-      use_blob=1;
-      break;
-    case 'K':				/* Use key cacheing */
-      key_cacheing=1;
-      if (*++pos)
-	key_cache_size=atol(pos);
-      break;
-    case 'W':				/* Use write cacheing */
-      write_cacheing=1;
-      if (*++pos)
-	my_default_record_cache_size=atoi(pos);
-      break;
-    case 'd':
-      remove_count= atoi(++pos);
-      break;
-    case 'i':
-      if (*++pos)
-	srand(atoi(pos));
-      break;
-    case 'l':
-      use_log=1;
-      break;
-    case 'L':
-      locking=1;
-      break;
-    case 'A':				/* use asyncron io */
-      async_io=1;
-      if (*++pos)
-	my_default_record_cache_size=atoi(pos);
-      break;
-    case 'v':				/* verbose */
-      verbose=1;
-      break;
-    case 'm':				/* records */
-      if ((recant=atoi(++pos)) < 10)
-      {
-	fprintf(stderr,"record count must be >= 10\n");
-	exit(1);
-      }
-      break;
-    case 'e':				/* myisam_block_length */
-      if ((myisam_block_size= atoi(++pos)) < MI_MIN_KEY_BLOCK_LENGTH ||
-	  myisam_block_size > MI_MAX_KEY_BLOCK_LENGTH)
-      {
-	fprintf(stderr,"Wrong myisam_block_length\n");
-	exit(1);
-      }
-      myisam_block_size= my_round_up_to_next_power(myisam_block_size);
-      break;
-    case 'E':				/* myisam_block_length */
-      if ((key_cache_block_size=atoi(++pos)) < MI_MIN_KEY_BLOCK_LENGTH ||
-	  key_cache_block_size > MI_MAX_KEY_BLOCK_LENGTH)
-      {
-	fprintf(stderr,"Wrong key_cache_block_size\n");
-	exit(1);
-      }
-      key_cache_block_size= my_round_up_to_next_power(key_cache_block_size);
-      break;
-    case 'f':
-      if ((first_key=atoi(++pos)) < 0 || first_key >= MYISAM_KEYS)
-	first_key=0;
-      break;
-    case 'k':
-      if ((keys=(uint) atoi(++pos)) < 1 ||
-	   keys > (uint) (MYISAM_KEYS-first_key))
-	keys=MYISAM_KEYS-first_key;
-      break;
-    case 'P':
-      pack_type=0;			/* Don't use DIFF_LENGTH */
-      pack_seg=0;
-      break;
-    case 'R':				/* Length of record pointer */
-      rec_pointer_size=atoi(++pos);
-      if (rec_pointer_size > 7)
-	rec_pointer_size=0;
-      break;
-    case 'S':
-      pack_fields=0;			/* Static-length-records */
-      break;
-    case 's':
-      silent=1;
-      break;
-    case 't':
-      testflag=atoi(++pos);		/* testmod */
-      break;
-    case 'q':
-      opt_quick_mode=1;
-      break;
-    case 'c':
-      create_flag|= HA_CREATE_CHECKSUM;
-      break;
-    case 'D':
-      create_flag|=HA_CREATE_DELAY_KEY_WRITE;
-      break;
-    case '?':
-    case 'I':
-    case 'V':
-      printf("%s  Ver 1.2 for %s at %s\n",progname,SYSTEM_TYPE,MACHINE_TYPE);
-      puts("By Monty, for your professional use\n");
-      printf("Usage: %s [-?AbBcDIKLPRqSsVWltv] [-k#] [-f#] [-m#] [-e#] [-E#] [-t#]\n",
-	     progname);
-      exit(0);
-    case '#':
-      DBUG_PUSH (++pos);
-      break;
-    default:
-      printf("Illegal option: '%c'\n",*pos);
-      break;
-    }
-  }
-  return;
-} /* get options */
-
-	/* Get a random value 0 <= x <= n */
-
-static uint rnd(uint max_value)
-{
-  return (uint) ((rand() & 32767)/32767.0*max_value);
-} /* rnd */
-
-
-	/* Create a variable length record */
-
-static void fix_length(uchar *rec, uint length)
-{
-  bmove(rec+STANDARD_LENGTH,
-	"0123456789012345678901234567890123456789012345678901234567890",
-	length-STANDARD_LENGTH);
-  strfill((char*) rec+length,STANDARD_LENGTH+60-length,' ');
-} /* fix_length */
-
-
-	/* Put maybe a blob in record */
-
-static void put_blob_in_record(uchar *blob_pos, char **blob_buffer)
-{
-  ulong i,length;
-  if (use_blob)
-  {
-    if (rnd(10) == 0)
-    {
-      if (! *blob_buffer &&
-	  !(*blob_buffer=my_malloc((uint) use_blob,MYF(MY_WME))))
-      {
-	use_blob=0;
-	return;
-      }
-      length=rnd(use_blob);
-      for (i=0 ; i < length ; i++)
-	(*blob_buffer)[i]=(char) (length+i);
-      int4store(blob_pos,length);
-      memcpy_fixed(blob_pos+4,(char*) blob_buffer,sizeof(char*));
-    }
-    else
-    {
-      int4store(blob_pos,0);
-    }
-  }
-  return;
-}
-
-
-static void copy_key(MI_INFO *info,uint inx,uchar *rec,uchar *key_buff)
-{
-  HA_KEYSEG *keyseg;
-
-  for (keyseg=info->s->keyinfo[inx].seg ; keyseg->type ; keyseg++)
-  {
-    memcpy(key_buff,rec+keyseg->start,(size_t) keyseg->length);
-    key_buff+=keyseg->length;
-  }
-  return;
-}
-

=== removed file 'storage/myisam/mi_test3.c'
--- storage/myisam/mi_test3.c	2008-07-06 18:04:11 +0000
+++ storage/myisam/mi_test3.c	1970-01-01 00:00:00 +0000
@@ -1,502 +0,0 @@
-/* Copyright (C) 2000-2004 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* Test av locking */
-
-#ifndef __NETWARE__
-
-#include "myisam.h"
-#include <sys/types.h>
-#ifdef HAVE_SYS_WAIT_H
-# include <sys/wait.h>
-#endif
-#ifndef WEXITSTATUS
-# define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
-#endif
-#ifndef WIFEXITED
-# define WIFEXITED(stat_val) (((stat_val) & 255) == 0)
-#endif
-
-
-#if defined(HAVE_LRAND48)
-#define rnd(X) (lrand48() % X)
-#define rnd_init(X) srand48(X)
-#else
-#define rnd(X) (random() % X)
-#define rnd_init(X) srandom(X)
-#endif
-
-
-const char *filename= "test3";
-uint tests=10,forks=10,key_cacheing=0,use_log=0;
-
-static void get_options(int argc, char *argv[]);
-void start_test(int id);
-int test_read(MI_INFO *,int),test_write(MI_INFO *,int,int),
-    test_update(MI_INFO *,int,int),test_rrnd(MI_INFO *,int);
-
-struct record {
-  uchar id[8];
-  uchar nr[4];
-  uchar text[10];
-} record;
-
-
-int main(int argc,char **argv)
-{
-  int status,wait_ret;
-  uint i=0;
-  MI_KEYDEF keyinfo[10];
-  MI_COLUMNDEF recinfo[10];
-  HA_KEYSEG keyseg[10][2];
-  MY_INIT(argv[0]);
-  get_options(argc,argv);
-
-  bzero((char*) keyinfo,sizeof(keyinfo));
-  bzero((char*) recinfo,sizeof(recinfo));
-  bzero((char*) keyseg,sizeof(keyseg));
-  keyinfo[0].seg= &keyseg[0][0];
-  keyinfo[0].seg[0].start=0;
-  keyinfo[0].seg[0].length=8;
-  keyinfo[0].seg[0].type=HA_KEYTYPE_TEXT;
-  keyinfo[0].seg[0].flag=HA_SPACE_PACK;
-  keyinfo[0].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[0].keysegs=1;
-  keyinfo[0].flag = (uint8) HA_PACK_KEY;
-  keyinfo[0].block_length= 0;                   /* Default block length */
-  keyinfo[1].seg= &keyseg[1][0];
-  keyinfo[1].seg[0].start=8;
-  keyinfo[1].seg[0].length=4;		/* Long is always 4 in myisam */
-  keyinfo[1].seg[0].type=HA_KEYTYPE_LONG_INT;
-  keyinfo[1].seg[0].flag=0;
-  keyinfo[1].key_alg=HA_KEY_ALG_BTREE;
-  keyinfo[1].keysegs=1;
-  keyinfo[1].flag =HA_NOSAME;
-  keyinfo[1].block_length= 0;                   /* Default block length */
-
-  recinfo[0].type=0;
-  recinfo[0].length=sizeof(record.id);
-  recinfo[1].type=0;
-  recinfo[1].length=sizeof(record.nr);
-  recinfo[2].type=0;
-  recinfo[2].length=sizeof(record.text);
-
-  puts("- Creating myisam-file");
-  my_delete(filename,MYF(0));		/* Remove old locks under gdb */
-  if (mi_create(filename,2,&keyinfo[0],2,&recinfo[0],0,(MI_UNIQUEDEF*) 0,
-		(MI_CREATE_INFO*) 0,0))
-    exit(1);
-
-  rnd_init(0);
-  printf("- Starting %d processes\n",forks); fflush(stdout);
-  for (i=0 ; i < forks; i++)
-  {
-    if (!fork())
-    {
-      start_test(i+1);
-      sleep(1);
-      return 0;
-    }
-    VOID(rnd(1));
-  }
-
-  for (i=0 ; i < forks ; i++)
-    while ((wait_ret=wait(&status)) && wait_ret == -1);
-  return 0;
-}
-
-
-static void get_options(int argc, char **argv)
-{
-  char *pos,*progname;
-
-  progname= argv[0];
-
-  while (--argc >0 && *(pos = *(++argv)) == '-' ) {
-    switch(*++pos) {
-    case 'l':
-      use_log=1;
-      break;
-    case 'f':
-      forks=atoi(++pos);
-      break;
-    case 't':
-      tests=atoi(++pos);
-      break;
-    case 'K':				/* Use key cacheing */
-      key_cacheing=1;
-      break;
-    case 'A':				/* All flags */
-      use_log=key_cacheing=1;
-      break;
-   case '?':
-    case 'I':
-    case 'V':
-      printf("%s  Ver 1.0 for %s at %s\n",progname,SYSTEM_TYPE,MACHINE_TYPE);
-      puts("By Monty, for your professional use\n");
-      puts("Test av locking with threads\n");
-      printf("Usage: %s [-?lKA] [-f#] [-t#]\n",progname);
-      exit(0);
-    case '#':
-      DBUG_PUSH (++pos);
-      break;
-    default:
-      printf("Illegal option: '%c'\n",*pos);
-      break;
-    }
-  }
-  return;
-}
-
-
-void start_test(int id)
-{
-  uint i;
-  int error,lock_type;
-  MI_ISAMINFO isam_info;
-  MI_INFO *file,*file1,*file2=0,*lock;
-
-  if (use_log)
-    mi_log(1);
-  if (!(file1=mi_open(filename,O_RDWR,HA_OPEN_WAIT_IF_LOCKED)) ||
-      !(file2=mi_open(filename,O_RDWR,HA_OPEN_WAIT_IF_LOCKED)))
-  {
-    fprintf(stderr,"Can't open isam-file: %s\n",filename);
-    exit(1);
-  }
-  if (key_cacheing && rnd(2) == 0)
-    init_key_cache(dflt_key_cache, KEY_CACHE_BLOCK_SIZE, 65536L, 0, 0);
-  printf("Process %d, pid: %d\n",id,getpid()); fflush(stdout);
-
-  for (error=i=0 ; i < tests && !error; i++)
-  {
-    file= (rnd(2) == 1) ? file1 : file2;
-    lock=0 ; lock_type=0;
-    if (rnd(10) == 0)
-    {
-      if (mi_lock_database(lock=(rnd(2) ? file1 : file2),
-			   lock_type=(rnd(2) == 0 ? F_RDLCK : F_WRLCK)))
-      {
-	fprintf(stderr,"%2d: start: Can't lock table %d\n",id,my_errno);
-	error=1;
-	break;
-      }
-    }
-    switch (rnd(4)) {
-    case 0: error=test_read(file,id); break;
-    case 1: error=test_rrnd(file,id); break;
-    case 2: error=test_write(file,id,lock_type); break;
-    case 3: error=test_update(file,id,lock_type); break;
-    }
-    if (lock)
-      mi_lock_database(lock,F_UNLCK);
-  }
-  if (!error)
-  {
-    mi_status(file1,&isam_info,HA_STATUS_VARIABLE);
-    printf("%2d: End of test.  Records:  %ld  Deleted:  %ld\n",
-	   id,(long) isam_info.records, (long) isam_info.deleted);
-    fflush(stdout);
-  }
-
-  mi_close(file1);
-  mi_close(file2);
-  if (use_log)
-    mi_log(0);
-  if (error)
-  {
-    printf("%2d: Aborted\n",id); fflush(stdout);
-    exit(1);
-  }
-}
-
-
-int test_read(MI_INFO *file,int id)
-{
-  uint i,lock,found,next,prev;
-  ulong find;
-
-  lock=0;
-  if (rnd(2) == 0)
-  {
-    lock=1;
-    if (mi_lock_database(file,F_RDLCK))
-    {
-      fprintf(stderr,"%2d: Can't lock table %d\n",id,my_errno);
-      return 1;
-    }
-  }
-
-  found=next=prev=0;
-  for (i=0 ; i < 100 ; i++)
-  {
-    find=rnd(100000);
-    if (!mi_rkey(file,record.id,1,(uchar*) &find, HA_WHOLE_KEY,
-                 HA_READ_KEY_EXACT))
-      found++;
-    else
-    {
-      if (my_errno != HA_ERR_KEY_NOT_FOUND)
-      {
-	fprintf(stderr,"%2d: Got error %d from read in read\n",id,my_errno);
-	return 1;
-      }
-      else if (!mi_rnext(file,record.id,1))
-	next++;
-      else
-      {
-	if (my_errno != HA_ERR_END_OF_FILE)
-	{
-	  fprintf(stderr,"%2d: Got error %d from rnext in read\n",id,my_errno);
-	  return 1;
-	}
-	else if (!mi_rprev(file,record.id,1))
-	  prev++;
-	else
-	{
-	  if (my_errno != HA_ERR_END_OF_FILE)
-	  {
-	    fprintf(stderr,"%2d: Got error %d from rnext in read\n",
-		    id,my_errno);
-	    return 1;
-	  }
-	}
-      }
-    }
-  }
-  if (lock)
-  {
-    if (mi_lock_database(file,F_UNLCK))
-    {
-      fprintf(stderr,"%2d: Can't unlock table\n",id);
-      return 1;
-    }
-  }
-  printf("%2d: read:   found: %5d  next: %5d   prev: %5d\n",
-	 id,found,next,prev);
-  fflush(stdout);
-  return 0;
-}
-
-
-int test_rrnd(MI_INFO *file,int id)
-{
-  uint count,lock;
-
-  lock=0;
-  if (rnd(2) == 0)
-  {
-    lock=1;
-    if (mi_lock_database(file,F_RDLCK))
-    {
-      fprintf(stderr,"%2d: Can't lock table (%d)\n",id,my_errno);
-      mi_close(file);
-      return 1;
-    }
-    if (rnd(2) == 0)
-      mi_extra(file,HA_EXTRA_CACHE,0);
-  }
-
-  count=0;
-  if (mi_rrnd(file,record.id,0L))
-  {
-    if (my_errno == HA_ERR_END_OF_FILE)
-      goto end;
-    fprintf(stderr,"%2d: Can't read first record (%d)\n",id,my_errno);
-    return 1;
-  }
-  for (count=1 ; !mi_rrnd(file,record.id,HA_OFFSET_ERROR) ;count++) ;
-  if (my_errno != HA_ERR_END_OF_FILE)
-  {
-    fprintf(stderr,"%2d: Got error %d from rrnd\n",id,my_errno);
-    return 1;
-  }
-
-end:
-  if (lock)
-  {
-    mi_extra(file,HA_EXTRA_NO_CACHE,0);
-    if (mi_lock_database(file,F_UNLCK))
-    {
-      fprintf(stderr,"%2d: Can't unlock table\n",id);
-      exit(0);
-    }
-  }
-  printf("%2d: rrnd:   %5d\n",id,count); fflush(stdout);
-  return 0;
-}
-
-
-int test_write(MI_INFO *file,int id,int lock_type)
-{
-  uint i,tries,count,lock;
-
-  lock=0;
-  if (rnd(2) == 0 || lock_type == F_RDLCK)
-  {
-    lock=1;
-    if (mi_lock_database(file,F_WRLCK))
-    {
-      if (lock_type == F_RDLCK && my_errno == EDEADLK)
-      {
-	printf("%2d: write:  deadlock\n",id); fflush(stdout);
-	return 0;
-      }
-      fprintf(stderr,"%2d: Can't lock table (%d)\n",id,my_errno);
-      mi_close(file);
-      return 1;
-    }
-    if (rnd(2) == 0)
-      mi_extra(file,HA_EXTRA_WRITE_CACHE,0);
-  }
-
-  sprintf((char*) record.id,"%7d",getpid());
-  strnmov((char*) record.text,"Testing...", sizeof(record.text));
-
-  tries=(uint) rnd(100)+10;
-  for (i=count=0 ; i < tries ; i++)
-  {
-    uint32 tmp=rnd(80000)+20000;
-    int4store(record.nr,tmp);
-    if (!mi_write(file,record.id))
-      count++;
-    else
-    {
-      if (my_errno != HA_ERR_FOUND_DUPP_KEY)
-      {
-	fprintf(stderr,"%2d: Got error %d (errno %d) from write\n",id,my_errno,
-		errno);
-	return 1;
-      }
-    }
-  }
-  if (lock)
-  {
-    mi_extra(file,HA_EXTRA_NO_CACHE,0);
-    if (mi_lock_database(file,F_UNLCK))
-    {
-      fprintf(stderr,"%2d: Can't unlock table\n",id);
-      exit(0);
-    }
-  }
-  printf("%2d: write:  %5d\n",id,count); fflush(stdout);
-  return 0;
-}
-
-
-int test_update(MI_INFO *file,int id,int lock_type)
-{
-  uint i,lock,found,next,prev,update;
-  uint32 tmp;
-  char find[4];
-  struct record new_record;
-
-  lock=0;
-  if (rnd(2) == 0 || lock_type == F_RDLCK)
-  {
-    lock=1;
-    if (mi_lock_database(file,F_WRLCK))
-    {
-      if (lock_type == F_RDLCK && my_errno == EDEADLK)
-      {
-	printf("%2d: write:  deadlock\n",id); fflush(stdout);
-	return 0;
-      }
-      fprintf(stderr,"%2d: Can't lock table (%d)\n",id,my_errno);
-      return 1;
-    }
-  }
-  bzero((char*) &new_record,sizeof(new_record));
-  strmov((char*) new_record.text,"Updated");
-
-  found=next=prev=update=0;
-  for (i=0 ; i < 100 ; i++)
-  {
-    tmp=rnd(100000);
-    int4store(find,tmp);
-    if (!mi_rkey(file,record.id,1,(uchar*) find, HA_WHOLE_KEY,
-                 HA_READ_KEY_EXACT))
-      found++;
-    else
-    {
-      if (my_errno != HA_ERR_KEY_NOT_FOUND)
-      {
-	fprintf(stderr,"%2d: Got error %d from read in update\n",id,my_errno);
-	return 1;
-      }
-      else if (!mi_rnext(file,record.id,1))
-	next++;
-      else
-      {
-	if (my_errno != HA_ERR_END_OF_FILE)
-	{
-	  fprintf(stderr,"%2d: Got error %d from rnext in update\n",
-		  id,my_errno);
-	  return 1;
-	}
-	else if (!mi_rprev(file,record.id,1))
-	  prev++;
-	else
-	{
-	  if (my_errno != HA_ERR_END_OF_FILE)
-	  {
-	    fprintf(stderr,"%2d: Got error %d from rnext in update\n",
-		    id,my_errno);
-	    return 1;
-	  }
-	  continue;
-	}
-      }
-    }
-    memcpy_fixed(new_record.id,record.id,sizeof(record.id));
-    tmp=rnd(20000)+40000;
-    int4store(new_record.nr,tmp);
-    if (!mi_update(file,record.id,new_record.id))
-      update++;
-    else
-    {
-      if (my_errno != HA_ERR_RECORD_CHANGED &&
-	  my_errno != HA_ERR_RECORD_DELETED &&
-	  my_errno != HA_ERR_FOUND_DUPP_KEY)
-      {
-	fprintf(stderr,"%2d: Got error %d from update\n",id,my_errno);
-	return 1;
-      }
-    }
-  }
-  if (lock)
-  {
-    if (mi_lock_database(file,F_UNLCK))
-    {
-      fprintf(stderr,"Can't unlock table,id, error%d\n",my_errno);
-      return 1;
-    }
-  }
-  printf("%2d: update: %5d\n",id,update); fflush(stdout);
-  return 0;
-}
-
-#else /* __NETWARE__ */
-
-#include <stdio.h>
-
-main()
-{
-	fprintf(stderr,"this test has not been ported to NetWare\n");
-	return 0;
-}
-
-#endif /* __NETWARE__ */
-

=== removed file 'storage/myisam/mi_test_all.in'
--- storage/myisam/mi_test_all.in	2008-07-13 21:29:19 +0000
+++ storage/myisam/mi_test_all.in	1970-01-01 00:00:00 +0000
@@ -1,148 +0,0 @@
-#!/bin/sh
-#
-# Execute some simple basic test on MyISAM libary to check if things
-# works at all.
-
-valgrind="valgrind --alignment=8 --leak-check=yes"
-silent="-s"
-
-if test -f mi_test1$MACH ; then suffix=$MACH ; else suffix=""; fi
-./mi_test1$suffix $silent
-./myisamchk$suffix -se test1
-./mi_test1$suffix $silent -N -S
-./myisamchk$suffix -se test1
-./mi_test1$suffix $silent -P --checksum
-./myisamchk$suffix -se test1
-./mi_test1$suffix $silent -P -N -S
-./myisamchk$suffix -se test1
-./mi_test1$suffix $silent -B -N -R2
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -k 480 --unique
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -N -S -R1
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -S
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -S -N --unique
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -S -N --key_length=127 --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -S -N --key_length=128
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -S --key_length=480
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -B
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -B --key_length=64  --unique
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -B -k 480 --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -B -k 480 -N  --unique --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -m
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -m -P --unique --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -m -P --key_length=480 --key_cache
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -m -p
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -w -S --unique
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -w --key_length=64 --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -w -N --key_length=480
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -w -S --key_length=480 --checksum
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -b -N
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -a -b --key_length=480
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent -p -B --key_length=480
-./myisamchk$suffix -sm test1
-
-./mi_test1$suffix $silent --checksum
-./myisamchk$suffix -se test1
-./myisamchk$suffix -rs test1
-./myisamchk$suffix -se test1
-./myisamchk$suffix -rqs test1
-./myisamchk$suffix -se test1
-./myisamchk$suffix -rs --correct-checksum test1
-./myisamchk$suffix -se test1
-./myisamchk$suffix -rqs --correct-checksum test1
-./myisamchk$suffix -se test1
-./myisamchk$suffix -ros --correct-checksum test1
-./myisamchk$suffix -se test1
-./myisamchk$suffix -rqos --correct-checksum test1
-./myisamchk$suffix -se test1
-
-# check of myisampack / myisamchk
-./myisampack$suffix --force -s test1
-# Ignore error for index file
-./myisamchk$suffix -es test1 2>&1 >& /dev/null
-./myisamchk$suffix -rqs test1
-./myisamchk$suffix -es test1
-./myisamchk$suffix -rs test1
-./myisamchk$suffix -es test1
-./myisamchk$suffix -rus test1
-./myisamchk$suffix -es test1
-
-./mi_test1$suffix $silent --checksum -S
-./myisamchk$suffix -se test1
-./myisamchk$suffix -ros test1
-./myisamchk$suffix -rqs test1
-./myisamchk$suffix -se test1
-
-./myisampack$suffix --force -s test1
-./myisamchk$suffix -rqs test1
-./myisamchk$suffix -es test1
-./myisamchk$suffix -rus test1
-./myisamchk$suffix -es test1
-
-./mi_test1$suffix $silent --checksum --unique
-./myisamchk$suffix -se test1
-./mi_test1$suffix $silent --unique -S
-./myisamchk$suffix -se test1
-
-
-./mi_test1$suffix $silent --key_multiple -N -S
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent --key_multiple -a -p --key_length=480
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent --key_multiple -a -B --key_length=480
-./myisamchk$suffix -sm test1
-./mi_test1$suffix $silent --key_multiple -P -S
-./myisamchk$suffix -sm test1
-
-./mi_test2$suffix $silent -L -K -W -P
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -L -K -W -P -A
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -L -K -W -P -S -R1 -m500
-echo "mi_test2$suffix $silent -L -K -R1 -m2000 ;  Should give error 135"
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -L -K -R1 -m2000
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -L -K -P -S -R3 -m50 -b1000000
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -L -B
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -D -B -c
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -m10000 -e8192 -K
-./myisamchk$suffix -sm test2
-./mi_test2$suffix $silent -m10000 -e16384 -E16384 -K -L
-./myisamchk$suffix -sm test2
-
-./mi_test2$suffix $silent -L -K -W -P -m50 -l
-./myisamlog$suffix
-./mi_test2$suffix $silent -L -K -W -P -m50 -l -b100
-./myisamlog$suffix
-time ./mi_test2$suffix $silent
-time ./mi_test2$suffix $silent -K -B
-time ./mi_test2$suffix $silent -L -B
-time ./mi_test2$suffix $silent -L -K -B
-time ./mi_test2$suffix $silent -L -K -W -B
-time ./mi_test2$suffix $silent -L -K -W -S -B
-time ./mi_test2$suffix $silent -D -K -W -S -B

=== removed file 'storage/myisam/mi_test_all.res'
--- storage/myisam/mi_test_all.res	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_test_all.res	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-myisamchk: MyISAM file test1
-myisamchk: warning: Size of indexfile is: 1024          Should be: 2048
-MyISAM-table 'test1' is usable but should be fixed
-mi_test2 -s -L -K -R1 -m2000 ;  Should give error 135
-Error: 135 in write at record: 1105
-got error: 135 when using MyISAM-database
-myisamchk: MyISAM file test2
-myisamchk: warning: Datafile is almost full,      65532 of      65534 used
-MyISAM-table 'test2' is usable but should be fixed
-Commands   Used count    Errors   Recover errors
-open                7         0                0
-write             350         0                0
-update             35         0                0
-delete            350         0                0
-close               7         0                0
-extra              42         0                0
-Total             791         0                0
-Commands   Used count    Errors   Recover errors
-open                8         0                0
-write             400         0                0
-update             40         0                0
-delete            400         0                0
-close               8         0                0
-extra              48         0                0
-Total             904         0                0
-
-real	0m0.221s
-user	0m0.120s
-sys	0m0.100s
-
-real	0m0.222s
-user	0m0.140s
-sys	0m0.084s
-
-real	0m0.232s
-user	0m0.112s
-sys	0m0.120s
-
-real	0m0.163s
-user	0m0.116s
-sys	0m0.036s
-
-real	0m0.159s
-user	0m0.136s
-sys	0m0.020s
-
-real	0m0.147s
-user	0m0.132s
-sys	0m0.016s
-
-real	0m0.211s
-user	0m0.124s
-sys	0m0.088s

=== modified file 'storage/myisam/mi_unique.c'
--- storage/myisam/mi_unique.c	2008-06-25 05:29:13 +0000
+++ storage/myisam/mi_unique.c	2008-07-16 03:26:24 +0000
@@ -24,7 +24,6 @@
   my_off_t lastpos=info->lastpos;
   MI_KEYDEF *key= &info->s->keyinfo[def->key];
   uchar *key_buff=info->lastkey2;
-  DBUG_ENTER("mi_check_unique");
 
   mi_unique_store(record+key->seg->start, unique_hash);
   _mi_make_key(info,def->key,key_buff,record,0);
@@ -37,7 +36,7 @@
   {
     info->page_changed=1;			/* Can't optimize read next */
     info->lastpos= lastpos;
-    DBUG_RETURN(0);				/* No matching rows */
+    return(0);				/* No matching rows */
   }
 
   for (;;)
@@ -50,8 +49,7 @@
       info->dupp_key_pos= info->lastpos;
       info->page_changed=1;			/* Can't optimize read next */
       info->lastpos=lastpos;
-      DBUG_PRINT("info",("Found duplicate"));
-      DBUG_RETURN(1);				/* Found identical  */
+      return(1);				/* Found identical  */
     }
     if (_mi_search_next(info,info->s->keyinfo+def->key, info->lastkey,
 			MI_UNIQUE_HASH_LENGTH, SEARCH_BIGGER,
@@ -60,7 +58,7 @@
     {
       info->page_changed=1;			/* Can't optimize read next */
       info->lastpos=lastpos;
-      DBUG_RETURN(0);				/* end of tree */
+      return(0);				/* end of tree */
     }
   }
 }

=== modified file 'storage/myisam/mi_update.c'
--- storage/myisam/mi_update.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_update.c	2008-07-16 05:44:59 +0000
@@ -27,26 +27,22 @@
   uint64_t changed;
   MYISAM_SHARE *share= info->s;
   ha_checksum old_checksum= 0;
-  DBUG_ENTER("mi_update");
 
-  DBUG_EXECUTE_IF("myisam_pretend_crashed_table_on_usage",
-                  mi_print_error(info->s, HA_ERR_CRASHED);
-                  DBUG_RETURN(my_errno= HA_ERR_CRASHED););
   if (!(info->update & HA_STATE_AKTIV))
   {
-    DBUG_RETURN(my_errno=HA_ERR_KEY_NOT_FOUND);
+    return(my_errno=HA_ERR_KEY_NOT_FOUND);
   }
   if (share->options & HA_OPTION_READ_ONLY_DATA)
   {
-    DBUG_RETURN(my_errno=EACCES);
+    return(my_errno=EACCES);
   }
   if (info->state->key_file_length >= share->base.margin_key_file_length)
   {
-    DBUG_RETURN(my_errno=HA_ERR_INDEX_FILE_FULL);
+    return(my_errno=HA_ERR_INDEX_FILE_FULL);
   }
   pos=info->lastpos;
   if (_mi_readinfo(info,F_WRLCK,1))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
 
   if (share->calc_checksum)
     old_checksum=info->checksum=(*share->calc_checksum)(info,oldrec);
@@ -161,14 +157,12 @@
   VOID(_mi_writeinfo(info, WRITEINFO_UPDATE_KEYFILE));
   if (info->invalidator != 0)
   {
-    DBUG_PRINT("info", ("invalidator... '%s' (update)", info->filename));
     (*info->invalidator)(info->filename);
     info->invalidator=0;
   }
-  DBUG_RETURN(0);
+  return(0);
 
 err:
-  DBUG_PRINT("error",("key: %d  errno: %d",i,my_errno));
   save_errno=my_errno;
   if (changed)
     key_changed|= HA_STATE_CHANGED;
@@ -207,5 +201,5 @@
     mi_print_error(info->s, HA_ERR_CRASHED);
     save_errno=HA_ERR_CRASHED;
   }
-  DBUG_RETURN(my_errno=save_errno);
+  return(my_errno=save_errno);
 } /* mi_update */

=== modified file 'storage/myisam/mi_write.c'
--- storage/myisam/mi_write.c	2008-07-14 22:29:09 +0000
+++ storage/myisam/mi_write.c	2008-07-16 16:52:09 +0000
@@ -47,18 +47,13 @@
   my_off_t filepos;
   uchar *buff;
   my_bool lock_tree= share->concurrent_insert;
-  DBUG_ENTER("mi_write");
-  DBUG_PRINT("enter",("isam: %d  data: %d",info->s->kfile,info->dfile));
 
-  DBUG_EXECUTE_IF("myisam_pretend_crashed_table_on_usage",
-                  mi_print_error(info->s, HA_ERR_CRASHED);
-                  DBUG_RETURN(my_errno= HA_ERR_CRASHED););
   if (share->options & HA_OPTION_READ_ONLY_DATA)
   {
-    DBUG_RETURN(my_errno=EACCES);
+    return(my_errno=EACCES);
   }
   if (_mi_readinfo(info,F_WRLCK,1))
-    DBUG_RETURN(my_errno);
+    return(my_errno);
   filepos= ((share->state.dellink != HA_OFFSET_ERROR &&
              !info->append_insert_at_end) ?
 	    share->state.dellink :
@@ -109,7 +104,6 @@
         {
           if (local_lock_tree)
             rw_unlock(&share->key_root_lock[i]);
-          DBUG_PRINT("error",("Got error: %d on write",my_errno));
           goto err;
         }
       }
@@ -140,7 +134,6 @@
   VOID(_mi_writeinfo(info, WRITEINFO_UPDATE_KEYFILE));
   if (info->invalidator != 0)
   {
-    DBUG_PRINT("info", ("invalidator... '%s' (update)", info->filename));
     (*info->invalidator)(info->filename);
     info->invalidator=0;
   }
@@ -156,7 +149,7 @@
   if (share->is_log_table)
     mi_update_status((void*) info);
 
-  DBUG_RETURN(0);
+  return(0);
 
 err:
   save_errno=my_errno;
@@ -204,7 +197,7 @@
   save_errno=my_errno;
   myisam_log_record(MI_LOG_WRITE,info,record,filepos,my_errno);
   VOID(_mi_writeinfo(info,WRITEINFO_UPDATE_KEYFILE));
-  DBUG_RETURN(my_errno=save_errno);
+  return(my_errno=save_errno);
 } /* mi_write */
 
 
@@ -212,15 +205,13 @@
 
 int _mi_ck_write(MI_INFO *info, uint keynr, uchar *key, uint key_length)
 {
-  DBUG_ENTER("_mi_ck_write");
-
   if (info->bulk_insert && is_tree_inited(&info->bulk_insert[keynr]))
   {
-    DBUG_RETURN(_mi_ck_write_tree(info, keynr, key, key_length));
+    return(_mi_ck_write_tree(info, keynr, key, key_length));
   }
   else
   {
-    DBUG_RETURN(_mi_ck_write_btree(info, keynr, key, key_length));
+    return(_mi_ck_write_btree(info, keynr, key, key_length));
   }
 } /* _mi_ck_write */
 
@@ -236,7 +227,6 @@
   uint comp_flag;
   MI_KEYDEF *keyinfo=info->s->keyinfo+keynr;
   my_off_t  *root=&info->s->state.key_root[keynr];
-  DBUG_ENTER("_mi_ck_write_btree");
 
   if (keyinfo->flag & HA_SORT_ALLOWS_SAME)
     comp_flag=SEARCH_BIGGER;			/* Put after same key */
@@ -251,21 +241,20 @@
 
   error=_mi_ck_real_write_btree(info, keyinfo, key, key_length,
                                 root, comp_flag);
-  DBUG_RETURN(error);
+  return(error);
 } /* _mi_ck_write_btree */
 
 int _mi_ck_real_write_btree(MI_INFO *info, MI_KEYDEF *keyinfo,
     uchar *key, uint key_length, my_off_t *root, uint comp_flag)
 {
   int error;
-  DBUG_ENTER("_mi_ck_real_write_btree");
   /* key_length parameter is used only if comp_flag is SEARCH_FIND */
   if (*root == HA_OFFSET_ERROR ||
       (error=w_search(info, keyinfo, comp_flag, key, key_length,
 		      *root, (uchar *) 0, (uchar*) 0,
 		      (my_off_t) 0, 1)) > 0)
     error=_mi_enlarge_root(info,keyinfo,key,root);
-  DBUG_RETURN(error);
+  return(error);
 } /* _mi_ck_real_write_btree */
 
 
@@ -277,7 +266,6 @@
   uint t_length,nod_flag;
   MI_KEY_PARAM s_temp;
   MYISAM_SHARE *share=info->s;
-  DBUG_ENTER("_mi_enlarge_root");
 
   nod_flag= (*root != HA_OFFSET_ERROR) ?  share->base.key_reflength : 0;
   _mi_kpointer(info,info->buff+2,*root); /* if nod */
@@ -288,8 +276,8 @@
   info->buff_used=info->page_changed=1;		/* info->buff is used */
   if ((*root= _mi_new(info,keyinfo,DFLT_INIT_HITS)) == HA_OFFSET_ERROR ||
       _mi_write_keypage(info,keyinfo,*root,DFLT_INIT_HITS,info->buff))
-    DBUG_RETURN(-1);
-  DBUG_RETURN(0);
+    return(-1);
+  return(0);
 } /* _mi_enlarge_root */
 
 
@@ -311,13 +299,11 @@
   uchar keybuff[MI_MAX_KEY_BUFF];
   my_bool was_last_key;
   my_off_t next_page, dupp_key_pos;
-  DBUG_ENTER("w_search");
-  DBUG_PRINT("enter",("page: %ld", (long) page));
 
   search_key_length= (comp_flag & SEARCH_FIND) ? key_length : USE_WHOLE_KEY;
   if (!(temp_buff= (uchar*) my_alloca((uint) keyinfo->block_length+
 				      MI_MAX_KEY_BUFF*2)))
-    DBUG_RETURN(-1);
+    return(-1);
   if (!_mi_fetch_keypage(info,keyinfo,page,DFLT_INIT_HITS,temp_buff,0))
     goto err;
 
@@ -338,11 +324,11 @@
       info->dupp_key_pos= dupp_key_pos;
       my_afree((uchar*) temp_buff);
       my_errno=HA_ERR_FOUND_DUPP_KEY;
-      DBUG_RETURN(-1);
+      return(-1);
     }
   }
   if (flag == MI_FOUND_WRONG_KEY)
-    DBUG_RETURN(-1);
+    return(-1);
   if (!was_last_key)
     insert_last=0;
   next_page=_mi_kpos(nod_flag,keypos);
@@ -356,11 +342,10 @@
       goto err;
   }
   my_afree((uchar*) temp_buff);
-  DBUG_RETURN(error);
+  return(error);
 err:
   my_afree((uchar*) temp_buff);
-  DBUG_PRINT("exit",("Error: %d",my_errno));
-  DBUG_RETURN (-1);
+  return (-1);
 } /* w_search */
 
 
@@ -398,9 +383,6 @@
   int t_length;
   uchar *endpos, *prev_key;
   MI_KEY_PARAM s_temp;
-  DBUG_ENTER("_mi_insert");
-  DBUG_PRINT("enter",("key_pos: 0x%lx", (long) key_pos));
-  DBUG_EXECUTE("key",_mi_print_key(DBUG_FILE,keyinfo->seg,key,USE_WHOLE_KEY););
 
   nod_flag=mi_test_if_nod(anc_buff);
   a_length=mi_getint(anc_buff);
@@ -410,27 +392,14 @@
 				(key_pos == endpos ? (uchar*) 0 : key_pos),
 				prev_key, prev_key,
 				key,&s_temp);
-#ifndef DBUG_OFF
-  if (key_pos != anc_buff+2+nod_flag && (keyinfo->flag &
-					 (HA_BINARY_PACK_KEY | HA_PACK_KEY)))
-  {
-    DBUG_DUMP("prev_key",(uchar*) key_buff,_mi_keylength(keyinfo,key_buff));
-  }
-  if (keyinfo->flag & HA_PACK_KEY)
-  {
-    DBUG_PRINT("test",("t_length: %d  ref_len: %d",
-		       t_length,s_temp.ref_length));
-    DBUG_PRINT("test",("n_ref_len: %d  n_length: %d  key_pos: 0x%lx",
-		       s_temp.n_ref_length,s_temp.n_length, (long) s_temp.key));
-  }
-#endif
+
   if (t_length > 0)
   {
     if (t_length >= keyinfo->maxlength*2+MAX_POINTER_LENGTH)
     {
       mi_print_error(info->s, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     bmove_upp((uchar*) endpos+t_length,(uchar*) endpos,(uint) (endpos-key_pos));
   }
@@ -440,7 +409,7 @@
     {
       mi_print_error(info->s, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_RETURN(-1);
+      return(-1);
     }
     bmove(key_pos,key_pos-t_length,(uint) (endpos-key_pos)+t_length);
   }
@@ -449,16 +418,16 @@
   mi_putint(anc_buff,a_length,nod_flag);
   if (a_length <= keyinfo->block_length)
   {
-    DBUG_RETURN(0);				/* There is room on page */
+    return(0);				/* There is room on page */
   }
   /* Page is full */
   if (nod_flag)
     insert_last=0;
   if (!(keyinfo->flag & (HA_VAR_LENGTH_KEY | HA_BINARY_PACK_KEY)) &&
       father_buff && !insert_last)
-    DBUG_RETURN(_mi_balance_page(info,keyinfo,key,anc_buff,father_buff,
+    return(_mi_balance_page(info,keyinfo,key,anc_buff,father_buff,
 				 father_key_pos,father_page));
-  DBUG_RETURN(_mi_split_page(info,keyinfo,key,anc_buff,key_buff, insert_last));
+  return(_mi_split_page(info,keyinfo,key,anc_buff,key_buff, insert_last));
 } /* _mi_insert */
 
 
@@ -472,8 +441,6 @@
   uchar *key_pos,*pos, *after_key= NULL;
   my_off_t new_pos;
   MI_KEY_PARAM s_temp;
-  DBUG_ENTER("mi_split_page");
-  DBUG_DUMP("buff",(uchar*) buff,mi_getint(buff));
 
   if (info->s->keyinfo+info->lastinx == keyinfo)
     info->page_changed=1;			/* Info->buff is used */
@@ -486,7 +453,7 @@
     key_pos=_mi_find_half_pos(nod_flag,keyinfo,buff,key_buff, &key_length,
 			      &after_key);
   if (!key_pos)
-    DBUG_RETURN(-1);
+    return(-1);
 
   length=(uint) (key_pos-buff);
   a_length=mi_getint(buff);
@@ -495,19 +462,18 @@
   key_pos=after_key;
   if (nod_flag)
   {
-    DBUG_PRINT("test",("Splitting nod"));
     pos=key_pos-nod_flag;
     memcpy((uchar*) info->buff+2,(uchar*) pos,(size_t) nod_flag);
   }
 
 	/* Move middle item to key and pointer to new page */
   if ((new_pos=_mi_new(info,keyinfo,DFLT_INIT_HITS)) == HA_OFFSET_ERROR)
-    DBUG_RETURN(-1);
+    return(-1);
   _mi_kpointer(info,_mi_move_key(keyinfo,key,key_buff),new_pos);
 
 	/* Store new page */
   if (!(*keyinfo->get_key)(keyinfo,nod_flag,&key_pos,key_buff))
-    DBUG_RETURN(-1);
+    return(-1);
 
   t_length=(*keyinfo->pack_key)(keyinfo,nod_flag,(uchar *) 0,
 				(uchar*) 0, (uchar*) 0,
@@ -519,9 +485,8 @@
   mi_putint(info->buff,length+t_length+key_ref_length,nod_flag);
 
   if (_mi_write_keypage(info,keyinfo,new_pos,DFLT_INIT_HITS,info->buff))
-    DBUG_RETURN(-1);
-  DBUG_DUMP("key",(uchar*) key,_mi_keylength(keyinfo,key));
-  DBUG_RETURN(2);				/* Middle key up */
+    return(-1);
+  return(2);				/* Middle key up */
 } /* _mi_split_page */
 
 
@@ -539,7 +504,6 @@
 {
   uint keys,length,key_ref_length;
   uchar *end,*lastpos;
-  DBUG_ENTER("_mi_find_half_pos");
 
   key_ref_length=2+nod_flag;
   length=mi_getint(page)-key_ref_length;
@@ -554,7 +518,7 @@
     end=page+keys*key_ref_length;
     *after_key=end+key_ref_length;
     memcpy(key,end,key_ref_length);
-    DBUG_RETURN(end);
+    return(end);
   }
 
   end=page+length/2-key_ref_length;		/* This is aprox. half */
@@ -563,13 +527,11 @@
   {
     lastpos=page;
     if (!(length=(*keyinfo->get_key)(keyinfo,nod_flag,&page,key)))
-      DBUG_RETURN(0);
+      return(0);
   } while (page < end);
   *return_key_length=length;
   *after_key=page;
-  DBUG_PRINT("exit",("returns: 0x%lx  page: 0x%lx  half: 0x%lx",
-                     (long) lastpos, (long) page, (long) end));
-  DBUG_RETURN(lastpos);
+  return(lastpos);
 } /* _mi_find_half_pos */
 
 
@@ -580,13 +542,15 @@
 	*/
 
 static uchar *_mi_find_last_pos(MI_KEYDEF *keyinfo, uchar *page,
-                                uchar *key, uint *return_key_length,
-                                uchar **after_key)
+				uchar *key, uint *return_key_length,
+				uchar **after_key)
 {
-  uint keys, length, last_length=0, key_ref_length;
+  uint keys;
+  uint length;
+  uint last_length= 0;
+  uint key_ref_length;
   uchar *end, *lastpos, *prevpos= NULL;
   uchar key_buff[MI_MAX_KEY_BUFF];
-  DBUG_ENTER("_mi_find_last_pos");
 
   key_ref_length=2;
   length=mi_getint(page)-key_ref_length;
@@ -600,7 +564,7 @@
     end=page+keys*length;
     *after_key=end+length;
     memcpy(key,end,length);
-    DBUG_RETURN(end);
+    return(end);
   }
 
   end= page + length - key_ref_length;
@@ -616,14 +580,12 @@
     {
       mi_print_error(keyinfo->share, HA_ERR_CRASHED);
       my_errno=HA_ERR_CRASHED;
-      DBUG_RETURN(0);
+      return(0);
     }
   }
   *return_key_length=last_length;
   *after_key=lastpos;
-  DBUG_PRINT("exit",("returns: 0x%lx  page: 0x%lx  end: 0x%lx",
-                     (long) prevpos,(long) page,(long) end));
-  DBUG_RETURN(prevpos);
+  return(prevpos);
 } /* _mi_find_last_pos */
 
 
@@ -641,7 +603,6 @@
   uchar *pos,*buff,*extra_buff;
   my_off_t next_page,new_pos;
   uchar tmp_part_key[MI_MAX_KEY_BUFF];
-  DBUG_ENTER("_mi_balance_page");
 
   k_length=keyinfo->keylength;
   father_length=mi_getint(father_buff);
@@ -658,7 +619,6 @@
     next_page= _mi_kpos(info->s->base.key_reflength,
 			father_key_pos+father_keylength);
     buff=info->buff;
-    DBUG_PRINT("test",("use right page: %lu", (ulong) next_page));
   }
   else
   {
@@ -667,12 +627,10 @@
     next_page= _mi_kpos(info->s->base.key_reflength,father_key_pos);
 					/* Fix that curr_buff is to left */
     buff=curr_buff; curr_buff=info->buff;
-    DBUG_PRINT("test",("use left page: %lu", (ulong) next_page));
   }					/* father_key_pos ptr to parting key */
 
   if (!_mi_fetch_keypage(info,keyinfo,next_page,DFLT_INIT_HITS,info->buff,0))
     goto err;
-  DBUG_DUMP("next",(uchar*) info->buff,mi_getint(info->buff));
 
 	/* Test if there is room to share keys */
 
@@ -713,7 +671,7 @@
     if (_mi_write_keypage(info,keyinfo,next_page,DFLT_INIT_HITS,info->buff) ||
 	_mi_write_keypage(info,keyinfo,father_page,DFLT_INIT_HITS,father_buff))
       goto err;
-    DBUG_RETURN(0);
+    return(0);
   }
 
 	/* curr_buff[] and buff[] are full, lets split and make new nod */
@@ -724,10 +682,6 @@
     new_left_length-=curr_keylength;
   extra_length=nod_flag+left_length+right_length-
     new_left_length-new_right_length-curr_keylength;
-  DBUG_PRINT("info",("left_length: %d  right_length: %d  new_left_length: %d  new_right_length: %d  extra_length: %d",
-		     left_length, right_length,
-		     new_left_length, new_right_length,
-		     extra_length));
   mi_putint(curr_buff,new_left_length,nod_flag);
   mi_putint(buff,new_right_length,nod_flag);
   mi_putint(extra_buff,extra_length+2,nod_flag);
@@ -760,10 +714,10 @@
                         DFLT_INIT_HITS,extra_buff))
     goto err;
 
-  DBUG_RETURN(1);				/* Middle key up */
+  return(1);				/* Middle key up */
 
 err:
-  DBUG_RETURN(-1);
+  return(-1);
 } /* _mi_balance_page */
 
 /**********************************************************************
@@ -779,13 +733,12 @@
 		      uint key_length)
 {
   int error;
-  DBUG_ENTER("_mi_ck_write_tree");
 
   error= tree_insert(&info->bulk_insert[keynr], key,
          key_length + info->s->rec_reflength,
          info->bulk_insert[keynr].custom_arg) ? 0 : HA_ERR_OUT_OF_MEM ;
 
-  DBUG_RETURN(error);
+  return(error);
 } /* _mi_ck_write_tree */
 
 
@@ -840,10 +793,8 @@
   bulk_insert_param *params;
   uint i, num_keys, total_keylength;
   uint64_t key_map;
-  DBUG_ENTER("_mi_init_bulk_insert");
-  DBUG_PRINT("enter",("cache_size: %lu", cache_size));
 
-  DBUG_ASSERT(!info->bulk_insert &&
+  assert(!info->bulk_insert &&
 	      (!rows || rows >= MI_MIN_ROWS_TO_USE_BULK_INSERT));
 
   mi_clear_all_keys_active(key_map);
@@ -860,7 +811,7 @@
 
   if (num_keys==0 ||
       num_keys * MI_MIN_SIZE_BULK_INSERT_TREE > cache_size)
-    DBUG_RETURN(0);
+    return(0);
 
   if (rows && rows*total_keylength < cache_size)
     cache_size= (ulong)rows;
@@ -872,7 +823,7 @@
                sizeof(bulk_insert_param)*num_keys),MYF(0));
 
   if (!info->bulk_insert)
-    DBUG_RETURN(HA_ERR_OUT_OF_MEM);
+    return(HA_ERR_OUT_OF_MEM);
 
   params=(bulk_insert_param *)(info->bulk_insert+share->base.keys);
   for (i=0 ; i < share->base.keys ; i++)
@@ -892,7 +843,7 @@
      info->bulk_insert[i].root=0;
   }
 
-  DBUG_RETURN(0);
+  return(0);
 }
 
 void mi_flush_bulk_insert(MI_INFO *info, uint inx)

=== modified file 'storage/myisam/my_pread.c'
--- storage/myisam/my_pread.c	2008-07-02 14:35:48 +0000
+++ storage/myisam/my_pread.c	2008-07-16 03:31:58 +0000
@@ -44,10 +44,6 @@
 {
   size_t readbytes;
   int error= 0;
-  DBUG_ENTER("my_pread");
-  DBUG_PRINT("my",("Fd: %d  Seek: %lu  Buffer: 0x%lx  Count: %u  MyFlags: %d",
-		   Filedes, (ulong) offset, (long) Buffer, (uint) Count,
-                   MyFlags));
   for (;;)
   {
     errno=0;					/* Linux doesn't reset this */
@@ -55,12 +51,8 @@
       my_errno= errno ? errno : -1;
     if (error || readbytes != Count)
     {
-      DBUG_PRINT("warning",("Read only %d bytes off %u from %d, errno: %d",
-                            (int) readbytes, (uint) Count,Filedes,my_errno));
       if ((readbytes == 0 || readbytes == (size_t) -1) && errno == EINTR)
       {
-        DBUG_PRINT("debug", ("my_pread() was interrupted and returned %d",
-                             (int) readbytes));
         continue;                              /* Interrupted */
       }
       if (MyFlags & (MY_WME | MY_FAE | MY_FNABP))
@@ -73,11 +65,11 @@
 		   my_filename(Filedes),my_errno);
       }
       if (readbytes == (size_t) -1 || (MyFlags & (MY_FNABP | MY_NABP)))
-	DBUG_RETURN(MY_FILE_ERROR);		/* Return with error */
+	return(MY_FILE_ERROR);		/* Return with error */
     }
     if (MyFlags & (MY_NABP | MY_FNABP))
-      DBUG_RETURN(0);				/* Read went ok; Return 0 */
-    DBUG_RETURN(readbytes);			/* purecov: inspected */
+      return(0);				/* Read went ok; Return 0 */
+    return(readbytes);			/* purecov: inspected */
   }
 } /* my_pread */
 
@@ -108,10 +100,6 @@
 {
   size_t writenbytes, written;
   uint errors;
-  DBUG_ENTER("my_pwrite");
-  DBUG_PRINT("my",("Fd: %d  Seek: %lu  Buffer: 0x%lx  Count: %u  MyFlags: %d",
-		   Filedes, (ulong) offset, (long) Buffer, (uint) Count,
-                   MyFlags));
   errors= 0;
   written= 0;
 
@@ -127,7 +115,6 @@
       Count-=writenbytes;
       offset+=writenbytes;
     }
-    DBUG_PRINT("error",("Write only %u bytes", (uint) writenbytes));
 #ifndef NO_BACKGROUND
     if (my_thread_var->abort)
       MyFlags&= ~ MY_WAIT_IF_FULL;		/* End if aborted by user */
@@ -150,13 +137,12 @@
 	my_error(EE_WRITE, MYF(ME_BELL | ME_WAITTANG),
 		 my_filename(Filedes),my_errno);
       }
-      DBUG_RETURN(MY_FILE_ERROR);		/* Error on read */
+      return(MY_FILE_ERROR);		/* Error on read */
     }
     else
       break;					/* Return bytes written */
   }
-  DBUG_EXECUTE_IF("check", my_seek(Filedes, -1, SEEK_SET, MYF(0)););
   if (MyFlags & (MY_NABP | MY_FNABP))
-    DBUG_RETURN(0);			/* Want only errors */
-  DBUG_RETURN(writenbytes+written); /* purecov: inspected */
+    return(0);			/* Want only errors */
+  return(writenbytes+written); /* purecov: inspected */
 } /* my_pwrite */

=== modified file 'storage/myisam/myisamchk.c'
--- storage/myisam/myisamchk.c	2008-07-15 19:53:56 +0000
+++ storage/myisam/myisamchk.c	2008-07-16 05:44:59 +0000
@@ -177,11 +177,6 @@
   {"correct-checksum", OPT_CORRECT_CHECKSUM,
    "Correct checksum information for table.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
-#ifndef DBUG_OFF
-  {"debug", '#',
-   "Output debug log. Often this is 'd:t:o,filename'.",
-   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
-#endif
   {"description", 'd',
    "Prints some information about table.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
@@ -346,10 +341,6 @@
   puts("Used without options all tables on the command will be checked for errors");
   printf("Usage: %s [OPTIONS] tables[.MYI]\n", my_progname_short);
   printf("\nGlobal options:\n");
-#ifndef DBUG_OFF
-  printf("\
-  -#, --debug=...     Output debug log. Often this is 'd:t:o,filename'.\n");
-#endif
   printf("\
   -?, --help          Display this help and exit.\n\
   -O, --set-variable var=option.\n\
@@ -657,16 +648,6 @@
     else
       check_param.testflag|= T_UPDATE_STATE;
     break;
-  case '#':
-    if (argument == disabled_my_option)
-    {
-      DBUG_POP();
-    }
-    else
-    {
-      DBUG_PUSH(argument ? argument : "d:t:o,/tmp/myisamchk.trace");
-    }
-    break;
   case 'V':
     print_version();
     exit(0);
@@ -787,7 +768,6 @@
   char llbuff[22],llbuff2[22];
   my_bool state_updated=0;
   MYISAM_SHARE *share;
-  DBUG_ENTER("myisamchk");
 
   param->out_flag=error=param->warning_printed=param->error_printed=
     recreate=0;
@@ -837,7 +817,7 @@
 		  my_errno,filename);
       break;
     }
-    DBUG_RETURN(1);
+    return(1);
   }
   share=info->s;
   share->options&= ~HA_OPTION_READ_ONLY_DATA; /* We are modifing it */
@@ -884,9 +864,9 @@
       {
 	mi_check_print_error(param,"%d when closing MyISAM-table '%s'",
 			     my_errno,filename);
-	DBUG_RETURN(1);
+	return(1);
       }
-      DBUG_RETURN(0);
+      return(0);
     }
   }
   if ((param->testflag & (T_REP_ANY | T_STATISTICS |
@@ -1116,7 +1096,7 @@
   if (mi_close(info))
   {
     mi_check_print_error(param,"%d when closing MyISAM-table '%s'",my_errno,filename);
-    DBUG_RETURN(1);
+    return(1);
   }
   if (error == 0)
   {
@@ -1153,7 +1133,7 @@
     VOID(fprintf(stderr, "MyISAM-table '%s' is usable but should be fixed\n",
 		 filename));
   VOID(fflush(stderr));
-  DBUG_RETURN(error);
+  return(error);
 } /* myisamchk */
 
 
@@ -1169,7 +1149,6 @@
   enum en_fieldtype type;
   MYISAM_SHARE *share=info->s;
   char llbuff[22],llbuff2[22];
-  DBUG_ENTER("describe");
 
   printf("\nMyISAM file:         %s\n",name);
   fputs("Record format:       ",stdout);
@@ -1240,7 +1219,7 @@
   printf("Data records:        %13s  Deleted blocks:     %13s\n",
 	 llstr(info->state->records,llbuff),llstr(info->state->del,llbuff2));
   if (param->testflag & T_SILENT)
-    DBUG_VOID_RETURN;				/* This is enough */
+    return;				/* This is enough */
 
   if (param->testflag & T_VERBOSE)
   {
@@ -1418,7 +1397,7 @@
       start+=share->rec[field].length;
     }
   }
-  DBUG_VOID_RETURN;
+  return;
 } /* describe */
 
 
@@ -1440,7 +1419,6 @@
   char llbuff[22],llbuff2[22];
   SORT_INFO sort_info;
   MI_SORT_PARAM sort_param;
-  DBUG_ENTER("sort_records");
 
   bzero((char*)&sort_info,sizeof(sort_info));
   bzero((char*)&sort_param,sizeof(sort_param));
@@ -1457,20 +1435,20 @@
 			   "Can't sort table '%s' on key %d;  No such key",
 		name,sort_key+1);
     param->error_printed=0;
-    DBUG_RETURN(0);				/* Nothing to do */
+    return(0);				/* Nothing to do */
   }
   if (keyinfo->flag & HA_FULLTEXT)
   {
     mi_check_print_warning(param,"Can't sort table '%s' on FULLTEXT key %d",
 			   name,sort_key+1);
     param->error_printed=0;
-    DBUG_RETURN(0);				/* Nothing to do */
+    return(0);				/* Nothing to do */
   }
   if (share->data_file_type == COMPRESSED_RECORD)
   {
     mi_check_print_warning(param,"Can't sort read-only table '%s'", name);
     param->error_printed=0;
-    DBUG_RETURN(0);				/* Nothing to do */
+    return(0);				/* Nothing to do */
   }
   if (!(param->testflag & T_SILENT))
   {
@@ -1481,7 +1459,7 @@
 	     llstr(info->state->del,llbuff2));
   }
   if (share->state.key_root[sort_key] == HA_OFFSET_ERROR)
-    DBUG_RETURN(0);				/* Nothing to do */
+    return(0);				/* Nothing to do */
 
   init_key_cache(dflt_key_cache, opt_key_cache_block_size, param->use_buffers,
                  0, 0);
@@ -1599,7 +1577,7 @@
   my_free(sort_info.buff,MYF(MY_ALLOW_ZERO_PTR));
   sort_info.buff=0;
   share->state.sortkey=sort_key;
-  DBUG_RETURN(flush_blocks(param, share->key_cache, share->kfile) |
+  return(flush_blocks(param, share->key_cache, share->kfile) |
 	      got_error);
 } /* sort_records */
 
@@ -1618,7 +1596,6 @@
   char llbuff[22];
   SORT_INFO *sort_info= sort_param->sort_info;
   MI_CHECK *param=sort_info->param;
-  DBUG_ENTER("sort_record_index");
 
   nod_flag=mi_test_if_nod(buff);
   temp_buff=0;
@@ -1628,7 +1605,7 @@
     if (!(temp_buff=(uchar*) my_alloca((uint) keyinfo->block_length)))
     {
       mi_check_print_error(param,"Not Enough memory");
-      DBUG_RETURN(-1);
+      return(-1);
     }
   }
   used_length=mi_getint(buff);
@@ -1686,11 +1663,11 @@
   }
   if (temp_buff)
     my_afree((uchar*) temp_buff);
-  DBUG_RETURN(0);
+  return(0);
 err:
   if (temp_buff)
     my_afree((uchar*) temp_buff);
-  DBUG_RETURN(1);
+  return(1);
 } /* sort_record_index */
 
 
@@ -1727,7 +1704,6 @@
 void mi_check_print_warning(MI_CHECK *param, const char *fmt,...)
 {
   va_list args;
-  DBUG_ENTER("mi_check_print_warning");
 
   fflush(stdout);
   if (!param->warning_printed && !param->error_printed)
@@ -1744,7 +1720,7 @@
   VOID(fputc('\n',stderr));
   fflush(stderr);
   va_end(args);
-  DBUG_VOID_RETURN;
+  return;
 }
 
 /* VARARGS */
@@ -1752,8 +1728,6 @@
 void mi_check_print_error(MI_CHECK *param, const char *fmt,...)
 {
   va_list args;
-  DBUG_ENTER("mi_check_print_error");
-  DBUG_PRINT("enter",("format: %s",fmt));
 
   fflush(stdout);
   if (!param->warning_printed && !param->error_printed)
@@ -1769,6 +1743,6 @@
   VOID(fputc('\n',stderr));
   fflush(stderr);
   va_end(args);
-  DBUG_VOID_RETURN;
+  return;
 }
 

=== modified file 'storage/myisam/myisamdef.h'
--- storage/myisam/myisamdef.h	2008-07-14 04:46:28 +0000
+++ storage/myisam/myisamdef.h	2008-07-16 16:52:09 +0000
@@ -376,32 +376,24 @@
 #define READING_NEXT	1
 #define READING_HEADER	2
 
+
 #define mi_getint(x)	((uint) mi_uint2korr(x) & 32767)
 #define mi_putint(x,y,nod) { uint16 boh=(nod ? (uint16) 32768 : 0) + (uint16) (y);\
 			  mi_int2store(x,boh); }
 #define mi_test_if_nod(x) (x[0] & 128 ? info->s->base.key_reflength : 0)
 #define mi_report_crashed(A, B) _mi_report_crashed((A), (B), __FILE__, __LINE__)
 #define mi_mark_crashed(x) do{(x)->s->state.changed|= STATE_CRASHED; \
-                              DBUG_PRINT("error", ("Marked table crashed")); \
                               mi_report_crashed((x), 0); \
                            }while(0)
 #define mi_mark_crashed_on_repair(x) do{(x)->s->state.changed|= \
                                         STATE_CRASHED|STATE_CRASHED_ON_REPAIR; \
                                         (x)->update|= HA_STATE_CHANGED; \
-                                        DBUG_PRINT("error", \
-                                                   ("Marked table crashed")); \
                                      }while(0)
 #define mi_is_crashed(x) ((x)->s->state.changed & STATE_CRASHED)
 #define mi_is_crashed_on_repair(x) ((x)->s->state.changed & STATE_CRASHED_ON_REPAIR)
 #define mi_print_error(SHARE, ERRNO)                     \
         mi_report_error((ERRNO), (SHARE)->index_file_name)
 
-C_MODE_START
-void _mi_report_crashed(MI_INFO *file __attribute__((unused)),
-                        const char *message __attribute__((unused)),
-                        const char *sfile __attribute__((unused)),
-                        uint sline __attribute__((unused)));
-C_MODE_END
 /* Functions to store length of space packed keys, VARCHAR or BLOB keys */
 
 #define store_key_length(key,length) \
@@ -779,8 +771,14 @@
 
 /* Needed for handler */
 void mi_disable_non_unique_index(MI_INFO *info, ha_rows rows);
+void _mi_report_crashed(MI_INFO *file __attribute__((unused)),
+                        const char *message __attribute__((unused)),
+                        const char *sfile __attribute__((unused)),
+                        uint sline __attribute__((unused)));
+
 #ifdef __cplusplus
 }
 #endif
 
+
 #endif

=== modified file 'storage/myisam/myisamlog.c'
--- storage/myisam/myisamlog.c	2008-07-06 18:04:11 +0000
+++ storage/myisam/myisamlog.c	2008-07-16 03:31:15 +0000
@@ -144,10 +144,6 @@
     {
       version=0;
       switch((option=*pos)) {
-      case '#':
-	DBUG_PUSH (++pos);
-	pos=" ";				/* Skip rest of arg */
-	break;
       case 'c':
 	if (! *++pos)
 	{
@@ -264,7 +260,6 @@
 	puts("         -o \"offset\"         -p # \"remove # components from path\"");
 	puts("         -r \"recover\"        -R \"file recordposition\"");
 	puts("         -u \"update\"         -v \"verbose\"   -w \"write file\"");
-	puts("         -D \"myisam compiled with DBUG\"   -P \"processes\"");
 	puts("\nOne can give a second and a third '-v' for more verbose.");
 	puts("Normaly one does a update (-u).");
 	puts("If a recover is done all writes and all possibly updates and deletes is done\nand errors are only counted.");
@@ -314,17 +309,16 @@
   enum ha_extra_function extra_command;
   TREE tree;
   struct file_info file_info,*curr_file_info;
-  DBUG_ENTER("examine_log");
 
   if ((file=my_open(file_name,O_RDONLY,MYF(MY_WME))) < 0)
-    DBUG_RETURN(1);
+    return(1);
   write_file=0;
   if (write_filename)
   {
     if (!(write_file=my_fopen(write_filename,O_WRONLY,MYF(MY_WME))))
     {
       my_close(file,MYF(0));
-      DBUG_RETURN(1);
+      return(1);
     }
   }
 
@@ -653,8 +647,8 @@
   VOID(end_io_cache(&cache));
   VOID(my_close(file,MYF(0)));
   if (write_file && my_fclose(write_file,MYF(MY_WME)))
-    DBUG_RETURN(1);
-  DBUG_RETURN(0);
+    return(1);
+  return(0);
 
  err:
   fflush(stdout);
@@ -674,14 +668,12 @@
   VOID(my_close(file,MYF(0)));
   if (write_file)
     VOID(my_fclose(write_file,MYF(MY_WME)));
-  DBUG_RETURN(1);
+  return(1);
 }
 
 
 static int read_string(IO_CACHE *file, register uchar* *to, register uint length)
 {
-  DBUG_ENTER("read_string");
-
   if (*to)
     my_free((uchar*) *to,MYF(0));
   if (!(*to= (uchar*) my_malloc(length+1,MYF(MY_WME))) ||
@@ -690,10 +682,10 @@
     if (*to)
       my_free(*to,MYF(0));
     *to= 0;
-    DBUG_RETURN(1);
+    return(1);
   }
   *((char*) *to+length)= '\0';
-  DBUG_RETURN (0);
+  return (0);
 }				/* read_string */
 
 
@@ -753,7 +745,6 @@
 
 static void file_info_free(struct file_info *fileinfo)
 {
-  DBUG_ENTER("file_info_free");
   if (update)
   {
     if (!fileinfo->closed)
@@ -763,7 +754,7 @@
   }
   my_free(fileinfo->name,MYF(0));
   my_free(fileinfo->show_name,MYF(0));
-  DBUG_VOID_RETURN;
+  return;
 }
 
 

=== modified file 'storage/myisam/myisampack.c'
--- storage/myisam/myisampack.c	2008-07-15 06:45:16 +0000
+++ storage/myisam/myisampack.c	2008-07-16 05:44:59 +0000
@@ -170,11 +170,6 @@
 static int mrg_close(PACK_MRG_INFO *mrg);
 static int mrg_rrnd(PACK_MRG_INFO *info,uchar *buf);
 static void mrg_reset(PACK_MRG_INFO *mrg);
-#if !defined(DBUG_OFF)
-static void fakebigcodes(HUFF_COUNTS *huff_counts, HUFF_COUNTS *end_count);
-static int fakecmp(my_off_t **count1, my_off_t **count2);
-#endif
-
 
 static int error_on_write=0,test_only=0,verbose=0,silent=0,
 	   write_loop=0,force_pack=0, isamchk_neaded=0;
@@ -351,9 +346,6 @@
     verbose++; /* Allow for selecting the level of verbosity. */
     silent= 0;
     break;
-  case '#':
-    DBUG_PUSH(argument ? argument : "d:t:o");
-    break;
   case 'V':
     print_version();
     exit(0);
@@ -397,14 +389,13 @@
 {
   MI_INFO *isam_file;
   MYISAM_SHARE *share;
-  DBUG_ENTER("open_isam_file");
 
   if (!(isam_file=mi_open(name,mode,
 			  (opt_wait ? HA_OPEN_WAIT_IF_LOCKED :
 			   HA_OPEN_ABORT_IF_LOCKED))))
   {
     VOID(fprintf(stderr, "%s gave error %d on open\n", name, my_errno));
-    DBUG_RETURN(0);
+    return(0);
   }
   share=isam_file->s;
   if (share->options & HA_OPTION_COMPRESS_RECORD && !join_table)
@@ -413,7 +404,7 @@
     {
       VOID(fprintf(stderr, "%s is already compressed\n", name));
       VOID(mi_close(isam_file));
-      DBUG_RETURN(0);
+      return(0);
     }
     if (verbose)
       puts("Recompressing already compressed table");
@@ -425,10 +416,10 @@
   {
     VOID(fprintf(stderr, "%s is too small to compress\n", name));
     VOID(mi_close(isam_file));
-    DBUG_RETURN(0);
+    return(0);
   }
   VOID(mi_lock_database(isam_file,F_WRLCK));
-  DBUG_RETURN(isam_file);
+  return(isam_file);
 }
 
 
@@ -490,7 +481,6 @@
   my_off_t old_length,new_length,tot_elements;
   HUFF_COUNTS *huff_counts;
   HUFF_TREE *huff_trees;
-  DBUG_ENTER("compress");
 
   isam_file=mrg->file[0];			/* Take this as an example */
   share=isam_file->s;
@@ -542,9 +532,6 @@
   for (i=0 ; i < mrg->count ; i++)
     mrg->records+=mrg->file[i]->s->state.state.records;
 
-  DBUG_PRINT("info", ("Compressing %s: (%lu records)",
-                      result_table ? new_name : org_name,
-                      (ulong) mrg->records));
   if (write_loop || verbose)
   {
     VOID(printf("Compressing %s: (%lu records)\n",
@@ -557,7 +544,6 @@
   /*
     Read the whole data file(s) for statistics.
   */
-  DBUG_PRINT("info", ("- Calculating statistics"));
   if (write_loop || verbose)
     VOID(printf("- Calculating statistics\n"));
   if (get_statistic(mrg,huff_counts))
@@ -633,7 +619,6 @@
   /*
     Compress the source file into the target file.
   */
-  DBUG_PRINT("info", ("- Compressing file"));
   if (write_loop || verbose)
     VOID(printf("- Compressing file\n"));
   error=compress_isam_file(mrg,huff_counts);
@@ -657,10 +642,6 @@
   end_file_buffer();
 
   /* Display statistics. */
-  DBUG_PRINT("info", ("Min record length: %6d  Max length: %6d  "
-                      "Mean total length: %6ld\n",
-                      mrg->min_pack_length, mrg->max_pack_length,
-                      (ulong) (mrg->records ? (new_length/mrg->records) : 0)));
   if (verbose && mrg->records)
     VOID(printf("Min record length: %6d   Max length: %6d   "
                 "Mean total length: %6ld\n", mrg->min_pack_length,
@@ -729,7 +710,7 @@
   {
     VOID(fprintf(stderr, "Aborting: %s is not compressed\n", org_name));
     VOID(my_delete(new_name,MYF(MY_WME)));
-    DBUG_RETURN(-1);
+    return(-1);
   }
   if (write_loop || verbose)
   {
@@ -740,7 +721,7 @@
     else
       puts("Empty file saved in compressed format");
   }
-  DBUG_RETURN(0);
+  return(0);
 
  err:
   free_counts_and_tree_and_queue(huff_trees,trees,huff_counts,fields);
@@ -750,7 +731,7 @@
     VOID(my_close(join_isam_file,MYF(0)));
   mrg_close(mrg);
   VOID(fprintf(stderr, "Aborted: %s is not compressed\n", org_name));
-  DBUG_RETURN(-1);
+  return(-1);
 }
 
 	/* Init a huff_count-struct for each field and init it */
@@ -841,7 +822,6 @@
   my_bool static_row_size;
   HUFF_COUNTS *count,*end_count;
   TREE_ELEMENT *element;
-  DBUG_ENTER("get_statistic");
 
   reclength=mrg->file[0]->s->base.reclength;
   record=(uchar*) my_alloca(reclength);
@@ -1083,14 +1063,6 @@
     VOID(fflush(stdout));
   }
 
-  /*
-    If --debug=d,fakebigcodes is set, fake the counts to get big Huffman
-    codes.
-  */
-  DBUG_EXECUTE_IF("fakebigcodes", fakebigcodes(huff_counts, end_count););
-
-  DBUG_PRINT("info", ("Found the following number of incidents "
-                      "of the byte codes:"));
   if (verbose >= 2)
     VOID(printf("Found the following number of incidents "
                 "of the byte codes:\n"));
@@ -1100,14 +1072,10 @@
     my_off_t  total_count;
     char      llbuf[32];
 
-    DBUG_PRINT("info", ("column: %3u", (uint) (count - huff_counts + 1)));
     if (verbose >= 2)
       VOID(printf("column: %3u\n", (uint) (count - huff_counts + 1)));
     if (count->tree_buff)
     {
-      DBUG_PRINT("info", ("number of distinct values: %u",
-                          (uint) ((count->tree_pos - count->tree_buff) /
-                                  count->field_length)));
       if (verbose >= 2)
         VOID(printf("number of distinct values: %u\n",
                     (uint) ((count->tree_pos - count->tree_buff) /
@@ -1119,15 +1087,11 @@
       if (count->counts[idx])
       {
         total_count+= count->counts[idx];
-        DBUG_PRINT("info", ("counts[0x%02x]: %12s", idx,
-                            llstr((int64_t) count->counts[idx], llbuf)));
         if (verbose >= 2)
           VOID(printf("counts[0x%02x]: %12s\n", idx,
                       llstr((int64_t) count->counts[idx], llbuf)));
       }
     }
-    DBUG_PRINT("info", ("total:        %12s", llstr((int64_t) total_count,
-                                                    llbuf)));
     if ((verbose >= 2) && total_count)
     {
       VOID(printf("total:        %12s\n",
@@ -1138,7 +1102,7 @@
   mrg->records=record_count;
   mrg->max_blob_length=max_blob_length;
   my_afree((uchar*) record);
-  DBUG_RETURN(error != HA_ERR_END_OF_FILE);
+  return(error != HA_ERR_END_OF_FILE);
 }
 
 static int compare_huff_elements(void *not_used __attribute__((unused)),
@@ -1156,7 +1120,6 @@
 {
   uint space_fields,fill_zero_fields,field_count[(int) FIELD_enum_val_count];
   my_off_t old_length,new_length,length;
-  DBUG_ENTER("check_counts");
 
   bzero((uchar*) field_count,sizeof(field_count));
   space_fields=fill_zero_fields=0;
@@ -1310,8 +1273,6 @@
     {
       HUFF_TREE tree;
 
-      DBUG_EXECUTE_IF("forceintervall",
-                      huff_counts->bytes_packed= ~ (my_off_t) 0;);
       tree.element_buffer=0;
       if (!make_huff_tree(&tree,huff_counts) &&
 	  tree.bytes_packed+tree.tree_pack_length < huff_counts->bytes_packed)
@@ -1337,16 +1298,6 @@
       fill_zero_fields++;
     field_count[huff_counts->field_type]++;
   }
-  DBUG_PRINT("info", ("normal:    %3d  empty-space:     %3d  "
-                      "empty-zero:       %3d  empty-fill: %3d",
-                      field_count[FIELD_NORMAL],space_fields,
-                      field_count[FIELD_SKIP_ZERO],fill_zero_fields));
-  DBUG_PRINT("info", ("pre-space: %3d  end-space:       %3d  "
-                      "intervall-fields: %3d  zero:       %3d",
-                      field_count[FIELD_SKIP_PRESPACE],
-                      field_count[FIELD_SKIP_ENDSPACE],
-                      field_count[FIELD_INTERVALL],
-                      field_count[FIELD_ZERO]));
   if (verbose)
     VOID(printf("\nnormal:    %3d  empty-space:     %3d  "
                 "empty-zero:       %3d  empty-fill: %3d\n"
@@ -1358,7 +1309,7 @@
                 field_count[FIELD_SKIP_ENDSPACE],
                 field_count[FIELD_INTERVALL],
                 field_count[FIELD_ZERO]));
-  DBUG_VOID_RETURN;
+  return;
 }
 
 	/* Test if we can use space-compression and empty-field-compression */
@@ -1435,11 +1386,10 @@
 {
   uint tree;
   HUFF_TREE *huff_tree;
-  DBUG_ENTER("make_huff_trees");
 
   if (!(huff_tree=(HUFF_TREE*) my_malloc(trees*sizeof(HUFF_TREE),
 					 MYF(MY_WME | MY_ZEROFILL))))
-    DBUG_RETURN(0);
+    return(0);
 
   for (tree=0 ; tree < trees ; tree++)
   {
@@ -1448,10 +1398,10 @@
       while (tree--)
 	my_free((uchar*) huff_tree[tree].element_buffer,MYF(0));
       my_free((uchar*) huff_tree,MYF(0));
-      DBUG_RETURN(0);
+      return(0);
     }
   }
-  DBUG_RETURN(huff_tree);
+  return(huff_tree);
 }
 
 /*
@@ -1728,7 +1678,6 @@
   uint i,found,bits_packed,first,last;
   my_off_t bytes_packed;
   HUFF_ELEMENT element_buffer[256];
-  DBUG_ENTER("calc_packed_length");
 
   /* 
     WARNING: We use a small hack for efficiency: Instead of placing
@@ -1760,7 +1709,7 @@
     }
   }
   if (!found)
-    DBUG_RETURN(0);			/* Empty tree */
+    return(0);			/* Empty tree */
   /*
     If there is only a single byte value in this field in all records,
     add a second element with zero incidence. This is required to enter
@@ -1825,7 +1774,7 @@
     queue.root[1]=(uchar*) new_huff_el;
     queue_replaced(&queue);
   }
-  DBUG_RETURN(bytes_packed+(bits_packed+7)/8);
+  return(bytes_packed+(bits_packed+7)/8);
 }
 
 
@@ -1869,8 +1818,6 @@
       }
     }
   }
-  DBUG_PRINT("info", ("Original trees:  %d  After join: %d",
-                      trees, tree_number));
   if (verbose)
     VOID(printf("Original trees:  %d  After join: %d\n", trees, tree_number));
   return tree_number;			/* Return trees left */
@@ -1958,7 +1905,7 @@
   char *ptr= digits;
   uint idx= bits;
 
-  DBUG_ASSERT(idx < sizeof(digits));
+  assert(idx < sizeof(digits));
   while (idx)
     *(ptr++)= '0' + ((char) (value >> (--idx)) & (char) 1);
   *ptr= '\0';
@@ -1987,7 +1934,7 @@
   char *ptr= digits;
   uint idx= 2 * sizeof(value); /* Two hex digits per byte. */
 
-  DBUG_ASSERT(idx < sizeof(digits));
+  assert(idx < sizeof(digits));
   while (idx)
   {
     if ((*(ptr++)= '0' + ((char) (value >> (4 * (--idx))) & (char) 0xf)) > '9')
@@ -2031,24 +1978,6 @@
   uint huff_tree_bits;
   huff_tree_bits=max_bit(trees ? trees-1 : 0);
 
-  DBUG_PRINT("info", (" "));
-  DBUG_PRINT("info", ("column types:"));
-  DBUG_PRINT("info", ("FIELD_NORMAL          0"));
-  DBUG_PRINT("info", ("FIELD_SKIP_ENDSPACE   1"));
-  DBUG_PRINT("info", ("FIELD_SKIP_PRESPACE   2"));
-  DBUG_PRINT("info", ("FIELD_SKIP_ZERO       3"));
-  DBUG_PRINT("info", ("FIELD_BLOB            4"));
-  DBUG_PRINT("info", ("FIELD_CONSTANT        5"));
-  DBUG_PRINT("info", ("FIELD_INTERVALL       6"));
-  DBUG_PRINT("info", ("FIELD_ZERO            7"));
-  DBUG_PRINT("info", ("FIELD_VARCHAR         8"));
-  DBUG_PRINT("info", ("FIELD_CHECK           9"));
-  DBUG_PRINT("info", (" "));
-  DBUG_PRINT("info", ("pack type as a set of flags:"));
-  DBUG_PRINT("info", ("PACK_TYPE_SELECTED      1"));
-  DBUG_PRINT("info", ("PACK_TYPE_SPACE_FIELDS  2"));
-  DBUG_PRINT("info", ("PACK_TYPE_ZERO_FILL     4"));
-  DBUG_PRINT("info", (" "));
   if (verbose >= 2)
   {
     VOID(printf("\n"));
@@ -2079,11 +2008,6 @@
     else
       write_bits(counts->length_bits,5);
     write_bits((uint64_t) counts->tree->tree_number - 1, huff_tree_bits);
-    DBUG_PRINT("info", ("column: %3u  type: %2u  pack: %2u  zero: %4u  "
-                        "lbits: %2u  tree: %2u  length: %4u",
-                        i , counts->field_type, counts->pack_type,
-                        counts->max_zero_fill, counts->length_bits,
-                        counts->tree->tree_number, counts->field_length));
     if (verbose >= 2)
       VOID(printf("column: %3u  type: %2u  pack: %2u  zero: %4u  lbits: %2u  "
                   "tree: %2u  length: %4u\n", i , counts->field_type,
@@ -2121,7 +2045,6 @@
     return 0;
   }
 
-  DBUG_PRINT("info", (" "));
   if (verbose >= 2)
     VOID(printf("\n"));
   tree_no= 0;
@@ -2132,7 +2055,6 @@
     if (huff_tree->tree_number == 0)
       continue;				/* Deleted tree */
     tree_no++;
-    DBUG_PRINT("info", (" "));
     if (verbose >= 3)
       VOID(printf("\n"));
     /* Count the total number of elements (byte codes or column values). */
@@ -2159,11 +2081,6 @@
       return 0;
     }
 
-    DBUG_PRINT("info", ("pos: %lu  elements: %u  tree-elements: %lu  "
-                        "char_bits: %u\n",
-                        (ulong) (file_buffer.pos - file_buffer.buffer),
-                        huff_tree->elements, (ulong) (offset - packed_tree),
-                        huff_tree->char_bits));
     if (!huff_tree->counts->tree_buff)
     {
       /* We do a byte compression on this column. Mark with bit 0. */
@@ -2186,12 +2103,6 @@
       write_bits(huff_tree->offset_bits,5);
       intervall_length+=int_length;
     }
-    DBUG_PRINT("info", ("tree: %2u  elements: %4u  char_bits: %2u  "
-                        "offset_bits: %2u  %s: %5u  codelen: %2u",
-                        tree_no, huff_tree->elements, huff_tree->char_bits,
-                        huff_tree->offset_bits, huff_tree->counts->tree_buff ?
-                        "bufflen" : "min_chr", huff_tree->counts->tree_buff ?
-                        int_length : huff_tree->min_chr, huff_tree->height));
     if (verbose >= 2)
       VOID(printf("tree: %2u  elements: %4u  char_bits: %2u  offset_bits: %2u  "
                   "%s: %5u  codelen: %2u\n", tree_no, huff_tree->elements,
@@ -2217,10 +2128,6 @@
 		   huff_tree->offset_bits+1);
       else
 	write_bits(packed_tree[i]-huff_tree->min_chr,huff_tree->char_bits+1);
-      DBUG_PRINT("info", ("tree[0x%04x]: %s0x%04x",
-                          i, (packed_tree[i] & IS_OFFSET) ?
-                          " -> " : "", (packed_tree[i] & IS_OFFSET) ?
-                          packed_tree[i] - IS_OFFSET + i : packed_tree[i]));
       if (verbose >= 3)
         VOID(printf("tree[0x%04x]: %s0x%04x\n",
                     i, (packed_tree[i] & IS_OFFSET) ? " -> " : "",
@@ -2242,10 +2149,6 @@
 
       if (! (len= huff_tree->code_len[i]))
         continue;
-      DBUG_PRINT("info", ("code[0x%04x]:      0x%s  bits: %2u  bin: %s", i,
-                          hexdigits(huff_tree->code[i]), huff_tree->code_len[i],
-                          bindigits(huff_tree->code[i],
-                                    huff_tree->code_len[i])));
       if (verbose >= 3)
         VOID(printf("code[0x%04x]:      0x%s  bits: %2u  bin: %s\n", i,
                     hexdigits(huff_tree->code[i]), huff_tree->code_len[i],
@@ -2255,9 +2158,6 @@
       code= 0;
       bits= 0;
       idx= 0;
-      DBUG_EXECUTE_IF("forcechkerr1", len--;);
-      DBUG_EXECUTE_IF("forcechkerr2", bits= 8 * sizeof(code););
-      DBUG_EXECUTE_IF("forcechkerr3", idx= length;);
       for (;;)
       {
         if (! len)
@@ -2296,7 +2196,6 @@
       if (errors)
         break;
 
-      DBUG_EXECUTE_IF("forcechkerr4", packed_tree[idx]++;);
       if (packed_tree[idx] != i)
       {
         VOID(fflush(stdout));
@@ -2315,8 +2214,6 @@
       for (i=0 ; i < int_length ; i++)
       {
  	write_bits((uint64_t) (uchar) huff_tree->counts->tree_buff[i], 8);
-        DBUG_PRINT("info", ("column_values[0x%04x]: 0x%02x",
-                            i, (uchar) huff_tree->counts->tree_buff[i]));
         if (verbose >= 3)
           VOID(printf("column_values[0x%04x]: 0x%02x\n",
                       i, (uchar) huff_tree->counts->tree_buff[i]));
@@ -2324,7 +2221,6 @@
     }
     flush_bits();
   }
-  DBUG_PRINT("info", (" "));
   if (verbose >= 2)
     VOID(printf("\n"));
   my_afree((uchar*) packed_tree);
@@ -2413,7 +2309,6 @@
   HUFF_TREE *tree;
   MI_INFO *isam_file=mrg->file[0];
   uint pack_version= (uint) isam_file->s->pack.version;
-  DBUG_ENTER("compress_isam_file");
 
   /* Allocate a buffer for the records (excluding blobs). */
   if (!(record=(uchar*) my_alloca(isam_file->s->base.reclength)))
@@ -2458,7 +2353,6 @@
                     calc_pack_length(pack_version, mrg->max_blob_length) : 0;
   max_pack_length=pack_ref_length+pack_blob_length;
 
-  DBUG_PRINT("fields", ("==="));
   mrg_reset(mrg);
   while ((error=mrg_rrnd(mrg,record)) != HA_ERR_END_OF_FILE)
   {
@@ -2474,29 +2368,16 @@
 	end_pos=start_pos+(field_length=count->field_length);
 	tree=count->tree;
 
-        DBUG_PRINT("fields", ("column: %3lu  type: %2u  pack: %2u  zero: %4u  "
-                              "lbits: %2u  tree: %2u  length: %4u",
-                              (ulong) (count - huff_counts + 1),
-                              count->field_type,
-                              count->pack_type, count->max_zero_fill,
-                              count->length_bits, count->tree->tree_number,
-                              count->field_length));
-
         /* Check if the column contains spaces only. */
 	if (count->pack_type & PACK_TYPE_SPACE_FIELDS)
 	{
 	  for (pos=start_pos ; *pos == ' ' && pos < end_pos; pos++) ;
 	  if (pos == end_pos)
 	  {
-            DBUG_PRINT("fields",
-                       ("PACK_TYPE_SPACE_FIELDS spaces only, bits:  1"));
-            DBUG_PRINT("fields", ("---"));
 	    write_bits(1,1);
 	    start_pos=end_pos;
 	    continue;
 	  }
-          DBUG_PRINT("fields",
-                     ("PACK_TYPE_SPACE_FIELDS not only spaces, bits:  1"));
 	  write_bits(0,1);
 	}
 	end_pos-=count->max_zero_fill;
@@ -2506,26 +2387,15 @@
 	case FIELD_SKIP_ZERO:
 	  if (!memcmp((uchar*) start_pos,zero_string,field_length))
 	  {
-            DBUG_PRINT("fields", ("FIELD_SKIP_ZERO zeroes only, bits:  1"));
 	    write_bits(1,1);
 	    start_pos=end_pos;
 	    break;
 	  }
-          DBUG_PRINT("fields", ("FIELD_SKIP_ZERO not only zeroes, bits:  1"));
 	  write_bits(0,1);
 	  /* Fall through */
 	case FIELD_NORMAL:
-          DBUG_PRINT("fields", ("FIELD_NORMAL %lu bytes",
-                                (ulong) (end_pos - start_pos)));
 	  for ( ; start_pos < end_pos ; start_pos++)
           {
-            DBUG_PRINT("fields",
-                       ("value: 0x%02x  code: 0x%s  bits: %2u  bin: %s",
-                        (uchar) *start_pos,
-                        hexdigits(tree->code[(uchar) *start_pos]),
-                        (uint) tree->code_len[(uchar) *start_pos],
-                        bindigits(tree->code[(uchar) *start_pos],
-                                  (uint) tree->code_len[(uchar) *start_pos])));
 	    write_bits(tree->code[(uchar) *start_pos],
 		       (uint) tree->code_len[(uchar) *start_pos]);
           }
@@ -2537,42 +2407,22 @@
 	  {
 	    if (length > count->min_space)
 	    {
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_ENDSPACE more than min_space, bits:  1"));
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_ENDSPACE skip %lu/%u bytes, bits: %2u",
-                          length, field_length, count->length_bits));
 	      write_bits(1,1);
 	      write_bits(length,count->length_bits);
 	    }
 	    else
 	    {
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_ENDSPACE not more than min_space, "
-                          "bits:  1"));
 	      write_bits(0,1);
 	      pos=end_pos;
 	    }
 	  }
 	  else
           {
-            DBUG_PRINT("fields",
-                       ("FIELD_SKIP_ENDSPACE skip %lu/%u bytes, bits: %2u",
-                        length, field_length, count->length_bits));
 	    write_bits(length,count->length_bits);
           }
           /* Encode all significant bytes. */
-          DBUG_PRINT("fields", ("FIELD_SKIP_ENDSPACE %lu bytes",
-                                (ulong) (pos - start_pos)));
 	  for ( ; start_pos < pos ; start_pos++)
           {
-            DBUG_PRINT("fields",
-                       ("value: 0x%02x  code: 0x%s  bits: %2u  bin: %s",
-                        (uchar) *start_pos,
-                        hexdigits(tree->code[(uchar) *start_pos]),
-                        (uint) tree->code_len[(uchar) *start_pos],
-                        bindigits(tree->code[(uchar) *start_pos],
-                                  (uint) tree->code_len[(uchar) *start_pos])));
 	    write_bits(tree->code[(uchar) *start_pos],
 		       (uint) tree->code_len[(uchar) *start_pos]);
           }
@@ -2585,42 +2435,22 @@
 	  {
 	    if (length > count->min_space)
 	    {
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_PRESPACE more than min_space, bits:  1"));
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_PRESPACE skip %lu/%u bytes, bits: %2u",
-                          length, field_length, count->length_bits));
 	      write_bits(1,1);
 	      write_bits(length,count->length_bits);
 	    }
 	    else
 	    {
-              DBUG_PRINT("fields",
-                         ("FIELD_SKIP_PRESPACE not more than min_space, "
-                          "bits:  1"));
 	      pos=start_pos;
 	      write_bits(0,1);
 	    }
 	  }
 	  else
           {
-            DBUG_PRINT("fields",
-                       ("FIELD_SKIP_PRESPACE skip %lu/%u bytes, bits: %2u",
-                        length, field_length, count->length_bits));
 	    write_bits(length,count->length_bits);
           }
           /* Encode all significant bytes. */
-          DBUG_PRINT("fields", ("FIELD_SKIP_PRESPACE %lu bytes",
-                                (ulong) (end_pos - start_pos)));
 	  for (start_pos=pos ; start_pos < end_pos ; start_pos++)
           {
-            DBUG_PRINT("fields",
-                       ("value: 0x%02x  code: 0x%s  bits: %2u  bin: %s",
-                        (uchar) *start_pos,
-                        hexdigits(tree->code[(uchar) *start_pos]),
-                        (uint) tree->code_len[(uchar) *start_pos],
-                        bindigits(tree->code[(uchar) *start_pos],
-                                  (uint) tree->code_len[(uchar) *start_pos])));
 	    write_bits(tree->code[(uchar) *start_pos],
 		       (uint) tree->code_len[(uchar) *start_pos]);
           }
@@ -2628,7 +2458,6 @@
 	case FIELD_CONSTANT:
 	case FIELD_ZERO:
 	case FIELD_CHECK:
-          DBUG_PRINT("fields", ("FIELD_CONSTANT/ZERO/CHECK"));
 	  start_pos=end_pos;
 	  break;
 	case FIELD_INTERVALL:
@@ -2636,10 +2465,6 @@
 	  pos=(uchar*) tree_search(&count->int_tree, start_pos,
 				  count->int_tree.custom_arg);
 	  intervall=(uint) (pos - count->tree_buff)/field_length;
-          DBUG_PRINT("fields", ("FIELD_INTERVALL"));
-          DBUG_PRINT("fields", ("index: %4u code: 0x%s  bits: %2u",
-                                intervall, hexdigits(tree->code[intervall]),
-                                (uint) tree->code_len[intervall]));
 	  write_bits(tree->code[intervall],(uint) tree->code_len[intervall]);
 	  start_pos=end_pos;
 	  break;
@@ -2651,17 +2476,13 @@
           /* Empty blobs are encoded with a single 1 bit. */
 	  if (!blob_length)
 	  {
-            DBUG_PRINT("fields", ("FIELD_BLOB empty, bits:  1"));
             write_bits(1,1);
 	  }
 	  else
 	  {
 	    uchar *blob,*blob_end;
-            DBUG_PRINT("fields", ("FIELD_BLOB not empty, bits:  1"));
 	    write_bits(0,1);
             /* Write the blob length. */
-            DBUG_PRINT("fields", ("FIELD_BLOB %lu bytes, bits: %2u",
-                                  blob_length, count->length_bits));
 	    write_bits(blob_length,count->length_bits);
 	    memcpy_fixed(&blob,end_pos-portable_sizeof_char_ptr,
 			 sizeof(char*));
@@ -2669,12 +2490,6 @@
             /* Encode the blob bytes. */
 	    for ( ; blob < blob_end ; blob++)
             {
-              DBUG_PRINT("fields",
-                         ("value: 0x%02x  code: 0x%s  bits: %2u  bin: %s",
-                          (uchar) *blob, hexdigits(tree->code[(uchar) *blob]),
-                          (uint) tree->code_len[(uchar) *blob],
-                          bindigits(tree->code[(uchar) *start_pos],
-                                    (uint)tree->code_len[(uchar) *start_pos])));
 	      write_bits(tree->code[(uchar) *blob],
 			 (uint) tree->code_len[(uchar) *blob]);
             }
@@ -2692,28 +2507,17 @@
           /* Empty varchar are encoded with a single 1 bit. */
 	  if (!col_length)
 	  {
-            DBUG_PRINT("fields", ("FIELD_VARCHAR empty, bits:  1"));
 	    write_bits(1,1);			/* Empty varchar */
 	  }
 	  else
 	  {
 	    uchar *end= start_pos + var_pack_length + col_length;
-            DBUG_PRINT("fields", ("FIELD_VARCHAR not empty, bits:  1"));
 	    write_bits(0,1);
             /* Write the varchar length. */
-            DBUG_PRINT("fields", ("FIELD_VARCHAR %lu bytes, bits: %2u",
-                                  col_length, count->length_bits));
 	    write_bits(col_length,count->length_bits);
             /* Encode the varchar bytes. */
 	    for (start_pos+= var_pack_length ; start_pos < end ; start_pos++)
             {
-              DBUG_PRINT("fields",
-                         ("value: 0x%02x  code: 0x%s  bits: %2u  bin: %s",
-                          (uchar) *start_pos,
-                          hexdigits(tree->code[(uchar) *start_pos]),
-                          (uint) tree->code_len[(uchar) *start_pos],
-                          bindigits(tree->code[(uchar) *start_pos],
-                                    (uint)tree->code_len[(uchar) *start_pos])));
 	      write_bits(tree->code[(uchar) *start_pos],
 			 (uint) tree->code_len[(uchar) *start_pos]);
             }
@@ -2726,7 +2530,6 @@
 	  abort();				/* Impossible */
 	}
 	start_pos+=count->max_zero_fill;
-        DBUG_PRINT("fields", ("---"));
       }
       flush_bits();
       length=(ulong) ((uchar*) file_buffer.pos - record_pos) - max_pack_length;
@@ -2734,11 +2537,6 @@
       if (pack_blob_length)
 	pack_length+= save_pack_length(pack_version, record_pos + pack_length,
 	                               tot_blob_length);
-      DBUG_PRINT("fields", ("record: %lu  length: %lu  blob-length: %lu  "
-                            "length-bytes: %lu", (ulong) record_count, length,
-                            tot_blob_length, pack_length));
-      DBUG_PRINT("fields", ("==="));
-
       /* Correct file buffer if the header was smaller */
       if (pack_length != max_pack_length)
       {
@@ -2773,7 +2571,7 @@
   mrg->ref_length=max_pack_length;
   mrg->min_pack_length=max_record_length ? min_record_length : 0;
   mrg->max_pack_length=max_record_length;
-  DBUG_RETURN(error || error_on_write || flush_buffer(~(ulong) 0));
+  return(error || error_on_write || flush_buffer(~(ulong) 0));
 }
 
 
@@ -2870,7 +2668,7 @@
 
 static void write_bits(register uint64_t value, register uint bits)
 {
-  DBUG_ASSERT(((bits < 8 * sizeof(value)) && ! (value >> bits)) ||
+  assert(((bits < 8 * sizeof(value)) && ! (value >> bits)) ||
               (bits == 8 * sizeof(value)));
 
   if ((file_buffer.bits-= (int) bits) >= 0)
@@ -2936,7 +2734,6 @@
   MYISAM_SHARE *share=isam_file->s;
   uint options=mi_uint2korr(share->state.header.options);
   uint key;
-  DBUG_ENTER("save_state");
 
   options|= HA_OPTION_COMPRESS_RECORD | HA_OPTION_READ_ONLY_DATA;
   mi_int2store(share->state.header.options,options);
@@ -2973,7 +2770,7 @@
   (void)ftruncate(share->kfile, share->base.keystart);
   if (share->base.keys)
     isamchk_neaded=1;
-  DBUG_RETURN(mi_state_info_write(share->kfile,&share->state,1+2));
+  return(mi_state_info_write(share->kfile,&share->state,1+2));
 }
 
 
@@ -2983,7 +2780,6 @@
   MI_STATE_INFO state;
   MI_INFO *isam_file=mrg->file[0];
   uint options;
-  DBUG_ENTER("save_state_mrg");
 
   state= isam_file->s->state;
   options= (mi_uint2korr(state.header.options) | HA_OPTION_COMPRESS_RECORD |
@@ -3006,7 +2802,7 @@
   if (isam_file->s->base.keys)
     isamchk_neaded=1;
   state.changed=STATE_CHANGED | STATE_NOT_ANALYZED; /* Force check of table */
-  DBUG_RETURN (mi_state_info_write(file,&state,1+2));
+  return (mi_state_info_write(file,&state,1+2));
 }
 
 
@@ -3070,129 +2866,3 @@
     my_free((uchar*) mrg->file,MYF(0));
   return error;
 }
-
-
-#if !defined(DBUG_OFF)
-/*
-  Fake the counts to get big Huffman codes.
-
-  SYNOPSIS
-    fakebigcodes()
-    huff_counts                 A pointer to the counts array.
-    end_count                   A pointer past the counts array.
-
-  DESCRIPTION
-
-    Huffman coding works by removing the two least frequent values from
-    the list of values and add a new value with the sum of their
-    incidences in a loop until only one value is left. Every time a
-    value is reused for a new value, it gets one more bit for its
-    encoding. Hence, the least frequent values get the longest codes.
-
-    To get a maximum code length for a value, two of the values must
-    have an incidence of 1. As their sum is 2, the next infrequent value
-    must have at least an incidence of 2, then 4, 8, 16 and so on. This
-    means that one needs 2**n bytes (values) for a code length of n
-    bits. However, using more distinct values forces the use of longer
-    codes, or reaching the code length with less total bytes (values).
-
-    To get 64(32)-bit codes, I sort the counts by decreasing incidence.
-    I assign counts of 1 to the two most frequent values, a count of 2
-    for the next one, then 4, 8, and so on until 2**64-1(2**30-1). All
-    the remaining values get 1. That way every possible byte has an
-    assigned code, though not all codes are used if not all byte values
-    are present in the column.
-
-    This strategy would work with distinct column values too, but
-    requires that at least 64(32) values are present. To make things
-    easier here, I cancel all distinct column values and force byte
-    compression for all columns.
-
-  RETURN
-    void
-*/
-
-static void fakebigcodes(HUFF_COUNTS *huff_counts, HUFF_COUNTS *end_count)
-{
-  HUFF_COUNTS   *count;
-  my_off_t      *cur_count_p;
-  my_off_t      *end_count_p;
-  my_off_t      **cur_sort_p;
-  my_off_t      **end_sort_p;
-  my_off_t      *sort_counts[256];
-  my_off_t      total;
-  DBUG_ENTER("fakebigcodes");
-
-  for (count= huff_counts; count < end_count; count++)
-  {
-    /*
-      Remove distinct column values.
-    */
-    if (huff_counts->tree_buff)
-    {
-      my_free((uchar*) huff_counts->tree_buff, MYF(0));
-      delete_tree(&huff_counts->int_tree);
-      huff_counts->tree_buff= NULL;
-      DBUG_PRINT("fakebigcodes", ("freed distinct column values"));
-    }
-
-    /*
-      Sort counts by decreasing incidence.
-    */
-    cur_count_p= count->counts;
-    end_count_p= cur_count_p + 256;
-    cur_sort_p= sort_counts;
-    while (cur_count_p < end_count_p)
-      *(cur_sort_p++)= cur_count_p++;
-    (void) my_qsort(sort_counts, 256, sizeof(my_off_t*), (qsort_cmp) fakecmp);
-
-    /*
-      Assign faked counts.
-    */
-    cur_sort_p= sort_counts;
-#if SIZEOF_LONG_LONG > 4
-    end_sort_p= sort_counts + 8 * sizeof(uint64_t) - 1;
-#else
-    end_sort_p= sort_counts + 8 * sizeof(uint64_t) - 2;
-#endif
-    /* Most frequent value gets a faked count of 1. */
-    **(cur_sort_p++)= 1;
-    total= 1;
-    while (cur_sort_p < end_sort_p)
-    {
-      **(cur_sort_p++)= total;
-      total<<= 1;
-    }
-    /* Set the last value. */
-    **(cur_sort_p++)= --total;
-    /*
-      Set the remaining counts.
-    */
-    end_sort_p= sort_counts + 256;
-    while (cur_sort_p < end_sort_p)
-      **(cur_sort_p++)= 1;
-  }
-  DBUG_VOID_RETURN;
-}
-
-
-/*
-  Compare two counts for reverse sorting.
-
-  SYNOPSIS
-    fakecmp()
-    count1              One count.
-    count2              Another count.
-
-  RETURN
-    1                   count1  < count2
-    0                   count1 == count2
-    -1                  count1 >  count2
-*/
-
-static int fakecmp(my_off_t **count1, my_off_t **count2)
-{
-  return ((**count1 < **count2) ? 1 :
-          (**count1 > **count2) ? -1 : 0);
-}
-#endif

=== modified file 'storage/myisam/plug.in'
--- storage/myisam/plug.in	2008-07-13 21:29:19 +0000
+++ storage/myisam/plug.in	2008-07-16 19:27:24 +0000
@@ -4,6 +4,3 @@
 MYSQL_PLUGIN_STATIC(myisam,     [libmyisam.la])
 MYSQL_PLUGIN_MANDATORY(myisam)  dnl Default
 MYSQL_PLUGIN_DEPENDS_ON_MYSQL_INTERNALS(myisam, [ha_myisam.cc])
-MYSQL_PLUGIN_ACTIONS(myisam,[
-  AC_CONFIG_FILES(storage/myisam/mi_test_all)
-])

=== modified file 'storage/myisam/sort.c'
--- storage/myisam/sort.c	2008-07-15 06:45:16 +0000
+++ storage/myisam/sort.c	2008-07-16 05:44:59 +0000
@@ -104,8 +104,6 @@
   ha_rows records;
   uchar **sort_keys;
   IO_CACHE tempfile, tempfile_for_exceptions;
-  DBUG_ENTER("_create_index_by_sort");
-  DBUG_PRINT("enter",("sort_length: %d", info->key_length));
 
   if (info->keyinfo->flag & HA_VAR_LENGTH_KEY)
   {
@@ -243,7 +241,7 @@
   close_cached_file(&tempfile);
   close_cached_file(&tempfile_for_exceptions);
 
-  DBUG_RETURN(error ? -1 : 0);
+  return(error ? -1 : 0);
 } /* _create_index_by_sort */
 
 
@@ -256,7 +254,6 @@
 {
   int error;
   uint idx;
-  DBUG_ENTER("find_all_keys");
 
   idx=error=0;
   sort_keys[0]=(uchar*) (sort_keys+keys);
@@ -266,7 +263,7 @@
     if (info->real_key_length > info->key_length)
     {
       if (write_key(info,sort_keys[idx],tempfile_for_exceptions))
-        DBUG_RETURN(HA_POS_ERROR);		/* purecov: inspected */
+        return(HA_POS_ERROR);		/* purecov: inspected */
       continue;
     }
 
@@ -274,7 +271,7 @@
     {
       if (info->write_keys(info,sort_keys,idx-1,(BUFFPEK *)alloc_dynamic(buffpek),
 		     tempfile))
-      DBUG_RETURN(HA_POS_ERROR);		/* purecov: inspected */
+      return(HA_POS_ERROR);		/* purecov: inspected */
 
       sort_keys[0]=(uchar*) (sort_keys+keys);
       memcpy(sort_keys[0],sort_keys[idx-1],(size_t) info->key_length);
@@ -283,18 +280,18 @@
     sort_keys[idx]=sort_keys[idx-1]+info->key_length;
   }
   if (error > 0)
-    DBUG_RETURN(HA_POS_ERROR);		/* Aborted by get_key */ /* purecov: inspected */
+    return(HA_POS_ERROR);		/* Aborted by get_key */ /* purecov: inspected */
   if (buffpek->elements)
   {
     if (info->write_keys(info,sort_keys,idx,(BUFFPEK *)alloc_dynamic(buffpek),
 		   tempfile))
-      DBUG_RETURN(HA_POS_ERROR);		/* purecov: inspected */
+      return(HA_POS_ERROR);		/* purecov: inspected */
     *maxbuffer=buffpek->elements-1;
   }
   else
     *maxbuffer=0;
 
-  DBUG_RETURN((*maxbuffer)*(keys-1)+idx);
+  return((*maxbuffer)*(keys-1)+idx);
 } /* find_all_keys */
 
 
@@ -313,9 +310,7 @@
   if (my_thread_init())
     goto err;
 
-  { /* Add extra block since DBUG_ENTER declare variables */
-    DBUG_ENTER("thr_find_all_keys");
-    DBUG_PRINT("enter", ("master: %d", sort_param->master));
+  { 
     if (sort_param->sort_info->got_error)
       goto err;
 
@@ -398,7 +393,6 @@
     idx= error= 0;
     sort_keys[0]= (uchar*) (sort_keys+keys);
 
-    DBUG_PRINT("info", ("reading keys"));
     while (!(error= sort_param->sort_info->got_error) &&
            !(error= (*sort_param->key_read)(sort_param, sort_keys[idx])))
     {
@@ -439,7 +433,6 @@
     goto ok;
 
 err:
-    DBUG_PRINT("error", ("got some error"));
     sort_param->sort_info->got_error= 1; /* no need to protect with a mutex */
     if (sort_keys)
       my_free((uchar*) sort_keys,MYF(0));
@@ -466,7 +459,6 @@
     if (!--sort_param->sort_info->threads_running)
       pthread_cond_signal(&sort_param->sort_info->cond);
     pthread_mutex_unlock(&sort_param->sort_info->mutex);
-    DBUG_PRINT("exit", ("======== ending thread ========"));
   }
   my_thread_end();
   return NULL;
@@ -485,7 +477,6 @@
   MYISAM_SHARE *share=info->s;
   MI_SORT_PARAM *sinfo;
   uchar *mergebuf=0;
-  DBUG_ENTER("thr_write_keys");
 
   for (i= 0, sinfo= sort_param ;
        i < sort_info->total_keys ;
@@ -622,7 +613,7 @@
     }
   }
   my_free((uchar*) mergebuf,MYF(MY_ALLOW_ZERO_PTR));
-  DBUG_RETURN(got_error);
+  return(got_error);
 }
 
         /* Write all keys in memory to file for later merge */
@@ -632,14 +623,13 @@
 {
   uchar **end;
   uint sort_length=info->key_length;
-  DBUG_ENTER("write_keys");
 
   my_qsort2((uchar*) sort_keys,count,sizeof(uchar*),(qsort2_cmp) info->key_cmp,
             info);
   if (!my_b_inited(tempfile) &&
       open_cached_file(tempfile, my_tmpdir(info->tmpdir), "ST",
                        DISK_BUFFER_SIZE, info->sort_info->param->myf_rw))
-    DBUG_RETURN(1); /* purecov: inspected */
+    return(1); /* purecov: inspected */
 
   buffpek->file_pos=my_b_tell(tempfile);
   buffpek->count=count;
@@ -647,9 +637,9 @@
   for (end=sort_keys+count ; sort_keys != end ; sort_keys++)
   {
     if (my_b_write(tempfile,(uchar*) *sort_keys,(uint) sort_length))
-      DBUG_RETURN(1); /* purecov: inspected */
+      return(1); /* purecov: inspected */
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* write_keys */
 
 
@@ -675,23 +665,22 @@
 {
   uchar **end;
   int err;
-  DBUG_ENTER("write_keys_varlen");
 
   my_qsort2((uchar*) sort_keys,count,sizeof(uchar*),(qsort2_cmp) info->key_cmp,
             info);
   if (!my_b_inited(tempfile) &&
       open_cached_file(tempfile, my_tmpdir(info->tmpdir), "ST",
                        DISK_BUFFER_SIZE, info->sort_info->param->myf_rw))
-    DBUG_RETURN(1); /* purecov: inspected */
+    return(1); /* purecov: inspected */
 
   buffpek->file_pos=my_b_tell(tempfile);
   buffpek->count=count;
   for (end=sort_keys+count ; sort_keys != end ; sort_keys++)
   {
     if ((err= my_var_write(info,tempfile, (uchar*) *sort_keys)))
-      DBUG_RETURN(err);
+      return(err);
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* write_keys_varlen */
 
 
@@ -699,17 +688,16 @@
 			    IO_CACHE *tempfile)
 {
   uint key_length=info->real_key_length;
-  DBUG_ENTER("write_key");
 
   if (!my_b_inited(tempfile) &&
       open_cached_file(tempfile, my_tmpdir(info->tmpdir), "ST",
                        DISK_BUFFER_SIZE, info->sort_info->param->myf_rw))
-    DBUG_RETURN(1);
+    return(1);
 
   if (my_b_write(tempfile,(uchar*)&key_length,sizeof(key_length)) ||
       my_b_write(tempfile,(uchar*)key,(uint) key_length))
-    DBUG_RETURN(1);
-  DBUG_RETURN(0);
+    return(1);
+  return(0);
 } /* write_key */
 
 
@@ -718,16 +706,14 @@
 static int  write_index(MI_SORT_PARAM *info, register uchar **sort_keys,
                               register uint count)
 {
-  DBUG_ENTER("write_index");
-
   my_qsort2((uchar*) sort_keys,(size_t) count,sizeof(uchar*),
            (qsort2_cmp) info->key_cmp,info);
   while (count--)
   {
     if ((*info->key_write)(info,*sort_keys++))
-      DBUG_RETURN(-1); /* purecov: inspected */
+      return(-1); /* purecov: inspected */
   }
-  DBUG_RETURN(0);
+  return(0);
 } /* write_index */
 
 
@@ -740,14 +726,13 @@
   register int i;
   IO_CACHE t_file2, *from_file, *to_file, *temp;
   BUFFPEK *lastbuff;
-  DBUG_ENTER("merge_many_buff");
 
   if (*maxbuffer < MERGEBUFF2)
-    DBUG_RETURN(0);                             /* purecov: inspected */
+    return(0);                             /* purecov: inspected */
   if (flush_io_cache(t_file) ||
       open_cached_file(&t_file2,my_tmpdir(info->tmpdir),"ST",
                        DISK_BUFFER_SIZE, info->sort_info->param->myf_rw))
-    DBUG_RETURN(1);                             /* purecov: inspected */
+    return(1);                             /* purecov: inspected */
 
   from_file= t_file ; to_file= &t_file2;
   while (*maxbuffer >= MERGEBUFF2)
@@ -774,7 +759,7 @@
   if (to_file == t_file)
     *t_file=t_file2;                            /* Copy result file */
 
-  DBUG_RETURN(*maxbuffer >= MERGEBUFF2);        /* Return 1 if interrupted */
+  return(*maxbuffer >= MERGEBUFF2);        /* Return 1 if interrupted */
 } /* merge_many_buff */
 
 
@@ -885,11 +870,10 @@
   BUFFPEK *buffpek,**refpek;
   QUEUE queue;
   volatile int *killed= killed_ptr(info->sort_info->param);
-  DBUG_ENTER("merge_buffers");
 
   count=error=0;
   maxcount=keys/((uint) (Tb-Fb) +1);
-  DBUG_ASSERT(maxcount > 0);
+  assert(maxcount > 0);
   if (to_file)
     to_start_filepos=my_b_tell(to_file);
   strpos=(uchar*) sort_keys;
@@ -898,7 +882,7 @@
   if (init_queue(&queue,(uint) (Tb-Fb)+1,offsetof(BUFFPEK,key),0,
                  (int (*)(void*, uchar *,uchar*)) info->key_cmp,
                  (void*) info))
-    DBUG_RETURN(1); /* purecov: inspected */
+    return(1); /* purecov: inspected */
 
   for (buffpek= Fb ; buffpek <= Tb ; buffpek++)
   {
@@ -1008,7 +992,7 @@
     lastbuff->file_pos=to_start_filepos;
 err:
   delete_queue(&queue);
-  DBUG_RETURN(error);
+  return(error);
 } /* merge_buffers */
 
 
@@ -1018,10 +1002,9 @@
 merge_index(MI_SORT_PARAM *info, uint keys, uchar **sort_keys,
             BUFFPEK *buffpek, int maxbuffer, IO_CACHE *tempfile)
 {
-  DBUG_ENTER("merge_index");
   if (merge_buffers(info,keys,tempfile,(IO_CACHE*) 0,sort_keys,buffpek,buffpek,
                     buffpek+maxbuffer))
-    DBUG_RETURN(1); /* purecov: inspected */
-  DBUG_RETURN(0);
+    return(1); /* purecov: inspected */
+  return(0);
 } /* merge_index */
 

=== removed file 'storage/myisam/test_pack'
--- storage/myisam/test_pack	2008-06-25 05:29:13 +0000
+++ storage/myisam/test_pack	1970-01-01 00:00:00 +0000
@@ -1,9 +0,0 @@
-silent="-s"
-suffix=$MACH
-mi_test1$MACH -s ; myisampack$MACH --force -s test1 ; myisamchk$MACH -es test1 ; myisamchk$MACH -rqs test1 ; myisamchk$MACH -es test1 ; myisamchk$MACH -us test1 ; myisamchk$MACH -es test1
-mi_test1$MACH -s -S ; myisampack$MACH --force -s test1 ; myisamchk$MACH -es test1 ; myisamchk$MACH -rqs test1 ; myisamchk$MACH -es test1 ;myisamchk$MACH -us test1 ; myisamchk$MACH -es test1
-mi_test1$MACH -s -b ; myisampack$MACH --force -s test1 ; myisamchk$MACH -es test1 ; myisamchk$MACH -rqs test1 ; myisamchk$MACH -es test1
-mi_test1$MACH -s -w ; myisampack$MACH --force -s test1 ; myisamchk$MACH -es test1 ; myisamchk$MACH -ros test1 ; myisamchk$MACH -es test1
-
-mi_test2$MACH -s -t4 ; myisampack$MACH --force -s test2 ; myisamchk$MACH -es test2 ; myisamchk$MACH -ros test2 ; myisamchk$MACH -es test2 ; myisamchk$MACH -s -u test2 ; myisamchk$MACH -sm test2
-mi_test2$MACH -s -t4 -b -N ; myisampack$MACH --force -s test2 ; myisamchk$MACH -es test2 ; myisamchk$MACH -ros test2 ; myisamchk$MACH -es test2 ; myisamchk$MACH -s -u test2 ; myisamchk$MACH -sm test2

=== modified file 'strings/dtoa.c'
--- strings/dtoa.c	2008-07-15 06:45:16 +0000
+++ strings/dtoa.c	2008-07-16 18:48:24 +0000
@@ -1338,6 +1338,7 @@
 #endif
   Stack_alloc alloc;
 
+  c= 0;
   *error= 0;
 
   alloc.begin= alloc.free= buf;

=== modified file 'tests/lib/mtr_process.pl'
--- tests/lib/mtr_process.pl	2008-07-15 09:43:34 +0000
+++ tests/lib/mtr_process.pl	2008-07-15 21:01:59 +0000
@@ -739,7 +739,7 @@
   # Shutdown time must be high as slave may be in reconnect
   mtr_add_arg($args, "--shutdown_timeout=$adm_shutdown_tmo");
   mtr_add_arg($args, "$command");
-  my $pid= mtr_spawn($::exe_mysqladmin, $args,
+  my $pid= mtr_spawn($::exe_drizzleadmin, $args,
 		     "", "", "", "",
 		     { append_log_file => 1 });
   mtr_verbose("mtr_mysqladmin_start, pid: $pid");

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2008-07-13 20:17:42 +0000
+++ tests/test-run.pl	2008-07-16 19:27:24 +0000
@@ -9,7 +9,7 @@
 #  Tool used for executing a suite of .test file
 #
 #  See the "MySQL Test framework manual" for more information
-#  http://dev.mysql.com/doc/mysqltest/en/index.html
+#  http://dev.mysql.com/doc/drizzletest/en/index.html
 #
 #  Please keep the test framework tools identical in all versions!
 #
@@ -109,7 +109,7 @@
 our $path_language;
 our $path_timefile;
 our $path_snapshot;
-our $path_mysqltest_log;
+our $path_drizzletest_log;
 our $path_current_test_log;
 our $path_my_basedir;
 
@@ -127,18 +127,18 @@
 our $opt_verbose= 0;  # Verbose output, enable with --verbose
 
 our $exe_master_mysqld;
-our $exe_mysql;
-our $exe_mysqladmin;
-our $exe_mysqlbinlog;
-our $exe_mysql_client_test;
+our $exe_drizzle;
+our $exe_drizzleadmin;
+our $exe_drizzlebinlog;
+our $exe_drizzle_client_test;
 our $exe_bug25714;
-our $exe_mysqld;
-our $exe_mysqlcheck;
-our $exe_mysqldump;
+our $exe_drizzled;
+our $exe_drizzlecheck;
+our $exe_drizzledump;
 our $exe_mysqlslap;
-our $exe_mysqlimport;
-our $exe_mysql_fix_system_tables;
-our $exe_mysqltest;
+our $exe_drizzleimport;
+our $exe_drizzle_fix_system_tables;
+our $exe_drizzletest;
 our $exe_slave_mysqld;
 our $exe_my_print_defaults;
 our $exe_perror;
@@ -227,7 +227,7 @@
 
 my $opt_valgrind= 0;
 my $opt_valgrind_mysqld= 0;
-my $opt_valgrind_mysqltest= 0;
+my $opt_valgrind_drizzletest= 0;
 my @default_valgrind_args= ("--show-reachable=yes");
 my @valgrind_args;
 my $opt_valgrind_path;
@@ -295,7 +295,7 @@
 sub mysqld_start ($$$);
 sub mysqld_arguments ($$$$);
 sub stop_all_servers ();
-sub run_mysqltest ($);
+sub run_drizzletest ($);
 sub usage ($);
 
 
@@ -511,7 +511,7 @@
              'gcov'                     => \$opt_gcov,
              'gprof'                    => \$opt_gprof,
              'valgrind|valgrind-all'    => \$opt_valgrind,
-             'valgrind-mysqltest'       => \$opt_valgrind_mysqltest,
+             'valgrind-drizzletest'       => \$opt_valgrind_drizzletest,
              'valgrind-mysqld'          => \$opt_valgrind_mysqld,
              'valgrind-options=s'       => sub {
 	       my ($opt, $value)= @_;
@@ -647,7 +647,7 @@
 
   if (!$opt_extern)
   {
-    $exe_mysqld=       mtr_exe_exists ("$glob_basedir/server/drizzled",
+    $exe_drizzled=       mtr_exe_exists ("$glob_basedir/server/drizzled",
 				       "$path_client_bindir/drizzled",
 				       "$glob_basedir/libexec/drizzled",
 				       "$glob_basedir/bin/drizzled",
@@ -848,8 +848,8 @@
   # --------------------------------------------------------------------------
   # Check if special exe was selected for master or slave
   # --------------------------------------------------------------------------
-  $exe_master_mysqld= $exe_master_mysqld || $exe_mysqld;
-  $exe_slave_mysqld=  $exe_slave_mysqld  || $exe_mysqld;
+  $exe_master_mysqld= $exe_master_mysqld || $exe_drizzled;
+  $exe_slave_mysqld=  $exe_slave_mysqld  || $exe_drizzled;
 
   # --------------------------------------------------------------------------
   # Check valgrind arguments
@@ -859,16 +859,16 @@
     mtr_report("Turning on valgrind for all executables");
     $opt_valgrind= 1;
     $opt_valgrind_mysqld= 1;
-    $opt_valgrind_mysqltest= 1;
+    $opt_valgrind_drizzletest= 1;
   }
   elsif ( $opt_valgrind_mysqld )
   {
     mtr_report("Turning on valgrind for mysqld(s) only");
     $opt_valgrind= 1;
   }
-  elsif ( $opt_valgrind_mysqltest )
+  elsif ( $opt_valgrind_drizzletest )
   {
-    mtr_report("Turning on valgrind for mysqltest and mysql_client_test only");
+    mtr_report("Turning on valgrind for drizzletest and drizzle_client_test only");
     $opt_valgrind= 1;
   }
 
@@ -1025,8 +1025,8 @@
   }
 
 
-  $path_timefile=  "$opt_vardir/log/mysqltest-time";
-  $path_mysqltest_log=  "$opt_vardir/log/mysqltest.log";
+  $path_timefile=  "$opt_vardir/log/drizzletest-time";
+  $path_drizzletest_log=  "$opt_vardir/log/drizzletest.log";
   $path_current_test_log= "$opt_vardir/log/current_test";
 
   $path_snapshot= "$opt_tmpdir/snapshot_$opt_master_myport/";
@@ -1119,7 +1119,7 @@
   #
   # --datadir must exist, mysqld will chdir into it
   #
-  my $list= `$exe_mysqld --no-defaults --datadir=$tmpdir --language=$path_language --skip-grant-tables --verbose --help`;
+  my $list= `$exe_drizzled --no-defaults --datadir=$tmpdir --language=$path_language --skip-grant-tables --verbose --help`;
 
   foreach my $line (split('\n', $list))
   {
@@ -1127,7 +1127,7 @@
     if ( !$mysql_version_id )
     {
       # Look for version
-      my $exe_name= basename($exe_mysqld);
+      my $exe_name= basename($exe_drizzled);
       mtr_verbose("exe_name: $exe_name");
       if ( $line =~ /^\S*$exe_name\s\sVer\s([0-9]*)\.([0-9]*)\.([0-9]*)/ )
       {
@@ -1193,7 +1193,7 @@
   mtr_add_arg($args, "--silent"); # Tab separated output
   mtr_add_arg($args, "-e '%s'", $query);
 
-  my $cmd= "$exe_mysql " . join(' ', @$args);
+  my $cmd= "$exe_drizzle " . join(' ', @$args);
   mtr_verbose("cmd: $cmd");
   return `$cmd`;
 }
@@ -1241,12 +1241,12 @@
   $exe_perror= "perror";
 
 # Look for the client binaries
-  $exe_mysqlcheck= mtr_exe_exists("$path_client_bindir/mysqlcheck");
-  $exe_mysqldump= mtr_exe_exists("$path_client_bindir/mysqldump");
-  $exe_mysqlimport= mtr_exe_exists("$path_client_bindir/mysqlimport");
-  $exe_mysqlbinlog= mtr_exe_exists("$path_client_bindir/mysqlbinlog");
-  $exe_mysqladmin= mtr_exe_exists("$path_client_bindir/mysqladmin");
-  $exe_mysql=          mtr_exe_exists("$path_client_bindir/mysql");
+  $exe_drizzlecheck= mtr_exe_exists("$path_client_bindir/drizzlecheck");
+  $exe_drizzledump= mtr_exe_exists("$path_client_bindir/drizzledump");
+  $exe_drizzleimport= mtr_exe_exists("$path_client_bindir/drizzleimport");
+  $exe_drizzlebinlog= mtr_exe_exists("$path_client_bindir/drizzlebinlog");
+  $exe_drizzleadmin= mtr_exe_exists("$path_client_bindir/drizzleadmin");
+  $exe_drizzle=          mtr_exe_exists("$path_client_bindir/drizzle");
 
   if (!$opt_extern)
   {
@@ -1257,18 +1257,18 @@
     }
   }
 
-# Look for mysqltest executable
+# Look for drizzletest executable
   {
-    $exe_mysqltest= mtr_exe_exists("$path_client_bindir/mysqltest");
+    $exe_drizzletest= mtr_exe_exists("$path_client_bindir/drizzletest");
   }
 
-# Look for mysql_client_test executable which may _not_ exist in
+# Look for drizzle_client_test executable which may _not_ exist in
 # some versions, test using it should be skipped
   {
-    $exe_mysql_client_test=
+    $exe_drizzle_client_test=
       mtr_exe_maybe_exists(
-          "$glob_basedir/tests/mysql_client_test",
-          "$glob_basedir/bin/mysql_client_test");
+          "$glob_basedir/tests/drizzle_client_test",
+          "$glob_basedir/bin/drizzle_client_test");
   }
 
 # Look for bug25714 executable which may _not_ exist in
@@ -1283,7 +1283,7 @@
 sub generate_cmdline_mysqldump ($) {
   my($mysqld) = @_;
   return
-    mtr_native_path($exe_mysqldump) .
+    mtr_native_path($exe_drizzledump) .
       " --no-defaults -uroot --debug-check " .
       "--port=$mysqld->{'port'} ";
 }
@@ -1296,13 +1296,13 @@
 #
 ##############################################################################
 
-sub mysql_client_test_arguments()
+sub drizzle_client_test_arguments()
 {
-  my $exe= $exe_mysql_client_test;
+  my $exe= $exe_drizzle_client_test;
 
   my $args;
   mtr_init_args(\$args);
-  if ( $opt_valgrind_mysqltest )
+  if ( $opt_valgrind_drizzletest )
   {
     valgrind_arguments($args, \$exe);
   }
@@ -1320,7 +1320,7 @@
   if ( $opt_debug )
   {
     mtr_add_arg($args,
-      "--debug=d:t:A,$path_vardir_trace/log/mysql_client_test.trace");
+      "--debug=d:t:A,$path_vardir_trace/log/drizzle_client_test.trace");
   }
 
   return join(" ", $exe, @$args);
@@ -1428,13 +1428,13 @@
 
   $ENV{MTR_BUILD_THREAD}=      $opt_mtr_build_thread;
 
-  $ENV{'EXE_MYSQL'}=          $exe_mysql;
+  $ENV{'EXE_MYSQL'}=          $exe_drizzle;
 
   # ----------------------------------------------------
   # Setup env so childs can execute mysqlcheck
   # ----------------------------------------------------
   my $cmdline_mysqlcheck=
-    mtr_native_path($exe_mysqlcheck) .
+    mtr_native_path($exe_drizzlecheck) .
     " --no-defaults --debug-check -uroot " .
     "--port=$master->[0]->{'port'} ";
 
@@ -1484,7 +1484,7 @@
   # Setup env so childs can execute mysqlimport
   # ----------------------------------------------------
   my $cmdline_mysqlimport=
-    mtr_native_path($exe_mysqlimport) .
+    mtr_native_path($exe_drizzleimport) .
     " -uroot --debug-check " .
     "--port=$master->[0]->{'port'} ";
 
@@ -1500,7 +1500,7 @@
   # Setup env so childs can execute mysqlbinlog
   # ----------------------------------------------------
   my $cmdline_mysqlbinlog=
-    mtr_native_path($exe_mysqlbinlog) .
+    mtr_native_path($exe_drizzlebinlog) .
       " --no-defaults --disable-force-if-open --debug-check";
   if ( !$opt_extern && $mysql_version_id >= 50000 )
   {
@@ -1518,7 +1518,7 @@
   # Setup env so childs can execute mysql
   # ----------------------------------------------------
   my $cmdline_mysql=
-    mtr_native_path($exe_mysql) .
+    mtr_native_path($exe_drizzle) .
     " --no-defaults --debug-check --host=localhost  --user=root --password= " .
     "--port=$master->[0]->{'port'} " .
     "--character-sets-dir=$path_charsetsdir";
@@ -1531,9 +1531,9 @@
   $ENV{'MYSQL_BUG25714'}=  $exe_bug25714;
 
   # ----------------------------------------------------
-  # Setup env so childs can execute mysql_client_test
+  # Setup env so childs can execute drizzle_client_test
   # ----------------------------------------------------
-  $ENV{'MYSQL_CLIENT_TEST'}=  mysql_client_test_arguments();
+  $ENV{'MYSQL_CLIENT_TEST'}=  drizzle_client_test_arguments();
 
 
   # ----------------------------------------------------
@@ -1543,7 +1543,7 @@
   if ( 0 )
   {
     my $cmdline_mysql_fix_system_tables=
-      "$exe_mysql_fix_system_tables --no-defaults --host=localhost " .
+      "$exe_drizzle_fix_system_tables --no-defaults --host=localhost " .
       "--user=root --password= " .
       "--basedir=$glob_basedir --bindir=$path_client_bindir --verbose " .
       "--port=$master->[0]->{'port'} ";
@@ -1559,7 +1559,7 @@
   # ----------------------------------------------------
   # Setup env so childs can execute mysqladmin
   # ----------------------------------------------------
-  $ENV{'MYSQLADMIN'}= mtr_native_path($exe_mysqladmin);
+  $ENV{'MYSQLADMIN'}= mtr_native_path($exe_drizzleadmin);
 
   # ----------------------------------------------------
   # Setup env so childs can execute perror  
@@ -2066,7 +2066,7 @@
   # If marked to skip, just print out and return.
   # Note that a test case not marked as 'skip' can still be
   # skipped later, because of the test case itself in cooperation
-  # with the mysqltest program tells us so.
+  # with the drizzletest program tells us so.
   # ----------------------------------------------------------------------
 
   if ( $tinfo->{'skip'} )
@@ -2080,12 +2080,12 @@
 }
 
 
-sub do_before_run_mysqltest($)
+sub do_before_run_drizzletest($)
 {
   my $tinfo= shift;
   my $args;
 
-  # Remove old files produced by mysqltest
+  # Remove old files produced by drizzletest
   my $base_file= mtr_match_extension($tinfo->{'result_file'},
 				    "result"); # Trim extension
   unlink("$base_file.reject");
@@ -2110,7 +2110,7 @@
 
 	my $sql= "include/set_binlog_format_".$tinfo->{binlog_format}.".sql";
 	mtr_verbose("Setting binlog format:", $tinfo->{binlog_format});
-	if (mtr_run($exe_mysql, $args, $sql, "", "", "") != 0)
+	if (mtr_run($exe_drizzle, $args, $sql, "", "", "") != 0)
 	{
 	  mtr_error("Failed to switch binlog format");
 	}
@@ -2119,14 +2119,14 @@
   }
 }
 
-sub do_after_run_mysqltest($)
+sub do_after_run_drizzletest($)
 {
   my $tinfo= shift;
 
-  # Save info from this testcase run to mysqltest.log
-  mtr_appendfile_to_file($path_current_test_log, $path_mysqltest_log)
+  # Save info from this testcase run to drizzletest.log
+  mtr_appendfile_to_file($path_current_test_log, $path_drizzletest_log)
     if -f $path_current_test_log;
-  mtr_appendfile_to_file($path_timefile, $path_mysqltest_log)
+  mtr_appendfile_to_file($path_timefile, $path_drizzletest_log)
     if -f $path_timefile;
 }
 
@@ -2155,7 +2155,7 @@
   # Set default message
   $tinfo->{'comment'}= "Detected by testcase(no log file)";
 
-  # Open mysqltest-time(the mysqltest log file)
+  # Open drizzletest-time(the drizzletest log file)
   my $F= IO::File->new($path_timefile)
     or return;
   my $reason;
@@ -2246,12 +2246,12 @@
   }
 
   {
-    do_before_run_mysqltest($tinfo);
+    do_before_run_drizzletest($tinfo);
 
-    my $res= run_mysqltest($tinfo);
+    my $res= run_drizzletest($tinfo);
     mtr_report_test_name($tinfo);
 
-    do_after_run_mysqltest($tinfo);
+    do_after_run_drizzletest($tinfo);
 
     if ( $res == 0 )
     {
@@ -2261,7 +2261,7 @@
     {
       # Testcase itself tell us to skip this one
 
-      # Try to get reason from mysqltest.log
+      # Try to get reason from drizzletest.log
       find_testcase_skipped_reason($tinfo);
       mtr_report_test_skipped($tinfo);
     }
@@ -2272,19 +2272,19 @@
     }
     elsif ( $res == 1 )
     {
-      # Test case failure reported by mysqltest
+      # Test case failure reported by drizzletest
       report_failure_and_restart($tinfo);
     }
     else
     {
-      # mysqltest failed, probably crashed
+      # drizzletest failed, probably crashed
       $tinfo->{comment}=
-	"mysqltest returned unexpected code $res, it has probably crashed";
+	"drizzletest returned unexpected code $res, it has probably crashed";
       report_failure_and_restart($tinfo);
     }
   }
 
-  # Remove the file that mysqltest writes info to
+  # Remove the file that drizzletest writes info to
   unlink($path_timefile);
 
   # ----------------------------------------------------------------------
@@ -2485,7 +2485,7 @@
     $sidx= $idx;
   }
 
-  my $prefix= "";               # If mysqltest server arg
+  my $prefix= "";               # If drizzletest server arg
 
   mtr_add_arg($args, "%s--no-defaults", $prefix);
 
@@ -3111,7 +3111,7 @@
     mtr_add_arg($args, "--record");
   }
 
-  my $res = mtr_run_test($exe_mysqltest,$args,
+  my $res = mtr_run_test($exe_drizzletest,$args,
 	        "include/check-testcase.test", "", "", "");
 
   if ( $res == 1  and $mode eq "after")
@@ -3157,7 +3157,7 @@
   $tinfo->{'slave_opt'} = [];
   $tinfo->{'slave_mi'} = [];
   $tinfo->{'comment'} = 'report server features';
-  run_mysqltest($tinfo);
+  run_drizzletest($tinfo);
 
   {
     stop_all_servers();
@@ -3165,9 +3165,9 @@
 }
 
 
-sub run_mysqltest ($) {
+sub run_drizzletest ($) {
   my ($tinfo)= @_;
-  my $exe= $exe_mysqltest;
+  my $exe= $exe_drizzletest;
   my $args;
 
   mtr_init_args(\$args);
@@ -3193,8 +3193,8 @@
   {
     $exe=  "strace";            # FIXME there are ktrace, ....
     mtr_add_arg($args, "-o");
-    mtr_add_arg($args, "%s/log/mysqltest.strace", $opt_vardir);
-    mtr_add_arg($args, "$exe_mysqltest");
+    mtr_add_arg($args, "%s/log/drizzletest.strace", $opt_vardir);
+    mtr_add_arg($args, "$exe_drizzletest");
   }
 
   if ( $opt_timer )
@@ -3214,25 +3214,25 @@
 
   if ( $opt_debug )
   {
-    mtr_add_arg($args, "--debug=d:t:A,%s/log/mysqltest.trace",
+    mtr_add_arg($args, "--debug=d:t:A,%s/log/drizzletest.trace",
 		$path_vardir_trace);
   }
 
   # ----------------------------------------------------------------------
-  # export MYSQL_TEST variable containing <path>/mysqltest <args>
+  # export MYSQL_TEST variable containing <path>/drizzletest <args>
   # ----------------------------------------------------------------------
   $ENV{'MYSQL_TEST'}=
-    mtr_native_path($exe_mysqltest) . " " . join(" ", @$args);
+    mtr_native_path($exe_drizzletest) . " " . join(" ", @$args);
 
   # ----------------------------------------------------------------------
   # Add arguments that should not go into the MYSQL_TEST env var
   # ----------------------------------------------------------------------
 
-  if ( $opt_valgrind_mysqltest )
+  if ( $opt_valgrind_drizzletest )
   {
     # Prefix the Valgrind options to the argument list.
     # We do this here, since we do not want to Valgrind the nested invocations
-    # of mysqltest; that would mess up the stderr output causing test failure.
+    # of drizzletest; that would mess up the stderr output causing test failure.
     my @args_saved = @$args;
     mtr_init_args(\$args);
     valgrind_arguments($args, \$exe);
@@ -3604,9 +3604,9 @@
 
 Options for debugging the product
 
-  client-ddd            Start mysqltest client in ddd
-  client-debugger=NAME  Start mysqltest in the selected debugger
-  client-gdb            Start mysqltest client in gdb
+  client-ddd            Start drizzletest client in ddd
+  client-debugger=NAME  Start drizzletest in the selected debugger
+  client-gdb            Start drizzletest client in gdb
   ddd                   Start mysqld in ddd
   debug                 Dump trace output for all servers and client programs
   debugger=NAME         Start mysqld in the selected debugger
@@ -3619,7 +3619,7 @@
                         test(s)
   master-binary=PATH    Specify the master "mysqld" to use
   slave-binary=PATH     Specify the slave "mysqld" to use
-  strace-client         Create strace output for mysqltest client
+  strace-client         Create strace output for drizzletest client
   max-save-core         Limit the number of core files saved (to avoid filling
                         up disks for heavily crashing server). Defaults to
                         $opt_max_save_core, set to 0 for no limit.
@@ -3628,10 +3628,10 @@
 
   gcov                  FIXME
   gprof                 FIXME
-  valgrind              Run the "mysqltest" and "mysqld" executables using
+  valgrind              Run the "drizzletest" and "mysqld" executables using
                         valgrind with default options
   valgrind-all          Synonym for --valgrind
-  valgrind-mysqltest    Run the "mysqltest" and "mysql_client_test" executable
+  valgrind-drizzletest    Run the "drizzletest" and "drizzle_client_test" executable
                         with valgrind
   valgrind-mysqld       Run the "mysqld" executable with valgrind
   valgrind-options=ARGS Deprecated, use --valgrind-option
@@ -3658,7 +3658,7 @@
   suite-timeout=MINUTES Max test suite run time (default $default_suite_timeout)
   warnings | log-warnings Pass --log-warnings to mysqld
 
-  sleep=SECONDS         Passed to mysqltest, will be used as fixed sleep time
+  sleep=SECONDS         Passed to drizzletest, will be used as fixed sleep time
 
 HERE
   mtr_exit(1);

